<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.111pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPControllerAccueil extends GMapFPController
{
	function __construct()
	{
		parent::__construct();
	}

	function view()
	{
		$this->input->set( 'view', 'accueil' );
		$this->input->set( 'layout', 'form'  );
		$this->input->set('hidemainmenu', 0);

		parent::display();
	}

	function miniatures()
	{
		$model	= $this->getModel( 'accueil' );
		if ($model->miniatures_del()) {
			$msg = JText::_( 'GMapFP Gallery Image Thumbnail Recreated' );
		} else {
			$msg = JText::_( 'Error Recreated GMapFP Gallery Image Thumbnail' );
		}
		$model->miniatures_create_gallerie();
		$model->miniatures_create_main();
		$model->miniatures_create_blank();
		
		$link = 'index.php?option=com_gmapfp&controller=accueil&task=view';
		$this->setRedirect($link, $msg);
	}

	function miniatures_create_gallerie()
	{
		$model	= $this->getModel( 'accueil' );
		$model->miniatures_create_gallerie();
		
		$link = 'index.php?option=com_gmapfp&controller=accueil&task=miniatures_create_main';
		$this->setRedirect($link);
	}

	function miniatures_create_main()
	{
		$model	= $this->getModel( 'accueil' );
		$model->miniatures_create_main();
		
		$link = 'index.php?option=com_gmapfp&controller=accueil&task=miniatures_create_blank';
		$this->setRedirect($link);
	}

	function miniatures_create_blank()
	{
		$model	= $this->getModel( 'accueil' );
		$model->miniatures_create_blank();
		
		$link = 'index.php?option=com_gmapfp&controller=accueil&task=view';
		$this->setRedirect($link);
	}

	function clear_images()
	{
		jimport( 'joomla.filesystem.folder' );
		jimport( 'joomla.filesystem.file' );
		$files = JFolder::files(COM_GMAPFP_IMAGES_FOLDER);
		
		$model = $this->getModel('accueil');
		$ListImgs = $model->getImages();
		if (count($files)){
			foreach ($files as $file){
				if ((!in_array($file, $ListImgs))and($file!='index.html')and($file!='blank.png')){
					JFile::delete(COM_GMAPFP_IMAGES_FOLDER.'/'.$file);
					JFile::delete(COM_GMAPFP_IMAGES_FOLDER.'/thumbsArt/'.$file);
					JFile::delete(COM_GMAPFP_IMAGES_FOLDER.'/thumbsGMap/'.$file);
				}
			}
		}
		
		$link = 'index.php?option=com_gmapfp&controller=accueil&task=view';
		$msg = JText::_('GMAPFP_NETTOYAGE_IMAGES_OK');
		$this->setRedirect($link, $msg);
	}

	function getCoordonner()
	{
		$model = $this->getModel('accueil');
		$result = $model->getCoordonner();
		
		$link = 'index.php?option=com_gmapfp&controller=accueil&task=view';
		$msg = JText::sprintf('GMAPFP_FIND_LAT_LNG_OK', $result);

		$this->setRedirect($link, $msg);
	}

	function falang()
	{
		$this->input->set( 'view', 'accueil' );
		$this->input->set( 'layout', 'select'  );
		$this->input->set( 'type', 'falang'  );
		$this->input->set( 'hidemainmenu', 0);

		parent::display();
	}
	
	function generate_falang()
	{
		jimport( 'joomla.filesystem.file' );
		$post	= JRequest::get('post');
		
		$model	= $this->getModel( 'accueil' );
		$lists = $model->getDataChamp();
		$customs_name = $this->get('Customs_name');

		if (@$customs_name[10]->nom) {
			$message_label = $customs_name[10]->nom;
		}else{
			$message_label = JText::_( 'GMAPFP_MESSAGE' );
		}
		if (@$customs_name[11]->nom) {
			$horaires_label = $customs_name[11]->nom;
		}else{
			$horaires_label = JText::_( 'GMAPFP_HORAIRES_PRIX' );
		}

		$falang_gmapfp_xml = 
'<?xml version="1.0" ?>
<falang type="contentelement">
  <name>GMapFP : Main</name>
	<author>Fabrice4821</author>
	<copyright>www.gmapfp.org</copyright>
	<version>1.0</version>
	<description>GMapFP Type</description>
  <reference>
  	<table name="gmapfp">
  		<field type="referenceid" name="id" translate="0">ID</field>
  		<field type="titletext" name="nom"  length="50" maxlength="200" translate="'.(int)array_key_exists("nom", $post).'">'.JText::_('GMAPFP_NOM').'</field>
  		<field type="text" name="alias"  length="50" maxlength="255" translate="'.(int)array_key_exists("alias", $post).'" posthandler="filterTitle">'.JText::_('JFIELD_ALIAS_LABEL').'</field>
  		<field type="text" name="adresse" length="50" maxlength="200" translate="'.(int)array_key_exists("adresse", $post).'">'.JText::_('GMAPFP_ADRESSE').'</field>
  		<field type="text" name="adresse2" length="50" maxlength="200" translate="'.(int)array_key_exists("adresse2", $post).'">'.JText::_('GMAPFP_ADRESSE').' 2</field>
  		<field type="text" name="ville" length="50" maxlength="200" translate="'.(int)array_key_exists("ville", $post).'">'.JText::_('GMAPFP_VILLE').'</field>
  		<field type="text" name="departement" length="50" maxlength="200" translate="'.(int)array_key_exists("departement", $post).'">'.JText::_('GMAPFP_DEPARTEMENT').'</field>
  		<field type="text" name="codepostal" length="50" maxlength="80" translate="'.(int)array_key_exists("codepostal", $post).'">'.JText::_('GMAPFP_CODEPOSTAL').'</field>
  		<field type="text" name="pay" length="50" maxlength="200" translate="'.(int)array_key_exists("pay", $post).'">'.JText::_('GMAPFP_PAYS').'</field>
  		<field type="text" name="email" length="50" maxlength="100" translate="'.(int)array_key_exists("email", $post).'">'.JText::_('GMAPFP_EMAIL').'</field>
  		<field type="text" name="web" length="50" maxlength="200" translate="'.(int)array_key_exists("web", $post).'">'.JText::_('GMAPFP_SITE_WEB').'</field>
  		<field type="text" name="img" length="50" maxlength="100" translate="0">'.JText::_('GMAPFP_IMAGE').'</field>
  		<field type="text" name="album" length="50" maxlength="100" translate="0">'.JText::_('GMAPFP_ALBUM').'</field>
  		<field type="htmltext" name="introtext" translate="'.(int)array_key_exists("message", $post).'" prehandleroriginal="fetchArticleText" prehandlertranslation="fetchArticleTranslation" posthandler="saveArticleText" ebuttons="ignore">'.$message_label.'</field>
  		<field type="hiddentext" name="fulltext" translate="'.(int)array_key_exists("message", $post).'" ebuttons="readmore">Fulltext</field>
  		<field type="textarea" name="horaires_prix" rows="5" columns="90" translate="'.(int)array_key_exists("horaires_prix", $post).'">'.$horaires_label.'</field>
  		<field type="text" name="link" length="50" maxlength="100" translate="'.(int)array_key_exists("link", $post).'">'.JText::_('GMAPFP_LINK').'</field>
  		<field type="text" name="article_id" length="50" maxlength="100" translate="'.(int)array_key_exists("article_id", $post).'">'.JText::_('GMAPFP_SELECT_ARTICLE').'</field>
  		<field type="readonlytext" name="icon" length="50" maxlength="100" translate="0">'.JText::_('GMAPFP_ICON').'</field>
  		<field type="text" name="icon_label" length="50" maxlength="100" translate="'.(int)array_key_exists("icon_label", $post).'">'.JText::_('GMAPFP_ICON_LABEL').'</field>
  		<field type="text" name="glng" length="50" maxlength="30" translate="0">'.JText::_('GMAPFP_LON').'</field>
  		<field type="text" name="glat" length="50" maxlength="30" translate="0">'.JText::_('GMAPFP_LAT').'</field>
  		<field type="text" name="gzoom" length="50" maxlength="2" translate="0">'.JText::_('Zoom').'</field>
  		<field type="text" name="access" length="50" maxlength="11" translate="0">'.JText::_('JFIELD_ACCESS_LABEL').'</field>
  		<field type="text" name="metakey" length="50" maxlength="250" translate="'.(int)array_key_exists("metakey", $post).'">'.JText::_('JFIELD_META_KEYWORDS_LABEL').'</field>
  		<field type="textarea" name="metadesc"  rows="5" columns="80" translate="'.(int)array_key_exists("metadesc", $post).'">'.JText::_('JFIELD_META_DESCRIPTION_LABEL').'</field>
  		<field type="text" name="publish_up" length="50" maxlength="20" translate="0">'.JText::_('JGLOBAL_FIELD_PUBLISH_UP_LABEL').'</field>
  		<field type="text" name="publish_down" length="50" maxlength="20" translate="0">'.JText::_('JGLOBAL_FIELD_PUBLISH_DOWN_LABEL').'</field>
  		<field type="text" name="ordering" length="50" maxlength="11" translate="0">'.JText::_('JGLOBAL_FIELD_ORDERING_LABEL').'</field>
  		<field type="textarea" name="attribs" length="50" maxlength="20" translate="0">'.JText::_('JFIELD_METADATA_ROBOTS_LABEL').'</field>
  		<field type="text" name="index_marqueur" length="50" maxlength="11" translate="0">'.JText::_('GMAPFP_MARKER').'</field>
  		<field type="text" name="classements" length="50" maxlength="255" translate="0">'.JText::_('GMAPFP_CLASSEMENTS').'</field>
  		<field type="text" name="labels" length="50" maxlength="255" translate="0">'.JText::_('GMAPFP_LABELS').'</field>
  		<field type="text" name="pictos" length="50" maxlength="255" translate="0">'.JText::_('GMAPFP_PICTOS').'</field>
';
		
		$customs = $lists['customs'];
		$ok = false;
		foreach ($lists['champs'] as $champ) {
			if ($ok) {
				switch ($customs[substr($champ->Field, 6)]->type) {
					case 0:
						if (array_key_exists($champ->Field, $post))
							$falang_gmapfp_xml .=
'  		<field type="text" name="'.$champ->Field.'" length="50" maxlength="250" translate="1">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
						else
							$falang_gmapfp_xml .=
'  		<field type="text" name="'.$champ->Field.'" length="50" maxlength="250" translate="0">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
						break;
					case 1:
						if (array_key_exists($champ->Field, $post))
						$falang_gmapfp_xml .=
'  		<field type="textarea" name="'.$champ->Field.'" rows="5" columns="90" translate="1">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
						else
						$falang_gmapfp_xml .=
'  		<field type="textarea" name="'.$champ->Field.'" rows="5" columns="90" translate="1">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
						break;
					case 2:
						if (array_key_exists($champ->Field, $post))
						$falang_gmapfp_xml .=
'  		<field type="htmltext" name="'.$champ->Field.'" rows="5" columns="80" translate="1">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
						else
						$falang_gmapfp_xml .=
'  		<field type="htmltext" name="'.$champ->Field.'" rows="5" columns="80" translate="0">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
						break;
					default :
						$falang_gmapfp_xml .=
'  		<field type="textarea" name="'.$champ->Field.'" rows="5" columns="90" translate="0">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
				}
			}
			
			if (!$ok and $champ->Field == 'pictos') $ok = true;
		}
		$falang_gmapfp_xml .=
'  	</table>
  	<component>
  		<form>com_gmapfp#gmapfp#cid#task#!edit</form>
  	</component>
  </reference>
  <translationfilters>
  	  <category>catid</category>
  	  <author>created_by</author>
  	  <keyword>nom</keyword>
  	  <published>published</published>
  	  <changed>created|modified</changed>
  	  <id>id</id>
  </translationfilters>
</falang>
';
		JFile::write(JPATH_ADMINISTRATOR.'/components/com_falang/contentelements/gmapfp.xml', $falang_gmapfp_xml);

		if (array_key_exists('ceate_all_files', $post)) {
			$falang_gmapfp_extension_type =
'<?xml version="1.0" ?>
<falang type="contentelement">
	<name>GMapFP : Fields</name>
	<author>Fabrice4821</author>
	<copyright>www.gmapfp.org</copyright>
	<version>1.0</version>
	<description>GMapFP Type</description>
	<reference>
		<table name="gmapfp_extension_type">
			<field type="referenceid" name="id" translate="0">ID</field>
			<field type="titletext" name="nom" translate="1">Name</field>
			<field type="text" name="description" translate="1">Description</field>
			<field type="textarea" name="parametres" translate="1">Parameters</field>
		</table>
	</reference>
	<translationfilters>
		<published>published</published>
		<id>id</id>
	</translationfilters>
</falang>';
			JFile::write(JPATH_ADMINISTRATOR.'/components/com_falang/contentelements/gmapfp_extension_type.xml', $falang_gmapfp_extension_type);
			$falang_gmapfp_personnalisation =
'<?xml version="1.0" ?>
<falang type="contentelement">
  <name>GMapFP : Perso</name>
  <author>Fabrice4821</author>
  <version>1.0</version>
  <description>Definition for Perso GMapFP Component</description>
  <reference>
     <table name="gmapfp_personnalisation">
      <field type="referenceid" name="id" translate="0">ID</field>
      <field type="titletext" name="nom" translate="1">Name</field>
      <field type="htmltext" name="intro_carte" translate="1">before map</field>
      <field type="htmltext" name="conclusion_carte" translate="1">after map</field>
      <field type="htmltext" name="intro_detail" translate="1">before detail</field>
      <field type="htmltext" name="conclusion_detail" translate="1">after detail</field>
     </table>
  </reference>
  <translationfilters>
    <published>published</published>
    <id>id</id>
  </translationfilters>
</falang>';
			JFile::write(JPATH_ADMINISTRATOR.'/components/com_falang/contentelements/gmapfp_personnalisation.xml', $falang_gmapfp_personnalisation);
			$falang_gmapfp_classements =
'<?xml version="1.0" ?>
<falang type="contentelement">
  <name>GMapFP : Classements</name>
  <author>Fabrice4821</author>
  <version>1.0</version>
  <description>Definition for rankings of GMapFP Component</description>
  <reference>
     <table name="gmapfp_classements">
      <field type="referenceid" name="id" translate="0">ID</field>
      <field type="titletext" name="nom" translate="1">Name</field>
      <field type="text" name="img" translate="1">Img</field>
     </table>
  </reference>
  <translationfilters>
    <id>id</id>
  </translationfilters>
</falang>';
			JFile::write(JPATH_ADMINISTRATOR.'/components/com_falang/contentelements/gmapfp_classements.xml', $falang_gmapfp_classements);
			$falang_gmapfp_params_custom_fields =
'<?xml version="1.0" ?>
<falang type="contentelement">
  <name>GMapFP : Custom</name>
  <author>Fabrice4821</author>
  <version>1.0</version>
  <description>Definition for Custom fields of GMapFP Component</description>
  <reference>
     <table name="gmapfp_params_custom_fields">
      <field type="referenceid" name="id" translate="0">ID</field>
      <field type="titletext" name="nom" translate="1">Name</field>
      <field type="text" name="items" translate="1">Items</field>
     </table>
  </reference>
  <translationfilters>
    <id>id</id>
  </translationfilters>
</falang>';
			JFile::write(JPATH_ADMINISTRATOR.'/components/com_falang/contentelements/gmapfp_params_custom_fields.xml', $falang_gmapfp_params_custom_fields);
		}
		die(print_r(JText::_( 'GMAPFP_UPDATE_OK' ).'<br />'));
	}

	function joomfish()
	{
		$this->input->set( 'view', 'accueil' );
		$this->input->set( 'layout', 'select'  );
		$this->input->set( 'type', 'joomfish'  );
		$this->input->set( 'hidemainmenu', 0);

		parent::display();
	}
	
	function generate_joomfish()
	{
		jimport( 'joomla.filesystem.file' );
		$post	= JRequest::get('post');
		
		$model	= $this->getModel( 'accueil' );
		$lists = $model->getDataChamp();
		$customs_name = $this->get('Customs_name');

		if (@$customs_name[10]->nom) {
			$message_label = $customs_name[10]->nom;
		}else{
			$message_label = JText::_( 'GMAPFP_MESSAGE' );
		}
		if (@$customs_name[11]->nom) {
			$horaires_label = $customs_name[11]->nom;
		}else{
			$horaires_label = JText::_( 'GMAPFP_HORAIRES_PRIX' );
		}

		$falang_gmapfp_xml = 
'<?xml version="1.0" ?>
<joomfish type="contentelement">
  <name>GMapFP : Main</name>
	<author>Fabrice4821</author>
	<copyright>www.gmapfp.org</copyright>
	<version>1.0</version>
	<description>GMapFP Type</description>
  <reference>
  	<table name="gmapfp">
  		<field type="referenceid" name="id" translate="0">ID</field>
  		<field type="titletext" name="nom"  length="50" maxlength="200" translate="'.(int)array_key_exists("nom", $post).'">'.JText::_('GMAPFP_NOM').'</field>
  		<field type="text" name="alias"  length="50" maxlength="255" translate="'.(int)array_key_exists("alias", $post).'" posthandler="filterTitle">'.JText::_('JFIELD_ALIAS_LABEL').'</field>
  		<field type="text" name="adresse" length="50" maxlength="200" translate="'.(int)array_key_exists("adresse", $post).'">'.JText::_('GMAPFP_ADRESSE').'</field>
  		<field type="text" name="adresse2" length="50" maxlength="200" translate="'.(int)array_key_exists("adresse2", $post).'">'.JText::_('GMAPFP_ADRESSE').' 2</field>
  		<field type="text" name="ville" length="50" maxlength="200" translate="'.(int)array_key_exists("ville", $post).'">'.JText::_('GMAPFP_VILLE').'</field>
  		<field type="text" name="departement" length="50" maxlength="200" translate="'.(int)array_key_exists("departement", $post).'">'.JText::_('GMAPFP_DEPARTEMENT').'</field>
  		<field type="text" name="codepostal" length="50" maxlength="80" translate="'.(int)array_key_exists("codepostal", $post).'">'.JText::_('GMAPFP_CODEPOSTAL').'</field>
  		<field type="text" name="pay" length="50" maxlength="200" translate="'.(int)array_key_exists("pay", $post).'">'.JText::_('GMAPFP_PAYS').'</field>
  		<field type="text" name="email" length="50" maxlength="100" translate="'.(int)array_key_exists("email", $post).'">'.JText::_('GMAPFP_EMAIL').'</field>
  		<field type="text" name="web" length="50" maxlength="200" translate="'.(int)array_key_exists("web", $post).'">'.JText::_('GMAPFP_SITE_WEB').'</field>
  		<field type="text" name="img" length="50" maxlength="100" translate="0">'.JText::_('GMAPFP_IMAGE').'</field>
  		<field type="text" name="album" length="50" maxlength="100" translate="0">'.JText::_('GMAPFP_ALBUM').'</field>
  		<field type="htmltext" name="introtext" translate="'.(int)array_key_exists("message", $post).'" prehandleroriginal="fetchArticleText" prehandlertranslation="fetchArticleTranslation" posthandler="saveArticleText" ebuttons="ignore">'.$message_label.'</field>
  		<field type="hiddentext" name="fulltext" translate="'.(int)array_key_exists("message", $post).'" ebuttons="readmore">Fulltext</field>
  		<field type="textarea" name="horaires_prix" rows="5" columns="90" translate="'.(int)array_key_exists("horaires_prix", $post).'">'.$horaires_label.'</field>
  		<field type="text" name="link" length="50" maxlength="100" translate="'.(int)array_key_exists("link", $post).'">'.JText::_('GMAPFP_LINK').'</field>
  		<field type="text" name="article_id" length="50" maxlength="100" translate="'.(int)array_key_exists("article_id", $post).'">'.JText::_('GMAPFP_SELECT_ARTICLE').'</field>
  		<field type="readonlytext" name="icon" length="50" maxlength="100" translate="0">'.JText::_('GMAPFP_ICON').'</field>
  		<field type="text" name="icon_label" length="50" maxlength="100" translate="'.(int)array_key_exists("icon_label", $post).'">'.JText::_('GMAPFP_ICON_LABEL').'</field>
  		<field type="text" name="glng" length="50" maxlength="30" translate="0">'.JText::_('GMAPFP_LON').'</field>
  		<field type="text" name="glat" length="50" maxlength="30" translate="0">'.JText::_('GMAPFP_LAT').'</field>
  		<field type="text" name="gzoom" length="50" maxlength="2" translate="0">'.JText::_('Zoom').'</field>
  		<field type="text" name="access" length="50" maxlength="11" translate="0">'.JText::_('JFIELD_ACCESS_LABEL').'</field>
  		<field type="text" name="metakey" length="50" maxlength="250" translate="'.(int)array_key_exists("metakey", $post).'">'.JText::_('JFIELD_META_KEYWORDS_LABEL').'</field>
  		<field type="textarea" name="metadesc"  rows="5" columns="80" translate="'.(int)array_key_exists("metadesc", $post).'">'.JText::_('JFIELD_META_DESCRIPTION_LABEL').'</field>
  		<field type="text" name="publish_up" length="50" maxlength="20" translate="0">'.JText::_('JGLOBAL_FIELD_PUBLISH_UP_LABEL').'</field>
  		<field type="text" name="publish_down" length="50" maxlength="20" translate="0">'.JText::_('JGLOBAL_FIELD_PUBLISH_DOWN_LABEL').'</field>
  		<field type="text" name="ordering" length="50" maxlength="11" translate="0">'.JText::_('JGLOBAL_FIELD_ORDERING_LABEL').'</field>
  		<field type="textarea" name="attribs" length="50" maxlength="20" translate="0">'.JText::_('JFIELD_METADATA_ROBOTS_LABEL').'</field>
  		<field type="text" name="index_marqueur" length="50" maxlength="11" translate="0">'.JText::_('GMAPFP_MARKER').'</field>
  		<field type="text" name="classements" length="50" maxlength="255" translate="0">'.JText::_('GMAPFP_CLASSEMENTS').'</field>
  		<field type="text" name="labels" length="50" maxlength="255" translate="0">'.JText::_('GMAPFP_LABELS').'</field>
  		<field type="text" name="pictos" length="50" maxlength="255" translate="0">'.JText::_('GMAPFP_PICTOS').'</field>
';
		
		$customs = $lists['customs'];
		$ok = false;
		foreach ($lists['champs'] as $champ) {
			if ($ok) {
				switch ($customs[substr($champ->Field, 6)]->type) {
					case 0:
						if (array_key_exists($champ->Field, $post))
							$falang_gmapfp_xml .=
'  		<field type="text" name="'.$champ->Field.'" length="50" maxlength="250" translate="1">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
						else
							$falang_gmapfp_xml .=
'  		<field type="text" name="'.$champ->Field.'" length="50" maxlength="250" translate="0">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
						break;
					case 1:
						if (array_key_exists($champ->Field, $post))
						$falang_gmapfp_xml .=
'  		<field type="textarea" name="'.$champ->Field.'" rows="5" columns="90" translate="1">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
						else
						$falang_gmapfp_xml .=
'  		<field type="textarea" name="'.$champ->Field.'" rows="5" columns="90" translate="1">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
						break;
					case 2:
						if (array_key_exists($champ->Field, $post))
						$falang_gmapfp_xml .=
'  		<field type="htmltext" name="'.$champ->Field.'" rows="5" columns="80" translate="1">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
						else
						$falang_gmapfp_xml .=
'  		<field type="htmltext" name="'.$champ->Field.'" rows="5" columns="80" translate="0">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
						break;
					default :
						$falang_gmapfp_xml .=
'  		<field type="textarea" name="'.$champ->Field.'" rows="5" columns="90" translate="0">'.$customs[substr($champ->Field, 6)]->nom.'</field>
';
				}
			}
			
			if (!$ok and $champ->Field == 'pictos') $ok = true;
		}
		$falang_gmapfp_xml .=
'  	</table>
  	<component>
  		<form>com_gmapfp#gmapfp#cid#task#!edit</form>
  	</component>
  </reference>
  <translationfilters>
  	  <category>catid</category>
  	  <author>created_by</author>
  	  <keyword>nom</keyword>
  	  <published>published</published>
  	  <changed>created|modified</changed>
  	  <id>id</id>
  </translationfilters>
</joomfish>
';
		JFile::write(JPATH_ADMINISTRATOR.'/components/com_joomfish/contentelements/gmapfp.xml', $falang_gmapfp_xml);

		if (array_key_exists('ceate_all_files', $post)) {
			$falang_gmapfp_extension_type =
'<?xml version="1.0" ?>
<joomfish type="contentelement">
	<name>GMapFP : Fields</name>
	<author>Fabrice4821</author>
	<copyright>www.gmapfp.org</copyright>
	<version>1.0</version>
	<description>GMapFP Type</description>
	<reference>
		<table name="gmapfp_extension_type">
			<field type="referenceid" name="id" translate="0">ID</field>
			<field type="titletext" name="nom" translate="1">Name</field>
			<field type="text" name="description" translate="1">Description</field>
			<field type="textarea" name="parametres" translate="1">Parameters</field>
		</table>
	</reference>
	<translationfilters>
		<published>published</published>
		<id>id</id>
	</translationfilters>
</joomfish>';
			JFile::write(JPATH_ADMINISTRATOR.'/components/com_joomfish/contentelements/gmapfp_extension_type.xml', $falang_gmapfp_extension_type);
			$falang_gmapfp_personnalisation =
'<?xml version="1.0" ?>
<joomfish type="contentelement">
  <name>GMapFP : Perso</name>
  <author>Fabrice4821</author>
  <version>1.0</version>
  <description>Definition for Perso GMapFP Component</description>
  <reference>
     <table name="gmapfp_personnalisation">
      <field type="referenceid" name="id" translate="0">ID</field>
      <field type="titletext" name="nom" translate="1">Name</field>
      <field type="htmltext" name="intro_carte" translate="1">before map</field>
      <field type="htmltext" name="conclusion_carte" translate="1">after map</field>
      <field type="htmltext" name="intro_detail" translate="1">before detail</field>
      <field type="htmltext" name="conclusion_detail" translate="1">after detail</field>
     </table>
  </reference>
  <translationfilters>
    <published>published</published>
    <id>id</id>
  </translationfilters>
</joomfish>';
			JFile::write(JPATH_ADMINISTRATOR.'/components/com_joomfish/contentelements/gmapfp_personnalisation.xml', $falang_gmapfp_personnalisation);
			$falang_gmapfp_classements =
'<?xml version="1.0" ?>
<joomfish type="contentelement">
  <name>GMapFP : Classements</name>
  <author>Fabrice4821</author>
  <version>1.0</version>
  <description>Definition for rankings of GMapFP Component</description>
  <reference>
     <table name="gmapfp_classements">
      <field type="referenceid" name="id" translate="0">ID</field>
      <field type="titletext" name="nom" translate="1">Name</field>
      <field type="text" name="img" translate="1">Img</field>
     </table>
  </reference>
  <translationfilters>
    <id>id</id>
  </translationfilters>
</joomfish>';
			JFile::write(JPATH_ADMINISTRATOR.'/components/com_joomfish/contentelements/gmapfp_classements.xml', $falang_gmapfp_classements);
			$falang_gmapfp_params_custom_fields =
'<?xml version="1.0" ?>
<joomfish type="contentelement">
  <name>GMapFP : Custom</name>
  <author>Fabrice4821</author>
  <version>1.0</version>
  <description>Definition for Custom fields of GMapFP Component</description>
  <reference>
     <table name="gmapfp_params_custom_fields">
      <field type="referenceid" name="id" translate="0">ID</field>
      <field type="titletext" name="nom" translate="1">Name</field>
      <field type="text" name="items" translate="1">Items</field>
     </table>
  </reference>
  <translationfilters>
    <id>id</id>
  </translationfilters>
</joomfish>';
			JFile::write(JPATH_ADMINISTRATOR.'/components/com_joomfish/contentelements/gmapfp_params_custom_fields.xml', $falang_gmapfp_params_custom_fields);
		}
		echo JText::_( 'GMAPFP_UPDATE_OK' ).'<br />';
		die;
	}

	function josetta()
	{
		$this->input->set( 'view', 'accueil' );
		$this->input->set( 'layout', 'select'  );
		$this->input->set( 'type', 'josetta'  );
		$this->input->set( 'hidemainmenu', 0);

		parent::display();
	}

}
?>
