<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.112pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPControllerChamps extends GMapFPController
{
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'unpublish', 	'publish');
	}

	function view()
	{
		if (!JFactory::getUser()->authorise('core.edit.fields', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$this->input->set( 'view', 'champs' );
		$this->input->set( 'layout', 'liste'  );

		parent::display();
	}

	function edit()
	{
		if (!JFactory::getUser()->authorise('core.edit.fields', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$this->input->set( 'view', 'champs' );
		$this->input->set( 'layout', 'detail'  );
		$this->input->set('hidemainmenu', 1);

		parent::display();
	}

	function save()
	{
		if (!JFactory::getUser()->authorise('core.edit.fields', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$model = $this->getModel('champs');

		$returnid=$model->store();
		if ($returnid['error'] == '') {
			$msg = JText::_( 'GMAPFP_SAVED' );
			$link = 'index.php?option=com_gmapfp&controller=champs&task=view';
			$type ='message';
		} else {
			$msg = JText::_( $returnid['error'] );
			$link = 'index.php?option=com_gmapfp&controller=champs&task=edit&nom='.$returnid['nom'].'&description='.$returnid['description'].'&filtrer='.$returnid['filtrer'].'&filtre_label='.$returnid['filtre_label'].'&recherche='.$returnid['recherche'].'&type='.$returnid['type'].'&parametres='.$returnid['parametres'].'&position='.$returnid['position'].'&for_cat='.$returnid['for_cat'].'&catid='.$returnid['catid'].'&form_separator='.$returnid['form_separator'].'&view_separator='.$returnid['view_separator'].'&published='.$returnid['published'].'&access='.$returnid['access'].'&ordering='.$returnid['ordering'];
			$type = 'error';
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg, $type);
	}

	function apply()
	{
		if (!JFactory::getUser()->authorise('core.edit.fields', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$model = $this->getModel('champs');

		$returnid=$model->store();
		if ($returnid['error'] == '') {
			$msg = JText::_( 'GMAPFP_SAVED' );
			$link = 'index.php?option=com_gmapfp&controller=champs&task=edit&cid[]='.$returnid['id'];
			$type ='message';
		} else {
			$msg = $returnid['error'];
			$link = 'index.php?option=com_gmapfp&controller=champs&task=edit&nom='.$returnid['nom'].'&description='.$returnid['description'].'&filtrer='.$returnid['filtrer'].'&filtre_label='.$returnid['filtre_label'].'&recherche='.$returnid['recherche'].'&type='.$returnid['type'].'&parametres='.$returnid['parametres'].'&position='.$returnid['position'].'&form_separator='.$returnid['form_separator'].'&view_separator='.$returnid['view_separator'].'&published='.$returnid['published'].'&access='.$returnid['access'].'&ordering='.$returnid['ordering'];
			$type = 'error';
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg, $type);
	}

	function save2new()
	{
		if (!JFactory::getUser()->authorise('core.edit.fields', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$model = $this->getModel('champs');

		$returnid=$model->store();
		if ($returnid['error'] == '') {
			$msg = JText::_( 'GMAPFP_SAVED' );
			$link = 'index.php?option=com_gmapfp&controller=champs&task=edit&cid[]=0';
			$type ='message';
		} else {
			$msg = $returnid['error'];
			$link = 'index.php?option=com_gmapfp&controller=champs&task=edit&nom='.$returnid['nom'].'&description='.$returnid['description'].'&filtrer='.$returnid['filtrer'].'&filtre_label='.$returnid['filtre_label'].'&recherche='.$returnid['recherche'].'&type='.$returnid['type'].'&parametres='.$returnid['parametres'].'&position='.$returnid['position'].'&form_separator='.$returnid['form_separator'].'&view_separator='.$returnid['view_separator'].'&published='.$returnid['published'].'&access='.$returnid['access'].'&ordering='.$returnid['ordering'];
			$type = 'error';
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg, $type);
	}

	function remove()
	{
		if (!JFactory::getUser()->authorise('core.edit.fields', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$model = $this->getModel('champs');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: One or more GMapFPs could not be Deleted' );
		} else {
			$msg = JText::_( 'GMapFP(s) Deleted' );
		}

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=view', $msg );
	}

	function publish()
	{
		if (!JFactory::getUser()->authorise('core.edit.fields', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=view' );

		// Initialize variables
		$db			= JFactory::getDBO();
		$user		= JFactory::getUser();
		$cid		= $this->input->post->get( 'cid', array(), 'array' );
		$task		= $this->input->get( 'task', '', 'cmd');
		$publish	= ($task == 'publish');
		$n			= count( $cid );

		if (empty( $cid )) {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}

		JArrayHelper::toInteger( $cid );
		$cids = implode( ',', $cid );

		$query = 'UPDATE #__gmapfp_extension_type'
		. ' SET published = ' . (int) $publish
		. ' WHERE id IN ( '. $cids .' )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			return JError::raiseWarning( 500, $row->getError() );
		}
		if ($n>1)
			$this->setMessage( JText::sprintf( $publish ? 'GMAPFP_ELEMENTS_N_ITEMS_PUBLISHED' : 'GMAPFP_ELEMENTS_N_ITEMS_UNPUBLISHED', $n ) );
		else
			$this->setMessage( JText::sprintf( $publish ? 'GMAPFP_ELEMENTS_N_ITEMS_PUBLISHED_1' : 'GMAPFP_ELEMENTS_N_ITEMS_UNPUBLISHED_1', $n ) );

	}
	
	function cancel()
	{
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=view', $msg );
	}

	function traduire()
	{
		if (!JFactory::getUser()->authorise('core.edit.fields', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$this->input->set( 'view', 'champs' );
		$this->input->set( 'layout', 'traduire'  );
		$this->input->set('hidemainmenu', 1);

		parent::display();
	}

	function traduire_delete()
	{
		if (!JFactory::getUser()->authorise('core.edit.fields', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$model = $this->getModel('champs');
		if(!$model->traduire_delete()) {
			$msg = JText::_( 'Error: One or more GMapFPs could not be Deleted' );
			$type = 'error';
		} else {
			$msg = JText::_( 'GMapFP(s) Deleted' );
			$type ='message';
		}

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=view', $msg, $type );
	}

	function traduire_save()
	{
		if (!JFactory::getUser()->authorise('core.edit.fields', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$model = $this->getModel('champs');
		if(!$model->traduire_save()) {
			$msg = JText::_( 'GMAPFP_TRADUCITON_LANGUE_EXISTE' );
			$type = 'error';
		} else {
			$msg = JText::_( 'GMAPFP_SAVED' );
			$type ='message';
		}

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=view', $msg, $type );
	}

	function traduire_apply()
	{
		if (!JFactory::getUser()->authorise('core.edit.fields', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$data = JRequest::get( 'post' );
		$model = $this->getModel('champs');
		if(!$model->traduire_save()) {
			$msg = JText::Sprintf( 'GMAPFP_TRADUCITON_LANGUE_EXISTE', $data["langue"] );
			$type = 'error';
		} else {
			$msg = JText::_( 'GMAPFP_SAVED' );
			$type ='message';
		}

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=traduire&id='.$data["typeid"].'&langue='.$data["langue"], $msg, $type );
	}

	public function saveOrderAjax()
	{
		if (!JFactory::getUser()->authorise('core.edit.fields', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$pks = $this->input->post->get('cid', array(), 'array');
		$order = $this->input->post->get('order', array(), 'array');
		$orderdir = $this->input->post->get('filter_order_Dir', 'asc', 'string');

		// Sanitize the input
		JArrayHelper::toInteger($pks);
		JArrayHelper::toInteger($order);

		// Get the model
		$model  = $this->getModel('champs');

		// Save the ordering
		$return = $model->saveorder($pks, $order, $orderdir);

		if ($return)
		{
			echo "1";
		}

		// Close the application
		JFactory::getApplication()->close();
	}
}
?>
