<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.108pro
	* Creation date: Mars 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPControllerFalang extends GMapFPController
{
	function update() {
	
		$db = JFactory::getDBO();
		
		$query = 'SHOW COLUMNS FROM #__gmapfp';
		$db->setQuery( $query );
		$champs = $db->loadObjectList();
		
		$query = 'SELECT * FROM #__gmapfp_extension_type';
		$db->setQuery( $query );
		$customs = $db->loadObjectList('nom');
		
		$falang_gmapfp_xml = 
'<?xml version="1.0" ?>
<falang type="contentelement">
  <name>GMapFP : main</name>
  <author>Stphane Bouey</author>
  <version>1.0.0</version>
  <description>Definition for the core content component</description>
  <copyright>www.faboba.com</copyright>
  <reference type="content">
  	<table name="gmapfp">
  		<field type="referenceid" name="id" translate="0">ID</field>
  		<field type="titletext" name="nom"  length="50" maxlength="200" translate="1">Name</field>
  		<field type="text" name="alias"  length="50" maxlength="255" translate="1" posthandler="filterTitle">Alias</field>
  		<field type="text" name="adresse" length="50" maxlength="200" translate="1">Address</field>
  		<field type="text" name="adresse2" length="50" maxlength="200" translate="1">Address 2</field>
  		<field type="text" name="ville" length="50" maxlength="200" translate="1">Town/Suburb/City</field>
  		<field type="text" name="departement" length="50" maxlength="200" translate="1">State/County/Province</field>
  		<field type="text" name="codepostal" length="50" maxlength="80" translate="1">Postcode</field>
  		<field type="text" name="pay" length="50" maxlength="200" translate="1">Country</field>
  		<field type="text" name="email" length="50" maxlength="100" translate="1">Email</field>
  		<field type="text" name="img" length="50" maxlength="100" translate="0">Picture</field>
  		<field type="htmltext" name="introtext" translate="1" prehandleroriginal="fetchArticleText" prehandlertranslation="fetchArticleTranslation" posthandler="saveArticleText" ebuttons="ignore">Message</field>
  		<field type="hiddentext" name="fulltext" translate="1" ebuttons="readmore">Fulltext</field>
  		<field type="text" name="link" length="50" maxlength="100" translate="0">Link</field>
  		<field type="text" name="article_id" length="50" maxlength="100" translate="0">Email</field>
  		<field type="readonlytext" name="icon" length="50" maxlength="100" translate="1">Icon</field>
  		<field type="text" name="icon_label" length="50" maxlength="100" translate="1">Icon label</field>
  		<field type="text" name="glng" length="50" maxlength="30" translate="0">Longitude</field>
  		<field type="text" name="glat" length="50" maxlength="30" translate="0">Latitude</field>
  		<field type="text" name="gzoom" length="50" maxlength="2" translate="0">Zoom</field>
  		<field type="text" name="metakey" length="50" maxlength="250" translate="1">Metakey</field>
  		<field type="textarea" name="metadesc"  rows="5" columns="80" translate="1">Metadesc</field>
  		<field type="created_date" name="created" translate="0">Created</field>
  		<field type="modified_date" name="modified" translate="0">Modified</field>
';

		$ok = false;
		foreach ($champs as $champ) {
			if ($ok) {
				switch ($customs[$champ->Field]->type) {
					case 0:
						$falang_gmapfp_xml .=
'  		<field type="text" name="'.$champ->Field.'" length="50" maxlength="250" translate="1">'.$champ->Field.'</field>
';
						break;
					case 1:
						$falang_gmapfp_xml .=
'  		<field type="textarea" name="'.$champ->Field.'" rows="5" columns="80" translate="1">'.$champ->Field.'</field>
';
						break;
					case 2:
						$falang_gmapfp_xml .=
'  		<field type="htmltext" name="'.$champ->Field.'" rows="5" columns="80" translate="1">'.$champ->Field.'</field>
';
						break;
				}
			}
			
			if (!$ok and $champ->Field == 'pictos') $ok = true;
		}
		$falang_gmapfp_xml .=
'  	</table>
  	<component>
  		<form>com_gmapfp#gmapfp#cid#task#!edit</form>
  	</component>
  </reference>
  <translationfilters>
  	  <category>catid</category>
  	  <author>created_by</author>
  	  <keyword>title</keyword>
  	  <published>published</published>
  	  <changed>created|modified</changed>
  	  <id>id</id>
  </translationfilters>
</falang>
';
	
		$link = 'index.php?option=com_gmapfp&controller=accueil&task=view';
		$this->setRedirect($link, $msg);
	
	}
}
?>