<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.112pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPControllerPersonnalisation extends GMapFPController
{
	function __construct()
	{
		parent::__construct();

	}

	function edit()
	{
		if (!JFactory::getUser()->authorise('core.edit.perso', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
			
		$this->input->set( 'view', 'personnalisation' );
		$this->input->set( 'layout', 'form'  );

		parent::display();
	}

	function apply()
	{
		if (!JFactory::getUser()->authorise('core.edit.perso', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
			
		$post	= JRequest::get('post');
		$model = $this->getModel('personnalisation');
		$returnid=$model->store($post);
		if ($returnid>0) {
			$msg = JText::_( 'GMAPFP_SAVED' );
		} else {
			$msg = JText::_( 'GMAPFP_SAVED_ERROR' );
		}

		$link = 'index.php?option=com_gmapfp&controller=personnalisation&task=edit';
		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg);
	}

	function remove()
	{
		if (!JFactory::getUser()->authorise('core.edit.perso', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
			
		$model = $this->getModel('personnalisation');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: One or more GMapFPs could not be Deleted' );
		} else {
			$msg = JText::_( 'GMapFP(s) Deleted' );
		}

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=personnalisation&task=edit', $msg );
	}
	
	function cancel()
	{
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_gmapfp&controller=personnalisation&task=edit', $msg );
	}

}
?>
