<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.112pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPControllerPersonnalisations extends GMapFPController
{
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks
		$this->registerTask( 'add', 'edit' );
		$this->registerTask( 'unpublish', 	'publish');
	}

	function view()
	{
		if (!JFactory::getUser()->authorise('core.edit.perso', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
			
		$this->input->set( 'view', 'personnalisations' );
		$this->input->set( 'layout', 'liste'  );

		parent::display();
	}

	function edit()
	{
		if (!JFactory::getUser()->authorise('core.edit.perso', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
			
		$this->input->set( 'view', 'personnalisations' );
		$this->input->set( 'layout', 'detail'  );
		$this->input->set('hidemainmenu', 1);

		parent::display();
	}

	function save()
	{
		if (!JFactory::getUser()->authorise('core.edit.perso', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
			
		$post	= JRequest::get('post');
		$model = $this->getModel('personnalisations');
		$returnid=$model->store($post);
		if ($returnid>0) {
			$msg = JText::_( 'GMAPFP_SAVED' );
		} else {
			$msg = JText::_( 'GMAPFP_SAVED_ERROR' );
		}

		$link = 'index.php?option=com_gmapfp&controller=personnalisations&task=view';
		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg);
	}

	function apply()
	{
		if (!JFactory::getUser()->authorise('core.edit.perso', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
			
		$post	= JRequest::get('post');
		$model = $this->getModel('personnalisations');
		$returnid=$model->store($post);
		if ($returnid>0) {
			$msg = JText::_( 'GMAPFP_SAVED' );
		} else {
			$msg = JText::_( 'GMAPFP_SAVED_ERROR' );
		}

		$link = 'index.php?option=com_gmapfp&controller=personnalisations&task=edit&cid[]='.(int)$returnid;
		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg);
	}

	function remove()
	{
		if (!JFactory::getUser()->authorise('core.edit.perso', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
			
		$model = $this->getModel('personnalisations');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: One or more GMapFPs could not be Deleted' );
		} else {
			$msg = JText::_( 'GMapFP(s) Deleted' );
		}

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=personnalisations&task=view', $msg );
	}

	function publish()
	{
		if (!JFactory::getUser()->authorise('core.edit.perso', 'com_gmapfp'))
			return JFactory::getApplication()->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
			
		$this->setRedirect( 'index.php?option=com_gmapfp&controller=personnalisations&task=view' );

		// Initialize variables
		$db			= JFactory::getDBO();
		$user		= JFactory::getUser();
		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$task		= JRequest::getCmd( 'task' );
		$publish	= ($task == 'publish');
		$n			= count( $cid );

		if (empty( $cid )) {
			return JFactory::getApplication()->enqueueMessage(JText::_( 'No items selected' ), 'error');
		}

		JArrayHelper::toInteger( $cid );
		$cids = implode( ',', $cid );

		$query = 'UPDATE #__gmapfp_personnalisation'
		. ' SET published = ' . (int) $publish
		. ' WHERE id IN ( '. $cids .' )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			return JFactory::getApplication()->enqueueMessage($row->getError(), 'error');
		}
		if ($n>1)
			$this->setMessage( JText::sprintf( $publish ? 'GMAPFP_ELEMENTS_N_ITEMS_PUBLISHED' : 'GMAPFP_ELEMENTS_N_ITEMS_UNPUBLISHED', $n ) );
		else
			$this->setMessage( JText::sprintf( $publish ? 'GMAPFP_ELEMENTS_N_ITEMS_PUBLISHED_1' : 'GMAPFP_ELEMENTS_N_ITEMS_UNPUBLISHED_1', $n ) );

	}
	
	function cancel()
	{
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_gmapfp&controller=personnalisations&task=view', $msg );
	}

}
?>
