<?php
	/*
	* GMapFP plugin for Updated
	* Version J3.116pro
	* Creation date: Mai 2018
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

/**
 * Joomla! master extension plugin.
 *
 * @since  1.6
 */
class PlgExtensionGMapFP extends JPlugin
{
	/**
	 * @var    integer Extension Identifier
	 * @since  1.6
	 */
	private $eid = 0;

	/**
	 * @var    JInstaller Installer object
	 * @since  1.6
	 */
	private $installer = null;

	/**
	 * Load the language file on instantiation.
	 *
	 * @var    boolean
	 * @since  3.1
	 */
	protected $autoloadLanguage = true;

	//Ajoute le clé de mise à jour dans la table concernée.
	public function onExtensionAfterSave($context, $table)
	{
		if ($context == "com_config.component" and $table->name == "COM_GMAPFP") {
			
			$params = json_decode($table->params);
			$db = JFactory::getDbo();
			
			// Look if the location is used already; doesn't matter what type you can't have two types at the same address, doesn't make sense
			$query = $db->getQuery(true)
				->select('MAX('.$db->quoteName('update_site_id').')')
				->from($db->quoteName('#__update_sites_extensions', 'a'))
				->join('INNER', $db->quoteName('#__extensions', 'b') . ' ON (' . $db->quoteName('a.extension_id') . ' = ' . $db->quoteName('b.extension_id') . ')')
    			->where($db->quoteName('b.type') . ' = ' . $db->quote('component') . ' AND ' . $db->quoteName('b.name') . ' = ' . $db->quote('com_gmapfp'));
			$db->setQuery($query);
			$update_site_id = (int) $db->loadResult();
			
			//verifie si de vieux site de mise à jour existe dans la base
			$query = $db->getQuery(true)
				->select($db->quoteName('update_site_id'))
				->from($db->quoteName('#__update_sites_extensions', 'a'))
				->join('INNER', $db->quoteName('#__extensions', 'b') . ' ON (' . $db->quoteName('a.extension_id') . ' = ' . $db->quoteName('b.extension_id') . ')')
    			->where($db->quoteName('b.type') . ' = ' . $db->quote('component') . ' AND ' . $db->quoteName('b.name') . ' = ' . $db->quote('com_gmapfp') . ' AND ' . $db->quoteName('a.update_site_id') . ' <> ' . $update_site_id);
			$db->setQuery($query);
			$old_update_site_ids = $db->loadColumn();
			
			//supprime les anciens liens de mise à jour
			if (!empty($old_update_site_ids)) {
				foreach($old_update_site_ids as $old_update_site_id) {
					$query = $db->getQuery(true)
						->delete($db->quoteName('#__update_sites_extensions'))
						->where($db->quoteName('update_site_id') . ' = ' . $old_update_site_id);
					$db->setQuery($query);
					$result = $db->execute();
				}
			}
			
			// Check if it has an update site id (creation might have faileD)
			if ($update_site_id)
			{
				// Fields to update.
				$fields = array(
					$db->quoteName('extra_query') . ' = ' . $db->quote('key='.$params->gmapfp_update_key)
				);

				// Conditions for which records should be updated.
				$conditions = array(
					$db->quoteName('update_site_id') . ' = ' . $db->quote($update_site_id)
				);
				
				// Link this extension to the relevant update site
				$query->clear()
					->update($db->quoteName('#__update_sites'))->set($fields)->where($conditions);
				$db->setQuery($query);
				$db->execute();
			}
		}
	}

}