<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.95pro
	* Creation date: Mai 2016
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPHelper
{

	public static function addSubmenu($vName = 'accueil')
	{
		$canDo	= self::getActions();

		JHtmlSidebar::addEntry(
			JText::_('GMAPFP_ACCUEIL'),
			'index.php?option=com_gmapfp&controller=accueil&task=view',
			$vName == 'accueil'
		);

		JHtmlSidebar::addEntry(
			JText::_('GMAPFP_LIEUX'),
			'index.php?option=com_gmapfp&controller=gmapfp&task=view',
			$vName == 'gmapfp'
		);

		if ($canDo->get('core.edit.fields'))
			JHtmlSidebar::addEntry(
				JText::_('GMAPFP_CHAMPS'),
				'index.php?option=com_gmapfp&controller=champs&task=view',
				$vName == 'champs'
			);

		if ($canDo->get('core.edit.markers'))
			JHtmlSidebar::addEntry(
				JText::_('GMAPFP_MARQUEURS'),
				'index.php?option=com_gmapfp&controller=marqueurs&task=view',
				$vName == 'marqueurs'
			);

		if ($canDo->get('core.edit.classements'))	
			JHtmlSidebar::addEntry(
				JText::_('GMAPFP_CLASSEMENTS'),
				'index.php?option=com_gmapfp&controller=classements&task=view',
				$vName == 'classements'
			);

		JHtmlSidebar::addEntry(
			JText::_('JCATEGORIES'),
			'index.php?option=com_categories&extension=com_gmapfp',
			$vName == 'categories'
		);
		if ($vName=='categories') {
			JToolBarHelper::title(
				JText::sprintf('COM_CATEGORIES_CATEGORIES_TITLE',JText::_('COM_GMAPFP')),
				'banners-categories');
		}

		if ($canDo->get('core.edit.perso'))
			JHtmlSidebar::addEntry(
				JText::_('GMAPFP_PERSONNALISATION'),
				'index.php?option=com_gmapfp&controller=personnalisations&task=view',
				$vName == 'personnalisations'
			);

		if (defined('COM_GMAPFP_VERSION_OT') and COM_GMAPFP_VERSION_OT) {
			JHtmlSidebar::addEntry(
				JText::_('GMAPFP_PHOTOS'),
				'index.php?option=com_gmapfp&controller=photos&task=view',
				$vName == 'photos'
			);
		}

		if ($canDo->get('core.admin'))
			JHtmlSidebar::addEntry(
				JText::_('CSS'),
				'index.php?option=com_gmapfp&controller=css&task=view',
				$vName == 'css'
			);

		if (defined('COM_GMAPFP_VERSION_CSV') and COM_GMAPFP_VERSION_CSV) {
			JHtmlSidebar::addEntry(
				JText::_('GMAPFP_IMPORT_EXPORT'),
				'index.php?option=com_gmapfp&controller=csv&task=view',
				$vName == 'csv'
			);
		}
	}

	public static function getActions($categoryId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($categoryId)) {
			$assetName = 'com_gmapfp';
		} else {
			$assetName = 'com_gmapfp.category.'.(int) $categoryId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.own', 'core.edit.state', 'core.delete', 'core.edit.fields', 'core.edit.markers', 'core.edit.classements', 'core.edit.perso'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}
}
