<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.122pro
	* Creation date: Juillet 2019
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined( '_JEXEC' ) or die;

class GMapFPRenderProcess
{	
	static function getProcessPage ( $filename, $courent_folder, $courent_file, $refresh_url, $folders, $files, $thumbs_text, $errorMsg = '' ) {
		
		echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' . "\n";
		echo '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-en" lang="en-en" dir="ltr" >'. "\n";
		echo '<head>'. "\n";
		echo '<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />'. "\n\n";
		echo '<title>'.$thumbs_text.'</title>'. "\n";
		echo '</head>'. "\n";
		echo '<body>'. "\n";
		echo '<div style="background:url('.JUri::root().'administrator/components/com_gmapfp/images/gmapfp_logo.png) no-repeat;height: 150px;position: fixed;top: 0;left: 0;width: 232px;"></div>'. "\n";
		echo '<center><div style="width:70%;border:5px solid #0000CC; margin-top:30px;font-family: sans-serif, Arial;font-weight:normal;color:#666;font-size:14px;padding:10px">';
		echo '<span>'.$thumbs_text.'</span><br /><span style="font-size:200%;">'.JText::_( 'GMAPFP_WAIT' ). '</span>';
		
		if ( $errorMsg == '' ) {
			echo '<p>' .$thumbs_text 
			.' <span style="color:#0066cc;">'. $filename . '</span>' 
			.' ... <b style="color:#009900">'.JText::_( 'OK' ).'</b></p>';
		} else {
			echo '<p>' .$thumbs_text 
			.' <span style="color:#0066cc;padding:0;margin:0"> '. $filename . '</span>' 
			.' ... <b style="color:#fc0000">'.JText::_( 'Error' ).'</b></p>';
			
		}
	
		// Creation bars de progresion fichiers
		$perfiles = 0; // display percents
		if ($files > 0) {
			$perfiles = round(($courent_file / $files)*100, 0);
		}
		$perCSS = ($perfiles * 400/100) - 400;
		$bgCSSfiles = 'background: url(\''.JURI::base(true).'/components/com_gmapfp/images/process.jpg\') '.$perCSS.'px 0 repeat-y;';
		
		// Creation bars de progresion repertoires
		$perfolders = 0; // display percents
		if ($folders > 0) {
			$perfolders = round(((($courent_folder / $folders)*100) + ((($courent_file / $files)*100) * (1 / $folders))), 0);
		}
		$perCSS = ($perfolders * 400/100) - 400;
		$bgCSSfolders = 'background: url(\''.JURI::base(true).'/components/com_gmapfp/images/process.jpg\') '.$perCSS.'px 0 repeat-y;';
		
		// BEGIN -----------------------------------------------------------------------
		echo '<p><span style="color:#0066cc">'. ($courent_folder + 1) .'</span> '.JText::_('GMAPFP_FROM'). ' <span style="color:#0066cc">'. $folders .'</span> '.JText::_('GMAPFP_FOLDER').'</p>';
		
		echo '<span style="font-size:10px;font-weight:bold">'.$perfolders.' &#37;</span><div style="width:400px;height:20px;font-size:20px;border-top:2px solid #666;border-left:2px solid #666;border-bottom:2px solid #ccc;border-right:2px solid #ccc;'.$bgCSSfolders.'"></div>';
		// END -------------------------------------------------------------------------

		// BEGIN -----------------------------------------------------------------------
		echo '<p>' . JText::_('GMAPFP_CREATION'). ': <span style="color:#0066cc">'. $courent_file .'</span> '.JText::_('GMAPFP_FROM'). ' <span style="color:#0066cc">'. $files .'</span> '.JText::_('GMAPFP_FILE').'</p>';
		
		echo '<span style="font-size:10px;font-weight:bold">'.$perfiles.' &#37;</span><div style="width:400px;height:20px;font-size:20px;border-top:2px solid #666;border-left:2px solid #666;border-bottom:2px solid #ccc;border-right:2px solid #ccc;'.$bgCSSfiles.'"></div>';
		// END -------------------------------------------------------------------------

		if ( $errorMsg != '' ) {
			$errorMessage = JText::_('GMAPFP_ERROR_THUMBS') . ' ('.$errorMsg.')';
			
			echo '<div style="text-align:left;margin: 10px 5px">';
			echo '<table border="0" cellpadding="7"><tr><td>'.JText::_('GMAPFP_ERROR_MESSAGE').':</td><td><span style="color:#fc0000">'.$errorMessage.'</span></td></tr>';
			
			echo '<tr><td colspan="1" rowspan="4" valign="top" >'.JText::_('GMAPFP_QUOI_FAIRE').' :</td>';
			
			echo '<td>&raquo; ' .JText::_( 'GMAPFP_PISTES_PB' ).' <br /><ul><li>'.JText::_( 'GMAPFP_SOLUTION_IMAGE' ).'</li><li>'.JText::_( 'GMAPFP_SOLUTION_GD' ).'</li><li>'.JText::_( 'GMAPFP_SOLUTION_PERMISSION' ).'</li></ul>'.JText::_( 'GMAPFP_SOLUTION_END' ).'<br /> <a href="'.$refresh_url.'&&courent_folder='.$courent_folder.'&courent_file='.$courent_file.'">' .JText::_( 'Next' ).'</a><hr /></td></tr>';
							
			echo '<tr><td>&raquo; ' .JText::_( 'GMAPFP_MEDIA_MANAGER_SOLUTION' ).' <br /> <a href="index.php?option=com_media">' .JText::_( 'GMAPFP_MEDIA_MANAGER_LINK' ).'</a><hr /></td></tr>';
			
			echo '</table>';
			echo '</div>';
			
			echo '</div></center></body></html>';
			exit;
		}
		
		echo '<meta http-equiv="refresh" content="0;url='.$refresh_url.'&courent_folder='.$courent_folder.'&courent_file='.$courent_file.'" />';
		
		echo '</div></center></body></html>';
		exit;
	}
	
	static function getProcessLatLng ( $courent_id, $total_id, $courent_count, $refresh_url, $message, $adresse, $errorMsg='') {
		
		$params	= JComponentHelper::getParams('com_gmapfp');
		$key = trim($params->get('gmapfp_google_key'));

		echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' . "\n";
		echo '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-en" lang="en-en" dir="ltr" >'. "\n";
		echo '<head>'. "\n";
		echo '<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />'. "\n\n";
		echo '<title>'.JText::_( 'GMAPFP_RECHERCHE_LAT_LNT' ).'</title>'. "\n";
		echo '<meta name="viewport" content="initial-scale=1.0, user-scalable=no" />
			<script type="text/javascript"
				src="https://maps.googleapis.com/maps/api/js?key='.$key.'">
			</script>
			
			<script type="text/javascript">
				var map;
				var geocoder;
				var lat_coordonnes;
				var lng_coordonnes;
				var total_function;
				var url;

				function initialize() {
					geocoder = new google.maps.Geocoder();
					var mapOptions = {
					center: new google.maps.LatLng(0, 0),
					zoom: 8
					};
					map = new google.maps.Map(document.getElementById("map-canvas"),
						mapOptions);

					google.maps.event.addListenerOnce(map, \'tilesloaded\', function(){
						auto_exec_geocode();
					});


					// Create a draggable marker which will later on be binded to a
					marker1 = new google.maps.Marker({
						map: map,
						position: new google.maps.LatLng(0, 0),
						draggable: true,
						title: \'Drag me!\'
					});
					google.maps.event.addListener(marker1, "drag", function() {
						document.getElementById("lat").value = marker1.getPosition().lat();
						lat_coordonnes = marker1.getPosition().lat();
						document.getElementById("lng").value = marker1.getPosition().lng();
						lng_coordonnes = marker1.getPosition().lng();
						document.getElementById("bp_save").style.display=\'inline-block\';
					});


				}
				
				function auto_exec_geocode(){
					total_function = true;
					codeAddress();
				}
				
				function codeAddress() {
					var address = document.getElementById(\'address\').value;
					geocoder.geocode( { \'address\': address}, function(results, status) {
						if (status == google.maps.GeocoderStatus.OK) {
							document.getElementById("lat").value = results[0].geometry.location.lat();
							lat_coordonnes = results[0].geometry.location.lat();
							document.getElementById("lng").value = results[0].geometry.location.lng();
							lng_coordonnes = results[0].geometry.location.lng();
							map.setCenter(results[0].geometry.location);
							marker1.setPosition(results[0].geometry.location);
							url = "'.JURI::base(true).'/'.$refresh_url.'&courent_id='.$courent_id.'&total_id='.$total_id.'&courent_count='.$courent_count.'&lat=";
							url = url + lat_coordonnes + "&lng=" + lng_coordonnes;
							if (total_function) setTimeout(function(){document.location.href = url;}, 100);
							if (!total_function && (lat_coordonnes > 0) && (lng_coordonnes >0)) document.getElementById("bp_save").style.display=\'inline-block\';
						} else {	
							document.getElementById("error_div").style.display=\'block\';
							document.getElementById("bp_geocode").style.display=\'inline-block\';
							document.getElementById("error_message").innerHTML = status;
							total_function = false;
							document.getElementById("bp_save").style.display=\'none\';
							map.setZoom(1);
						}
					});
				};
				
				function save_lat_lng() {
					document.location.href = url;
				}
	
				google.maps.event.addDomListener(window, \'load\', initialize);
		
			</script>		
		';
		echo '</head>'. "\n";
		echo '<body>'. "\n";
		echo '<div style="background:url('.JUri::root().'administrator/components/com_gmapfp/images/gmapfp_logo.png) no-repeat;height: 150px;position: fixed;top: 0;left: 0;width: 232px;"></div>'. "\n";
		echo '<center><div style="width:70%;border:5px solid #0000CC; margin-top:30px;font-family: sans-serif, Arial;font-weight:normal;color:#666;font-size:14px;padding:10px">';
		echo '<br/><span>'.JText::_( 'GMAPFP_RECHERCHE_LAT_LNT' ).'</span><br /><span style="font-size:200%;">'.JText::_( 'GMAPFP_WAIT' ). '</span>';
		
		if ( $errorMsg == '' ) {
			echo '<p>' 
			.' <span style="color:#0066cc;">'. $message . '</span>' 
			.' ... <b style="color:#009900">'.JText::_( 'OK' ).'</b></p>';
		} else {
			echo '<p>' 
			.' <span style="color:#0066cc;padding:0;margin:0"> '. $message . '</span>' 
			.' ... <b style="color:#fc0000">'.JText::_( 'Error' ).'</b></p>';
			
		}
	
		// Creation bars de progresion fichiers
		$perfiles = 0; // display percents
		if ($total_id > 0) {
			$perfiles = round(($courent_count / $total_id)*100, 0);
		}
		$perCSS = ($perfiles * 400/100) - 400;
		$bgCSSfiles = 'background: url(\''.JURI::base(true).'/components/com_gmapfp/images/process.jpg\') '.$perCSS.'px 0 repeat-y;';
		
		// BEGIN -----------------------------------------------------------------------
		echo '<p>' . JText::_('GMAPFP_RECHERCHE_DE'). ': <span style="color:#0066cc">'. $courent_count .'</span> '.JText::_('GMAPFP_FROM'). ' <span style="color:#0066cc">'. $total_id .'</span></p>';
		
		echo '<span style="font-size:10px;font-weight:bold">'.$perfiles.' &#37;</span><div style="width:400px;height:20px;font-size:20px;border-top:2px solid #666;border-left:2px solid #666;border-bottom:2px solid #ccc;border-right:2px solid #ccc;'.$bgCSSfiles.'"></div>';
		// END -------------------------------------------------------------------------

		echo '
			<div id="panel">
				'.JText::_( 'GMAPFP_ADRESSE' ).' <input style="width:400px;" id="address" type="textbox" value="'.$adresse.'">
				<input style="display:none;" id="bp_geocode" type="button" value="'.JText::_( 'GMAPFP_GEOCODE' ).'" onclick="total_function = false; codeAddress();"><br/>
				Lat : <input id="lat" type="textbox" value="">
				Lng : <input id="lng" type="textbox" value="">
				<input style="display:none;" id="bp_save" type="button" value="'.JText::_( 'JAPPLY' ).'" onclick="save_lat_lng();">
			</div>
			<div id="map-canvas" style="height:300px;"></div>
		';
		
		echo '<div id="error_div" style="text-align:left;margin: 10px 5px; display:none;">';
		echo '<table border="0" cellpadding="7"><tr><td>'.JText::_('GMAPFP_ERROR_MESSAGE').':</td><td><span id="error_message" style="color:#fc0000"></span></td></tr>';
		
		echo '<tr><td colspan="1" rowspan="4" valign="top" >'.JText::_('GMAPFP_QUOI_FAIRE').' :</td>';
		
		echo '<tr><td>' .JText::_( 'GMAPFP_LAT_LNG_MANAGER_SOLUTION' ).'<br/><br/>
			<a href="index.php?option=com_gmapfp&controller=gmapfp&task=edit&cid[]='.$courent_id.'" target="_blank">' .JText::_( 'GMAPFP_LAT_LNG_MANAGER_LINK' ).'</a><br/><br/>
			<a href="'.$refresh_url.'&&courent_id='.$courent_id.'&total_id='.$total_id.'&courent_count='.$courent_count.'">' .JText::_( 'GMAPFP_LAT_LNG_NEXT_LINK' ).'</a>
			</td></tr>';
		
		echo '</table>';
		echo '</div>';
		
		echo '</div></center></body></html>';
		exit;
	}
	
	static function getProcessSEF ($nbre_ids, $courent_id, $refresh_url, $return_url, $nombre_ids_traites = 100) {
		
		echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' . "\n";
		echo '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-en" lang="en-en" dir="ltr" >'. "\n";
		echo '<head>'. "\n";
		echo '<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />'. "\n\n";
		echo '<title>check_GMapFP_SEF</title>'. "\n";
		echo '</head>'. "\n";
		echo '<body>'. "\n";
		echo '<div style="background:url('.JUri::root().'administrator/components/com_gmapfp/images/gmapfp_logo.png) no-repeat;height: 150px;position: fixed;top: 0;left: 0;width: 232px;"></div>'. "\n";
		echo '<center><div style="width:70%;border:5px solid #0000CC; margin-top:30px;font-family: sans-serif, Arial;font-weight:normal;color:#666;font-size:14px;padding:10px">';
		echo '<span>'.JText::_( 'GMAPFP_SEF_CALCUL' ).' ('.$nbre_ids.')</span><br /><span style="font-size:200%;">'.JText::_( 'GMAPFP_WAIT_SEF' ). '</span><br/>';
		
		// Creation bars de progresion fichiers
		$perfiles = 0; // display percents
		if ($nbre_ids > 0) {
			$perfiles = round(($courent_id / $nbre_ids)*100, 0);
		}
		$perCSS = ($perfiles * 400/100) - 400;
		$bgCSSfiles = 'background: url(\''.JURI::base(true).'/administrator/components/com_gmapfp/images/process.jpg\') '.$perCSS.'px 0 repeat-y;';
			
		// BEGIN -----------------------------------------------------------------------
		echo '<span style="font-size:10px;font-weight:bold">'.$perfiles.' &#37;</span><div style="width:400px;height:20px;font-size:20px;border-top:2px solid #666;border-left:2px solid #666;border-bottom:2px solid #ccc;border-right:2px solid #ccc;'.$bgCSSfiles.'"></div>';
		// END -------------------------------------------------------------------------

		echo '<meta http-equiv="refresh" content="0;url='.$refresh_url.'&courent_id='.($courent_id + $nombre_ids_traites).'&nbre_ids='.$nbre_ids.'&return_url='.$return_url.'" />';
		
		echo '</div></center></body></html>';
		exit;
	}
	
}
?>