<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.125pro
	* Creation date: Dcembre 2020
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPModelChamps extends JModelLegacy
{
    var $_data;
    var $_list;
    var $_total;
	var $nbre_type_champ = 37; // si ajout, ne pas oublier de voir fct "store"
	var $nbre_position_champ = 9;
    
    function __construct()
    {
        parent::__construct();

		$app = JFactory::getApplication(); 
		$option    = $app->input->get('option', '', 'WORD'); 
        $controller = $app->input->get('controller', '', 'WORD');

        $array = $app->input->get('cid', array(0), 'ARRAY');
		if (array_key_exists(0, $array))
			$this->setId((int)$array[0]);
            
        $limit      = $app->getUserStateFromRequest( $option.$controller.'limit', 'limit', $app->getCfg('list_limit'), 'int');
        $limitstart = $app->getUserStateFromRequest( $option.$controller.'limitstart', 'limitstart', 0, 'int' );

        // In case limit has been changed, adjust limitstart accordingly
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

    
        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);
    }

    function _buildQuery()
    {
        $query = ' SELECT a.*, b.title as access_name'
            . ' FROM #__gmapfp_extension_type a '
			. ' LEFT JOIN #__viewlevels b ON b.id = a.access '
			. $this->_QueryOrder()
        ;

        return $query;
    }

    function setId($id)
    {
        $this->_id      = $id;
        $this->_data    = null;
    }

    function getList()
    {
        if (empty( $this->_list ))
        {
            $query = $this->_buildQuery();
            $results = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit'));
        }
		foreach ($results as $result) {
			$query = ' SELECT langue '
				. ' FROM #__gmapfp_extension_lang '
				. 'WHERE typeid = '.$result->id;
            $this->_db->setQuery( $query );
			$lien = '';
            $langues = $this->_db->loadObjectList();
			//if ($langues) die(print_r($langues));
			if ($langues)
			foreach ($langues as $langue) {
				$lien .= '<a href="index.php?option=com_gmapfp&controller=champs&task=traduire&id='.$result->id.'&langue='.$langue->langue.'">'.$langue->langue.'</a> ; ';
			}
			$result->langue = $lien;
		}
		
		$this->_list = $results;
        return $results;
    }
    
    function getList_all()
    {
        if (empty( $this->_list_all ))
        {
            $query = $this->_buildQuery();
            $results = $this->_getList( $query);
        }
		
		$this->_list_all = $results;
        return $results;
    }
    
    function getData()
    {
        if (empty( $this->_data )) {
            $query = ' SELECT * FROM #__gmapfp_extension_type '.
                    '  WHERE id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();
        }
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->nom = null;
            $this->_data->alias = null;
            $this->_data->description = null;
            $this->_data->filtrer = 0;
            $this->_data->filtre_label = null;
            $this->_data->rechercher = 0;
            $this->_data->type = null;
            $this->_data->parametres = null;
            $this->_data->position = null;
            $this->_data->for_cat = 0;
            $this->_data->catid = null;
            $this->_data->form_separator = null;
            $this->_data->view_separator = null;
            $this->_data->published = null;
            $this->_data->access = 1;
            $this->_data->ordering = null;
            $this->_data->required = null;
        }

        return $this->_data;
    }
    
    function _QueryOrder() {
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 
        $controller = JRequest::getWord('controller');
        
        $filter_order       = $mainframe->getUserStateFromRequest( $option.$controller.'filter_order', 'filter_order', 'nom', 'string' );
        $filter_order_Dir   = $mainframe->getUserStateFromRequest( $option.$controller.'filter_order_Dir', 'filter_order_Dir', '', 'word' );
        
		if ( $filter_order == 'a.ordering')
			$order = 'ORDER BY a.position '.$filter_order_Dir. ', a.ordering';
		else
			$order = 'ORDER BY '.$filter_order.' '.$filter_order_Dir;
		
        return $order;
    }

    function getPagination()
    {
        if (empty($this->_pagination))
        {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
        }

        return $this->_pagination;
    }       
    
    function getTotal()
    {
        if (empty($this->_total))
        {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }

        return $this->_total;
    }

    function getListChamps($selected = 0)
    {
		$items = array();
		
		for($i = 0; $i <= $this->nbre_type_champ; $i++) {
			$alias = JFilterOutput::stringURLSafe(JText::_( 'GMAPFP_CHAMP_TYPE'.$i ));
			if ($i != 13)
				$items[$alias] = JHTML::_('select.option', $i, JText::_( 'GMAPFP_CHAMP_TYPE'.$i ) );
			else
				if (file_exists(JPATH_ADMINISTRATOR.('/components/com_calendar_gmapfp')))
					$items[$alias] = JHTML::_('select.option', $i, JText::_( 'GMAPFP_CHAMP_TYPE'.$i ) );
		}
		ksort($items);
		$list = JHTML::_('select.genericlist', $items, 'type', 'size="5" class="inputbox input-xxlarge" onchange="ActualiseParametres();"', 'value', 'text', $selected);
        return $list;
    }

    function getPositionChamps($selected = 0)
    {
		$items = array();
		
		for($i = 0; $i < $this->nbre_position_champ; $i++) {
			$items[] = JHTML::_('select.option', $i, JText::_( 'GMAPFP_CHAMP_POSITION'.$i ) );
		}
		//ajoute les champs "onglet"
		$query = ' SELECT id, nom FROM #__gmapfp_extension_type '.
				' WHERE type = 14 AND published = 1'.
				' ORDER BY ordering';
		$this->_db->setQuery( $query );
		$results = $this->_db->loadObjectList();
		if ($results)
			foreach ($results as $result) {
				$items[] = JHTML::_('select.option', '-'.$result->id, $result->nom );
			}
		
		$list = JHTML::_('select.genericlist', $items, 'position', 'size="1" class="inputbox"', 'value', 'text', $selected);
        return $list;
    }

    function store()
    {
        $row = $this->getTable('Champs', 'GMapFPTable');
        $data = JRequest::get( 'post' );
		$data['parametres'] = JRequest::getVar( 'parametres', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$data['field_separator'] = JRequest::getVar( 'field_separator', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$data['form_separator'] = JRequest::getVar( 'form_separator', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$data['view_separator'] = JRequest::getVar( 'view_separator', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$data['catid'] = JRequest::getVar( 'catid', array(), 'post', 'array' );
		$data['catid'] = implode(',', $data['catid']);
		$data['error'] = '';

		if ($data['id']) {
			$query = ' SELECT * FROM #__gmapfp_extension_type '.
                    '  WHERE id = '.$data['id'];
            $this->_db->setQuery( $query );
            $old_value = $this->_db->loadObject();
		}
		
		if ($data['type'] == 14) $data['position'] = 0;
		if ($data['type'] == 9) {
			$data['filtrer'] = $data['filtrer_module'];
			$data['filtre_label'] = $data['filtre_label_module'];
		}

        if (!$row->bind($data)) {
			$data['error'] = $this->setError($this->_db->getErrorMsg());
			return $data;
        }

        if (!$row->check()) {
			$data['error'] = $this->setError($this->_db->getErrorMsg());
			return $data;
        }

        if (!$row->store()) {
			$data['error'] = $this->setError($this->_db->getErrorMsg());
			return $data;
        }
		
		//Insertion du champ dans la table gmapfp ou met  jour le type
		if (!$data['id']) {
			switch ($row->type) {
				case 0 :
				case 1 :
				case 2 :
				case 3 :
				case 6 :
				case 7 :
				case 8 :
				case 10 :
				case 17 :
				case 20 :
					$query = ' ALTER TABLE  `#__gmapfp` '.
							'ADD  `field_'.$row->id.'` '.
							'TEXT NOT NULL';
					break;
				case 4 :
				case 5 :
				case 11 :
				case 12 :
				case 16 :
				case 19 :
					$query = ' ALTER TABLE  `#__gmapfp` '.
							'ADD  `field_'.$row->id.'` '.
							'VARCHAR( 250 ) NOT NULL';
					break;
				case 9 :
				case 15 :
					$query = ' ALTER TABLE  `#__gmapfp` '.
							'ADD  `field_'.$row->id.'` '.
							'DATETIME NOT NULL';
					break;
				case 13 :
				case 14 :
				case 18 :
					$query = ' ALTER TABLE  `#__gmapfp` '.
							'ADD  `field_'.$row->id.'` '.
							'INT(11) UNSIGNED NOT NULL';
					break;
			}
			//test si il s'agit d'un champ de repositionnement
			if(!in_array($row->type, array(21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37))) {
				$this->_db->setQuery( $query );
				$this->_db->query();
			}
		} else {
			if ($old_value->type != $row->type) {
				if (($row->type == 13 or $row->type == 14 or $row->type == 18) and ($old_value->type != 13 and $old_value->type != 14 and $old_value->type != 18)) {
					$query = ' ALTER TABLE `#__gmapfp` '.
							'CHANGE `field_'.$old_value->id.'` `field_'.$row->id.'` '.
							'INT(11) UNSIGNED NOT NULL';
					$this->_db->setQuery( $query );
					$this->_db->query();
				}
				if (($row->type == 9 or $row->type == 15) and ($old_value->type != 9 and $old_value->type != 15)) {
					$query = ' ALTER TABLE `#__gmapfp` '.
							'CHANGE `field_'.$old_value->id.'` `field_'.$row->id.'` '.
							'DATETIME NOT NULL';
					$this->_db->setQuery( $query );
					$this->_db->query();
				}
				if (($row->type == 4 or $row->type == 5 or $row->type == 11 or $row->type == 12 or $row->type == 16 or $row->type == 19) 
					and ($old_value->type != 4 and $old_value->type != 5 and $old_value->type != 11 and $old_value->type != 12  and $old_value->type != 16  and $old_value->type != 19)) {
					$query = ' ALTER TABLE `#__gmapfp` '.
							'CHANGE `field_'.$old_value->id.'` `field_'.$row->id.'` '.
							'VARCHAR( 250 ) NOT NULL';
					$this->_db->setQuery( $query );
					$this->_db->query();
				}
				if (($row->type == 0 or $row->type == 1 or $row->type == 2 or $row->type == 3 or $row->type == 6 or $row->type == 7 or $row->type == 8 or $row->type == 10 or $row->type == 17 or $row->type == 20) 
					and ($old_value->type != 0 and $old_value->type != 1 and $old_value->type != 2 and $old_value->type != 3 and $old_value->type != 6 and $old_value->type != 7 and $old_value->type != 8 and $old_value->type != 10 and $old_value->type != 17 and $old_value->type != 20)) {
					$query = ' ALTER TABLE `#__gmapfp` '.
							'CHANGE `field_'.$old_value->id.'` `field_'.$row->id.'` '.
							'TEXT NOT NULL';
					$this->_db->setQuery( $query );
					$this->_db->query();
				}
				
			} 
		}
		$data['id'] = $row->id;

        return $data;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

        $row = $this->getTable('Champs', 'GMapFPTable');

        if (count( $cids ))
        {
            foreach($cids as $cid) {
                if (!$row->delete( $cid )) {
                    $this->setError( $row->getErrorMsg() );
                    return false;
                }
				$query = ' SHOW COLUMNS '.
						' FROM `#__gmapfp` '.
						' LIKE "field_'.$cid.'"';
				$this->_db->setQuery( $query );
				$exists = $this->_db->loadResult();				
				
				if ($exists) {
					$query = ' ALTER TABLE `#__gmapfp` '.
							'  DROP `field_'.$cid.'`';
					$this->_db->setQuery( $query );
					$this->_db->query();
				}
            }                       
        }
        return true;
    }
            
	function saveorder($cid = array(), $order='', $orderdir='asc')
	{
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cnt = count($cid);
		// Update the ordering for items in the cid array
		foreach ($cid as $i => $id) {
			if ($orderdir == 'asc') {
				$query = ' UPDATE #__gmapfp_extension_type '.
						'  SET ordering = '.$i.
						'  WHERE id = '.$id;
			} else {
				$query = ' UPDATE #__gmapfp_extension_type '.
						'  SET ordering = '.($cnt-$i).
						'  WHERE id = '.$id;
			}
            $this->_db->setQuery( $query );
            $this->_db->query();
		}

		$this->cleanCache();

		return true;
	}
	
    function getTraductionChamp($id = '', $langue = '')
    {
		$query = ' SELECT * FROM #__gmapfp_extension_lang '.
				'  WHERE typeid = '.$id.
				" AND langue = '".$langue."'";
		$this->_db->setQuery( $query );
		$result = $this->_db->loadObject();

		if (!$result) {
            $result = new stdClass();
            $result->id = 0;
            $result->nom = null;
            $result->langue = $langue;
            $result->parametres = null;
			$result->filtre_label = null;
		}
			
		return $result;
	}
	
    function getDataChamp()
    {
		if (!$this->_id) $this->_id = JRequest::getInt('id');
		$query = ' SELECT nom, parametres, filtre_label, id FROM #__gmapfp_extension_type '.
				'  WHERE id = '.$this->_id;
		$this->_db->setQuery( $query );
		$result = $this->_db->loadObject();

		return $result;
	}

    function traduire_delete()
    {
		$data = JRequest::get( 'post' );

		$query = ' DELETE FROM #__gmapfp_extension_lang '.
				'  WHERE id = '.$data['id'];
		$this->_db->setQuery( $query );
		$this->_db->query();

        return true;
    }

    function traduire_save()
    {
		$data = JRequest::get( 'post' );
		
		$isNew = !$data['id'];
		
		if ($isNew) {
			$query = ' SELECT id FROM #__gmapfp_extension_lang '.
				' WHERE typeid = '.$data['typeid'].
				" AND langue = '".$data['langue']."'";
			$this->_db->setQuery( $query );
			$result = !$this->_db->loadObject();

			$query = ' INSERT INTO #__gmapfp_extension_lang (typeid, langue, nom, parametres, filtre_label)'.
					"  VALUES (".$data["typeid"].", '".$data["langue"]."', '".$data["nom"]."', '".$data["parametres"]."', '".$data["filtre_label"]."')";
		} else {
			$query = ' UPDATE #__gmapfp_extension_lang'.
					' SET typeid = '.$data["typeid"].", langue = '".$data["langue"]."', nom = '".$data["nom"]."', parametres = '".$data["parametres"]."', filtre_label = '".$data["filtre_label"]."'".
					' WHERE id = '.$data["id"];
			$result = true;
		}
		if ($result) {
			$this->_db->setQuery( $query );
			$this->_db->query();
		}

        return $result;
    }
}
