<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.108pro
	* Creation date: Mars 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPModelCSV extends JModelLegacy
{

	function __construct()
	{
		parent::__construct();
	}

	function export($data)
	{
		$list = array();
		$output_file="export_gmapfp.csv";
		
		switch ($data['task']) {
			case 'ExportLieux':
				$query = 'SELECT a.*, b.title '.
					'FROM #__gmapfp AS a '.
					'LEFT OUTER JOIN #__categories AS b on a.catid = b.id '.
					'ORDER BY b.title ';
				$file_out="export_gmapfp_places_";
				$cat	= false;
			break;
			case 'ExportCat':
				$query = 'SELECT * '.
					'FROM #__categories '.
					'WHERE section = "com_gmapfp" '.
					'OR section = "com_gmapfp_groupes" '.
					'ORDER BY section, id ';
				$file_out="export_gmapfp_cat_";
				$cat	= true;
			break;
		}


		$this->_db->setQuery( $query );
		$list2 = $this->_db->loadAssocList();

		//determine le nombre d'lment dans le tableau
		$nbre = count($list2);

		$search = array("\n", "\r");
		$replace = array("<brn />", "<brr />");
		
		$temps 	= '';
		$id		='';
		$catid 	= '';
		$index 	= 0;
		if ($nbre > 0) {
			//crais la colonne de titres
			foreach (array_keys($list2[0]) as $fields) {
				if ($cat) {
					$temps[] = html_entity_decode($fields);
				} else {
					switch ($fields) {
						case 'id' :
							$id = $index;
							break;
						 case 'catid' :
							$catid = $index;
							break;
						default :
							$temps[] = html_entity_decode($fields);
					}
				}
				$index++;
			}
			$list[] = $temps;
			unset($temps);
			for ($i = 0; $i < $nbre; $i++) {
				$index = 0;
				foreach (array_values($list2[$i]) as $fields) {
					if ((($index <> $id)and($index <> $catid))or($cat)) {
						$temps[] = str_replace($search, $replace, $fields);
					}
					$index++;
				}
				$list[] = $temps;
				unset($temps);
			}
		}
		// Open a new output file
		//$file = fopen ($output_file,'w');
		$file = fopen ($output_file,'w');
		// Put contents of $output into the $file
		foreach ($list as $fields) {
			fputcsv($file, $fields );
		}
		fclose($file);
	
		// This line will stream the file to the user rather than spray it across the screen
		header("Content-type: application/octet-stream");
		// Internet Explorer support
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Content-disposition:  attachment; filename=".$file_out.
		date("ymd").".csv");
		header("Pragma: no-cache");
		header("Expires: 0");
		//echo $output;
		readfile($output_file);
		exit();
		
		return true;
	}

	function ImportLieux($params)
	{
		$file = $_FILES['lieux'];

		$replace = array("\n", "\r");
		$search = array("<brn />", "<brr />");
		$temps 	= '';
		$fields_name 	= '';
		$cat_id	= 0;
		$cat 	= '';
		$result	= '';
        $db = JFactory::getDBO();

		if (($handle = fopen($file['tmp_name'], "r")) !== FALSE) {
			while (($data = fgetcsv($handle, 0, ",")) !== FALSE) {
				$num = count($data);
				if ($fields_name == '') {
					for ($c=0; $c < $num; $c++) {
						if ($data[$c] == 'title') {
							$cat_id = $c;
						} else {
							$temps.='`'.$data[$c].'`,';
						}
					}
					$fields_name = $temps.'`catid`';
					$temps	= '';;
				} else {
					for ($c=0; $c < $num; $c++) {
						if ($cat_id == $c) {
							$cat	= $data[$c];
						} else {
							$temps.='"'.addslashes ($data[$c]).'",';
						}
					}
					
					if ($cat <> $result) {
						// recherche si la categorie existe
						$query = "SELECT id FROM #__categories " 
							."\n WHERE title = (\"".addslashes ($cat)."\")";
						$this->_db->setQuery( $query );
						$result = $this->_db->loadAssoc();
						
						if ($result == "") {
							$query = "INSERT INTO #__categories (`title`,`section`,`published`)" 
								."\n VALUES (\"".addslashes ($cat)."\",\"com_gmapfp\",\"1\")";
							$db->setQuery($query);
							$db->query();
							if ($db->getErrorNum()) {
								exit($db->stderr());
							}
							// recherche si la categorie existe
							$query = "SELECT id FROM #__categories " 
								."\n WHERE title = (\"".addslashes ($cat)."\")";
							$this->_db->setQuery( $query );
							$result = $this->_db->loadAssoc();
						}
					}
					
					$temps	.= '"'.$result['id'].'"';
					$temps = str_replace($search, $replace, $temps);

					$query = "INSERT INTO #__gmapfp (".$fields_name.")" 
						."\n VALUES (".$temps.")";
					$db->setQuery($query);
					$db->query();
					if ($db->getErrorNum()) {
						exit($db->stderr());
					}
					$temps	= '';
				}
			}
			fclose($handle);
		}

	}
	
	function ImportCat($params)
	{
		$file = $_FILES['cat'];

		$replace 	= array("\n", "\r");
		$search 	= array("<brn />", "<brr />");
		$temps 		= '';
		$fields_name 	= '';
		$section_id	= 0;
		$section 	= '';
		$result		= '';
		$old_categories = array();
		$new_categories	= array();
		$old_groupes	= array();
		$old_ids		= array();
		$new_ids		= array();
        $db 		= JFactory::getDBO();

		if (($handle = fopen($file['tmp_name'], "r")) !== FALSE) {
			while (($data = fgetcsv($handle, 0, ",")) !== FALSE) {
				$num = count($data);
				if ($fields_name == '') {
					// traite les noms des champs
					for ($c=0; $c < $num; $c++) {
						switch ($data[$c]){
							case 'id' :
								break;
							case 'section' :
								$section_id = $c;
							default :
							$temps.='`'.$data[$c].'`,';
						}
					}
					$fields_name = substr($temps, 0 , -1);
					$temps	= '';;
				} else {
					//traite les champs
					if ($data[6] == 'com_gmapfp') $old_categories[$data[0]] = $data[2];
					if ($data[6] == 'com_gmapfp_groupes') $old_groupes[$data[0]] = $data[2];
					for ($c=1; $c < $num; $c++) {
						if ($section_id == $c) {
							$section = $data[$c];
						}
						$temps.='"'.addslashes ($data[$c]).'",';
					}

					$temps = substr($temps, 0 , -1);
					$temps = str_replace($search, $replace, $temps);
					
					//analyse le contenu de la ligne de contenu
					if ($section == 'com_gmapfp') {
						// recherche si la categorie existe
						$query = "SELECT id FROM #__categories " 
							."\n WHERE title = (\"".addslashes ($old_categories[$data[0]])."\")";
						$this->_db->setQuery( $query );
						$result = $this->_db->loadAssoc();
							
						if ($result == "") {
							$query = "INSERT INTO #__categories (".$fields_name.")" 
								."\n VALUES (".$temps.")";
							$db->setQuery($query);
							$db->query();
							if ($db->getErrorNum()) {
								exit($db->stderr());
							}
							$query = "SELECT id FROM #__categories " 
								."\n WHERE title = (\"".addslashes ($section)."\")";
							$this->_db->setQuery( $query );
							$result = $this->_db->loadAssoc();

						}
						$new_categories[$result['id']] = $data[2];
					} else {
						$new_groupes[$result['id']] = $data[2];
						//test si le groupe existe dj
						$query = "SELECT id FROM #__categories " 
							."\n WHERE title = (\"".addslashes ($old_groupes[$data[0]])."\")";
						$this->_db->setQuery( $query );
						$result = $this->_db->loadAssoc();
						
						if ($result == "") {
							$result = array_diff_assoc( $old_categories, $new_categories);
							if (count($result) == 0) {
								//inserer les groupes de catgories sans changer les ids dans le champ params.
								$query = "INSERT INTO #__categories (".$fields_name.")" 
									."\n VALUES (".$temps.")";
								$db->setQuery($query);
								$db->query();
								if ($db->getErrorNum()) {
									exit($db->stderr());
								}
							} else {
								//remplace les ancien ids dans params par les nouveaux
								$old_ids = explode (",", $data[$c-1]);
								$taille = strlen ($data[$c-1]);
								$taille++;
								foreach ($old_ids as $old_id) {
									$new_ids[] = array_search( $old_categories[$old_id], $new_categories);
								}
								$new_ids = implode ( ",", $new_ids);
								$temps 	= substr( $temps, 0, -$taille);
								$temps .= $new_ids.'"';
								
								$query = "INSERT INTO #__categories (".$fields_name.")" 
									."\n VALUES (".$temps.")";
								$db->setQuery($query);
								$db->query();
								if ($db->getErrorNum()) {
									exit($db->stderr());
								}
							}
						}
					}
					$temps	= '';
				}
			}
			fclose($handle);
		}
	}
	
	function delete($data)
	{
        $db 		= JFactory::getDBO();
		switch ($data['task']) {
			case 'DelLieux':
				$query = 'TRUNCATE `#__gmapfp`';
			break;
			case 'DelCat':
				$query = 'DELETE FROM `#__categories` '
					.'WHERE (`section` = "com_gmapfp") '
					.'OR (`section` = "com_gmapfp_groupes")';
			break;
		}
		$db->setQuery($query);
		$db->query();
		if ($db->getErrorNum()) {
			exit($db->stderr());
		}
	}
	
}
?>
