<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.0pro
	* Creation date: Mai 2013
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('JPATH_BASE') or die;

class JFormFieldModal_Perso extends JFormField
{
	protected $type = 'Modal_Perso';

	protected function getInput()
	{
		JHtml::_('behavior.modal', 'a.modal');

		$script = array();
		$script[] = '	function jSelectArticle(id, nom, object) {';
		$script[] = '		document.getElementById(object + \'_id\').value = id;';
		$script[] = '		document.getElementById(object + \'_name\').value = nom;';
		$script[] = '		SqueezeBox.close();';
		$script[] = '	}';

		JFactory::getDocument()->addScriptDeclaration(implode("\n", $script));

		$html	= array();
		$link 	= 'index.php?option=com_gmapfp&amp;controller=element&amp;task=perso&amp;tmpl=component&amp;object='.$this->id;

		$db	= JFactory::getDBO();
		$db->setQuery(
			'SELECT nom' .
			' FROM #__gmapfp_personnalisation' .
			' WHERE id = '.(int) $this->value
		);
		$title = $db->loadResult();

		if ($error = $db->getErrorMsg()) {
			JError::raiseWarning(500, $error);
		}

		if (empty($title)) {
			$title = JText::_('GMAPFP_SELECT_PERSO');
		}
		$title = htmlspecialchars($title, ENT_QUOTES, 'UTF-8');

		$html[] = '	<div class="input-prepend input-append">';
		$html[] = '  <input type="text" id="'.$this->id.'_name" value="'.$title.'" disabled="disabled" class="input-mdium" />';

		$html[] = '	<a class="modal btn" title="'.JText::_('GMAPFP_SELECT_ARTICLE').'"  href="'.$link.'" rel="{handler: \'iframe\', size: {x: 800, y: 450}}">'.JText::_('JSELECT').'</a>';
		$html[] = '	</div>';

		if (0 == (int)$this->value) {
			$value = '';
		} else {
			$value = (int)$this->value;
		}

		$class = '';
		if ($this->required) {
			$class = ' class="required modal-value"';
		}

		$html[] = '<input type="hidden" id="'.$this->id.'_id"'.$class.' name="'.$this->name.'" value="'.$value.'" />';

		return implode("\n", $html);
	}
}