<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.131pro
	* Creation date: Septembre 2022
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPModelGMapFP extends JModelLegacy
{
	var $_list;
	var $_label;
	var $_classement;
	var $_picto;
	
	var $_data;
	var $_id;
	var $_datacustom;
	
	function __construct()
	{
		parent::__construct();
		
		require_once(JPATH_ADMINISTRATOR.'/components/com_gmapfp/models/helpers/champs.php');

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
	}

	function _buildQuery()
	{
		$query = ' SELECT * '
			. ' FROM #__gmapfp_marqueurs where published = 1 ORDER BY nom '
		;

		return $query;
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
		$this->_datacustom = null;
	}

	function getChamps($id_lieu = '')
	{
		return Champs::get($id_lieu);
	}
	
	function &getData()
	{
		// Load the data
		if (empty( $this->_data )) {
			$query = ' SELECT c.*, v.name AS last_editor, w.name AS author_name, cat.params AS cat_params '.
					'  FROM #__gmapfp AS c '.
					'  LEFT JOIN #__users AS v ON v.id = c.modified_by' .
					'  LEFT JOIN #__users AS w ON w.id = c.created_by' .
					'  LEFT JOIN #__categories AS cat ON cat.id = c.catid' .
					'  WHERE c.id = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$createdate = JFactory::getDate();
			$this->_data = new stdClass();
			$this->_data->id = 0;
			$this->_data->tif_id = null;
			$this->_data->nom = null;
			$this->_data->alias = null;
			$this->_data->sef = null;
			$this->_data->adresse = null;
			$this->_data->adresse2 = null;
			$this->_data->codepostal = null;
			$this->_data->ville = null;
			$this->_data->departement = null;
			$this->_data->pay = null;
			$this->_data->email = null;
			$this->_data->web = null;
			$this->_data->img = null;
			$this->_data->album = null;
			$this->_data->introtext = null;
			$this->_data->fulltext = null;
			$this->_data->horaires_prix = null;
			$this->_data->link = null;
			$this->_data->article_id = null;
			$this->_data->icon = null;
			$this->_data->icon_label = null;
			$this->_data->glat = null;
			$this->_data->glng = null;
			$this->_data->gzoom = null;
			$this->_data->kml = null;
			$this->_data->catid = null;
			$this->_data->created_by = null;
			$this->_data->published = null;
			$this->_data->access = 1;
			$this->_data->checked_out = null;
			$this->_data->metadesc = null;
			$this->_data->metakey = null;
			$this->_data->metadata = null;
			$this->_data->featured = 0;
			$this->_data->hits = 0;
			$this->_data->version = 0;
			$this->_data->modified = null;
			$this->_data->modified_by = 0;
			$this->_data->created = null;
			$this->_data->author_name = null;
			$this->_data->publish_up = null;
			$this->_data->publish_down = null;
			$this->_data->ordering = 0;		
			$this->_data->attribs = null;	
			$this->_data->index_marqueur = 0;	
			$this->_data->language = null;
			$this->_data->classements = null;
			$this->_data->labels = null;
			$this->_data->pictos = null;
			$this->_data->cat_params = '{}';
		}
		
		if (JString::strlen($this->_data->fulltext) > 1) {
			$this->_data->text = $this->_data->introtext . "<hr id=\"system-readmore\" />" . $this->_data->fulltext;
		} else {
			$this->_data->text = $this->_data->introtext;
		}
		
		$metadatas = substr($this->_data->metadata, 2, -2);
		$metadatas = explode('","', $metadatas);
		foreach ( $metadatas as $metadata)
		{
			$metadata = explode('":"', $metadata);
			switch ($metadata[0])
			{
				case 'robots':
					$this->_data->robots = str_replace('\"', '"', $metadata[1]);
					break;
				case 'author':
					$this->_data->author = str_replace('\"', '"', $metadata[1]);
					break;
				case 'rights':
					$this->_data->rights = str_replace('\"', '"', $metadata[1]);
					break;
				case 'xreference':
					$this->_data->xreference = str_replace('\"', '"', $metadata[1]);
			}
		}
		
		return $this->_data;
	}

	function &getCustom()
	{
		if (empty( $this->_datacustom )) {
			$query = ' SELECT * FROM #__gmapfp_params_custom_fields  ';
			$this->_datacustom = $this->_getList( $query );
		}

		return $this->_datacustom;
	}

	function &getLabel()
	{
		if (empty( $this->_label )) {
			$query = ' SELECT * FROM #__gmapfp_classements WHERE (cat = 2) AND (published = 1) ORDER BY ordering ';
			$this->_label = $this->_getList( $query );
		}

		return $this->_label;
	}

	function &getClassement()
	{
		if (empty( $this->_classement )) {
			$query = ' SELECT * FROM #__gmapfp_classements WHERE (cat = 1) AND (published = 1) ORDER BY ordering ';
			$this->_classement = $this->_getList( $query );
		}

		return $this->_classement;
	}

	function &getPicto()
	{
		if (empty( $this->_picto )) {
			$query = ' SELECT * FROM #__gmapfp_classements WHERE (cat = 3) AND (published = 1) ORDER BY ordering ';
			$this->_picto = $this->_getList( $query );
		}

		return $this->_picto;
	}

	function &getMarqueurs()
	{
		if (empty( $this->_list ))
		{
			$query = $this->_buildQuery();
			$this->_list = $this->_getList( $query );
		}

		return $this->_list;
	}

	function store($data)
	{
		$dispatcher = \JEventDispatcher::getInstance();
		$user		= JFactory::getUser();
		$table 		= $this->getTable('GMapFP', 'GMapFPTable');
		$nullDate	= $this->_db->getNullDate();
		$datenow 	= JFactory::getDate();
		$config 	= JFactory::getConfig();
		$tzoffset 	= $config->get('offset');
		$params 	= JComponentHelper::getParams('com_gmapfp');

		// Include the plugins for the save events.
		\JPluginHelper::importPlugin('content');

		$selections	= JRequest::getVar( 'classements', array(), 'post', 'array' );
		$classements = implode(',', $selections);
		$selections = JRequest::getVar( 'labels', array(), 'post', 'array' );
		$labels 	= implode(',', $selections);
		$selections = JRequest::getVar( 'pictos', array(), 'post', 'array' );
		$pictos 	= implode(',', $selections);

		$data['catid'] 	= implode(',', $data['catid']);

		// Bind the form fields to the table
		if (!$table->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		$table->classements = $classements;
		$table->labels = $labels;
		$table->pictos = $pictos;

		//Traite les champs perso dont le rsultat est un tableau (ne retourne pas le champ si vide !)		
		$query = ' SELECT id FROM #__gmapfp_extension_type '.
				'  WHERE (type = 3 OR type = 6 OR type = 10)'.
				'  AND published = 1';
		$this->_db->setQuery( $query );
		$tableau = $this->_db->loadColumn();
		foreach ($tableau as $id_field_array) {
			$champ_form = 'perso_field_'.$id_field_array;
			$champ_sql = 'field_'.$id_field_array;
			$value = JRequest::getVar( $champ_form, array(), 'post', 'array' );
			$table->$champ_sql = implode(',', $value);
		}

		// sanitise id field
		$table->id = (int) $table->id;

		// Get details variables from the request
		$details	= JRequest::getVar( 'details', array(), 'post', 'array');
		$table->bind($details);

		$isNew = true;
		// Are we saving from an item edit?
		if ($table->id) {
			$isNew = false;
			$table->modified 		= $datenow->tosql();
			$table->modified_by 	= $user->get('id');
			$table->created 		= JFactory::getDate($table->created, $tzoffset)->tosql();
		} else
			$table->created		= $datenow->tosql();

		// Append time if not added to publish date
		if (strlen(trim($table->publish_up)) <= 10) {
			$table->publish_up .= ' 00:00:00';
		}

		if (!$table->publish_up)
		{
			$table->publish_up = $nullDate;
		} else
			$table->publish_up = JFactory::getDate($table->publish_up, $tzoffset)->tosql();

		// Handle never unpublish date
		if (trim($table->publish_down) == JText::_('Never') || trim( $table->publish_down ) == '')
		{
			$table->publish_down = $nullDate;
		}
		else
			$table->publish_down = JFactory::getDate($table->publish_down, $tzoffset)->tosql();

		// Increment the content version number
		$table->version++;

		$table->metadata = json_encode($data['metadata']);

		// Prepare the content for saving to the database
		GMapFPsHelper::saveGMapfpPrep( $table );

		// Make sure the record is valid
		if (!$table->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Trigger the before save event.
		$dispatcher->trigger('onContentBeforeSave', array('com_gmapfp.gmapfp', $table, $isNew));

		// Store the web link table to the database
		if (!$table->store()) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}

		// attribut le n 1  ordering et dcale les autres n
		if (!$table->reorder()) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}
		
		//traite les champs perso. 
		//Ceux qui accepte des balise html		
		$query = ' SELECT id FROM #__gmapfp_extension_type '.
				'  WHERE (type = 2 OR type = 1)'.
				'  AND published = 1';
		$this->_db->setQuery( $query );
		$editeurs = $this->_db->loadColumn();
		//Ceux qui sont des datetime		
		$query = ' SELECT id FROM #__gmapfp_extension_type '.
				'  WHERE (type = 15)'.
				'  AND published = 1';
		$this->_db->setQuery( $query );
		$datetime = $this->_db->loadColumn();
		//Ceux qui sont des date		
		$query = ' SELECT id FROM #__gmapfp_extension_type '.
				'  WHERE (type = 9)'.
				'  AND published = 1';
		$this->_db->setQuery( $query );
		$date_type = $this->_db->loadColumn();
		//Ceux qui sont des heures (pour IE6 car ne gre pas le type time)		
		$query = ' SELECT id FROM #__gmapfp_extension_type '.
				'  WHERE (type = 16)'.
				'  AND published = 1';
		$this->_db->setQuery( $query );
		$heure = $this->_db->loadColumn();

		$mes_valeurs = array();
		foreach ($data as $key => $value) {
			if (substr($key, 0, 11) == 'perso_field') {
				//si checkbox, ou list, ou radio buton, ou ...
				$search = array("\r", "\n", "\t", "\0", " ", "\x0B");
				if (is_array($value)) $value = implode("\r\n", str_replace($search, '', $value));
				//si editeur
				if (in_array(substr($key, 12), $editeurs)) {
					$value = JRequest::getVar( $key, '', 'post', 'string', JREQUEST_ALLOWRAW );
					$value = str_replace( '<br>', '<br />', $value );
				}
				if (in_array(substr($key, 12), $datetime) and !empty($value)) {
					$config = JFactory::getConfig();
					$tzoffset = $config->get('offset');
					$date = JFactory::getDate($value, $tzoffset);
					$value = $date->tosql();
				}
				if (in_array(substr($key, 12), $date_type) and !empty($value)) {
					// ne pas tenir compte du time zone offset sur l'enregistrement des dates
					$date = JFactory::getDate($value);
					$value = $date->tosql();
				}
				if (in_array(substr($key, 12), $heure) and !empty($value)) {
					$value = str_replace( ' ', '', $value );
					$value = str_replace( array('h', 'H'), ':', trim($value) );
					list($heures, $minutes) = explode(':', $value);
					if (empty((int)$heures) and empty((int)$minutes))
						$value = '';
					else {
						if ((int)$heures > 23 or empty($heures)) $heures = 0;
						if ((int)$minutes > 59 or empty($minutes)) $minutes = 0;
						$value = $heures.':'.$minutes;
					}
				}
				$mes_valeurs[] = '`field_'.substr($key, 12).'` = '.$this->_db->quote($value);
			}
		}
		if ($mes_valeurs) {
			$query = 'UPDATE `#__gmapfp` '.
				' SET '.implode(',', $mes_valeurs).
				' WHERE id = '.$table->id;
			$this->_db->setQuery( $query );
			if (!$this->_db->query())
			{
				die(print_r($this->_db->getErrorMsg()));
			}
		}

		// Trigger the after save event.
		$dispatcher->trigger('onContentAfterSave', array('com_gmapfp.gmapfp', $table, $isNew));

		//SEF en base, traite le champ
		if ($params->get('gmapfp_sef_cached')) {
			if(!class_exists('GMapFPHelperRoute')) require_once (JPATH_SITE . '/components/com_gmapfp/helpers/route.php');
			$map_link=GMapFPHelperRoute::getArticleRoute($table->id.':'.$table->alias, $table->catid);
			$query = 'UPDATE #__gmapfp SET sef = "'.$map_link.'" WHERE id = '.$table->id;
			$this->_db->setQuery($query);
			$this->_db->execute();
		}

		return $table->id;
	}

	function delete()
	{
		$dispatcher = \JEventDispatcher::getInstance();
		$config = JComponentHelper::getParams('com_gmapfp');
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		// Include the plugins for the delete events.
		\JPluginHelper::importPlugin('content');

		$table = $this->getTable('GMapFP', 'GMapFPTable');

		if (count( $cids ))
		{
			foreach($cids as $cid) {
				// efface l'image principale lier au lieux
				if ($config->get('gmapfp_del_img')) {
					//rcupre et vrifi que l'image principale n'est pas utilise par un autre id
					$query = ' SELECT img FROM #__gmapfp '.
							'  WHERE id = '.$cid;
					$this->_db->setQuery( $query );
					$result = $this->_db->loadObject();
					
					$query = ' SELECT id FROM #__gmapfp '.
							'  WHERE img = \''.$result->img.'\'';
					$list = $this->_getList( $query );

					if ((count($list)==1) && ($result->img!='blank.png')) {
						unlink(COM_GMAPFP_IMAGES_FOLDER."/".$result->img);
						unlink(COM_GMAPFP_IMAGES_FOLDER."/thumbsArt/".$result->img);
						unlink(COM_GMAPFP_IMAGES_FOLDER."/thumbsGMap/".$result->img);
					}
				}
				//efface la gallerie d'image d'un lieu
				if ($config->get('gmapfp_del_galerie')) {
					$this->rrmdir(COM_GMAPFP_IMAGES_FOLDER.'/GA'.$cid.'/thumbs');
					$this->rrmdir(COM_GMAPFP_IMAGES_FOLDER.'/GA'.$cid);
				}
				$table->load($cid);
				//efface l'enregistrement du lieux
				if (!$table->delete( $cid )) {
					$this->setError( $table->getErrorMsg() );
					return false;
				};
				// Trigger the after event.
				$dispatcher->trigger('onContentAfterDelete', array('com_gmapfp.gmapfp', $table));
			}						
		}
		return true;
	}
	
	function rrmdir($dir) { 
		if (is_dir($dir)) { 
			$objects = scandir($dir); 
			foreach ($objects as $object) { 
				if ($object != "." && $object != "..") { 
					if (filetype($dir."/".$object) == "dir") rmdir($dir."/".$object); else unlink($dir."/".$object); 
				} 
			} 
			reset($objects); 
			rmdir($dir); 
		} 
	} 

    function getImages()
    {
        jimport( 'joomla.filesystem.file' );
        jimport( 'joomla.filesystem.folder' );
		$images     = array ();
		$id 		= JRequest::getVar('cid');
		if (is_array($id)) $id = (int)$id[0]; else $id = (int)$id;
		if ($id==0) return false;
		
		$basePath = COM_GMAPFP_IMAGES_FOLDER.'/GA'.$id;
		// Cre le rpertoire s'il n'exist pas
		$buffer = "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>";
		if (!JFolder::exists($basePath)) {
			JFolder::create($basePath);
			JFile::write($basePath."/index.html", $buffer);
		}
		if (!JFolder::exists($basePath.'/thumbs')) {
			JFolder::create($basePath.'/thumbs');
			JFile::write($basePath.'/thumbs/index.html', $buffer);
		}
        // Get the list of files and folders from the given folder
        $fileList   = JFolder::files($basePath);

        // Iterate over the files if they exist
        if ($fileList !== false) {
            foreach ($fileList as $file)
            {
                if (is_file($basePath.'/'.$file) && substr($file, 0, 1) != '.' && strtolower($file) !== 'index.html') {
                    $tmp = new JObject();
                    $tmp->name = $file;
                    $tmp->path_relative = COM_GMAPFP_IMAGES_HTTP.'/GA'.$id;
                    $tmp->path = $basePath.'/'.$file;
                    $tmp->size = filesize($tmp->path);
                    $tmp->size = round($tmp->size/1024, 2);

                    $ext = strtolower(JFile::getExt($file));
                    switch ($ext)
                    {
                        // Image
                        case 'jpg':
                        case 'png':
                        case 'gif':
                        case 'xcf':
                        case 'odg':
                        case 'bmp':
                        case 'jpeg':
                            $info = @getimagesize($tmp->path);
                            $tmp->width     = @$info[0];
                            $tmp->height    = @$info[1];
                            $tmp->type      = @$info[2];
                            $tmp->mime      = @$info['mime'];

                            if (($info[0] > 60) || ($info[1] > 60)) {

								if ($tmp->width > $tmp->height) {
									$percentage = (60 / $tmp->width);
								} else {
									$percentage = (60 / $tmp->height);
								}
						
								//gets the new value and applies the percentage, then rounds the value
								$tmp->width = round($tmp->width * $percentage);
								$tmp->height = round($tmp->height * $percentage);
                            }
                 			//lecture des infos exif du fichier image
							$xml = substr($file, 0, -(strlen(JFile::getExt($file))+1));
							$xml .= '.xml';

							if (JFile::exists($basePath.'/infos/'.$xml)) {
								$xml_str = file_get_contents($basePath.'/infos/'.$xml);
								$xml_data = new SimpleXMLElement($xml_str);
									$tmp->titre = (string) $xml_data->titre;
									$tmp->description = (string) $xml_data->description;
							} else {
									$tmp->titre = '';
									$tmp->description = '';
							}
                 			$images[] = $tmp;
                            break;
                    }
                }
            }
        }
        return $images;
    }

	public function checkin($pk = null)
	{
		// Only attempt to check the row in if it exists.
		if ($pk)
		{
			$user = JFactory::getUser();

			// Get an instance of the row to checkin.
			$table = $this->getTable('GMapFP', 'GMapFPTable');
			if (!$table->load($pk))
			{
				$this->setError($table->getError());
				return false;
			}

			// Check if this is the user having previously checked out the row.
			if ($table->checked_out > 0 && $table->checked_out != $user->get('id') && !$user->authorise('core.admin', 'com_checkin'))
			{
				$this->setError(JText::_('JLIB_APPLICATION_ERROR_CHECKIN_USER_MISMATCH'));
				return false;
			}

			// Attempt to check the row in.
			if (!$table->checkin($pk))
			{
				$this->setError($table->getError());
				return false;
			}
		}

		return true;
	}

	public function checkout($pk = null)
	{
		// Only attempt to check the row in if it exists.
		if ($pk)
		{
			$user = JFactory::getUser();

			// Get an instance of the row to checkout.
			$table = $this->getTable('GMapFP', 'GMapFPTable');
			if (!$table->load($pk))
			{
				$this->setError($table->getError());
				return false;
			}

			// Check if this is the user having previously checked out the row.
			if ($table->checked_out > 0 && $table->checked_out != $user->get('id'))
			{
				$this->setError(JText::_('JLIB_APPLICATION_ERROR_CHECKOUT_USER_MISMATCH'));
				return false;
			}

			// Attempt to check the row out.
			if (!$table->checkout($user->get('id'), $pk))
			{
				$this->setError($table->getError());
				return false;
			}
		}

		return true;
	}

	function PaneName()
	{	
		$query = ' SELECT id, nom FROM #__gmapfp_extension_type '.
				'  WHERE type = 14 AND published = 1'.
				' ORDER BY ordering';
		$this->_db->setQuery( $query );
		return $this->_db->loadAssocList('id');

	}

	function saveorder($cid = array(), $order='' , $orderdir = 'asc')
	{
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cnt = count($cid);
		// Update the ordering for items in the cid array
		foreach ($cid as $i => $id) {
			if ($orderdir == 'asc') {
				$query = ' UPDATE #__gmapfp '.
						'  SET ordering = '.$i.
						'  WHERE id = '.$id;
			} else {
				$query = ' UPDATE #__gmapfp '.
						'  SET ordering = '.($cnt-$i).
						'  WHERE id = '.$id;
			}
            $this->_db->setQuery( $query );
            $this->_db->query();
		}

		$this->cleanCache();

		return true;
	}
}
?>
