<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.125pro
	* Creation date: Décembre 2020
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPModelGMapFPs extends JModelLegacy
{
	var $_data = null;

	var $_total = null;

	var $_pagination = null;

		function __construct()
		{
			parent::__construct();
			
			$app 	= JFactory::getApplication(); 
			$option = $app->input->get('option', '', 'CMD'); 
			
			$limit 		= $app->getUserStateFromRequest( $option.'limit', 'limit', $app->getCfg('list_limit'), 'int');
			$limitstart = $app->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );	

			// In case limit has been changed, adjust limitstart accordingly
			$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

			$this->setState('limit', $limit);
			$this->setState('limitstart', $limitstart);
			
		}
		
	function &getCustom()
	{
		if (empty( $this->_datacustom )) {
			$query = ' SELECT * FROM #__gmapfp_params_custom_fields  ';
			$this->_datacustom = $this->_getList( $query );
		}

		return $this->_datacustom;
	}

	function getlistville()
	{
		$query = 'SELECT DISTINCT ville' .
				' FROM #__gmapfp' .
				' ORDER BY ville';
		return $this->_getList( $query );
	}
	
	function getlistdepartement()
	{
		$query = 'SELECT DISTINCT departement' .
				' FROM #__gmapfp' .
				' ORDER BY departement';
		return $this->_getList( $query );
	}
	
	function getlistpays()
	{
		$query = 'SELECT DISTINCT pay' .
				' FROM #__gmapfp' .
				' ORDER BY pay';
		return $this->_getList( $query );
	}
	
	function _buildQuery()
	{
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();

		$query = ' SELECT a.*, c.name AS auteur, c.email AS auteur_mail, ag.title AS access_level, l.title AS language_title, e.name AS editor'.
			' FROM #__gmapfp a '.
			' LEFT JOIN #__users c ON c.id = a.created_by'.
			' LEFT JOIN #__users e ON e.id = a.checked_out'.
			' LEFT JOIN #__viewlevels AS ag ON ag.id = a.access'.
			' LEFT JOIN #__languages AS l ON l.lang_code = a.language'.
			$where.
			$orderby
		;

		//die(print_r($query));
		return $query;
	}

	function _buildContentWhere()
	{
		$app 		= JFactory::getApplication(); 
		$option    	= $app->input->get('option', '', 'CMD'); 
		$user		= JFactory::getUser();
		$db			= JFactory::getDBO();
		
        $filtreville 		= $app->getUserStateFromRequest( $option.'filtreville', 		'filtreville', 			'-- '.JText::_( 'GMAPFP_VILLE_FILTRE' ).' --', 		'string' );
        $filtredepartement 	= $app->getUserStateFromRequest( $option.'filtredepartement', 'filtredepartement', 	'-- '.JText::_( 'GMAPFP_DEPARTEMENT_FILTRE' ).' --', 	'string' );
        $filtrepay		 	= $app->getUserStateFromRequest( $option.'filtrepay', 		'filtrepay', 			'-- '.JText::_( 'GMAPFP_PAYS_FILTRE' ).' --', 	'string' );
        $filtrecategorie 	= $app->getUserStateFromRequest( $option.'filtrecategorie', 	'filtrecategorie', 		0, 	'int' );
		
		$filter_order		= $app->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $app->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search				= $app->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );

		$where = array();

		$groups		= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';

		if (!empty($search)) {
			if (stripos($search, 'id:') === 0)
			{
				$where[] = 'a.id = ' . (int) substr($search, 3);
			}
			elseif (stripos($search, 'tif:') === 0)
			{
				$where[] = 'a.tif_id LIKE ' .$db->Quote( '%'.$db->escape( substr($search, 4), true ).'%', false );
			}
			else
				$where[] = 'LOWER(a.nom) LIKE '.$db->Quote( '%'.$db->escape( $search, true ).'%', false );
		}

        if ($filtreville<>'-- '.JText::_( 'GMAPFP_VILLE_FILTRE' ).' --') {
            $where[] = 'ville = \''.addslashes($filtreville).'\'';
        }           

		if ($filtredepartement<>'-- '.JText::_( 'GMAPFP_DEPARTEMENT_FILTRE' ).' --') {
			$where[] = 'departement = \''.addslashes($filtredepartement).'\'';
		}

		if ($filtrepay<>'-- '.JText::_( 'GMAPFP_PAYS_FILTRE' ).' --') {
			$where[] = 'pay = \''.addslashes($filtrepay).'\'';
		}

        if ($filtrecategorie<>0) {
				$catids = self::enfants_catid($filtrecategorie);
				// die(print_r($catids));
				foreach ($catids as $catid)
					$whereOr[] = '(a.catid LIKE "'.$catid.',%"'.' OR a.catid LIKE "%,'.$catid.',%"'.' OR a.catid LIKE "%,'.$catid.'"'.' OR a.catid = "'.$catid.'")';
				$where[] = '('.implode(' OR ', $whereOr).')';
        }

		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}

	protected static function enfants_catid($id)
	{
		$ids[] = $id;
		//renvoie tous les enfants de $id trié par parent et ordre alphabétique
		$count_ids = count($ids);
		
		for ($i = 0; $i < $count_ids; $i++) {
			if (self::_enfant($ids[$i]))
				$ids = array_merge(array_slice($ids, 0, $i+1), self::_enfant($ids[$i]), array_slice($ids, $i+1));
			$count_ids = count($ids);
		}

		return $ids;
	}
	
	protected static function _enfant($id)
	{
		$db	= JFactory::getDBO();
		$query = "SELECT id" .
				"\n FROM #__categories" .
				"\n WHERE parent_id = ".$id .
				"\n AND extension = 'com_gmapfp'" .
				"\n AND published = true" .
				"\n ORDER BY title";
    	$db->setQuery( $query );
		$result = $db->loadColumn();
		return $result;
	}

	function _buildContentOrderBy()
	{
		$app 	= JFactory::getApplication(); 
		$option = $app->input->get('option', '', 'CMD'); 

		$filter_order		= $app->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $app->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );

		if ($filter_order == 'a.ordering'){
			$orderby 	= ' ORDER BY  a.ordering '.$filter_order_Dir;
		} else {
			if ($filter_order) {
				$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , a.catid, a.ordering ';
			}else{
				$orderby 	= ' ORDER BY a.catid, a.ordering ';
			};
		}

		return $orderby;
	}

	function getData()
	{
        if (empty( $this->_data ))
        {
            $query = $this->_buildQuery();
            $this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit'));
        }

        return $this->_data;
	}

	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

        return $this->_total;
	}

	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}		
	
	function getGMapFPcatsTitle()
	{
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName(array('title', 'id', 'published')));
		$query->from($db->quoteName('#__categories'));
		$query->where($db->quoteName('extension') . ' = '. $db->quote('com_gmapfp'));

		$db->setQuery($query);
		return $db->loadObjectList('id');
	}

	function saveorder($cid = array(), $order= '')
	{
		JSession::checkToken() or jexit( 'Invalid Token' );
		$total		= count($cid);

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// JLog::add('$cid : '.implode(',', $cid), JLog::WARNING);
		// JLog::add('$order : '.implode(',', $order), JLog::WARNING);

		// Instantiate an article table object
		$row = $this->getTable('GMapFP', 'GMapFPTable');

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($db->getErrorMsg() );
					return false;
				}
			}
		}

		return true;
	}
}
