<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.123pro
	* Creation date: Septembre 2019
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class Champs
{
	static function get($id_lieu = '', $view = array())
	{
		$champ = array ();
		$catid_field = array ();
		$db		= JFactory::getDBO();
		$app	= JFactory::getApplication();
		
		if ($app->isSite()) {
			//filtre par langue
			$params	= clone($app->getParams('com_gmapfp'));

			$tag	= JFactory::getLanguage()->getTag();
			$join = '';
			$case = '';
			$parametres = ', a.parametres, a.nom';
			if ($app->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
				$wheres[] ='(c.langue = ' . $db->Quote($tag).'OR c.langue IS NULL)';
				$join = ' LEFT OUTER JOIN #__gmapfp_extension_lang AS c on a.id = c.typeid';
				$case = ', CASE WHEN CHAR_LENGTH(c.nom) THEN c.nom ELSE a.nom END as nom, '.
					' CASE WHEN CHAR_LENGTH(c.parametres) THEN c.parametres ELSE a.parametres END as parametres ';
				$parametres = '';
			}
			$wheres[] ='a.published = 1';
			
			$query = ' SELECT a.alias, a.description, a.position, a.for_cat, a.catid, a.ordering, a.type, a.form_separator, a.required, a.id '.$parametres.
					$case.
					' FROM #__gmapfp_extension_type as a '.
					$join.
					' WHERE ' . implode( '  AND ', $wheres ).
					' ORDER BY a.ordering';
			$db->setQuery( $query );
			$fields = $db->loadObjectList();
			$administrator = "administrator/";
		} else {
			define('GMAPFP_ANDROID', 0);
			$params = JComponentHelper::getParams('com_gmapfp');
			
			$query = ' SELECT * '.
					' FROM #__gmapfp_extension_type '.
					' WHERE published = 1'.
					' ORDER BY ordering';
			$db->setQuery( $query );
			$fields = $db->loadObjectList();
			$administrator = "";
		}

		//$fields = champs perso publis
		//$values = valeur des champs de la table GMapFP du lieu
		if ($fields) {
			$query = ' SELECT * '.
					' FROM #__gmapfp '.
					' WHERE id = '.$id_lieu;
			$db->setQuery( $query );
			$values = @$db->loadAssoc();
			if (!$values and !$params->get('choix_categorie', 0)) {
				$tmp = $params->get('catids');
				$values['catid'] = $tmp[0];
				unset($tmp);
			}
			
			$editor = JFactory::getEditor();
			foreach ($fields as $field) {
				$display_none = "";

				if  ($app->isSite() && !($view and in_array($field->id, $view))) {
					$display_none = 'style = "display:none;"';
				} else {
					if ($field->for_cat) {
						$catids = explode(',', $field->catid);
						foreach ($catids as $catid)
							if  (!$app->isSite() || ($view and in_array($field->id, $view))) 
								$catid_field['field_catid_'.$field->id][] = 'cat'.$catid;
								
						$intersection = array_intersect(explode(',',$values['catid']), $catids);
						if (empty($intersection))
							$display_none = 'style = "display: none;"';
					}
				};

				if ($field->required) {
					$required = ' required';
					if ($app->isSite())
						$required_picto = '&nbsp;&nbsp;&nbsp;<img src="components/com_gmapfp/images/icons/'.$params->get('gmapfp_icon_folder').'/switch.png" height="16px" title="'.JText::_('GMAPFP_OBLIGATOIRE').'">';
					else
						// $required_picto = '&nbsp;&nbsp;&nbsp;*';
						$required_picto = '';
				} else {
					$required = '';
					$required_picto = '';
				}
				
				($field->description) ? $description = 'class="hasTip" title="'.$field->nom.'::'.$field->description.'"' : $description = "";
				
				switch ($field->type) {
					case 0 : // champ text
						($field->required) ? $required = ' required' : $required = '';
						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td>
								<input class="inputbox'.$required.'" type="text" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" size="50" value="'.@$values['field_'.$field->id].'" />
							</td>
						</tr>
						';
						break;
					case 11 : // champ url
					case 12 : //image url
					case 19 : // champ url (bouton)
						($field->required) ? $required = ' required validate-url' : $required = '';
						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td>
								<input class="inputbox'.$required.'" placeholder="http://mysite.com" type="url" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" size="50" value="'.@$values['field_'.$field->id].'" />
							</td>
						</tr>
						';
						break;
					case 17 : //tel
						($field->required) ? $required = ' required' : $required = '';
						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td>
								<input class="inputbox validate-tel'.$required.'" placeholder="+33 2 01 02 03 04 05" type="tel" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" size="50" value="'.@$values['field_'.$field->id].'" />
							</td>
						</tr>
						';
						break;
					case 20 : //email
						($field->required) ? $required = ' required' : $required = '';
						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td>
								<input class="inputbox validate-email'.$required.'" placeholder="support@gmapfp.org" type="email" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" size="50" value="'.@$values['field_'.$field->id].'" />
							</td>
						</tr>
						';
						break;
					case 18 : //article Joomla
						($field->required) ? $required = ' required' : $required = '';
						$article_name = "";
						if (@$values['field_'.$field->id]) {
							$query = ' SELECT title '.
									' FROM #__content '.
									' WHERE id = '.$values['field_'.$field->id];
							$db->setQuery( $query );
							$article_name = $db->loadResult();
						
						}
						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td>
								<div class="input-append pull-left" style="float: left;">
                                	<input class="inputbox" disabled="disabled" type="text" name="text_link" id="jform_perso_field_'.$field->id.'_name" size="30" value="'.$article_name.'" />
                                        <a class="btn modal modal_jform_article" title="'.JText::_('GMAPFP_SELECT_ARTICLE_DESC').'"  href="'.$administrator.'index.php?option=com_content&amp;view=articles&amp;layout=modal&amp;tmpl=component&amp;function=jSelectArticle'.$field->id.'" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('GMAPFP_SELECT_ARTICLE').'</a>
                                        <a class="btn hasTooltip"  href="javascript:;" onClick="jResetArticle'.$field->id.'()" data-placement="bottom" title="'.JText::_('JSEARCH_RESET').'"><i class="icon-remove">&nbsp;</i></a>
                                </div>
                                <input type="hidden" id="jform_perso_field_'.$field->id.'_id" name="perso_field_'.$field->id.'" value="'.@$values['field_'.$field->id].'" />                
								<script language="javascript" type="text/javascript">
									function jSelectArticle'.$field->id.'(id, title, catid) {
										document.getElementById("jform_perso_field_'.$field->id.'_id").value = id;
										document.getElementById("jform_perso_field_'.$field->id.'_name").value = title;
										SqueezeBox.close();
									}

									function jResetArticle'.$field->id.'() {
										document.getElementById("jform_perso_field_'.$field->id.'_id").value = "";
										document.getElementById("jform_perso_field_'.$field->id.'_name").value = "";
									}
								</script>
							</td>
						</tr>
						';
						break;
					case 1 : // champ textarea
						($field->required) ? $required = ' required' : $required = '';
						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td>
								<textarea rows="4" cols="32" class="'.$required.'" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" >'.(@$values['field_'.$field->id]).'</textarea>
							</td>
						</tr>
						';
						break;
					case 2 : // champ editor
						if (GMAPFP_ANDROID) {
							$editeur = '<textarea class="inputbox" rows="6" cols="65" id="perso_field_'.$field->id.'" name="perso_field_'.$field->id.'">'.htmlspecialchars(@$values['field_'.$field->id], ENT_COMPAT, 'UTF-8').'</textarea>';
						}else{
							$editeur = $editor->display('perso_field_'.$field->id, htmlspecialchars(@$values['field_'.$field->id], ENT_COMPAT, 'UTF-8'), '600', '300', '75', '20', false, 'perso_field_'.$field->id);
						}

						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.'
								</label>
							</td>
							<td>
							'.$editeur.'
							</td>
						</tr>
						';
						break;
					case 3 : // champ checkbox
						($field->required) ? $required = ' validate-checkbox' : $required = '';
						$temp = '
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td>
								';
						$parametres = explode("\r\n", $field->parametres);
						$checkeds = explode("\r\n", @$values['field_'.$field->id]);
						foreach($parametres as $parametre){
							if (in_array( strstr($parametre, '::', 1), $checkeds)) $check = 'checked'; else $check = '';
							$temp .= '<input class="inputbox'.$required.'" style="float: none;" type="checkbox" name="perso_field_'.$field->id.'[]" id="perso_field_'.$field->id.'" value="'.strstr($parametre, '::', 1).'"'.$check.'>&nbsp;'.substr(strstr($parametre, '::', 0),2).$field->form_separator."\n";
						}
						$temp .= '
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
					case 4 : // champ radiobuton
						($field->required) ? $required = ' validate-checkbox' : $required = '';
						$temp = '
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td>
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td class="controls" style="line-height: 3em;">
								<fieldset id="perso_field_'.$field->id.'" class="radio btn-group">
								';
						$parametres = explode("\n", $field->parametres);
						$cn = 0;
						foreach($parametres as $parametre){
							if (strstr($parametre, '::', 1) == str_replace("\n", "", @$values['field_'.$field->id])) {
								$check = 'checked="checked"'; 
								$btn_class = 'active';
							} else {
								$check = '';
								$btn_class = '';
							}
							$temp .= '<input type="radio" class="'.$required.'" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.$cn.'" value="'.strstr($parametre, '::', 1).'" '.$check.'>'."\n";
							$temp .= '<label for="perso_field_'.$field->id.$cn.'" class="btn">'.substr(strstr($parametre, '::', 0),2).'</label>'."\n";
							$cn++;
						}
						$temp .= '
								</fieldset>
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
					case 5 : // champ list 1 choix
						($field->required) ? $required = ' required validate-dropdown' : $required = '';
						$temp = '
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td>
								<select name="perso_field_'.$field->id.'" class="'.$required.'" id="perso_field_'.$field->id.'" size="1">';
						$parametres = explode("\n", $field->parametres);
						if (str_replace("\n", "", @$values['field_'.$field->id]) == '0' or str_replace("\n", "", @$values['field_'.$field->id]) == '') $check = 'selected="selected"'; else $check = '';			
						$temp .= "\n".'<option class="inputbox" value="0" '.$check.'>'.JText::_('JGLOBAL_SELECT_AN_OPTION').'</option>';
						foreach($parametres as $parametre){
							if (trim(strstr($parametre, '::', 1)) == str_replace("\n", "", @$values['field_'.$field->id])) $check = 'selected="selected"'; else $check = '';
							$temp .= "\n".'<option class="inputbox" value="'.strstr($parametre, '::', 1).'" '.$check.'>'.substr(strstr($parametre, '::', 0),2).'</option>';
						}
						$temp .= '
								</select>
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
					case 6 : // champ list multi choix
						($field->required) ? $required = ' required validate-dropdown' : $required = '';
						$temp = '
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td>
								<select name="perso_field_'.$field->id.'[]" class="'.$required.'" id="perso_field_'.$field->id.'" multiple size="4">';
						$parametres = explode("\r\n", $field->parametres);
						$checkeds = explode("\r\n", @$values['field_'.$field->id]);
						foreach($parametres as $parametre){
							if (in_array( strstr($parametre, '::', 1), $checkeds)) $check = 'selected="selected"'; else $check = '';
							$temp .= "\n".'<option class="inputbox" value="'.strstr($parametre, '::', 1)."\n".'" '.$check.'>'.substr(strstr($parametre, '::', 0),2).'</option>';
						}
						$temp .= '
								</select>
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
					case 7 : // champ text readonly
						$champ[$field->position][]='
						<tr  class="disable" '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td>
								<input class="inputbox" readonly="readonly" type="text" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" size="50" value="'.$field->parametres.'" />
							</td>
						</tr>
						';
						break;
					case 8 : // champ text d'information
						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.'
								</label>
							</td>
							<td>
								'.$field->parametres.'
							</td>
						</tr>
						';
						break;
					case 9 : // champ date
					case 15 : // champ date / heure
						// si utilisation fonction JCalendar => bug javascript !
						$attribs = array();
						
						if ($field->type == 9) {
							$date_format = "%Y-%m-%d";
							$date_format2 = "Y-m-d";
							$attribs['showTime'] = false;
						}
						if ($field->type == 15) {
							$date_format = "%Y-%m-%d %H:%M";
							$date_format2 = "Y-m-d H:i";
							$attribs['showTime'] = true;
						}
						
						$thedate = "";
						if (@$values['field_'.$field->id] and $values['field_'.$field->id] != '0000-00-00 00:00:00') {
							$thedate = htmlspecialchars(JHtml::date( @$values['field_'.$field->id], $date_format2), ENT_COMPAT, 'UTF-8');
						}
						
						($field->required) ? $attribs['required'] = '' : false;
						$cal = JHtml::calendar($thedate,'perso_field_'.$field->id,'perso_field_'.$field->id,$date_format,$attribs);
						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'" >
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td>
								'.$cal.'
							</td>
						</tr>
						';
						
						break;
					case 16 : // champ heure
						($field->required) ? $required = ' required' : $required = '';
						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td>
								<input class="inputbox'.$required.'" type="time" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" size="50" value="'.@$values['field_'.$field->id].'" />
							</td>
						</tr>
						';
						break;
					case 10 : // champ lment GMapFP
						$wheres = array();;
						//gestion des droits
						require_once JPATH_COMPONENT_ADMINISTRATOR.'/helpers/gmapfp.php';
						$canDo	= GMapFPHelper::getActions();
						$user   = JFactory::getUser();
						if (!$canDo->get('core.edit')) $wheres[] = 'created_by = '.$user->id;
		
						($field->required) ? $required = ' required validate-dropdown' : $required = '';
						$temp = '
						<tr '.$display_none.' id="field_catid_'.$field->id.'" >
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.$required_picto.'
								</label>
							</td>
							<td>
								<select name="perso_field_'.$field->id.'[]" class="'.$required.'" id="perso_field_'.$field->id.'" multiple size="4">';
						
						$parametres = explode("\r\n", $field->parametres);
						$checkeds = explode("\r\n", @$values['field_'.$field->id]);

						if (!empty($parametres))
							foreach ($parametres as $parametre)
								if (substr($parametre, 0, 5) == 'catid') {
									$filtre = substr($parametre, strpos('=', $parametre)+1);
									$wheres[] = '(catid LIKE "'.$filtre.',%"'.' OR catid LIKE "%,'.$filtre.',%"'.' OR catid LIKE "%,'.$filtre.'"'.' OR catid = "'.$filtre.'")';
								}
						$wheres[] = "published = 1";
						$query = ' SELECT id, nom '.
								' FROM #__gmapfp '.
								' WHERE '.implode( ' AND ', $wheres ).
								' ORDER BY nom';
						$db->setQuery( $query );
						$results = $db->loadObjectList();
						
						foreach($results as $result){
							if (in_array( $result->id, $checkeds)) $check = 'selected="selected"'; else $check = '';
							$temp .= "\n".'<option class="inputbox" value="'.$result->id."\n".'" '.$check.'>'.$result->nom.'</option>';
						}
						$temp .= '
								</select>
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
					case 13 : // champ calendrier GMapFP
						$temp = '
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'" '. $description.'>
									'.$field->nom.'
								</label>
							</td>
							<td>
								<select name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'">';
						
						$parametres = explode("\r\n", $field->parametres);
						$checkeds = explode("\r\n", @$values['field_'.$field->id]);

						$where = '';
						if (!empty($parametres))
							foreach ($parametres as $parametre)
								if (substr($parametre, 0, 5) == 'catid')
									$where = substr($parametre, strpos('=', $parametre)+1); 
						$query = ' SELECT id, nom '.
								' FROM #__calendar_gmapfp_items '.
								' WHERE published = 1'.
								' ORDER BY nom'.
								$where;
						$db->setQuery( $query );
						$tmp = new stdclass();
						$tmp->id = "";
						$tmp->nom = JText::_('COM_GMAPFP_SELECT_CALENDAR');
						$results = array($tmp);
						unset($tmp);
						$results = array_merge($results, $db->loadObjectList());
						
						foreach($results as $result){
							if (in_array( $result->id, $checkeds)) $check = 'selected="selected"'; else $check = '';
							$temp .= "\n".'<option class="inputbox" value="'.$result->id."\n".'" '.$check.'>'.$result->nom.'</option>';
						}
						$temp .= '
								</select>
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
				}
			}
		}
		$champ['json'] = json_encode($catid_field);
		return $champ;
	}
	
}
?>
