<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.108pro
	* Creation date: Mars 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPModelMarqueur extends JModelAdmin
{
	public $typeAlias = 'com_gmapfp.marqueur';

	protected function canDelete($record)
	{
		if (!empty($record->id))
		{
			$user = JFactory::getUser();
			return $user->authorise('core.edit.markers', 'com_gmapfp');
		}
	}

	protected function canEditState($record)
	{
		$user = JFactory::getUser();
		return $user->authorise('core.edit.markers', 'com_gmapfp');
	}

	public function getTable($type = 'marqueur', $prefix = 'GMapFPTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	public function getForm($data = array(), $loadData = true)
	{
		// Get the form.
		$form = $this->loadForm('com_gmapfp.marqueur', 'marqueur', array('control' => 'jform', 'load_data' => $loadData));

		if (empty($form))
		{
			return false;
		}

		return $form;
	}

	protected function loadFormData()
	{
		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_gmapfp.edit.marqueur.data', array());

		if (empty($data))
		{
			$data = $this->getItem();
		}

		$this->preprocessData('com_gmapfp.marqueur', $data);

		return $data;
	}
	
}
