<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.108pro
	* Creation date: Mars 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPModelMarqueurs extends JModelLegacy
{
    var $_data;
    var $_list;
    var $_total;
    
    function __construct()
    {
        parent::__construct();

		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 
        $controller = JRequest::getWord('controller');

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);
            
        $limit      = $mainframe->getUserStateFromRequest( $option.$controller.'limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $limitstart = $mainframe->getUserStateFromRequest( $option.$controller.'limitstart', 'limitstart', 0, 'int' );

        // In case limit has been changed, adjust limitstart accordingly
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

    
        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);
    }

    function _buildQuery()
    {
		$app 			= JFactory::getApplication();
		$input 			= $app->input;
		$option    		= $input->getCMD('option'); 
        $controller 	= $input->getWord('controller');
		
        $filter_order       = $app->getUserStateFromRequest( $option.$controller.'filter_order', 'filter_order', 'nom', 'cmd' );
        $filter_order_Dir   = $app->getUserStateFromRequest( $option.$controller.'filter_order_Dir', 'filter_order_Dir', '', 'word' );

        $query = ' SELECT * '
            . ' FROM #__gmapfp_marqueurs '
			. ' ORDER BY '.$filter_order.' '.$filter_order_Dir
        ;

        return $query;
    }

    function setId($id)
    {
        $this->_id      = $id;
        $this->_data    = null;
    }

    function getList()
    {
        if (empty( $this->_list ))
        {
            $query = $this->_buildQuery();
            $this->_list = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit'));
        }
        
        return $this->_list;
    }
    
    function getPagination()
    {
        if (empty($this->_pagination))
        {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
        }

        return $this->_pagination;
    }       
    
    function getTotal()
    {
        if (empty($this->_total))
        {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }

        return $this->_total;
    }

    function delete()
    {
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

        $row = $this->getTable('Marqueur', 'GMapFPTable');

        if (count( $cids ))
        {
            foreach($cids as $cid) {
                if (!$row->delete( $cid )) {
                    $this->setError( $row->getErrorMsg() );
                    return false;
                }
            }                       
        }
        return true;
    }
            
}
