<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.108pro
	* Creation date: Mars 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPModelPhotos extends JModelLegacy
{
	var $_data;

		function __construct()
		{
			parent::__construct();
			
			$mainframe = JFactory::getApplication(); 
			$option    = JRequest::getCMD('option'); 
			
			$type = JRequest::getVar('type');
			if ($type != '0') {
				$user_id = JRequest::getVar('user_id');
				$this->setId($user_id);
			} else {
				$array = JRequest::getVar('cid',  0, '', 'array');
				$this->setId((int)$array[0]);
			}
			
			$limit = $mainframe->getUserStateFromRequest( $option.'limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
			$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );	
			$this->setState('limit', $limit);
			$this->setState('limitstart', $limitstart);
			
			$search	= $mainframe->getUserStateFromRequest( $option.'items.search', 'search', '',	'string' );
			$search	= JString::strtolower($search);
			$this->search = $search;

		}
		
		function setId($id)
		{
			$this->_id = intval( $id );
			$_data = null;
			$this->_total = null;
		}
	
	function getlistville()
	{
		$query = 'SELECT DISTINCT ville' .
				' FROM #__gmapfp' .
				' ORDER BY ville';
		return $this->_getList( $query );
	}
	
	function getlistdepartement()
	{
		$query = 'SELECT DISTINCT departement' .
				' FROM #__gmapfp' .
				' ORDER BY departement';
		return $this->_getList( $query );
	}
	
	function _buildQuery()
	{
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 
		
		$db		= $this->getDBO();

		$where[] = ' b.id = a.catid ';
		$where[] = ' a.published = "1" ';
				
		if ($this->search) {
			$where[] = 'LOWER( nom ) LIKE '.$db->Quote( '%'.$db->Escape( $this->search, true ).'%', false );
		}

		$filtreville = $mainframe->getUserStateFromRequest( $option.'filtreville', 'filtreville', '-- '.JText::_( 'GMAPFP_VILLE_FILTRE' ).' --', 'string' );
		$filtredepartement = $mainframe->getUserStateFromRequest( $option.'filtredepartement', 'filtredepartement', '-- '.JText::_( 'GMAPFP_DEPARTEMENT_FILTRE' ).' --', 'string' );
		$filtrecategorie = $mainframe->getUserStateFromRequest( $option.'filtrecategorie', 'filtrecategorie', '-- '.JText::_( 'GMAPFP_CATEGORIE_FILTRE' ).' --', 'string' );

		if ($filtreville<>'-- '.JText::_( 'GMAPFP_VILLE_FILTRE' ).' --') {
			$where[] = 'ville = \''.addslashes($filtreville).'\'';
		}			

		if ($filtredepartement<>'-- '.JText::_( 'GMAPFP_DEPARTEMENT_FILTRE' ).' --') {
			$where[] = 'departement = \''.addslashes($filtredepartement).'\'';
		}
		
		if ($filtrecategorie<>'-- '.JText::_( 'GMAPFP_CATEGORIE_FILTRE' ).' --') {
			$where[] = 'title = \''.addslashes($filtrecategorie).'\'';
		}
		
		$where = (count($where) ? ' WHERE '.implode(' AND ', $where) : '');

		$filter_order = $mainframe->getUserStateFromRequest( $option.'filter_order', 'filter_order', '', 'cmd' );
		$filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 'filter_order_Dir', '', 'word' );
		if (!$filter_order) {$filter_order='id';}
		$order = ' ORDER BY '. $filter_order .' '. $filter_order_Dir;

		$query = ' SELECT a.*, b.title '
			. ' FROM #__gmapfp AS a, #__categories AS b '.
			$where.
			$order
		;
		return $query;
	}

	function getData()
	{
		if (empty( $_data ))
		{
			$query = $this->_buildQuery();
			$_data = $this->_getList( $query );
		}

		return $_data;
	}

	function limitArray($array,$start,$limit) {
		$return = Array();
		for ($i=0;$i<count($array);$i++) {
			if ($i >= $start && $i < ($start+$limit)) {
				$return[] = $array[$i];
			}
		}
		return $return;
	}

	function getTotal()
	{
		return $this->_total;
	}

	function getPagination()
	{
		jimport('joomla.html.pagination');
		$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		return $this->_pagination;
	}		

function resize_image2($src_file, $dest_file, $new_size, $method, $dest_qual)
{
	$mainframe = JFactory::getApplication(); 
	$msg = '';
	$imagetype = array( 1 => 'GIF', 2 => 'JPG', 3 => 'PNG', 4 => 'SWF', 5 => 'PSD', 6 => 'BMP', 7 => 'TIFF', 8 => 'TIFF', 9 => 'JPC', 10 => 'JP2', 11 => 'JPX', 12 => 'JB2', 13 => 'SWC', 14 => 'IFF');
	$imginfo = getimagesize($src_file);

	if ($imginfo == null)
		$msg = $src_file.'GMAPFP_ERROR001';

	$imginfo[2] = $imagetype[$imginfo[2]];

  	// GD can only handle JPG & PNG images
  	if ($imginfo[2] != 'JPG' && $imginfo[2] != 'PNG' && ($method == 'gd1' || $method == 'gd2'))
    	$msg = 'GMAPFP_ERROR002';
  	// height/width
  	$srcWidth = $imginfo[0];
  	$srcHeight = $imginfo[1];

  	$ratioW = $srcWidth / $new_size;
  	$ratioH = $srcHeight / $new_size;
  	$destWidth = (int)($srcWidth / $ratioW);
  	$destHeight = (int)($srcHeight / $ratioH);
	
  	// Method for thumbnails creation
  	switch ($method) {
  		case "gd2" :
    		if (!function_exists('imagecreatefromjpeg'))
    			$msg = 'GMAPFP_ERROR004';
        	if (!function_exists('imagecreatetruecolor'))
    			$msg = 'GMAPFP_ERROR005';
    		if ($imginfo[2] == 'JPG')
      			$src_img = imagecreatefromjpeg($src_file);
    		else
      			$src_img = imagecreatefrompng($src_file);
    		if (!$src_img){
      			$ERROR = $lang_errors['invalid_image'];
      			return false;
    		}
    		$dst_img = imagecreatetruecolor($destWidth, $destHeight);
    		imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $destWidth, (int)$destHeight, $srcWidth, $srcHeight);
    		imagejpeg($dst_img, $dest_file, $dest_qual);
    		imagedestroy($src_img);
    		imagedestroy($dst_img);
    	break;
  	}

	// Set mode of uploaded picture
	chmod($dest_file, octdec('755'));
	
	// We check that the image is valid
	$imginfo = getimagesize($dest_file);
	if ($imginfo == null)
		$msg = 'GMAPFP_ERROR006';

	return $msg;
}

	function make()
	{
		$mainframe = JFactory::getApplication(); 

		$config = JComponentHelper::getParams('com_gmapfp');
		$msg='';
		
		$xmlcontent = '<?xml version="1.0" encoding="utf-8" standalone="yes"?>
						<content>';
		
		$items = $this->getdata();
		foreach($items as $item) {
			
			if (($item->album<>0)&&($item->published==1)) {
				$xmlcontent .= '<gallery>
        			<image>'.JURI::base().'..'.$config->get('gmapfp_chemin_img').$item->img.'</image>
					<txt>'.$item->ville.' : '.$item->nom.'</txt>
					<url>../../../index2.php?option=com_gmapfp&view=gmapfp&layout=article&id='.$item->id.'&Itemid=</url>
					<thumb>'.JURI::base().'..'.$config->get('gmapfp_chemin_img')."miniatures/miniature_".$item->img.'</thumb>
    				</gallery>';
			
			
			//die(print_r($mainframe->getCfg('absolute_path').$config->get('gmapfp_chemin_img')));
			
            	$msg = $this->resize_image2($mainframe->getCfg('absolute_path').$config->get('gmapfp_chemin_img').$item->img, $mainframe->getCfg('absolute_path').$config->get('gmapfp_chemin_img')."miniatures/miniature_".$item->img, 100, 'gd2', 75);
			};
			
			
		}

		$file 			= JPATH_COMPONENT_SITE.'/flash_galerie/content.xml';
		//$csscontent	 	= JRequest::getVar('csscontent', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$xmlcontent .= '</content>';
		if( $fp = @fopen( $file, 'w' )) {
			fputs( $fp, stripslashes( $xmlcontent ) );
			fclose( $fp );
		}else{
			$msg = 'GMAPFP_ERROR007';
		}

		return $msg;
	}
	
}
