CREATE TABLE IF NOT EXISTS `#__gmapfp` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `nom` varchar(200) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `sef` varchar(255) DEFAULT NULL,
  `adresse` varchar(200) DEFAULT NULL,
  `adresse2` varchar(200) DEFAULT NULL,
  `ville` varchar(200) DEFAULT NULL,
  `departement` varchar(200) DEFAULT NULL,
  `codepostal` varchar(80) DEFAULT NULL,
  `pay` varchar(200) DEFAULT NULL,
  `email` varchar(100) DEFAULT NULL,
  `web` varchar(200) DEFAULT NULL,
  `img` varchar(100) DEFAULT NULL,
  `album` tinyint(1) NOT NULL DEFAULT '0',
  `introtext` mediumtext,
  `fulltext` mediumtext,
  `horaires_prix` mediumtext,
  `link` varchar(200) DEFAULT NULL,
  `article_id` int(100) DEFAULT '0',
  `icon` varchar(100) DEFAULT NULL,
  `icon_label` varchar(100) DEFAULT NULL,
  `glng` varchar(30) DEFAULT NULL,
  `glat` varchar(30) DEFAULT NULL,
  `gzoom` varchar(2) DEFAULT NULL,
  `kml` VARCHAR(255) DEFAULT NULL ,
  `catid` varchar(255) NOT NULL DEFAULT '0',
  `created_by` int(10) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `featured` TINYINT(1) UNSIGNED NOT NULL DEFAULT '0',
  `access` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) NOT NULL DEFAULT '0',
  `checked_out_time` DATETIME NOT NULL DEFAULT  '0000-00-00 00:00:00',
  `metadesc` text,
  `metakey` text,
  `metadata` text,
  `hits` int(11) unsigned NOT NULL DEFAULT '0',
  `version` int(11) unsigned NOT NULL DEFAULT '1',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(11) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `attribs` text,
  `index_marqueur` int(11) DEFAULT NULL,
  `language` char(7) NOT NULL,
  `classements` varchar(255) DEFAULT NULL,
  `labels` varchar(255) DEFAULT NULL,
  `pictos` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__gmapfp_personnalisation` (
    `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
    `nom` varchar(200) NOT NULL,
    `intro_filtre` mediumtext DEFAULT NULL,
    `intro_carte` mediumtext DEFAULT NULL,
    `conclusion_carte` mediumtext DEFAULT NULL,
    `intro_detail` mediumtext DEFAULT NULL,
    `conclusion_detail` mediumtext DEFAULT NULL,
    `published` tinyint(1) NOT NULL DEFAULT '0',
    PRIMARY KEY (`id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__gmapfp_marqueurs` (
  `id` int(11) NOT NULL auto_increment,
  `nom` text NOT NULL,
  `url` text NOT NULL,
  `marker_width` int(4),
  `marker_height` int(4),
  `centre_x` int(4),
  `centre_y` int(4),
  `url_shadow` text NOT NULL,
  `shadow_width` int(4),
  `shadow_height` int(4),
  `checked_out_time` DATETIME NOT NULL DEFAULT  '0000-00-00 00:00:00',
  `optimized` tinyint(1) UNSIGNED NOT NULL DEFAULT '1',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__gmapfp_params_custom_fields` (
  `id` int(11) NOT NULL auto_increment,
  `nom` varchar(255) DEFAULT NULL,
  `items` text DEFAULT NULL,
  `nom originel` varchar(100) DEFAULT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__gmapfp_classements` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nom` text NOT NULL,
  `cat` int(2) NOT NULL,
  `img` text NOT NULL,
  `ordering` int(11) NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `filtrable` tinyint(1) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__gmapfp_extension_type` (
 `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
 `nom` varchar(255) NOT NULL,
 `alias` varchar(255) NOT NULL,
 `description` varchar(255) NOT NULL,
 `filtrer` tinyint(1) NOT NULL,
 `filtre_label` varchar(100) NOT NULL,
 `recherche` tinyint(1) NOT NULL,
 `type` tinyint(2) NOT NULL,
 `parametres` text NOT NULL,
 `position` int(11) NOT NULL,
 `for_cat` INT NOT NULL,
 `catid` TEXT NOT NULL,
 `form_separator` varchar(20) NOT NULL,
 `view_separator` varchar(20) NOT NULL,
 `field_separator` varchar(20) NOT NULL,
 `published` tinyint(1) NOT NULL,
 `access` int(11) NOT NULL,
 `ordering` int(11) NOT NULL,
 `required` TINYINT(1) NOT NULL,
 PRIMARY KEY (`id`)
) ENGINE=MyISAM;

CREATE TABLE IF NOT EXISTS `#__gmapfp_extension_lang` (
 `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
 `typeid` int(11) NOT NULL,
 `langue` varchar(5) NOT NULL,
 `nom` varchar(255) NOT NULL,
 `parametres` text NOT NULL,
 `filtre_label` varchar(100) NOT NULL,
 PRIMARY KEY (`id`)
) ENGINE=MyISAM;