<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.109pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPViewAccueil extends JViewLegacy
{
    public function display($tpl = NULL)
	{
		$app	= JFactory::getApplication(); 
		//transfert en table les valeurs de customs
		$this->get('Customs'); 
		
		$this->document->addStyleSheet('components/com_gmapfp/views/general.css');
		switch ($app->input->get('layout', '', 'word')){
			case 'select':
				$list			= $this->get('DataChamp');
				$customs_name 	= $this->get('Customs_name');
				$this->champs	= $list ['champs'];
				$this->customs	= $list ['customs'];
				$this->customs_name = $customs_name;
				break;
			default:
				JToolBarHelper::title( JText::_( 'GMAPFP_ACCUEIL_MANAGER' ),'home' );
				$this->state = $this->get('State');
				$this->non_lat_lng = $this->get('NonLatLng')->count;
		}

		$this->sidebar = JHtmlSidebar::render();
		parent::display();
	}

	/**
	 * News du site de GMapFP
	 */
	function rss_out($rssurl) {
	 	
		$cache_time	= 43200;
		$rssDoc = false;
		$output = "";

		try
		{
			$feed = new JFeedFactory;
			$rssDoc = $feed->getFeed($rssurl);
		}
		catch (Exception $e)
		{
			$output = JText::_('JLIB_UTIL_ERROR_LOADING_FEED_DATA');
		}

		if ( $rssDoc == false ) {
			$output = JText::_('Error: Feed not retrieved');
		} else {	
			// channel header and link
			
			$numItems = 5;
			for( $j = 0; $j < $numItems; $j++ ) {
				$item = $rssDoc[$j];
				$output .= '<h5 class="feed-link">';
				$output .= '<a href="' .$item->guid. '" target="_blank">' .$item->title. '</a></h5>';
				if($item->content) {
					$output .= '<div class="feed-item-description">'.$this->limitText($item->content, 250).'</div>';
				}
			}
		}	 	
	 	return $output;
	 }

	function Infos_News() {
	 	
        $lang = JFactory::getLanguage(); 
        $tag_lang=(substr($lang->getTag(),0,2)); 

		//  get RSS parsed object
		if ($tag_lang=='fr'){
			$rssurl		= 'http://gmapfp.org/fr/news?format=feed&type=rss';
		}else{
			$rssurl		= 'http://gmapfp.org/en/news-of-gmapfp?format=feed&type=rss';
		};
		return $this->rss_out($rssurl);
	}
	
	function Infos_Stats() {
	 	
		$total		= $this->get('Stats');
		return $total;
	 }

	function Infos_Versions() {
	 	
		$total		= $this->get('Versions');
		return $total;
	 }

	function limitText($texte, $nbreCar)
	{
		if(is_numeric($nbreCar)){
			$PointSuspension		= '...';
			$LongueurAvantSansHtml	= strlen(trim(strip_tags($texte)));
			$MasqueHtmlSplit		= '#</?([a-zA-Z1-6]+)(?: +[a-zA-Z]+="[^"]*")*( ?/)?>#';
			$MasqueHtmlMatch		= '#<(?:/([a-zA-Z1-6]+)|([a-zA-Z1-6]+)(?: +[a-zA-Z]+="[^"]*")*( ?/)?)>#';
			$texte					.= ' ';
			$BoutsTexte				= preg_split($MasqueHtmlSplit, $texte, -1,  PREG_SPLIT_OFFSET_CAPTURE | PREG_SPLIT_NO_EMPTY);
			$NombreBouts			= count($BoutsTexte);
			if( $NombreBouts == 1 ){
				$texte				.= ' ';
				$LongueurAvant		= strlen($texte);
				$texte 				= substr($texte, 0, strpos($texte, ' ', $LongueurAvant > $nbreCar ? $nbreCar : $LongueurAvant));
				if ($PointSuspension!='' && $LongueurAvant > $nbreCar) {
					$texte			.= $PointSuspension;
				}
			} else {
				$longueur				= 0;
				$indexDernierBout		= $NombreBouts - 1;
				$position				= $BoutsTexte[$indexDernierBout][1] + strlen($BoutsTexte[$indexDernierBout][0]) - 1;
				$indexBout				= $indexDernierBout;
				$rechercheEspace		= true;
				foreach( $BoutsTexte as $index => $bout )
				{
					$longueur += strlen($bout[0]);
					if( $longueur >= $nbreCar )
					{
						 $position_fin_bout = $bout[1] + strlen($bout[0]) - 1;
						 $position = $position_fin_bout - ($longueur - $nbreCar);
						 if( ($positionEspace = strpos($bout[0], ' ', $position - $bout[1])) !== false  )
						 {
								$position	= $bout[1] + $positionEspace;
								$rechercheEspace = false;
						 }
						 if( $index != $indexDernierBout )
								$indexBout	= $index + 1;
						 break;
					}
				}
				if( $rechercheEspace === true ){
					for( $i=$indexBout; $i<=$indexDernierBout; $i++ ){
						 $position = $BoutsTexte[$i][1];
						 if( ($positionEspace = strpos($BoutsTexte[$i][0], ' ')) !== false ){
								$position += $positionEspace;
								break;
						 }
					}
				}
				$texte					= substr($texte, 0, $position);
				preg_match_all($MasqueHtmlMatch, $texte, $retour, PREG_OFFSET_CAPTURE);
				$BoutsTag				= array();
				foreach( $retour[0] as $index => $tag ){
					if( isset($retour[3][$index][0]) ){
						 continue;
					}
					if( $retour[0][$index][0][1] != '/' ){
						 array_unshift($BoutsTag, $retour[2][$index][0]);
					} else {
						 array_shift($BoutsTag);
					}
				}
				if( !empty($BoutsTag) ){
					foreach( $BoutsTag as $tag ){
						 $texte		.= '</'.$tag.'>';
					}
				}
				if ($PointSuspension!='' && $LongueurAvantSansHtml > $nbreCar) {
					$texte				.= 'ReplacePointSuspension';
					$pattern			= '#((</[^>]*>[\n\t\r ]*)?(</[^>]*>[\n\t\r ]*)?((</[^>]*>)[\n\t\r ]*)?(</[^>]*>)[\n\t\r ]*ReplacePointSuspension)#i';
					$texte				= preg_replace($pattern, $PointSuspension.'${2}${3}${5}', $texte);
				}
			}
		}
		return $texte;
	}

}
