<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.109pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPViewChamps extends JViewLegacy
{
	function display($tpl = NULL)
	{
		if (!JFactory::getUser()->authorise('core.edit.fields', 'com_gmapfp')) {
			throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'), 404);
			return false;
		}

		$this->document->addStyleSheet('components/com_gmapfp/views/general.css');
		$app 		= JFactory::getApplication();
		$input		= $app->input;
		$option 	= $input->get('option'); 
		$controller	= $input->get('controller'); 
		$this->state= $this->get('State');
		$params 	= JComponentHelper::getParams('com_gmapfp'); 

		switch ($input->get('layout', '', 'word')){
			case 'liste': 
				require_once JPATH_COMPONENT.'/helpers/gmapfp.php';
				$canDo	= GMapFPHelper::getActions($this->state->get('filter.category_id'));
				JToolBarHelper::title(   JText::_( 'GMAPFP_CHAMPS_MANAGER' ), 'champs' );
				if ($canDo->get('core.create')) {
					JToolBarHelper::addNew();
				}
				if (($canDo->get('core.edit'))) {
					JToolBarHelper::editList();
					if ($params->get('gmapfp_compa_trad_joom25', 0)) 
						JToolBarHelper::custom('traduire', 'copy', 'copy', JText::_( 'GMAPFP_TRADUIRE' ), true);
				}
				if ($canDo->get('core.edit.state')) {
					JToolBarHelper::divider();
					JToolBarHelper::publishList();
					JToolBarHelper::unpublishList();
				}
				if ( $canDo->get('core.delete')) {
					JToolBarHelper::divider();
					JToolBarHelper::deleteList();
				}
			
				// Get data from the model
				$champs		= $this->get('List');
				$this->champs_all		= $this->get('List_all');
				break;
			case 'traduire' :
				// Get data from the model
				$champs		= $this->get('DataChamp');
				
				//cres la liste des types de champs
				$model = $this->getModel('champs');
				
				$this->champ_traduction=$model->getTraductionChamp($champs->id, $input->get('langue', '', 'string'));
	
				JToolBarHelper::title(   JText::_( 'GMAPFP_CHAMPS_TRADUIRE' ).': <small>[ ' . JText::_( 'GMAPFP_EDIT' ).' ]</small>', 'champs' );
				JToolBarHelper::apply('traduire_apply');
				JToolBarHelper::save('traduire_save');
				JToolBarHelper::custom('traduire_delete', 'delete', 'delete', JText::_( 'JTOOLBAR_DELETE' ), false);
				JToolBarHelper::cancel( 'cancel', 'JTOOLBAR_CLOSE' );
				break;
			default :
				// Get data from the model
				$champs		= $this->get('Data');
				$isNew		= ($champs->id < 1);
				
				if ($isNew) {
					$champs->nom = '';
					$champs->description = $input->get('description', '', 'string');
					$champs->filtrer = $input->get('filtrer', '', 'int');
					$champs->filtre_label = $input->get('filtre_label', '', 'string');
					$champs->recherche = $input->get('recherche', '', 'int');
					$champs->type = $input->get('type', '', 'int');
					$champs->parametres = $input->get('parametres', '', 'string');
					$champs->position = $input->get('position', '', 'int');
					$champs->for_cat = $input->get('for_cat', '', 'int');
					$champs->catid = $input->get('catid', '', 'int');
					$champs->form_separator = $input->get('form_separator', '', 'string');
					$champs->view_separator = $input->get('view_separator', '', 'string');
					$champs->published = $input->get('published', '', 'int');
					$champs->ordering = $input->get('ordering', '', 'int');
				}
	
				//cres la liste des types de champs
				$model = $this->getModel('champs');
				
				$this->list_champs = $model->getListChamps($champs->type);
				$this->position_champs=$model->getPositionChamps($champs->position);

				$listcategories = JHtml::_('category.options', 'com_gmapfp');
				if (!empty($listcategories))
				{
					if (!is_array($champs->catid)) $champs->catid = explode(',', $champs->catid);
					$lists['catid']	= JHTML::_('select.genericlist',   $listcategories, 'catid[]', 'class="inputbox" size="5" multiple="multiple"', 'value', 'text', $champs->catid, '' );
				}
	
				$text = $isNew ? JText::_( 'GMAPFP_NEW' ) : JText::_( 'GMAPFP_EDIT' );
				JToolBarHelper::title(   JText::_( 'GMAPFP_CHAMPS_MANAGER' ).': <small>[ ' . $text.' ]</small>', 'champs' );
				JToolBarHelper::apply();
				JToolBarHelper::save();
				JToolBarHelper::save2new();
				if ($isNew)  {
					JToolBarHelper::cancel();
				} else {
					// for existing items the button is renamed `close`
					JToolBarHelper::cancel( 'cancel', 'JTOOLBAR_CLOSE' );
				}
		}
		JHTML::_('behavior.tooltip');

		$this->champs = $champs;
		
		$pageNav = $this->get( 'Pagination' );				
		$this->pageNav = $pageNav;

		$filter_order 		= $app->getUserStateFromRequest( $option.$controller.'filter_order', 'filter_order', 'nom', 'cmd');
		$filter_order_Dir 	= $app->getUserStateFromRequest( $option.$controller.'filter_order_Dir', 'filter_order_Dir', '', 'word');
		$this->limit 		= $app->getUserStateFromRequest( $option.'limit', 'limit', $app->getCfg('list_limit'), 'int');
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
		$this->lists = $lists;

		$this->sidebar = JHtmlSidebar::render();
		parent::display();

	}
}
