<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.109pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPViewClassements extends JViewLegacy
{
	function display($tpl = NULL)
	{
		if (!JFactory::getUser()->authorise('core.edit.classements', 'com_gmapfp')) {
			throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'), 404);
			return false;
		}	
		
		$this->document->addStyleSheet('components/com_gmapfp/views/general.css');
		$app 		= JFactory::getApplication(); 
		$option    	= $app->input->get('option'); 
		$controller	= $app->input->get('controller'); 
		$this->state= $this->get('State');

		$list = array();

		if ($app->input->get('task', '', 'word')=='view' or $app->input->get('layout', '', 'word')=='liste') 
		{
			require_once JPATH_COMPONENT.'/helpers/gmapfp.php';
			$canDo	= GMapFPHelper::getActions($this->state->get('filter.category_id'));
			JToolBarHelper::title(   JText::_( 'GMAPFP_CLASSEMENTS_MANAGER' ), 'classement' );
			if ($canDo->get('core.create')) {
				JToolBarHelper::addNew();
			}
			if (($canDo->get('core.edit'))) {
				JToolBarHelper::editList();
			}
			if ($canDo->get('core.edit.state')) {
				JToolBarHelper::divider();
				JToolBarHelper::publishList();
				JToolBarHelper::unpublishList();
			}
			if ( $canDo->get('core.delete')) {
				JToolBarHelper::divider();
				JToolBarHelper::deleteList();
			}
		
			// Get data from the model
			$classements	= $this->get('List');
			$this->pagination 	= $this->get('Pagination');

			$filter_order 		= $app->getUserStateFromRequest( $option.$controller.'filter_order', 'filter_order', 'nom', 'cmd');
			$filter_order_Dir 	= $app->getUserStateFromRequest( $option.$controller.'filter_order_Dir', 'filter_order_Dir', '', 'word');
			$lists['order_Dir'] = $filter_order_Dir;
			$lists['order'] 	= $filter_order;


		} else {
			// Get data from the model
			$classements	= $this->get('Data');
			$isNew			= ($classements->id < 1);
	
			$text = $isNew ? JText::_( 'GMAPFP_NEW' ) : JText::_( 'GMAPFP_EDIT' );
			JToolBarHelper::title(   JText::_( 'GMAPFP_CLASSEMENTS_MANAGER' ).': <small>[ ' . $text.' ]</small>', 'classement' );
			JToolBarHelper::apply();
			JToolBarHelper::save();
			if ($isNew)  {
				JToolBarHelper::cancel();
			} else {
				// for existing items the button is renamed `close`
				JToolBarHelper::cancel( 'cancel', 'JTOOLBAR_CLOSE' );
			}

			//creation de la liste des images
			jimport( 'joomla.filesystem.folder' );
			$imageFiles = JFolder::files( JPATH_SITE.'/images/gmapfp/classements' );
			$directory	= JURI::base().'..'.'/images/gmapfp/classements/';
			$javascript	= 'onchange="changeDisplayImage('."'".$directory."'".');"';
			$images 	= array(  JHTML::_('select.option',  '', '- '. JText::_( 'Select Image' ) .' -' ) );
			$extensions = "bmp|gif|jpg|jpeg|png";
			foreach ( $imageFiles as $file ) {
			   if ( preg_match( "#$extensions#i", $file ) ) {
					$images[] = JHTML::_('select.option',  $file);
				}
			}
			$lists['images'] = JHTML::_('select.genericlist',  $images, 'img', 'class="inputbox required" size="1" '. $javascript, 'value', 'text', $classements->img );

			//Cration de la liste des langues
			jimport('joomla.language.helper');
			$List_langue['*'] = JText::_('JALL_LANGUAGE');
			$List_langue = array_merge($List_langue, JLanguageHelper::createLanguageList($classements->language, constant('JPATH_SITE'), true, true));

			$lists['language'] = JHtml::_('select.genericlist', $List_langue, 'language',
				array(
					'list.attr' => false,
					'list.select' => $classements->language
				)
			);
			
			//Cration de la liste des types
			$types 		= array();
			$types[] 	= JHTML::_('select.option',  '', '- '. JText::_( 'GMAPFP_SELECT_TYPE' ) .' -' );
			$types[] 	= JHTML::_('select.option',  1, JText::_( 'GMAPFP_CLASSEMENTs' ) );
			$types[] 	= JHTML::_('select.option',  2, JText::_( 'GMAPFP_LABELs' ) );
			$types[] 	= JHTML::_('select.option',  3, JText::_( 'GMAPFP_PICTOs' ) );
			$lists['types'] = JHTML::_('select.genericlist',  $types, 'cat', 'class="inputbox required" size="1" ', 'value', 'text', $classements->cat );
		}
		JHTML::_('behavior.tooltip');

		$this->classements = $classements;
		$this->lists = $lists;
		
		$this->lists = $lists;

		$this->sidebar = JHtmlSidebar::render();
		parent::display();

	}
}
