<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.132pro
	* Creation date: Septembre 2022
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

// Load the tooltip behavior.
JHtml::_('behavior.tooltip');
JHtml::_('behavior.formvalidation');
JHtml::_('behavior.keepalive');
JHtml::_('formbehavior.chosen', 'select');
JHtml::_('behavior.modal', 'a.modal_jform_article');

$config 	= JFactory::getConfig();
$editor 	= JEditor::getInstance($config->get('editor'));

$config = JComponentHelper::getParams('com_gmapfp'); 
		
$_lat = $this->config->get('gmapfp_centre_lat');
$_lng = $this->config->get('gmapfp_centre_lng');
$_zoom = $this->config->get('gmapfp_zoom_admin', 10);
if (empty($_lat)) {$_lat = 47.927385663;};
if (empty($_lng)) {$_lng = 2.1437072753;};

if ($this->config->get('gmapfp_autocomplete_adresse', 0)) {
	echo '
		<style type="text/css">
			.disable {color: grey; font-size: 80%; }
		</style>
	';
	$readonly = 'readonly="readonly"';
} else {
	echo '
		<style type="text/css">
			.enable {display: none; }
		</style>
	';
	$readonly = '';
};

// Dfinition de JUri::base() sans tenir compte du paramtre $config->get('live_site') de la config principale
$uri = JUri::getInstance();
$base['prefix'] = $uri->toString(array('scheme', 'host', 'port'));
if (strpos(php_sapi_name(), 'cgi') !== false && !ini_get('cgi.fix_pathinfo') && !empty($_SERVER['REQUEST_URI']))
	$script_name = $_SERVER['PHP_SELF'];
else $script_name = $_SERVER['SCRIPT_NAME'];
$base['path'] = rtrim(dirname($script_name), '/\\');
$Base_URL = $base['prefix'] . $base['path'] . '/';

?>

<script language="javascript" type="text/javascript">
	Joomla.submitbutton = function(pressbutton) {
		var form = document.adminForm;
		if (pressbutton == 'cancel') {
			submitform( pressbutton );
			return;
		}
		ValueIsReal=(IsReal("glat")&&IsReal("glng")&&IsReal("gzoom"));
		if ((form.nom.value == "")||(form.catid.value == "")||!ValueIsReal) {
			alert( "<?php echo JText::_( 'GMAPFP_CHAMPS_VIDE', true ); ?>" );
			return false;
		} else {
			<?php
			echo $editor->save( 'text_message' );
			echo $editor->save( 'text_horaires_prix' );
			?>
			submitform( pressbutton );
		}
	}
</script>

<script language="javascript" type="text/javascript">
	<?php
	echo 'var field_catid_json = '.$this->extension_fields['json'].';'."\n";
	?>
	function display_catid_field() {
		var value = jQuery('#catid').val();
		
		if(Object.keys(field_catid_json).length > 0)
			for ( var cle in field_catid_json ) {
				var my_array_cat = field_catid_json[cle];
				var correspond = false;
				if (my_array_cat && value)
					for (var i = 0; i < my_array_cat.length; i++) {
						for (var j = 0; j < value.length; j++) {
							if (my_array_cat[i] == 'cat'+value[j]) {
								correspond = true;
							}
						}
					}
				if (correspond) {
					document.getElementById(cle).style.display = "table-row";
				} else {
					document.getElementById(cle).style.display = "none";
				}
			}
	}
</script>

<script language="javascript" type="text/javascript">
    var geocoder;
    var map;
    var marker1;
	var toto;
	var modif_adresse = false;
	var modif_codepostal = false;
	var modif_ville = false;
	var modif_departement = false;
	var modif_pay = false;
	var kml_layer = "";
	var optionkml = { preserveViewport: true };

	
    function autocomplet_champs(latlng, change) {
	  //rcupre ville cp dpartement et pays
		if (latlng == "") latlng = marker1.getPosition();
		geocoder.geocode({'latLng': latlng}, function(results, status) {
		  if (status == google.maps.GeocoderStatus.OK) {
			  var adresse=""; var cp=""; var ville=""; var pays=""; var region=""; var dep=""; var canton="";
			if (results[0]) {
				for ( var i=0; i<results[0].address_components.length; i++) {
					switch (results[0].address_components[i].types[0]) {
						case "street_number":
							adresse = results[0].address_components[i].long_name;
							break;
						case "route":
							adresse = adresse + ' ' + results[0].address_components[i].long_name;
							break;
						case "postal_code":
							cp = results[0].address_components[i].long_name;
							break;
						case "country":
							pays = results[0].address_components[i].long_name;
							break;
						case "administrative_area_level_1": //FR:region US:state
							region = results[0].address_components[i].long_name;
							break;
						case "administrative_area_level_2": //FR:dpartement US:counties
							dep = results[0].address_components[i].long_name;
							break;
						case "administrative_area_level_3": //FR:canton US:?
							canton = results[0].address_components[i].long_name;
							break;
						case "locality":
							ville = results[0].address_components[i].long_name;
							break;
					}
				}
				
				<?php 
				if ($this->config->get('gmapfpadresse1_view',1) and $this->config->get('gmapfp_autocomplete_adresse',0) and $this->config->get('gmapfp_autocomplete_adresse_adresse',1)==2) echo "if (!modif_adresse || change) document.getElementById('adresse').value = adresse;";
				if ($this->config->get('gmapfp_cp_view',1) and $this->config->get('gmapfp_autocomplete_adresse',0)) echo "if (!modif_codepostal || change) document.getElementById('codepostal').value = cp;";
				if ($this->config->get('gmapfp_pays_view',1) and $this->config->get('gmapfp_autocomplete_adresse',0)) echo "if (!modif_pay || change) document.getElementById('pay').value = pays;";
				switch ($this->config->get('gmapfp_autocomplete_adresse_dep',0)) {
					case 0 :
					if ($this->config->get('gmapfp_departement_view',1) and $this->config->get('gmapfp_autocomplete_adresse',0)) echo "if (!modif_departement || change) document.getElementById('departement').value = dep;";
					break;
					case 1 :
					if ($this->config->get('gmapfp_departement_view',1) and $this->config->get('gmapfp_autocomplete_adresse',0)) echo "if (!modif_departement || change) document.getElementById('departement').value = region;";
					break;
					case 2 :
					if ($this->config->get('gmapfp_departement_view',1) and $this->config->get('gmapfp_autocomplete_adresse',0)) echo "if (!modif_departement || change) document.getElementById('departement').value = canton;";
				}
				if ($this->config->get('gmapfp_ville_view',1) and $this->config->get('gmapfp_autocomplete_adresse',0)) echo "if (!modif_ville || change) document.getElementById('ville').value = ville;"; ?>
				UpdateAddress();
			} else {
			  alert("No results found");
			}
		  } else {
			alert("Geocoder failed due to: " + status);
		  }
		});		  
	}
	
	function init_GMapFP() {
		UpdateAddress();
		geocoder = new google.maps.Geocoder();
        
		var lat, lng, zoom_carte;
        if(document.adminForm.glat.value!=0) lat = document.adminForm.glat.value;
        else lat = <?php echo $_lat?>;
        if(document.adminForm.glng.value!=0) lng = document.adminForm.glng.value;
        else lng = <?php echo $_lng?>;
        if(document.adminForm.gzoom.value!=0) zoom_carte = parseInt(document.adminForm.gzoom.value);
        else zoom_carte = <?php echo $_zoom?>;

		var latlng = new google.maps.LatLng(lat, lng);
		var myOptions = {
		  zoom: zoom_carte,
		  center: latlng,
		  mapTypeId: "<?php echo $this->config->get('gmapfp_type_admin', 'roadmap');?>"
		  //google.maps.MapTypeId.ROADMAP
		};

		map = new google.maps.Map(document.getElementById("map"), myOptions);

        <?php if ($this->item->kml) echo "change_kml('".$this->item->kml."')"; ?>
		
		var input = document.getElementById('autocomplete_adresse');
        var autocomplete = new google.maps.places.Autocomplete(input);

		google.maps.event.addListener(autocomplete, 'place_changed', function() {
			document.getElementById('localisation').value = document.getElementById('adresse').value + ' ' + document.getElementById('adresse2').value + ' ' + document.getElementById('autocomplete_adresse').value;
			showAddress(document.getElementById('localisation'));
		});

	  google.maps.event.addListener(map, "bounds_changed", function() {
		   document.adminForm.gzoom.value = map.getZoom();
	  });

      // Create a draggable marker which will later on be binded to a
      marker1 = new google.maps.Marker({
          map: map,
          position: new google.maps.LatLng(lat, lng),
          draggable: true,
          title: 'Drag me!'
      });
	  google.maps.event.addListener(marker1, "drag", function() {
		document.adminForm.glat.value = marker1.getPosition().lat();
		document.adminForm.glng.value = marker1.getPosition().lng();
	  });
	  google.maps.event.addListener(marker1, "dragend", function() {
		autocomplet_champs(marker1.getPosition(), false);
	  });
    }

    // Register an event listener to fire when the page finishes loading.
    google.maps.event.addDomListener(window, 'load', pre_init_GMapFP);

	var tstIntGMapFP;
	
	function CheckGMapFP() {
		if (document.getElementById("map")) {
			if (document.getElementById("map").offsetWidth != document.getElementById("map").getAttribute("oldValue")) {
				document.getElementById("map").setAttribute("oldValue",document.getElementById("map").offsetWidth);
				init_GMapFP();
			}
		}
	}
	
	function pre_init_GMapFP() {
	   document.getElementById("map").setAttribute("oldValue",0);
	   tstIntGMapFP = setInterval("CheckGMapFP()",500);
	}

    function showAddress(e) {
		if (geocoder) {
			geocoder.geocode( { 'address' : e.value}, function(results, status) {
				if (status == google.maps.GeocoderStatus.OK) {
				  map.setCenter(results[0].geometry.location);
				  marker1.setPosition(results[0].geometry.location); 
					document.adminForm.glat.value = results[0].geometry.location.lat();
					document.adminForm.glng.value = results[0].geometry.location.lng();
					autocomplet_champs(results[0].geometry.location, false);
				} else {
				  alert(e.value + " not found for the following reason: " + status);
				}
			})
		}
    }

    function getCoordinate() {
		var lat, lng;
        if(document.adminForm.glat.value!=0) lat = document.adminForm.glat.value;
        else lat = <?php echo $_lat?>;
        if(document.adminForm.glng.value!=0) lng = document.adminForm.glng.value;
        else lng = <?php echo $_lng?>;
        if(document.adminForm.gzoom.value!=0) zoom_carte = parseInt(document.adminForm.gzoom.value);
        else zoom = <?php echo $_zoom?>;

		ValueIsReal = (IsReal("glat")&&IsReal("glng")&&IsReal("gzoom"));
		if (ValueIsReal) {
			var latlng = new google.maps.LatLng(lat, lng);
			map.setZoom(zoom_carte);
			map.setCenter(latlng);
			marker1.setPosition(latlng); 
			autocomplet_champs(latlng, false);
		}
    }
	
	function changeDisplayImage() {
		if (document.adminForm.img.value !='') {
			document.adminForm.imagelib.src='<?php echo COM_GMAPFP_IMAGES_HTTP; ?>/thumbsArt/' + document.adminForm.img.value;
		} else {
			document.adminForm.imagelib.src='<?php echo COM_GMAPFP_IMAGES_HTTP; ?>/blank/blank.png';
		}
	}

	function changeDisplayIcon(chemin) {
		if (document.adminForm.icon.value !='') {
			document.adminForm.imageicon.src=chemin + document.adminForm.icon.value;
		} else {
			document.adminForm.imageicon.src=chemin + '../blank/blank.png';
		}
	}

    function addphoto(namefile, file){
        var optX = new Option(file, namefile);
        var selX = document.adminForm.elements['img'];
        var lenghX = selX.length;
        selX.options[lenghX] = optX;
                selX.options[lenghX].selected = true;
    }

	function UpdateAddress(){
 		document.adminForm.localisation.value = document.adminForm.adresse.value + " " + document.adminForm.adresse2.value + " " + document.adminForm.codepostal.value + " " + document.adminForm.ville.value + " " + document.adminForm.departement.value + ", " + document.adminForm.pay.value;	
	}

	function IsReal(id){
		MonNombre=document.getElementById(id).value;
		if(isNaN(MonNombre))
		{
			alert("\"" + MonNombre + "\" <?php echo JText::_( 'GMAPFP_PAS_NOMBRE' ); ?>");
			return false;
		}	
		return true;
	}
	
	function change_disable (nom) {
		document.getElementById(nom).removeAttribute('readonly');
		document.getElementById('disable'+nom).className = "";
		document.getElementById('button'+nom).style.display = "none";
		eval('modif_'+nom+' = true;');
	}
	
	function Geolocalise() {
		if(navigator.geolocation) {
			navigator.geolocation.getCurrentPosition(function(position) {
			  var pos = new google.maps.LatLng(position.coords.latitude,
											   position.coords.longitude);
				marker1.setPosition(pos);
				map.setCenter(pos);
				document.adminForm.glat.value = marker1.getPosition().lat();
				document.adminForm.glng.value = marker1.getPosition().lng();
				autocomplet_champs('', true);
				jQuery('#info_geolocalisation').html('');
			}, function() {
				jQuery('#info_geolocalisation').html('<?php echo JText::_('GMAPFP_ERROR_GEOLOC'); ?>');
			});
		} else {
			// Browser doesn't support Geolocation
			jQuery('#info_geolocalisation').html('<?php echo JText::_('GMAPFP_ERROR_GEOLOC_DONT_SUPPORT'); ?>');
		}	
	}
	
	function change_kml(url){
		if (!url) url = document.adminForm.kml.value;
		var kml_urls = url.split(';');
		if (kml_layer) kml_layer.setMap(null);
		for (var kml_cnt = 0; kml_cnt < kml_urls.length; kml_cnt++) {
			kml_layer = new google.maps.KmlLayer(kml_urls[kml_cnt], optionkml);
			kml_layer.setMap(map);
		}
	}
</script>

<script language="javascript" type="text/javascript">
	function jSelectArticle_id_name(id, title, catid, object, url, language) {
		document.getElementById("jform_article_id").value = id;
		document.getElementById("jform_article_name").value = title;
		SqueezeBox.close();
	}

	function jResetArticle_id_name() {
		document.getElementById("jform_article_id").value = "";
		document.getElementById("jform_article_name").value = "";
	}

	function jSelectUser_jform_created_by(id, title) {
		var old_id = document.getElementById("jform_created_by_id").value;
		if (old_id != id) {
			document.getElementById("jform_created_by_id").value = id;
			document.getElementById("jform_created_by_name").value = title;
		}
		SqueezeBox.close();
	}
</script>

<?php 
	//fonction dropfile
?>
<script language="javascript" type="text/javascript">
	jQuery(document).ready(function ($){
		$('#dropzonefp').unbind();
		$('#dropzonefp').filedrop({
			fallback_id: 'upload_filefp_input',   // an identifier of a standard file input element, becomes the target of \"click\" events on the dropzone
			url: 'index.php?option=com_gmapfp&controller=dropfiles&task=upload_image&<?php echo JSession::getFormToken();?>=1',              // upload handler, handles each file separately, can also be a function taking the file and returning a url
			paramname: 'image1',          // POST parameter name used on serverside to reference file, can also be a function taking the filename and returning the paramname
			maxfiles: 1,
			maxfilesize: 20,    // max file size in MBs
			queuefiles: 1,
			data: {
				module_id : function(){
					return $('input[name=id]').val(); 
				}
			},
			error: function(err, file) {
				switch(err) {
					case 'BrowserNotSupported':
						bootbox.alert(Joomla.JText._('GMAPFP_BROWSER_NOT_SUPPORT_HTML5'));
						break;
					case 'TooManyFiles':
						// user uploaded more than 'maxfiles'
						bootbox.alert(Joomla.JText._('GMAPFP_TOO_MANY_FILES') + ' !');
						break;
					case 'FileTooLarge':
						// program encountered a file whose size is greater than 'maxfilesize'
						// FileTooLarge also has access to the file which was too large
						// use file.name to reference the filename of the culprit file
						bootbox.alert(file.name + Joomla.JText._('GMAPFP_FILE_TOO_LARGE') + ' !');
						break;
					case 'FileTypeNotAllowed':
						// The file type is not in the specified list 'allowedfiletypes'
						bootbox.alert(file.name + Joomla.JText._('GMAPFP_FILE_TYPE_NOT_ALLOWED') + ' !');
						break;
					case 'FileExtensionNotAllowed':
						// The file extension is not in the specified list 'allowedfileextensions'
						bootbox.alert(file.name + Joomla.JText._('GMAPFP_EXTENSION_TYPE_NOT_ALLOWED') + ' !');
						break;
					default:
						break;
				}
			},
			dragOver: function() {
				$(this).css('border', '3px dashed red');
				// user dragging files over #dropzone
			},
			dragLeave: function() {
				$(this).css('border', '3px dashed #BBBBBB');
				// user dragging files out of #dropzone
			},
			drop: function() {
				// user drops file
				$(this).css('border', '3px dashed #BBBBBB');
			},
			uploadStarted: function(i, file, len){
				// a file began uploading
				// i = index => 0, 1, 2, 3, 4 etc
				// file is the actual file of the index
				// len = total files user dropped
				var bar = $('<div class="progress progress-striped active">'+
								'<div class="bar"></div>'+
							'</div>');
				$('#gmapfp_image').append(bar);
				
				var preview = $('#gmapfp_image');
				var image = $('img', preview);

				var reader = new FileReader();

				reader.onload = function(e){
						// e.target.result holds the DataURL which
						image.attr('src',e.target.result);
				};

				// Reading the file as a DataURL. When finished,
				// this will trigger the onload function above:
				reader.readAsDataURL(file);

				preview.appendTo('#gmapfp_image');
				// Associating a preview container
				// with the file, using jQuery's $.data():

				$.data(file,preview);
			},
			uploadFinished: function(i, file, response, time) {
				// response is the data you got back from server in JSON format.
				var preview = $('#gmapfp_image');
				var image = $('img', preview);
				if (response.response != true) {
					bootbox.alert(response.datas);
					if ($('#img').val()) {
						image.attr('src','../images/gmapfp/thumbsArt/' + $('#img').val());
					} else {
						image.attr('src','../images/gmapfp/blank/blank.png');
					}
					preview.appendTo('#gmapfp_image');
				} else {
					$('<option />', {val: response.datas, text: file.name}).appendTo($('#img'))
					$('#img option[value="' + response.datas + '"]').attr('selected', 'selected');
					// $('#img').trigger('chosen:updated'); //nouvelle methode
					$('#img').val(response.datas).trigger('liszt:updated'); //ancienne methode
					image.attr('src','../images/gmapfp/thumbsArt/' + response.datas);
					preview.appendTo('#gmapfp_image');
				}
			},
			progressUpdated: function(i, file, progress) {
				// this function is used for large files and updates intermittently
				// progress is the integer value of file being uploaded percentage to completion
				$.data(file).find('.progress .bar').width(progress+'%');
			},
			beforeEach: function(file) {
				// file is a file object
				// return false to cancel upload
				if(!file.type.match(/^image\//)){
					bootbox.alert(Joomla.JText._('GMAPFP_ONLY_IMAGE_ALLOWED') + ' !');
					return false;
				}
			},
			afterAll: function() {
				// runs after all files have been uploaded or otherwise dealt with
				$('#dropzonefp .progress').delay(300).fadeIn(300).hide(300, function(){
				  $(this).remove();
				});
			}
		});
		jQuery('#upload_filefp_button').on('click',function(){
			jQuery('#upload_filefp_input').trigger('click');
			return false;
		});
	});

</script>

<form action="index.php" method="post" name="adminForm" id="adminForm" class="gmapfp form-horizontal">
			<table  class="adminform">
				<tr>
					<td>
							<?php 
								if (@$this->custom[6]->nom) {
									$titre =  $this->custom[6]->nom;
								}else{
									$titre =  JText::_( 'GMAPFP_NOM' );
								}
							?>
						<label for="nom" class="hasTip" title="<?php echo str_replace('"', '&quot;', $titre.'::'.JText::_('JFIELD_TITLE_DESC')).'">';
							echo $titre; ?>:
						</label>
					</td>
					<td>
						<input class="inputbox required" type="text" name="nom" id="nom" size="60" maxlength="200" value="<?php echo str_replace('"', '&quot;',$this->item->nom); ?>" />
					</td>
					<td>
						<label for="alias" class="hasTip" title="<?php echo str_replace('"', '&quot;', JText::_('JFIELD_ALIAS_LABEL').'::'.JText::_('JFIELD_ALIAS_DESC')) ?>">
							<?php echo JText::_( 'JFIELD_ALIAS_LABEL' ); ?>:
						</label>
					</td>
					<td>
						<input class="text_area" type="text" name="alias" id="alias" size="32" maxlength="255" value="<?php echo $this->item->alias;?>" />
					</td>
				</tr>
			</table>
	<div class="row-fluid">
		<div class="span9">
			   <?php             
				echo JHtml::_('bootstrap.startTabSet', 'myTab', array('active' => 'localisation'));
				echo JHtml::_('bootstrap.addTab', 'myTab', 'localisation', JText::_('GMAPFP_LOCALISATION', true));
                ?>
                <table class="admintable"><tr><td>
                    <table>
                    	<?php
							if (@$this->extension_fields[0])
							foreach($this->extension_fields[0] as $field) {
								echo $field;
							};
						?>
						<?php if ($this->config->get('gmapfp_autocomplete_adresse_adresse',1)==2) { ?>
							<tr <?php if (!$this->config->get('gmapfp_autocomplete_adresse',0)){echo 'style="display: none; visibility: hidden;"';}?>>
								<td class="key">
									<label for="autocomplete_adresse" class="hasTip" title="<?php echo JText::_( 'GMAPFP_AUTOCOMPLET_VILLE_PAYS' ).'::'.JText::_( 'GMAPFP_VILLE_DESC' ); ?>">
										<?php echo JText::_( 'GMAPFP_AUTOCOMPLET_VILLE_PAYS' ); ?>:
									</label>
								</td>
								<td>
									<input class="inputbox" type="text" name="autocomplete_adresse" id="autocomplete_adresse" size="50" maxlength="80" title="<?php echo JText::_( 'GMAPFP_VILLE_DESC' ); ?>"/>
									<div id="buttonmelocaliser" style="margin-left:5px; display: inline-block;"> 
										<div class="blank enable btn"> 
											<a title="<?php echo JText::_('GMAPFP_ME_LOCALISER'); ?>" href="javascript:Geolocalise();"> 
											<?php echo JText::_('GMAPFP_ME_LOCALISER'); ?></a> 
										</div> 
									</div> 
								</td>
							</tr>
						<?php } ?>
 						<?php if ($this->config->get('gmapfp_autocomplete_adresse_adresse',1)==1) { ?>
							<tr <?php if (!$this->config->get('gmapfpadresse1_view', 1)){echo 'style="display: none; visibility: hidden;"';}?>>
								<td width="110" class="key">
									<label for="adresse">
										<?php echo JText::_( 'GMAPFP_ADRESSE' ); ?> 1:
									</label>
								</td>
								<td>
									<input class="inputbox" type="text" name="adresse" id="adresse" onchange="UpdateAddress();" size="50" maxlength="200" value="<?php echo str_replace('"', '&quot;',$this->item->adresse); ?>" />
								</td>
							</tr>
						<?php } else { ?>
							<tr <?php if (!$this->config->get('gmapfpadresse1_view', 1)){echo 'style="display: none; visibility: hidden;"';}?> id="disableadresse" class="disable">
								<td width="110" class="key">
									<label for="adresse">
										<?php echo JText::_( 'GMAPFP_ADRESSE' ); ?> 1:
									</label>
								</td>
								<td>
									<input class="inputbox" type="text" name="adresse" id="adresse" onchange="UpdateAddress();" size="50" maxlength="200" value="<?php echo str_replace('"', '&quot;',$this->item->adresse); ?>" <?php echo $readonly; ?> />
									<div id="buttonadresse" style="margin-left:5px; display: inline-block;"> 
										<div class="blank enable btn"> 
											<a title="<?php echo JText::_('JMODIFY'); ?>" href="javascript:change_disable('adresse');"> 
											<?php echo JText::_('JMODIFY'); ?></a> 
										</div> 
									</div> 
								</td>
							</tr>
						<?php } ?>
                        <tr <?php if (!$this->config->get('gmapfpadresse2_view', 1)){echo 'style="display: none; visibility: hidden;"';}?>>
                            <td width="110" class="key">
                                <label for="adresse2">
                                    <?php echo JText::_( 'GMAPFP_ADRESSE' ); ?> 2:
                                </label>
                            </td>
                            <td>
                                <input class="inputbox" type="text" name="adresse2" id="adresse2" onchange="UpdateAddress();" size="50" maxlength="200" value="<?php echo str_replace('"', '&quot;',$this->item->adresse2); ?>" />
                            </td>
                        </tr>
						<?php if ($this->config->get('gmapfp_autocomplete_adresse_adresse',1)==1) { ?>
							<tr <?php if (!$this->config->get('gmapfp_autocomplete_adresse',0)){echo 'style="display: none; visibility: hidden;"';}?>>
								<td class="key">
									<label for="autocomplete_adresse" class="hasTip" title="<?php echo JText::_( 'GMAPFP_AUTOCOMPLET_VILLE_PAYS' ).'::'.JText::_( 'GMAPFP_VILLE_DESC' ); ?>">
										<?php echo JText::_( 'GMAPFP_AUTOCOMPLET_VILLE_PAYS' ); ?>:
									</label>
								</td>
								<td>
									<input class="inputbox" type="text" name="autocomplete_adresse" id="autocomplete_adresse" size="50" maxlength="80" title="<?php echo JText::_( 'GMAPFP_VILLE_DESC' ); ?>"/>
									<div id="buttoncodepostal" style="margin-left:5px; display: inline-block;"> 
										<div class="blank enable btn"> 
											<a title="<?php echo JText::_('GMAPFP_ME_LOCALISER'); ?>" href="javascript:Geolocalise();"> 
											<?php echo JText::_('GMAPFP_ME_LOCALISER'); ?></a> 
										</div> 
									</div> 
								</td>
							</tr>
						<?php } ?>
                        <tr <?php if (!$this->config->get('gmapfp_cp_view', 1)){echo 'style="display: none; visibility: hidden;"';}?> id="disablecodepostal" class="disable">
                            <td class="key">
                                <label for="codepostal">
                                    <?php echo JText::_( 'GMAPFP_CODEPOSTAL' ); ?>:
                                </label>
                            </td>
                            <td>
                                <input class="inputbox" type="text" name="codepostal" id="codepostal" onchange="UpdateAddress();" size="50" maxlength="80" value="<?php echo str_replace('"', '&quot;',$this->item->codepostal); ?>" <?php echo $readonly; ?>/>
                                <div id="buttoncodepostal" style="margin-left:5px; display: inline-block;"> 
                                    <div class="blank enable btn"> 
                                        <a title="<?php echo JText::_('JMODIFY'); ?>" href="javascript:change_disable('codepostal');"> 
                    					<?php echo JText::_('JMODIFY'); ?></a> 
                                    </div> 
                                </div> 
                            </td>
                        </tr>
                        <tr <?php if (!$this->config->get('gmapfp_ville_view', 1)){echo 'style="display: none; visibility: hidden;"';}?> id="disableville" class="disable">
                            <td class="key">
                                <label for="ville">
                                    <?php echo JText::_( 'GMAPFP_VILLE' ); ?>:
                                </label>
                            </td>
                            <td>
                                <input class="inputbox" type="text" name="ville" id="ville" onchange="UpdateAddress();" size="50" maxlength="200" value="<?php echo str_replace('"', '&quot;',$this->item->ville); ?>" <?php echo $readonly; ?>/>
                                <div id="buttonville" style="margin-left:5px; display: inline-block;"> 
                                    <div class="blank enable btn"> 
                                        <a title="<?php echo JText::_('JMODIFY'); ?>" href="javascript:change_disable('ville');"> 
                    					<?php echo JText::_('JMODIFY'); ?></a> 
                                    </div> 
                                </div> 
                            </td>
                        </tr>
                        <tr <?php if (!$this->config->get('gmapfp_departement_view', 1)){echo 'style="display: none; visibility: hidden;"';}?> id="disabledepartement" class="disable">
                            <td class="key">
                                <label for="departement" >
                                    <?php echo JText::_( 'GMAPFP_DEPARTEMENT' ); ?>:
                                </label>
                            </td>
                            <td>
                                <input class="inputbox" type="text" name="departement" id="departement" onchange="UpdateAddress();" size="50" maxlength="200" value="<?php echo str_replace('"', '&quot;',$this->item->departement); ?>" <?php echo $readonly; ?>/>
                                <div id="buttondepartement" style="margin-left:5px; display: inline-block;"> 
                                    <div class="blank enable btn"> 
                                        <a title="<?php echo JText::_('JMODIFY'); ?>" href="javascript:change_disable('departement');"> 
                    					<?php echo JText::_('JMODIFY'); ?></a> 
                                    </div> 
                                </div> 
                            </td>
                        </tr>
                        <tr <?php if (!$this->config->get('gmapfp_pays_view', 1)){echo 'style="display: none; visibility: hidden;"';}?> id="disablepay" class="disable">
                            <td class="key">
                                <label for="pay">
                                    <?php echo JText::_( 'GMAPFP_PAYS' ); ?>:
                                </label>
                            </td>
                            <td>
                                <input class="inputbox" type="text" name="pay" id="pay" onchange="UpdateAddress();" size="50" maxlength="200" value="<?php echo str_replace('"', '&quot;',$this->item->pay); ?>" <?php echo $readonly; ?>/>
                                <div id="buttonpay" style="margin-left:5px; display: inline-block;"> 
                                    <div class="blank enable btn"> 
                                        <a title="<?php echo JText::_('JMODIFY'); ?>" href="javascript:change_disable('pay');"> 
                                        <?php echo JText::_('JMODIFY'); ?></a> 
                                    </div> 
                                </div> 
                            </td>
                        </tr>
                        <tr <?php if (!$this->config->get('gmapfp_autocomplete_adresse',0)){echo 'style="display: none; visibility: hidden;"';}?>>
                        	<td>
                            </td>
                        	<td>
                                <div class="btn" style="margin-left:5px;"> 
                                    <div class="blank"> 
                                        <a title="<?php echo JText::_('GMAPFP_REACATUALISER_DESC'); ?>" href="javascript:;"  onclick="autocomplet_champs('', true);"> 
                    					<?php echo JText::_('GMAPFP_REACATUALISER'); ?></a> 
                                    </div> 
                                </div> 
                            </td>
                        </tr>
                    	<?php
							if (@$this->extension_fields[1])
							foreach($this->extension_fields[1] as $field) {
								echo $field;
							};
						?>
                    	<?php
							if (@$this->extension_fields[2])
							foreach($this->extension_fields[2] as $field) {
								echo $field;
							};
						?>
                        <tr <?php if (!$this->config->get('gmapfp_email_view', 1)){echo 'style="display: none; visibility: hidden;"';}?>>
                            <td class="key">
                                <label for="email">
                                    <?php echo JText::_( 'GMAPFP_EMAIL' ); ?>:
                                </label>
                            </td>
                            <td>
                                <input class="inputbox" type="email" name="email" id="email" size="50" maxlength="100" value="<?php echo str_replace('"', '&quot;',$this->item->email); ?>" />
                            </td>
                        </tr>
                        <tr <?php if (!$this->config->get('gmapfp_web_view', 1)){echo 'style="display: none; visibility: hidden;"';}?>>
                            <td class="key">
                                <label for="web">
                                    <?php echo JText::_( 'GMAPFP_SITE_WEB' ); ?>:
                                </label>
                            </td>
                            <td>
                                <input class="inputbox" type="url" name="web" id="web" size="50" maxlength="200" value="<?php echo str_replace('"', '&quot;',$this->item->web); ?>" />
                            </td>
                        </tr>
                    	<?php
							if (@$this->extension_fields[3])
							foreach($this->extension_fields[3] as $field) {
								echo $field;
							};
						?>
                        </table></td>
                            <td  valign="top" width="30%" class="key">
								<div id="dropzonefp">
									<label for="img" style="cursor:default;">
										<?php echo JText::_('GMAPFP_IMAGE'); ?>:
									</label>
									<label class="drop_info" style="cursor:default;">
										<?php echo JText::_('GMAPFP_DROP_ZONE_IMAGE'); ?>
									</label>
									<div id="gmapfp_image" style="overflow:auto;">
									<?php 
										$directory		= COM_GMAPFP_IMAGES_HTTP.'/thumbsArt/';
										$javascript		= 'onchange="changeDisplayImage();"';
					
										if ((stristr($this->item->img,'bmp'))||(stristr($this->item->img,'gif'))||(stristr($this->item->img,'jpg'))||(stristr($this->item->img,'jpeg'))||(stristr($this->item->img,'png'))) {
											?>
											<img src="<?php echo $directory.$this->item->img; ?>" name="imagelib"/>
											<?php
										} else {
											?>
											<img src="<?php echo COM_GMAPFP_IMAGES_HTTP; ?>/blank/blank.png" name="imagelib"/>
											<?php
										}
									echo'</div>';
									echo '<div>';
										echo $this->lists['images'];
									?>
										<br />
										<input type="file" id="upload_filefp_input" multiple="">
										<a href="" id="upload_filefp_button" class="btn btn-primary"><i class="icon-picture"></i>&nbsp;<?php echo '&nbsp;&nbsp;&nbsp;'.JText::_('GMAPFP_UPLOAD') ?></span></a>
									</div>
								</div>
							</td>
						</tr>
					</table>
                    <table class="admintable">
                        <tr>
                            <td width="110" class="key">
                                <label for="localisation">       
                                    <?php echo JText::_('GMAPFP_MAJ_ADRESSE'); ?>:
                                </label>
                            </td>
                            <td valign="top">
                                <input type="text" style="width:70%" id="localisation" name="localisation" value="" />
                                <div class="btn" style="margin-left:5px;"> 
                                    <div class="blank"> 
                                        <a title="<?php echo JText::_('GMAPFP_CHERCHER'); ?>" href="javascript:;"  onclick="showAddress(document.adminForm.localisation);"> 
                    					<?php echo JText::_('GMAPFP_CHERCHER'); ?></a> 
                                    </div> 
                                </div> 
                            </td>
                        </tr>
                        <tr>
                            <td width="110" class="key">
                                <label for="glat">
                                    <?php echo JText::_('GMAPFP_LAT'); ?>
                                </label>
                                <label for="glng">
                                    - <?php echo JText::_('GMAPFP_LON'); ?>
                                </label>
                                <label for="gzoom">
                                    - Zoom:
                                </label>
                            </td>
                            <td valign="top">
                                <input class="inputbox" onblur="IsReal('glat');" type="text" name="glat" id="glat" size="24" maxlength="30" value="<?php echo $this->item->glat ?>" />
                                <input class="inputbox" onblur="IsReal('glng');" type="text" name="glng" id="glng" size="24" maxlength="30" value="<?php echo $this->item->glng ?>" />
                                <input class="inputbox" onblur="IsReal('gzoom');" type="text" name="gzoom" id="gzoom" size="2" maxlength="12" value="<?php echo $this->item->gzoom ?>" />
                                <div class="btn" style="margin-left:5px;"> 
                                    <div class="blank"> 
                                        <a title="<?php echo JText::_('GMAPFP_CHERCHER_COORDONNEES'); ?>" href="javascript:;"  onclick="getCoordinate();"> 
                    					<?php echo JText::_('GMAPFP_CHERCHER_COORDONNEES'); ?></a> 
                                    </div> 
                                </div> 
                            </td>
                        </tr>
                        <tr>
                            <td width="100" align="right" class="key">
                                <label for="map">
                                    <?php echo JText::_('GMAPFP_CARTE'); ?>:
                                </label>
                            </td>
                            <td>
								<div id="map" style="width: 100%; height: 500px; overflow:hidden;"></div>
								<div id="info_geolocalisation" class="gmapfp_geolocal_info"></div>
                            </td>
                        </tr>
                        <tr>
                            <td width="100" class="key">
                                <label for="marker"><?php echo JText::_( 'GMAPFP_MARKER' ); ?>:</label>
                            </td>
                            <td>
                                <div class="controls" style=" height: auto; ">
                                    <fieldset class="radio btn-group" style="white-space: normal;">
                                    <?php 
										$marqueurs = '';
										$marqueur_cat = '';
										
										//ajoute les lments du marqueur par dfaut
										$defaul_marqueur = new stdclass();
										$defaul_marqueur->url = JUri::root().'images/gmapfp/marqueurs/cat_default.png';
										$defaul_marqueur->nom = JText::_( 'GMAPFP_MARKER_CAT_DEFAULT');
										$defaul_marqueur->id = 0;
										array_unshift($this->marqueurs, $defaul_marqueur);
										
                                        $cnt = 0;
                                        foreach($this->marqueurs as $marqueur) {
                                            $checked = '';
                                            if ($this->item->index_marqueur == 0 or (!$this->item->index_marqueur and $cnt==0)) { $checked = 'checked="checked"'; }
                                            $checked = '';
                                            if ($this->item->index_marqueur == $marqueur->id) { $checked = 'checked="checked"'; }
                                            $marqueurs .= '<input type="radio" style="float:none;" name="index_marqueur" id="index_marqueur'.$cnt.'" value="'.$marqueur->id.'" '.$checked.' /><label for="index_marqueur'.$cnt.'" style="display: inline-block !important;height: 46px"><img src="'.$marqueur->url.'" title="'.$marqueur->nom.'" /></label>';
                                            $cnt++;
                                        }
										echo $marqueur_cat.$marqueurs;
                                    ?>
                                    </tr>
                                </div>
                            </td>
                        </tr>
                        <tr <?php if (!$this->config->get('gmapfp_KML_view', 1)){echo 'style="display: none; visibility: hidden;"';}?>>
                            <td class="key">
                                <label for="kml">
                                    <?php echo JText::_( 'GMAPFP_KML' ); ?>:
                                </label>
                            </td>
                            <td>
                                <input class="inputbox input-xxlarge" type="url" name="kml" onkeyup="change_kml();" id="kml" size="50" maxlength="255" value="<?php echo $this->item->kml; ?>" />
                            </td>
                        </tr>
                    </table>
			   <?php             
				echo JHtml::_('bootstrap.endTab');
				$hide = '';
				if (!$this->config->get('gmapfp_classements_view', 1) and !$this->config->get('gmapfp_pictos_view', 1) and !$this->config->get('gmapfp_labels_view', 1) and !COM_GMAPFP_VERSION_OT){$hide = '" style="display: none; visibility: hidden;';}
				echo JHtml::_('bootstrap.addTab', 'myTab', 'icons'.$hide, JText::_('GMAPFP_ICONS', true));
				//echo JHtml::_('bootstrap.addTab', 'myTab', 'icons', JText::_('GMAPFP_ICONS', true));
                ?>            
                    <table class="admintable">
                        <?php if (COM_GMAPFP_VERSION_OT) {?>
                        <tr>
                            <td class="key">
                                <label for="album">
                                    <?php echo JText::_( 'GMAPFP_ALBUM' ); ?>:
                                </label>
                            </td>
                            <td>
                                <?php if ($this->item->album == '1') { $checked = 'checked="checked"'; }else{ $checked = ''; }; ?>
                                <input class="inputbox" type="checkbox" name="album" id="album" value="1" <?php echo $checked ?> />
                            </td>
                        </tr>
                        <?php }?>
                        <tr <?php if (!$this->config->get('gmapfp_classements_view', 1)){echo 'style="display: none; visibility: hidden;"';}?>>
                            <td width="110" class="key">
                                <label for="classements">
								<?php 
                                    echo JText::_( 'GMAPFP_CLASSEMENTS' );
                                ?>:
                                </label>
                            </td>
                            <td valign="top" class="inputbox">
                                <?php echo $this->lists['classements']; ?>
                            </td>
                        </tr>
 						<tr <?php if (!$this->config->get('gmapfp_labels_view', 1)){echo 'style="display: none; visibility: hidden;"';}?>>
                            <td width="110" class="key">
                                <label for="labels">
								<?php 
                                    echo JText::_( 'GMAPFP_LABELS' );
                                ?>:
                                </label>
                            </td>
                            <td valign="top" class="inputbox">
                                <?php echo $this->lists['labels']; ?>
                            </td>
                        </tr>
						<tr <?php if (!$this->config->get('gmapfp_pictos_view', 1)){echo 'style="display: none; visibility: hidden;"';}?>>
                            <td width="110" class="key">
                                <label for="pictos">
								<?php 
                                    echo JText::_( 'GMAPFP_PICTOS' );
                                ?>:
                                </label>
                            </td>
                            <td valign="top" class="inputbox">
                                <?php echo $this->lists['pictos']; ?>
                            </td>
                        </tr>
                    </table>
			   <?php             
				echo JHtml::_('bootstrap.endTab');
				echo JHtml::_('bootstrap.addTab', 'myTab', 'details', JText::_('GMAPFP_DETAILS', true));
                ?>            
                    <table class="admintable">
						<?php
                            if (@$this->extension_fields[4])
                            foreach($this->extension_fields[4] as $field) {
                                echo $field;
                            };
                        ?>
						<tr <?php if (!$this->config->get('gmapfp_message_view', 1)){echo 'style="display: none; visibility: hidden;"';}?>>
                            <td width="110" class="key">
                                <label for="text_message">
								<?php 
                                    if (@$this->custom[10]->nom) {
                                        echo $this->custom[10]->nom;
                                    }else{
                                        echo JText::_( 'GMAPFP_MESSAGE' );
                                    }
                                ?>:
                                </label>
                            </td>
                            <td valign="top" class="inputbox">
                                <?php
								echo $editor->display('text_message', htmlspecialchars($this->item->text, ENT_COMPAT, 'UTF-8'), '600', '300', '75', '20', true, 'text_message');                                ?>
                            </td>
                        </tr>
                        <tr <?php if (!$this->config->get('gmapfp_prix_view', 1)){echo 'style="display: none; visibility: hidden;"';}?>>
                            <td width="110" class="key">
                                <label for="text_horaires_prix">
								<?php 
                                    if (@$this->custom[11]->nom) {
                                        echo $this->custom[11]->nom;
                                    }else{
                                        echo JText::_( 'GMAPFP_HORAIRES_PRIX' );
                                    }
                                ?>:
                                </label>
                            </td>
                            <td valign="top" class="inputbox">
                                <?php
								echo $editor->display('text_horaires_prix', htmlspecialchars($this->item->horaires_prix, ENT_COMPAT, 'UTF-8'), '600', '300', '75', '20', false, 'text_horaires_prix');                                ?>
                            </td>
                        </tr>
                    	<?php
							if (@$this->extension_fields[5])
							foreach($this->extension_fields[5] as $field) {
								echo $field;
							};
						?>
                    	<?php
							if (@$this->extension_fields[7])
							foreach($this->extension_fields[7] as $field) {
								echo $field;
							};
						?>
                    </table>                        
			   <?php             
				echo JHtml::_('bootstrap.endTab');
				echo JHtml::_('bootstrap.addTab', 'myTab', 'galerie', JText::_('GMAPFP_GALERIE', true));
                ?>            
                    <table class="admintable" width="100%">
                        <tr>
                            <td width="100%">
                                <?php 
									if ($this->item->id){
                                ?>            
                        <iframe src="index.php?option=com_gmapfp&controller=gmapfp&task=galerie&tmpl=component&cid=<?php echo $this->item->id;?>" id="folderframe" name="folderframe" width="100%" height="420px" marginwidth="0" marginheight="0" scrolling="auto" frameborder="0"></iframe>
                                <?php 
									}else{
										echo JText::_('GMAPFP_VALIDATE_BEFORE');
									}
                                ?>            
                            </td>
                        </tr> 
                    </table>
				<?php     
				echo JHtml::_('bootstrap.endTab');
				//Traite les ongles perso
				foreach ($this->pane_name as $key => $pane_name) {
					$html = '';
					foreach ($this->extension_fields as $key2 => $gmapfp_pane) {
						if (is_int($key2) and $key == (0-$key2)) {
							foreach ($gmapfp_pane as $datas)
							$html .= $datas;
						}
					}
					if ($html) {
						echo JHtml::_('bootstrap.addTab', 'myTab', 'perso_pane_'.$key, str_replace("'", "&apos;", $pane_name['nom']));
						echo '<table class="admintable">';
						echo $html;
						echo '</table>';
						echo JHtml::_('bootstrap.endTab');
					}
				}
				
				$hide = '';
				if (!$this->config->get('gmapfp_liaison_URL_view', 1)) {$hide = '" style="display: none; visibility: hidden;';}
				echo JHtml::_('bootstrap.addTab', 'myTab', 'externe'.$hide, JText::_('GMAPFP_EXTERNE', true));
				?>            
					<table class="admintable">
						<tr>
							<td class="key">
								<label for="jform_article_name">
									<?php echo JText::_( 'GMAPFP_LINK' ); ?>:
								</label>
							</td>
							<td>
								<div class="input-append pull-left" style="float: left;">
									<input class="inputbox" type="text" name="text_link" id="jform_article_name" size="60" maxlength="200" value="<?php echo str_replace('"', '&quot;',$this->item->link); ?>" />
										<a class="btn modal_jform_article" title="<?php echo JText::_( 'GMAPFP_SELECT_ARTICLE' ); ?>"  href="index.php?option=com_content&amp;view=articles&amp;layout=modal&amp;tmpl=component&amp;<?php echo JSession::getFormToken(); ?>=1&amp;function=jSelectArticle_id_name" rel="{handler: 'iframe', size: {x: 800, y: 500}}"><?php echo JText::_( 'GMAPFP_SELECT_ARTICLE' ); ?></a>
										<a class="btn hasTooltip"  href="javascript:;" onClick="jResetArticle_id_name()" data-placement="bottom" title="<?php echo JText::_( 'JSEARCH_RESET' ); ?>"><i class="icon-remove">&nbsp;</i></a>
								</div>
								<input type="hidden" id="jform_article_id" name="article_id" value="<?php echo $this->item->article_id; ?>" />                
							</td>
						</tr>
						<tr>
							<td width="30%" class="key">
								<label for="icon">
									<?php echo JText::_('GMAPFP_ICON'); ?>:
								</label>
							</td>
							<td valign="center"">
								<?php 
									$chemin			= 'images/gmapfp/icons';
									$directory		= JURI::root().'/'.$chemin.'/';
									$javascript		= 'onchange="changeDisplayIcon('."'".$directory."'".');"';
									echo "<div>/images/gmapfp/icons/</div>";
									echo $lists		= JHTML::_('list.images', 'icon', $this->item->icon, $javascript, $chemin, "bmp|gif|jpg|jpeg|png"  );
									if ((stristr($this->item->icon,'bmp'))||(stristr($this->item->icon,'gif'))||(stristr($this->item->icon,'jpg'))||(stristr($this->item->icon,'jpeg'))||(stristr($this->item->icon,'png'))) {
										?>
										<img src="<?php echo $directory.$this->item->icon; ?>" name="imageicon" style="height:32px"/>
										<?php
									} else {
										?>
										<img src="<?php echo $directory; ?>../blank/blank.png" name="imageicon" style="height:32px"/>
										<?php
									}
								?>
							</td>
						</tr>
						<tr>
							<td class="key">
								<label for="icon_label">
									<?php echo JText::_( 'GMAPFP_ICON_LABEL' ); ?>:
								</label>
							</td>
							<td>
								<input class="inputbox" type="text" name="icon_label" id="icon_label" size="60" maxlength="100" value="<?php echo str_replace('"', '&quot;',$this->item->icon_label); ?>" />
							</td>
						</tr>
					</table>
				<?php     
				echo JHtml::_('bootstrap.endTab');
				
				echo JHtml::_('bootstrap.addTab', 'myTab', 'meta', JText::_('JGLOBAL_FIELDSET_PUBLISHING', true));
				?>            
					<div class="row-fluid form-horizontal-desktop">
						<div class="span6">
							<ul class="adminformlist">
								<li class="control-group">
									<label id="jform_created_user_id-lbl" for="jform_created_user_id" class=""><?php echo JText::_('JGLOBAL_FIELD_CREATED_BY_LABEL'); ?></label>
									<?php JHtml::script('jui/fielduser.min.js', false, true, false, false, true); ?>				
									<div class="field-user-wrapper"
										data-url="index.php?option=com_users&amp;view=users&amp;layout=modal&amp;tmpl=component&amp;required=0&amp;field={field-user-id}&amp;ismoo=0"
										data-modal=".modal"
										data-modal-width="100%"
										data-modal-height="400px"
										data-input=".field-user-input"
										data-input-name=".field-user-input-name"
										data-button-select=".button-select"
										>
										<div class="input-append">
											<input
												type="text" id="jform_created_user_id"
												value="<?php echo $this->item->author_name; ?>"
												placeholder="<?php echo JText::_('JOPTION_SELECT_AUTHOR'); ?>"
												readonly
												class="field-user-input-name "
											/>
											<a class="btn btn-primary button-select" title="<?php echo JText::_('JOPTION_SELECT_AUTHOR'); ?>"><span class="icon-user"></span></a>
											<div id="userModal_jform_created_user_id" tabindex="-1" class="modal hide fade">
												<div class="modal-header">
													<button type="button" class="close" data-dismiss="modal">x</button>
													<h3><?php echo JText::_('JOPTION_SELECT_AUTHOR'); ?></h3>
												</div>
												<div class="modal-body">
												</div>
												<div class="modal-footer">
													<button class="btn" data-dismiss="modal"><?php echo JText::_('JCANCEL'); ?></button>
												</div>
											</div>
										</div>
										<input 
											type="hidden" 
											id="jform_created_user_id_id" 
											name="created_by" 
											value="<?php echo $this->item->created_by; ?>"
											class="field-user-input "
											data-onchange=""
										/>
									</div>
								</li>
								
								<li>
									<?php 
									echo '<label for="jform_created" class="hasTip" title="'.JText::_('JGLOBAL_FIELD_CREATED_LABEL').'::'.JText::_('JGLOBAL_FIELD_CREATED_DESC').'" >'.JText::_('JGLOBAL_FIELD_CREATED_LABEL').'</label>';
									if ($this->item->created == '' or $this->item->created == '0000-00-00 00:00:00') $created = '';
									else $created = JHtml::_('date',  $this->item->created, 'Y-m-d H:i:s' );
									echo JHtml::_('calendar', $created, 'created', 'jform_created', '%Y-%m-%d %H:%M:%S'); 
									?>
								</li>

								<li>
									<?php 
									echo '<label for="jform_publish_up" class="hasTip" title="'.JText::_('JGLOBAL_FIELD_PUBLISH_UP_LABEL').'::'.JText::_('JGLOBAL_FIELD_PUBLISH_UP_DESC').'" >'.JText::_('JGLOBAL_FIELD_PUBLISH_UP_LABEL').'</label>';
									if ($this->item->publish_up == '' or $this->item->publish_up == '0000-00-00 00:00:00') $publish_up = '';
									else $publish_up = JHtml::_('date',  $this->item->publish_up, 'Y-m-d H:i:s' );
									echo JHtml::_('calendar', $publish_up, 'publish_up', 'jform_publish_up', '%Y-%m-%d %H:%M:%S'); 
									?>
								</li>

								<li>
									<?php 
									echo '<label for="jform_publish_down" class="hasTip" title="'.JText::_('JGLOBAL_FIELD_PUBLISH_DOWN_LABEL').'::'.JText::_('JGLOBAL_FIELD_PUBLISH_DOWN_DESC').'" >'.JText::_('JGLOBAL_FIELD_PUBLISH_DOWN_LABEL').'</label>';
									if ($this->item->publish_down == '' or $this->item->publish_down == '0000-00-00 00:00:00') $publish_down = '';
									else $publish_down = JHtml::_('date',  $this->item->publish_down, 'Y-m-d H:i:s' );
									echo JHtml::_('calendar', $publish_down, 'publish_down', 'jform_publish_down', '%Y-%m-%d %H:%M:%S'); 
									?>
								</li>
							</ul>
						</div>
						<div class="span6">
							<?php echo '<label id="jform_metadesc-lbl" for="jform_metadesc" class="hasTip" title="'.str_replace('"', '&quot;', JText::_('JFIELD_META_DESCRIPTION_LABEL').'::'.JText::_('JFIELD_META_DESCRIPTION_DESC')).'">'.JText::_('JFIELD_META_DESCRIPTION_LABEL').'</label>'; ?>
								<textarea name="metadesc" id="jform_metadesc" cols="30" rows="3" class="inputbox"><?php echo htmlspecialchars($this->item->metadesc, ENT_COMPAT, 'UTF-8'); ?></textarea>

							<?php echo '<label id="jform_metakey-lbl" for="jform_metakey" class="hasTip" title="'.str_replace('"', '&quot;', JText::_('JFIELD_META_KEYWORDS_LABEL').'::'.JText::_('JFIELD_META_KEYWORDS_DESC')).'">'.JText::_('JFIELD_META_KEYWORDS_LABEL').'</label>'; ?>
								<textarea name="metakey" id="jform_metakey" cols="30" rows="3" class="inputbox"><?php echo htmlspecialchars($this->item->metakey, ENT_COMPAT, 'UTF-8') ?></textarea>

							<?php echo '<label id="jform_metadata_robots-lbl" for="jform_metadata_robots" class="hasTip" title="'.str_replace('"', '&quot;', JText::_('JFIELD_METADATA_ROBOTS_LABEL').'::'.JText::_('JFIELD_METADATA_ROBOTS_DESC')).'">'.JText::_('JFIELD_METADATA_ROBOTS_LABEL').'</label>';
								echo '<select id="jform_metadata_robots" name="metadata[robots]"> ';
									if ($this->item->robots == "") {
										echo '<option value="" selected="selected">'.JText::_('JGLOBAL_USE_GLOBAL').'</option>';
									} else {
										echo '<option value="">'.JText::_('JGLOBAL_USE_GLOBAL').'</option>';
									}
									if ($this->item->robots == "index, follow") {
										echo '<option value="index, follow" selected="selected">'.JText::_('JGLOBAL_INDEX_FOLLOW').'</option>';
									} else {
										echo '<option value="index, follow">'.JText::_('JGLOBAL_INDEX_FOLLOW').'</option>';
									}
									if ($this->item->robots == "noindex, follow") {
										echo '<option value="noindex, follow" selected="selected">'.JText::_('JGLOBAL_NOINDEX_FOLLOW').'</option>';
									} else {
										echo '<option value="noindex, follow">'.JText::_('JGLOBAL_NOINDEX_FOLLOW').'</option>';
									}
									if ($this->item->robots == "index, nofollow") {
										echo '<option value="index, nofollow" selected="selected">'.JText::_('JGLOBAL_INDEX_NOFOLLOW').'</option>';
									} else {
										echo '<option value="index, nofollow">'.JText::_('JGLOBAL_INDEX_NOFOLLOW').'</option>';
									}
									if ($this->item->robots == "noindex, nofollow") {
										echo '<option value="noindex, nofollow" selected="selected">'.JText::_('JGLOBAL_NOINDEX_NOFOLLOW').'</option>';
									} else {
										echo '<option value="noindex, nofollow">'.JText::_('JGLOBAL_NOINDEX_NOFOLLOW').'</option>';
									}
								echo '</select> ';
							?>
						</div>
					</div>	
			   <?php             
				echo JHtml::_('bootstrap.endTab');
				
				echo JHtml::_('bootstrap.addTab', 'myTab', 'hide_field', JText::_('GMAPFP_CHAMP_POSITION6', true));
				?>            
					<table>
						<?php 
							if (@$this->extension_fields[6])
							foreach($this->extension_fields[6] as $field) {
								echo $field;
							};
						?>
					</table>
			   <?php             
				echo JHtml::_('bootstrap.endTab');
				echo JHtml::_('bootstrap.endTabSet');
                ?>            
		</div>
		<div class="span3">
			<?php				
			$db			= JFactory::getDBO();
			$nullDate	= $db->getNullDate();

			// used to hide "Reset Hits" when hits = 0
			if ( !$this->item->hits ) {
				$visibility = 'style="display: none; visibility: hidden;"';
			} else {
				$visibility = '';
			}


			if ( $this->item->id )
				echo '<strong>'.JText::sprintf( 'JGLOBAL_RECORD_NUMBER', $this->item->id ).'</strong>';
			if ( $this->tif and $this->item->tif_id )
				echo '<br/><strong>ID TourInFrance : '.$this->item->tif_id.'</strong>';
			?>
			<table width="100%" style="border: 1px dashed silver; padding: 5px; margin-bottom: 10px;">
				<tr>
					<td>
						<strong><?php echo JText::_( 'JGLOBAL_LIST_HITS_LABEL' ); ?></strong>
					</td>
					<td>
						<?php echo $this->item->hits;?>
						<span <?php echo $visibility; ?>>
							<input name="reset_hits" type="button" class="btn" value="<?php echo JText::_( 'JSEARCH_RESET' ); ?>" onclick="submitbutton('resethits');" />
						</span>
					</td>
				</tr>
				<tr>
					<td>
						<strong><?php echo JText::_( 'JVERSION' ); ?></strong>
					</td>
					<td>
						<?php echo $this->item->version;?>
					</td>
				</tr>
				<?php
					if ( $this->item->modified != $nullDate ) {
				?>
				<tr>
					<td>
						<strong><?php echo JText::_( 'JGLOBAL_FIELD_MODIFIED_LABEL' ); ?></strong>
					</td>
					<td>
						<?php
						echo JHTML::_('date',  $this->item->modified, JText::_('DATE_FORMAT_LC2'));
						if ($this->item->modified_by) {
						?>
					</td>
				</tr>
				<tr>
					<td>
						<strong><?php echo JText::_( 'JGLOBAL_FIELD_MODIFIED_BY_LABEL' ); ?></strong>
					</td>
					<td>
					<?php
							echo $this->item->last_editor;
						}
					}
					?>
					</td>
				</tr>
			</table>
			<fieldset class="form-vertical">
				<div class="control-group">
					<div class="control-label">
						<label for="published" class="hasTip" title="<?php echo str_replace('"', '&quot;', JText::_('JPUBLISHED').'::'.JText::_('JFIELD_PUBLISHED_DESC')) ?>">
							<?php echo JText::_( 'JPUBLISHED' ); ?>:
						</label>
					</div>
					<div class="controls">
						<select id="published" name="published" class="chzn-color-state" size="1">
							<option value="1" <?php if ($this->item->published or $this->item->published==null) echo 'selected="selected"' ?>><?php echo JText::_( 'JPUBLISHED' ); ?></option>
							<option value="0" <?php if (!$this->item->published and $this->item->published!=null) echo 'selected="selected"' ?>><?php echo JText::_( 'JUNPUBLISHED' ); ?></option>
						</select>
					</div>
				</div>
				<div class="control-group">
					<div class="control-label">
						<label for="featured" class="hasTip" title="<?php echo str_replace('"', '&quot;', JText::_('JFEATURED').'::'.JText::_('JFIELD_FEATURED_DESC')) ?>">
							<?php echo JText::_( 'JFEATURED' ); ?>:
						</label>
					</div>
					<div class="controls">
						<fieldset class="btn-group btn-group-yesno radio">
							<input type="radio" name="featured" id="featured0" value="0"  <?php if (!$this->item->featured) echo 'checked="checked"' ?>>
							<label for="featured0" class="btn"><?php echo JText::_( 'JNO' ); ?></label>
							<input type="radio" name="featured" id="featured1" value="1"  <?php if ($this->item->featured) echo 'checked="checked"' ?>>
							<label for="featured1" class="btn"><?php echo JText::_( 'JYES' ); ?></label>
						</fieldset>
					</div>
				</div>
				<div class="control-group">
					<div class="control-label">
						<label for="catid" class="hasTip" title="<?php echo str_replace('"', '&quot;', JText::_('JCATEGORY').'::'.JText::_('JFIELD_CATEGORY_DESC')) ?>">
							<?php 
								if (@$this->custom[12]->nom) {
									echo $this->custom[12]->nom;
								}else{
									echo JText::_( 'JCATEGORY' );
								}
							?>:
						</label>
					</div>
					<div class="controls">
						<?php
							echo $this->lists['catid'];
						?>
					</div>
				</div>
				<div class="control-group">
					<div class="control-label">
						<label for="access" class="hasTip" title="<?php echo str_replace('"', '&quot;', JText::_('JFIELD_ACCESS_LABEL').'::'.JText::_('JFIELD_ACCESS_DESC')) ?>">
							<?php echo JText::_( 'JFIELD_ACCESS_LABEL' ); ?>:
						</label>
					</div>
					<div class="controls">
						<?php echo JHtml::_('access.level', 'access', $this->item->access, '', false); ?>
					</div>
				</div>
				<div class="control-group">
					<div class="control-label">
						<label for="language" class="hasTip" title="<?php echo str_replace('"', '&quot;', JText::_('JFIELD_LANGUAGE_LABEL').'::'.JText::_('JFIELD_LANGUAGE_DESC')) ?>">
							<?php echo JText::_( 'JFIELD_LANGUAGE_LABEL' ); ?>:
						</label>
					</div>
					<div class="controls">
						<?php
							// Merge any additional options in the XML definition.
							jimport('joomla.language.helper');

							$List_langue['*'] = JText::_('JALL_LANGUAGE');
							$List_langue = array_merge($List_langue, JLanguageHelper::createLanguageList($this->item->language, constant('JPATH_SITE'), true, true));

							echo JHtml::_('select.genericlist', $List_langue, 'language',
								array(
									'list.attr' => false,
									'list.select' => $this->item->language
								)
							);

						?>
					</div>
				</div>
			</fieldset>
		</div>
	</div>

	<div class="clr"></div>
	<?php /* if ($this->canDo->get('core.admin')): ?>
		<div class="width-100 fltlft">
			<?php echo JHtml::_('sliders.start','permissions-sliders-'.$this->item->id, array('useCookie'=>1)); ?>

				<?php echo JHtml::_('sliders.panel',JText::_('COM_GMAPFP_FIELDSET_RULES'), 'access-rules'); ?>

				<fieldset class="panelform">
				</fieldset>

			<?php echo JHtml::_('sliders.end'); ?>
		</div>
	<?php endif;*/ ?>

	<input type="hidden" name="version" value="<?php echo $this->item->version; ?>" />
	<input type="hidden" name="hits" value="<?php echo $this->item->hits; ?>" />
    <input type="hidden" name="userid" value="<?php echo $this->item->created_by; ?>" />
    <input type="hidden" name="option" value="com_gmapfp" />
    <input type="hidden" name="id" value="<?php echo $this->item->id; ?>" />
    <input type="hidden" name="task" value="" />
    <input type="hidden" name="controller" value="gmapfp" />
</form>
<div class="copyright" align="center">
	<br />
	<?php echo JText::_( 'GMAPFP_COPYRIGHT' );?>
</div>
