<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.133pro
	* Creation date: Août 2023
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPViewGMapFP extends JViewLegacy
{
	protected $form;

	function display($tpl = NULL)
	{
		if (!JFactory::getUser()->authorise('core.manage', 'com_gmapfp')) {
			throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'), 404);
			return false;
		}

		if (is_dir(JPATH_ADMINISTRATOR.'/components/com_tiffps'))
			$this->tif = true;
		else
			$this->tif = false;

			$mainframe	= JFactory::getApplication(); 
		$Itemid    = $mainframe->input->get('Itemid'); 
		$option    = $mainframe->input->get('option'); 
		$user		= JFactory::getUser();
        $lang 		= JFactory::getLanguage(); 
        $tag_lang	= $lang->getTag();
		if (($tag_lang!='en-AU') AND ($tag_lang!='en-GB') AND ($tag_lang!='pt-BR') AND ($tag_lang!='pt-PT') AND ($tag_lang!='zh-CN') AND ($tag_lang!='zh-TW'))
			{$tag_lang=(substr($lang->getTag(),0,2)); };

		JHtml::_('jquery.framework');	
		$this->document->addStyleSheet('components/com_gmapfp/views/general.css');
        $this->document->addStyleSheet('../components/com_gmapfp/assets/dropfiles.css');
	    $this->document->addScript( '../components/com_gmapfp/assets/jquery.filedrop.js');
	    $this->document->addScript( '../components/com_gmapfp/assets/bootbox.min.js');
		
		JText::script('GMAPFP_BROWSER_NOT_SUPPORT_HTML5');
		JText::script('GMAPFP_TOO_MANY_FILES');
		JText::script('GMAPFP_FILE_TOO_LARGE');
		JText::script('GMAPFP_FILE_TYPE_NOT_ALLOWED');
		JText::script('GMAPFP_EXTENSION_TYPE_NOT_ALLOWED');
		JText::script('GMAPFP_ONLY_IMAGE_ALLOWED');
		JText::script('GMAPFP_ALREADY_EXIST');

		$config 	= JComponentHelper::getParams('com_gmapfp');
		$key 		= $config->get('gmapfp_google_key');

		$this->document->setMetaData('viewport', 'initial-scale=1.0, user-scalable=no');
        $this->document->addCustomTag( '<script type="text/javascript" src="//maps.googleapis.com/maps/api/js?language='.$tag_lang.'&libraries=places&v=3.53&key='.$key.'"></script>'); 

		$gmapfp		= $this->get('Data');
		$marqueurs	= $this->get('Marqueurs');
		$custom		= $this->get('Custom');
		$isNew		= ($gmapfp->id < 1);
        $galerie    = $this->get('images');
		$label		= $this->get('Label');
		$classement	= $this->get('Classement');
		$picto		= $this->get('Picto');

		$config_media = JComponentHelper::getParams('com_media');
		/*if ($config_media->get('enable_flash', 0)) {
			JHTML::_('behavior.uploader', 'file-upload', array('onAllComplete' => 'function(){ MediaManager.refreshFrame(); }'));
		}*/

		$text = $isNew ? JText::_( 'GMAPFP_NEW' ) : JText::_( 'GMAPFP_EDIT' );
		JToolBarHelper::title(   JText::_( 'GMAPFP_LIEUX_MANAGER' ).': <small>[ ' . $text.' ]</small>', 'lieux' );
		JToolBarHelper::apply();
		JToolBarHelper::save();
		JToolbarHelper::save2new();
		if ($isNew)  {
			JToolBarHelper::cancel();
		} else {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel( 'cancel', 'JTOOLBAR_CLOSE' );
		}

		// build the html select list for ordering
		$query = 'SELECT ordering AS value, nom AS text'
			. ' FROM #__gmapfp'
			. ' ORDER BY ordering';

		// build the html select list for labels
		foreach($label as $temp) {
			$labels[] = JHTML::_('select.option', $temp->id, $temp->nom );
		}
		if (isset($labels)) $lists['labels'] = JHTML::_('select.genericlist', $labels, 'labels[]', 'size="5" multiple class="inputbox"', 'value', 'text', $gmapfp->labels == '' ? '' : explode( ',', $gmapfp->labels ));

		// build the html select list for classements
		foreach($classement as $temp) {
			$classements[] = JHTML::_('select.option', $temp->id, $temp->nom );
		}
		if (isset($classements)) $lists['classements'] = JHTML::_('select.genericlist', $classements, 'classements[]', 'size="5" multiple class="inputbox"', 'value', 'text', $gmapfp->classements == '' ? '' : explode( ',', $gmapfp->classements ));

		// build the html select list for pictos
		foreach($picto as $temp) {
			$pictos[] = JHTML::_('select.option', $temp->id, $temp->nom );
		}
		if (isset($pictos)) $lists['pictos'] = JHTML::_('select.genericlist', $pictos, 'pictos[]', 'size="5" multiple class="inputbox"', 'value', 'text', $gmapfp->pictos == '' ? '' : explode( ',', $gmapfp->pictos ));

		// build list of categories
		$categories = JHtml::_('category.options', $option);
		$lists['catid'] = JHTML::_('select.genericlist', $categories, 'catid[]', 'class="inputbox required" size="4"  multiple onchange="display_catid_field();"', 'value', 'text', explode(',', $gmapfp->catid ));

		//creation de la liste des images principales
		jimport( 'joomla.filesystem.folder' );
		$imageFiles = JFolder::files( JPATH_SITE.'/images/gmapfp' );
        $directory	= JURI::base().'../images/gmapfp/thumbsArt/';
		$javascript	= 'onchange="changeDisplayImage('."'".$directory."'".');"';
		$images 	= array(  JHTML::_('select.option',  '', '- '. JText::_( 'Select Image' ) .' -' ) );
		$extensions = "bmp|gif|jpg|jpeg|png";
		$userid		= $user->id;
		if ($config->get("gmapfp_view_all_img", 1)) {
			$image_existe = true;
			foreach ( $imageFiles as $file ) {
			   if ( preg_match( "#$extensions#i", $file ) ) {
			   		$name = strstr($file, '__');
					if ($name)
						$images[] = JHTML::_('select.option',  $file, substr($name, 2 ));
					else
						$images[] = JHTML::_('select.option',  $file);
				}
			}
		} else {
			$image_existe = false;
			foreach ( $imageFiles as $file ) {
			   if ( (preg_match( "#$extensions#i", $file ))AND((substr($file, 0, strlen($userid)+2) == $userid.'__' )OR($file=='blank.png')) ) {
					if ($file=='blank.png') {
						$images[] = JHTML::_('select.option',  $file);
					} else {
						$images[] = JHTML::_('select.option',  $file, substr($file, strlen($userid)+2 ));
						if ($file == $gmapfp->img) $image_existe = true;
					}
				}
			}
		};
		if (!$image_existe) {
			foreach ( $imageFiles as $file ) {
				if ($file == $gmapfp->img) {
			   		$name = strstr($file, '__');
					if ($name)
						$images[] = JHTML::_('select.option',  $file, substr($name, 2 ));
					else
						$images[] = JHTML::_('select.option',  $file);
					break;
				}
			}
		}
		$lists['images'] = JHTML::_('select.genericlist',  $images, 'img', 'class="inputbox" size="1" '. $javascript, 'value', 'text', $gmapfp->img );
		//**
		
		$model = $this->getModel('gmapfp');
		$this->extension_fields = $model->getChamps($gmapfp->id);

		if (!property_exists($gmapfp, 'robots')) $gmapfp->robots = "";
 
        $this->galerie = $galerie;
		$this->custom = $custom;
		$this->user = $user;
		$this->item = $gmapfp;
		$this->marqueurs = $marqueurs;
		$this->config_media = $config_media;
		$this->config = $config;
		$this->lists = $lists;
		$this->pane_name = $model->PaneName();

		$this->state	= $this->get('State');
		$this->canDo	= GMapFPHelper::getActions($this->state->get('filter.category_id'));

		parent::display();
	}

    function setImage($index = 0)
    {
		if (isset($this->galerie[$index])) {
            $this->_tmp_img = $this->galerie[$index];
        } else {
            $this->_tmp_img = new JObject;
        }
    }

}
