<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.109pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPViewGMapFPs extends JViewLegacy
{
	function display($tpl = NULL)
	{
		if (!JFactory::getUser()->authorise('core.manage', 'com_gmapfp')) {
			throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'), 404);
			return false;
		}

		$this->document->addStyleSheet('components/com_gmapfp/views/general.css');
		$mainframe = JFactory::getApplication(); 
		$option    = $mainframe->input->get('option'); 
		
		if (is_dir(JPATH_ADMINISTRATOR.'/components/com_tiffps'))
			$this->tif = true;
		else
			$this->tif = false;

		JHTML::_('behavior.tooltip');

		// Get data from the model
		$items		= $this->get( 'Data');
		$custom		= $this->get( 'Custom');
		$total		= $this->get( 'Total');
		$pageNav 	= $this->get( 'Pagination' );
		$this->state= $this->get('State');
		$this->gmapfp_cats_title = $this->get('GMapFPcatsTitle');

		$filtrevilles = array();
		$filtrevilles[] = JHTML::_('select.option', '-- '.JText::_( 'GMAPFP_VILLE_FILTRE' ).' --' );
				foreach($this->get('listville') as $temp) {
					$filtrevilles[] = JHTML::_('select.option', $temp->ville );
				}
		$filtredepartements = array();
		$filtredepartements[] = JHTML::_('select.option', '-- '.JText::_( 'GMAPFP_DEPARTEMENT_FILTRE' ).' --' );
				foreach($this->get('listdepartement') as $temp) {
					$filtredepartements[] = JHTML::_('select.option', $temp->departement );
				}
		$filtrepays = array();
		$filtrepays[] = JHTML::_('select.option', '-- '.JText::_( 'GMAPFP_PAYS_FILTRE' ).' --' );
				foreach($this->get('listpays') as $temp) {
					$filtrepays[] = JHTML::_('select.option', $temp->pay );
				}
		$filtrecategories = array();
		$filtrecategories[] = JHTML::_('select.option', 0, '-- '.JText::_( 'JCATEGORY' ).' --' );
				foreach(JHtml::_('category.options', 'com_gmapfp') as $temp) {
					$filtrecategories[] = JHTML::_('select.option', $temp->value, $temp->text );
				}

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir 	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 	'filter_order_Dir', 	'', 											'word');
		$search				= $mainframe->getUserStateFromRequest( $option.'search', 			'search', 				'',												'string' );
		$filtreville 		= $mainframe->getUserStateFromRequest( $option.'filtreville', 		'filtreville', 			'-- '.JText::_( 'GMAPFP_VILLE' ).' --', 		'string' );
		$filtredepartement 	= $mainframe->getUserStateFromRequest( $option.'filtredepartement', 'filtredepartement', 	'-- '.JText::_( 'GMAPFP_DEPARTEMENT' ).' --', 	'string' );
		$filtrepay 			= $mainframe->getUserStateFromRequest( $option.'filtrepay', 		'filtrepay', 			'-- '.JText::_( 'GMAPFP_PAYS' ).' --',		 	'string' );
		$filtrecategorie 	= $mainframe->getUserStateFromRequest( $option.'filtrecategorie', 	'filtrecategorie', 		'0', 	'int' );
		$this->limit 		= $mainframe->getUserStateFromRequest( $option.'limit', 'limit', $mainframe->getCfg('list_limit'), 'int');

		$lists['ville'] 		= JHTML::_('select.genericlist', $filtrevilles, 'filtreville', 'size="1" class="input-medium" onchange="form.submit()"', 'value', 'text', $filtreville );
		$lists['departement'] 	= JHTML::_('select.genericlist', $filtredepartements, 'filtredepartement', 'size="1" class="input-medium" onchange="form.submit()"', 'value', 'text', $filtredepartement );
		$lists['pays'] 			= JHTML::_('select.genericlist', $filtrepays, 'filtrepay', 'size="1" class="input-medium" onchange="form.submit()"', 'value', 'text', $filtrepay );
		$lists['categorie'] 	= JHTML::_('select.genericlist', $filtrecategories, 'filtrecategorie', 'size="1" class="input-medium" onchange="form.submit()"', 'value', 'text', $filtrecategorie );

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		// search filter
		$lists['search'] = $search;
		
		$this->custom =	$custom;
		$this->lists = 	$lists;
		$this->items =	$items;
		$this->pageNav = $pageNav;

		$this->addToolbar();
		$this->sidebar = JHtmlSidebar::render();

		parent::display();

	}

	protected function addToolbar()
	{
		require_once JPATH_COMPONENT.'/helpers/gmapfp.php';
		$canDo	= GMapFPHelper::getActions($this->state->get('filter.category_id'));
		$user	= JFactory::getUser();

		JToolBarHelper::title(   JText::_( 'GMAPFP_LIEUX_MANAGER' ), 'lieux' );
		if ($canDo->get('core.create')) {
			JToolBarHelper::addNew();
		}
		if (($canDo->get('core.edit'))) {
			JToolBarHelper::editList();
			JToolBarHelper::divider();
		}
		if ($canDo->get('core.create')) {
			JToolBarHelper::custom( 'copy', 'copy.png', 'copy_f2.png', 'JTOOLBAR_SAVE_AS_COPY' );
		}
		if (($canDo->get('core.edit'))) {
			JToolBarHelper::custom( 'user', 'user.png', 'edit_f2.png', 'JAUTHOR' );
			JToolBarHelper::divider();
		}

		if ($canDo->get('core.edit.state')) {
			if ($this->state->get('filter.state') != 2){
				JToolBarHelper::publishList();
				JToolBarHelper::unpublishList();
				JToolBarHelper::divider();
			}
		}
		if ( $canDo->get('core.delete')) {
			JToolBarHelper::deleteList();
			JToolBarHelper::divider();
		}
		if ($canDo->get('core.admin')) {
			JToolBarHelper::preferences('com_gmapfp');
			JToolBarHelper::divider();
		}
	}

}
