<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.109pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPViewMarqueur extends JViewLegacy
{
	protected $form;

	protected $item;

	protected $state;

	protected $canDo;

	public function display($tpl = null)
	{
		$this->form		= $this->get('Form');
		$this->item		= $this->get('Item');
		$this->state	= $this->get('State');
		$this->canDo	= JHelperContent::getActions('com_gmapfp');
		$this->params 	= JComponentHelper::getParams('com_gmapfp');

		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			throw new Exception(implode("\n", $errors), 500);
			return false;
		}

		$this->addToolbar();
		parent::display($tpl);
	}

	protected function addToolbar()
	{
		JFactory::getApplication()->input->set('hidemainmenu', true);

		$user		= JFactory::getUser();
		$isNew		= ($this->item and $this->item->id == 0);
		$canDo		= $this->canDo;

		JToolbarHelper::title($isNew ? JText::_('GMAPFP_NEW') : JText::_('GMAPFP_EDIT'), 'bookmark gmapfp-marqueurs');

		// If not checked out, can save the item.
		if (($canDo->get('core.edit') || $canDo->get('core.create')))
		{
			JToolbarHelper::apply('marqueur.apply');
			JToolbarHelper::save('marqueur.save');
		}

		if ($canDo->get('core.create'))
		{
			JToolbarHelper::save2new('marqueur.save2new');
		}
		// If an existing item, can save to a copy.
		if (!$isNew && $canDo->get('core.create'))
		{
			JToolbarHelper::save2copy('marqueur.save2copy');
		}

		if (empty($this->item->id))
		{
			JToolbarHelper::cancel('marqueur.cancel');
		}
		else
		{
			/*if ($this->state->params->get('save_history', 0) && $user->authorise('core.edit.markers'))
			{
				JToolbarHelper::versions('com_gmapfpfp.marqueur', $this->item->id);
			}*/

			JToolbarHelper::cancel('marqueur.cancel', 'JTOOLBAR_CLOSE');
		}

	}
}
