<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.109pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPViewPersonnalisations extends JViewLegacy
{
	function display($tpl = NULL)
	{
		if (!JFactory::getUser()->authorise('core.edit.perso', 'com_gmapfp')) {
			throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'), 404);
			return false;
		}
			
		$this->document->addStyleSheet('components/com_gmapfp/views/general.css');
		$app 		= JFactory::getApplication(); 
		$option		= $app->input->get('option'); 
		$controller	= $app->input->get('controller'); 
		$this->state= $this->get('State');

		if ($app->input->get('task', '', 'word')=='view') 
		{
			require_once JPATH_COMPONENT.'/helpers/gmapfp.php';
			$canDo	= GMapFPHelper::getActions($this->state->get('filter.category_id'));
			JToolBarHelper::title(   JText::_( 'GMAPFP_PERSONNALISATIONS_MANAGER' ), 'personnalisation' );
			if ($canDo->get('core.create')) {
				JToolBarHelper::addNew();
			}
			if (($canDo->get('core.edit'))) {
				JToolBarHelper::editList();
			}
			if ($canDo->get('core.edit.state')) {
				JToolBarHelper::divider();
				JToolBarHelper::publishList();
				JToolBarHelper::unpublishList();
			}
			if ( $canDo->get('core.delete')) {
				JToolBarHelper::divider();
				JToolBarHelper::deleteList();
			}
		
			// Get data from the model
			$personnalisations	= $this->get('List');
		}
		else
		{
			// Get data from the model
			$personnalisations		= $this->get('Data');
			$isNew		= ($personnalisations->id < 1);
	
			$text = $isNew ? JText::_( 'GMAPFP_NEW' ) : JText::_( 'GMAPFP_EDIT' );
			JToolBarHelper::title(   JText::_( 'GMAPFP_PERSONNALISATIONS_MANAGER' ).': <small>[ ' . $text.' ]</small>', 'personnalisation' );
			JToolBarHelper::apply();
			JToolBarHelper::save();
			if ($isNew)  {
				JToolBarHelper::cancel();
		} else {
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel( 'cancel', 'JTOOLBAR_CLOSE' );
		}
		}
		JHTML::_('behavior.tooltip');

		$this->personnalisations = $personnalisations;
		
		$pageNav = $this->get( 'Pagination' );				
		$this->pageNav = $pageNav;

		$filter_order 		= $app->getUserStateFromRequest( $option.$controller.'filter_order', 'filter_order', 'nom', 'cmd');
		$filter_order_Dir 	= $app->getUserStateFromRequest( $option.$controller.'filter_order_Dir', 'filter_order_Dir', '', 'word');
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
		$this->lists = $lists;

		$this->sidebar = JHtmlSidebar::render();
		parent::display();

	}
}
