﻿<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3_117pro
	* Creation date: Juin 2018
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;
 
class com_GMapFPInstallerScript
{
	var $event_before_save ;
	var $option;
	var $name ;
	var $event_after_save  ;

	/**
	* method to install the component
	* @return void
	*/
	function install($parent) 
	{
		jimport( 'joomla.filesystem.file' );
		jimport( 'joomla.filesystem.folder' );

		$path = JPATH_SITE;
		@mkdir(JPATH_ROOT."/images/gmapfp/");

		$lang		= JFactory::getLanguage();
		$langue		= substr((@$lang->getTag()),0,2);
		if ($langue!='fr') $langue = 'en';
		
		$url = JURI::root();
	
		//Creation du fichier CSS utilisateur
		$buffer = "/* Cette page est dédié à la personnalisation de votre CSS GMapFP */"."\n";
		$buffer .= "/* This page is for your GMapFP CSS */";
		JFile::write($path."/media/com_gmapfp/css/gmapfp.css", $buffer);

		//Installation du fichier JComments
		if (!JFolder::exists($path .'/components/com_jcomments/plugins/'))
			JFolder::create($path .'/components/com_jcomments/plugins/');
		$filesource = $path .'/components/com_gmapfp/libraries/jcomments/index.html';
		$filedest = $path .'/components/com_jcomments/index.html';
		JFile::copy($filesource, $filedest, '', true);
		$filedest = $path .'/components/com_jcomments/plugins/index.html';
		JFile::copy($filesource, $filedest, '', true);
		$filesource = $path .'/components/com_gmapfp/libraries/jcomments/com_gmapfp.plugin.php';
		$filedest = $path .'/components/com_jcomments/plugins/com_gmapfp.plugin.php';
		JFile::copy($filesource, $filedest, '', true);
		
		$db = JFactory::getDBO();

		/*mise à jour des données marqueurs*/
		if ($langue == 'fr')
			$query = "INSERT INTO `#__gmapfp_marqueurs` (`id`, `nom`, `url`, `published`, `marker_width`, `marker_height`, `centre_x`, `centre_y`, `url_shadow`, `shadow_width`, `shadow_height`) VALUES
				('', 'marqueur', '../images/gmapfp/marqueurs/marker.png', 1, 20, 34, 10, 34, '//www.google.com/mapfiles/shadow50.png', 0, 0),
				('', 'marqueur home', '//chart.apis.google.com/chart?chst=d_map_xpin_icon&chld=pin_star|home|FFFF00|FF0000', 1, 23, 39, 11, 39, '//www.google.com/mapfiles/shadow50.png', 0, 0),
				('', 'marqueur flag', '//chart.apis.google.com/chart?chst=d_map_xpin_icon&chld=pin_star|flag|FFFF00|00FF00', 1, 23, 39, 11, 39, '//www.google.com/mapfiles/shadow50.png', 0, 0),
				('', 'marqueur info', '//chart.apis.google.com/chart?chst=d_map_xpin_icon&chld=pin_star|info|FFFF00|0000FF', 1, 23, 39, 11, 39, '//www.google.com/mapfiles/shadow50.png', 0, 0),
				('', 'marqueur bar', '//chart.apis.google.com/chart?chst=d_map_xpin_icon&chld=pin_star|bar|FFFF00|FF0000', 1, 23, 39, 11, 39, '//www.google.com/mapfiles/shadow50.png', 0, 0),
				('', 'marqueur cafe', '//chart.apis.google.com/chart?chst=d_map_xpin_icon&chld=pin_star|cafe|FFFF00|FF0000', 1, 23, 39, 11, 39, '//www.google.com/mapfiles/shadow50.png', 0, 0),
				('', 'A&eacute;roport', '../images/gmapfp/marqueurs/airport.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'marqueurBleu', '../images/gmapfp/marqueurs/blue-dot.png', 1, 32, 32, 16, 32, '', 0, 0),
				('', 'marqueurVert', '../images/gmapfp/marqueurs/green-dot.png', 1, 32, 32, 16, 32, '', 0, 0),
				('', 'marqueurOrange', '../images/gmapfp/marqueurs/orange-dot.png', 1, 32, 32, 16, 32, '', 0, 0),
				('', 'marqueurJaune', '../images/gmapfp/marqueurs/yellow-dot.png', 1, 32, 32, 16, 32, '', 0, 0),
				('', 'marqueurViolet', '../images/gmapfp/marqueurs/purple-dot.png', 1, 32, 32, 16, 32, '', 0, 0),
				('', 'marqueurRose', '../images/gmapfp/marqueurs/pink-dot.png', 1, 32, 32, 16, 32, '', 0, 0),
				('', 'Pain', '../images/gmapfp/marqueurs/bread.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'Ferry', '../images/gmapfp/marqueurs/ferry.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'P&Ecirc;cheur', '../images/gmapfp/marqueurs/fishing.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'For&ecirc;t', '../images/gmapfp/marqueurs/forest2.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'Equitation', '../images/gmapfp/marqueurs/horseriding.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'Restaurant', '../images/gmapfp/marqueurs/restaurant.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'Piscine', '../images/gmapfp/marqueurs/swimming.png', 1, 32, 37, 16, 37, '', 0, 0);";
		if ($langue != 'fr')
			$query = "INSERT INTO `#__gmapfp_marqueurs` (`id`, `nom`, `url`, `published`, `marker_width`, `marker_height`, `centre_x`, `centre_y`, `url_shadow`, `shadow_width`, `shadow_height`) VALUES
				('', 'marker', '../images/gmapfp/marqueurs/marker.png', 1, 20, 34, 10, 34, '//www.google.com/mapfiles/shadow50.png', 0, 0),
				('', 'marker home', '//chart.apis.google.com/chart?chst=d_map_xpin_icon&chld=pin_star|home|FFFF00|FF0000', 1, 23, 39, 11, 39, '//www.google.com/mapfiles/shadow50.png', 0, 0),
				('', 'marker flag', '//chart.apis.google.com/chart?chst=d_map_xpin_icon&chld=pin_star|flag|FFFF00|00FF00', 1, 23, 39, 11, 39, '//www.google.com/mapfiles/shadow50.png', 0, 0),
				('', 'marker info', '//chart.apis.google.com/chart?chst=d_map_xpin_icon&chld=pin_star|info|FFFF00|0000FF', 1, 23, 39, 11, 39, '//www.google.com/mapfiles/shadow50.png', 0, 0),
				('', 'marker bar', '//chart.apis.google.com/chart?chst=d_map_xpin_icon&chld=pin_star|bar|FFFF00|FF0000', 1, 23, 39, 11, 39, '//www.google.com/mapfiles/shadow50.png', 0, 0),
				('', 'marker cofe', '//chart.apis.google.com/chart?chst=d_map_xpin_icon&chld=pin_star|cafe|FFFF00|FF0000', 1, 23, 39, 11, 39, '//www.google.com/mapfiles/shadow50.png', 0, 0),
				('', 'Airport', '../images/gmapfp/marqueurs/airport.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'markerBlue', '../images/gmapfp/marqueurs/blue-dot.png', 1, 32, 32, 16, 32, '', 0, 0),
				('', 'markerGreen', '../images/gmapfp/marqueurs/green-dot.png', 1, 32, 32, 16, 32, '', 0, 0),
				('', 'markerOrange', '../images/gmapfp/marqueurs/orange-dot.png', 1, 32, 32, 16, 32, '', 0, 0),
				('', 'markerYellow', '../images/gmapfp/marqueurs/yellow-dot.png', 1, 32, 32, 16, 32, '', 0, 0),
				('', 'markerPurple', '../images/gmapfp/marqueurs/purple-dot.png', 1, 32, 32, 16, 32, '', 0, 0),
				('', 'markerPink', '../images/gmapfp/marqueurs/pink-dot.png', 1, 32, 32, 16, 32, '', 0, 0),
				('', 'Bread', '../images/gmapfp/marqueurs/bread.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'Ferry', '../images/gmapfp/marqueurs/ferry.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'Fisher', '../images/gmapfp/marqueurs/fishing.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'Forest', '../images/gmapfp/marqueurs/forest2.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'Riding', '../images/gmapfp/marqueurs/horseriding.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'Restaurant', '../images/gmapfp/marqueurs/restaurant.png', 1, 32, 37, 16, 37, '', 0, 0),
				('', 'Swimming pool', '../images/gmapfp/marqueurs/swimming.png', 1, 32, 37, 16, 37, '', 0, 0);";
		$db->setQuery($query);
		$db->query();
		if ($db->getErrorNum()) {
			exit($db->stderr());
		}
				
			/*mise à jour des données classements*/
		if ($langue == 'fr')
			$query = "INSERT INTO `#__gmapfp_classements` (`id`, `nom`, `cat`, `img`, `ordering`, `published`, `language`, `filtrable`) VALUES
				('', '1 etoile', 1, '1etoile.gif', 6, 1, '*', 1),
				('', 'TV', 3, 'chambre_tv.jpg', 29, 1, '*', 1),
				('', 'Gite de france', 1, 'gitesdefrance.png', 11, 1, '*', 1),
				('', 'Garage ferme', 3, 'garage_ferme.jpg', 21, 1, '*', 1),
				('', 'Animaux', 3, 'animaux.jpg', 22, 1, '*', 1),
				('', 'CB', 3, 'carte_bleue.jpg', 23, 1, '*', 1),
				('', 'Cheques vacances', 3, 'cheque_vacances.jpg', 24, 1, '*', 1),
				('', 'Climatisation', 3, 'climatisation.jpg', 25, 1, '*', 1),
				('', 'Piscine', 3, 'piscine.jpg', 26, 1, '*', 1),
				('', 'Restaurant', 3, 'restaurant.jpg', 27, 1, '*', 1),
				('', 'Wifi', 3, 'wifi.jpg', 28, 1, '*', 1),
				('', '2 etoiles', 1, '2etoiles.gif', 7, 1, '*', 1),
				('', '3 etoiles', 1, '3etoiles.gif', 8, 1, '*', 1),
				('', '4 etoiles', 1, '4etoiles.gif', 9, 1, '*', 1),
				('', '5 etoiles', 1, '5etoiles.gif', 10, 1, '*', 1),
				('', '1 epis', 1, '1epis.gif', 12, 1, '*', 1),
				('', '2 epis', 1, '2epis.gif', 13, 1, '*', 1),
				('', '3 epis', 1, '3epis.gif', 14, 1, '*', 1),
				('', '4 epis', 1, '4epis.gif', 15, 1, '*', 1),
				('', '5 epis', 1, '5epis.gif', 16, 1, '*', 1),
				('', '1 clef', 1, '1clef.gif', 17, 1, '*', 1),
				('', '2 clefs', 1, '2clefs.gif', 18, 1, '*', 1),
				('', '3 clefs', 1, '3clefs.gif', 19, 1, '*', 1),
				('', '4 clefs', 1, '4clefs.gif', 20, 1, '*', 1),
				('', 'Label tourisme handicap', 2, 'label-tourisme-handicap.jpg', 1, 1, '*', 0),
				('', 'Handicap Moteur', 2, 'handicap-moteur.gif', 2, 1, '*', 1),
				('', 'Handicap Mental', 2, 'handicap-mental.gif', 3, 1, '*', 1),
				('', 'Handicap Auditif', 2, 'handicap-auditif.gif', 4, 1, '*', 1),
				('', 'Handicap Visuel', 2, 'handicap-visuel.gif', 5, 1, '*', 1);";
		if ($langue != 'fr')
			$query = "INSERT INTO `#__gmapfp_classements` (`id`, `nom`, `cat`, `img`, `ordering`, `published`, `language`, `filtrable`) VALUES
				('', '1 star', 1, '1etoile.gif', 6, 1, '*', 1),
				('', 'TV', 3, 'chambre_tv.jpg', 29, 1, '*', 1),
				('', 'Cottage France', 1, 'gitesdefrance.png', 11, 1, '*', 1),
				('', 'Secure garage', 3, 'garage_ferme.jpg', 21, 1, '*', 1),
				('', 'Pets', 3, 'animaux.jpg', 22, 1, '*', 1),
				('', 'CB', 3, 'carte_bleue.jpg', 23, 1, '*', 1),
				('', 'Holiday vouchers', 3, 'cheque_vacances.jpg', 24, 1, '*', 1),
				('', 'Airconditioning', 3, 'climatisation.jpg', 25, 1, '*', 1),
				('', 'Swimming pool', 3, 'piscine.jpg', 26, 1, '*', 1),
				('', 'Restaurant', 3, 'restaurant.jpg', 27, 1, '*', 1),
				('', 'Wifi', 3, 'wifi.jpg', 28, 1, '*', 1),
				('', '2 stars', 1, '2etoiles.gif', 7, 1, '*', 1),
				('', '3 stars', 1, '3etoiles.gif', 8, 1, '*', 1),
				('', '4 stars', 1, '4etoiles.gif', 9, 1, '*', 1),
				('', '5 stars', 1, '5etoiles.gif', 10, 1, '*', 1),
				('', '1 ear', 1, '1epis.gif', 12, 1, '*', 1),
				('', '2 ears', 1, '2epis.gif', 13, 1, '*', 1),
				('', '3 ears', 1, '3epis.gif', 14, 1, '*', 1),
				('', '4 ears', 1, '4epis.gif', 15, 1, '*', 1),
				('', '5 ears', 1, '5epis.gif', 16, 1, '*', 1),
				('', '1 key', 1, '1clef.gif', 17, 1, '*', 1),
				('', '2 keys', 1, '2clefs.gif', 18, 1, '*', 1),
				('', '3 keys', 1, '3clefs.gif', 19, 1, '*', 1),
				('', '4 keys', 1, '4clefs.gif', 20, 1, '*', 1),
				('', 'Label tourism handicap', 2, 'label-tourisme-handicap.jpg', 1, 1, '*', 0),
				('', 'Motor handicap', 2, 'handicap-moteur.gif', 2, 1, '*', 1),
				('', 'Mental handicap', 2, 'handicap-mental.gif', 3, 1, '*', 1),
				('', 'Hearing handicap', 2, 'handicap-auditif.gif', 4, 1, '*', 1),
				('', 'Visual handicap', 2, 'handicap-visuel.gif', 5, 1, '*', 1);";
		$db->setQuery($query);
		$db->query();
		if ($db->getErrorNum()) {
			exit($db->stderr());
		}

		/*mise à jour des données custom fields*/
		$query = "INSERT INTO `#__gmapfp_params_custom_fields` (`id`, `nom`, `items`, `nom originel`) VALUES
			(1, '', '', 'Non Utilisé'),
			(2, '', '', 'Non Utilisé'),
			(3, '', '', 'Non Utilisé'),
			(4, '', '', 'Non Utilisé'),
			(5, '', '', 'Non Utilisé'),
			(6, '', '', 'Non Utilisé'),
			(7, '', '', 'Nom'),
			(8, '', '', 'Non Utilisé'),
			(9, '', '', 'Non Utilisé'),
			(10, '', '', 'Non Utilisé'),
			(11, '', '', 'Message'),
			(12, '', '', 'Horaires & Prix'),
			(13, '', '', 'Categorie'),
			(14, '', '', 'Non Utilisé');";
		$db->setQuery($query);
		$db->query();
		if ($db->getErrorNum()) {
			exit($db->stderr());
		}
		
	}
 
	/**
	 * method to uninstall the component
	 * @return void
	 */
	function uninstall($parent) 
	{
			$db = JFactory::getDBO();
			$query = 'DELETE FROM #__menu
			WHERE menutype = "main" and path LIKE "gmapfp%"
			';
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
	}
 
	/**
	 * method to update the component
	 *
	 * @return void
	 */
	function update($parent) 
	{
		jimport( 'joomla.filesystem.file' );
		jimport( 'joomla.filesystem.folder' );
		$lang		= JFactory::getLanguage();
		$langue		= substr((@$lang->getTag()),0,2);
		$path = JPATH_SITE;
		
		//mise a jour des table de données
		$db = JFactory::getDBO();

		//Installation du fichier JComments
		if (!JFolder::exists($path .'/components/com_jcomments/plugins/'))
			JFolder::create($path .'/components/com_jcomments/plugins/');
		$filesource = $path .'/components/com_gmapfp/libraries/jcomments/index.html';
		$filedest = $path .'/components/com_jcomments/plugins/index.html';
		JFile::copy($filesource, $filedest, '', true);
		$filesource = $path .'/components/com_gmapfp/libraries/jcomments/com_gmapfp.plugin.php';
		$filedest = $path .'/components/com_jcomments/plugins/com_gmapfp.plugin.php';
		JFile::copy($filesource, $filedest, '', true);

		//Installation du fichier des images s'il n'existe pas et déplace le fichier css
		$foldersource = $path .'/media/com_gmapfp/imagesfolder/';
		$folderdest = $path .'/images/gmapfp/';
		if (!JFolder::exists($folderdest)) {
			JFolder::copy($foldersource, $folderdest, '', true);
		} else {
			$foldersource = $path .'/media/com_gmapfp/imagesfolder/blank/';
			$folderdest = $path .'/images/gmapfp/blank/';
			JFolder::copy($foldersource, $folderdest, '', true);
			
			$foldersource = $path .'/media/com_gmapfp/imagesfolder/classements/';
			$folderdest = $path .'/images/gmapfp/classements/';
			if (!JFolder::exists($folderdest)) {
				JFolder::copy($foldersource, $folderdest, '', true);
			}
			
			$foldersource = $path .'/media/com_gmapfp/imagesfolder/markerclusterer/';
			$folderdest = $path .'/images/gmapfp/markerclusterer/';
			if (!JFolder::exists($folderdest)) {
				JFolder::copy($foldersource, $folderdest, '', true);
			}
			
			$foldersource = $path .'/media/com_gmapfp/imagesfolder/marqueurs/';
			$folderdest = $path .'/images/gmapfp/marqueurs/';
			if (!JFolder::exists($folderdest)) {
				JFolder::copy($foldersource, $folderdest, '', true);
			}
			
			$foldersource = $path .'/media/com_gmapfp/imagesfolder/thumbsArt/';
			$folderdest = $path .'/images/gmapfp/thumbsArt/';
			if (!JFolder::exists($folderdest)) {
				JFolder::copy($foldersource, $folderdest, '', true);
			}
			
			$foldersource = $path .'/media/com_gmapfp/imagesfolder/thumbsGMap/';
			$folderdest = $path .'/images/gmapfp/thumbsGMap/';
			if (!JFolder::exists($folderdest)) {
				JFolder::copy($foldersource, $folderdest, '', true);
			}
		}
		$filedest = $path .'/media/com_gmapfp/css/gmapfp.css';
		if (!JFile::exists($filedest)) {
			$filesource = $path .'/components/com_gmapfp/views/gmapfp/gmapfp.css';
			JFile::copy($filesource, $filedest, '', true);
		}
		JFolder::delete($foldersource);

		/**********************************/
		/* détection si version free      */
		/**********************************/
		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'created_by'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		$free_version = (empty($list_id));
		
		if ($free_version) $this->update_table_free_to_pro();
		
//ajout de la possibiliter du cadenas checkout => passage de la version 10.87 à la version 10.88"
		//Changement du type de checkout
		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'checked_out'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if ($list_id->Type != 'int(10)') {
			$query = "ALTER TABLE  `#__gmapfp` CHANGE  `checked_out`  `checked_out` INT( 10 ) NOT NULL DEFAULT  '0'";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		}

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'checked_out_time'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		//passage de la version J3.2 à la version J3.3"
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `checked_out_time` DATETIME NOT NULL DEFAULT  '0000-00-00 00:00:00' AFTER  `checked_out`";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			unset($list_id);
			//actualise les valeurs des champs checkbox, radio button et drow list suivant la nouvelle syntaxe.
			$query = "SELECT * FROM `#__gmapfp_extension_type` WHERE type>=3 and type<=6";
			$db->setQuery( $query );
			$fields = $db->loadObjectList();
			foreach($fields as $field){
				$params = explode("\r\n", $field->parametres);
				$cn = 1;
				$new_param = array();
				foreach($params as $param){
					$new_param[]=$cn.'::'.$param;
					$cn++;
				}
				$field->parametres = implode("\r\n", $new_param);
				$query = "UPDATE  `#__gmapfp_extension_type` SET  `parametres` =".$db->Quote($field->parametres)." WHERE `id` = ".$field->id;
				$db->setQuery($query);
				$db->query();
				if ($db->getErrorNum()) {
					exit($db->stderr());
				}
			}
			unset($fields, $field, $params, $param, $new_param, $cn);	
		};
		
		//J3_30P
		$query = "ALTER TABLE  `#__gmapfp_extension_type` CHANGE `position` `position` INT( 11 ) NOT NULL;";
		$db->setQuery($query);
		$db->query();
		if ($db->getErrorNum()) {
			exit($db->stderr());
		}

		//J3_59P
		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'sef'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD `sef` VARCHAR(255) NOT NULL AFTER `alias`;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		}
		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'kml'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD `kml` VARCHAR(255) NOT NULL AFTER `gzoom`;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		}

		//J3_60P
		$query = "SHOW COLUMNS FROM `#__gmapfp_personnalisation` LIKE 'intro_filtre'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE `#__gmapfp_personnalisation` ADD `intro_filtre` MEDIUMTEXT NULL DEFAULT NULL AFTER `nom`;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		}

		//J3_69P
		$query = "SHOW COLUMNS FROM `#__gmapfp_extension_type` LIKE 'required'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE `#__gmapfp_extension_type` ADD `required` TINYINT(1) NOT NULL;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		}

		//J3_84P
		$query = "ALTER TABLE `#__gmapfp` CHANGE `catid` `catid` VARCHAR(255) NOT NULL DEFAULT '0';";
		$db->setQuery($query);
		$db->query();
		if ($db->getErrorNum()) {
			exit($db->stderr());
		}

		//J3_93P
		$query = "SHOW COLUMNS FROM `#__gmapfp_extension_type` LIKE 'field_separator'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE `#__gmapfp_extension_type` ADD `field_separator` VARCHAR(20) NOT NULL DEFAULT '' AFTER `catid`;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		}
		
		//J3_95P Supprime licence version free
		$db->setQuery("SELECT extension_id FROM  `#__extensions` WHERE  `name` =  \"plg_system_cp\"");
		$old_name = $db->loadResult();
		
		if ($old_name) {
			$db->setQuery("DELETE FROM  `#__extensions` WHERE  `extension_id` = ".(int)$old_name);
			$db->query();
		}
		
		//J3_108P
		$query = "SHOW COLUMNS FROM `#__gmapfp_marqueurs` LIKE 'checked_out_time'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE `#__gmapfp_marqueurs` ADD `checked_out_time` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00 ' AFTER `shadow_height`;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		}
		$query = "SHOW COLUMNS FROM `#__gmapfp_marqueurs` LIKE 'optimized'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE `#__gmapfp_marqueurs` ADD `optimized` TINYINT(1) UNSIGNED NOT NULL DEFAULT '1' AFTER `checked_out_time`;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		}
		
		//J3_113P
		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'featured'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE `#__gmapfp` ADD `featured` TINYINT(1) UNSIGNED NOT NULL DEFAULT '0' AFTER `published`;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		}
		
		//J3_121P
		$query = "ALTER TABLE `#__gmapfp` CHANGE `sef` `sef` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;";
		$db->setQuery($query);
		$db->query();
		if ($db->getErrorNum()) {
			exit($db->stderr());
		}
		$query = "ALTER TABLE `#__gmapfp` CHANGE `kml` `kml` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;";
		$db->setQuery($query);
		$db->query();
		if ($db->getErrorNum()) {
			exit($db->stderr());
		}
		$query = "ALTER TABLE `#__gmapfp` CHANGE `classements` `classements` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;";
		$db->setQuery($query);
		$db->query();
		if ($db->getErrorNum()) {
			exit($db->stderr());
		}
		$query = "ALTER TABLE `#__gmapfp` CHANGE `labels` `labels` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;";
		$db->setQuery($query);
		$db->query();
		if ($db->getErrorNum()) {
			exit($db->stderr());
		}
		$query = "ALTER TABLE `#__gmapfp` CHANGE `pictos` `pictos` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;";
		$db->setQuery($query);
		$db->query();
		if ($db->getErrorNum()) {
			exit($db->stderr());
		}
		//$this->affiche_bienvenue(0);
		
	}

	function update_table_free_to_pro() {
		$db = JFactory::getDBO();
		$lang	= JFactory::getLanguage();
		$langue	=substr((@$lang->getTag()),0,2);

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'fulltext'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = ' ALTER TABLE `#__gmapfp` '.
					'CHANGE `message` `fulltext` '.
					' MEDIUMTEXT NULL DEFAULT NULL';
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}		
		}

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'introtext'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = ' ALTER TABLE `#__gmapfp` '.
					' CHANGE `intro` `introtext` '.
					' MEDIUMTEXT NULL DEFAULT NULL';
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}		
		}

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'attribs'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `attribs` text NULL DEFAULT NULL AFTER  `ordering` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'index_marqueur'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `index_marqueur` INT (11) NULL DEFAULT 0 AFTER  `attribs` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}

		/*tranfert toutes les données des marqueurs*/
			$query = "SELECT id, url FROM `#__gmapfp_marqueurs`;";
			$db->setQuery($query);
			$marqueurs = $db->loadObjectList();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			
			foreach ($marqueurs as $marqueur) {
				$query = "UPDATE `#__gmapfp` SET `index_marqueur` = ".$marqueur->id." WHERE `marqueur` = '".$marqueur->url."';";
				$db->setQuery($query);
				$db->query();
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'language'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `language` VARCHAR (7) NULL DEFAULT NULL AFTER  `index_marqueur` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'classements'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `classements` VARCHAR (255) NULL DEFAULT NULL AFTER  `language` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'labels'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `labels` VARCHAR (255) NULL DEFAULT NULL AFTER  `classements` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'pictos'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `pictos` VARCHAR (255) NULL DEFAULT NULL AFTER  `labels` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'created_by'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` CHANGE  `userid`  `created_by` INT( 10 ) NULL DEFAULT NULL";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'access'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `access` INT (11) NULL DEFAULT 1 AFTER  `published` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'metadata'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `metadata` TEXT NULL DEFAULT NULL AFTER  `metakey` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'hits'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `hits` INT (11) unsigned NOT NULL DEFAULT '0' AFTER  `metadata` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'version'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `version` INT (11) unsigned NOT NULL DEFAULT '1' AFTER  `hits` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'modified'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `modified` DATETIME NOT NULL DEFAULT  '0000-00-00 00:00:00' AFTER  `version` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'modified_by'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `modified_by` INT (11) NULL DEFAULT 0 AFTER  `modified` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'created'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `created` DATETIME NOT NULL DEFAULT  '0000-00-00 00:00:00' AFTER  `modified_by` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'publish_up'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `publish_up` DATETIME NOT NULL DEFAULT  '0000-00-00 00:00:00' AFTER  `created` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp` LIKE 'publish_down'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp` ADD  `publish_down` DATETIME NOT NULL DEFAULT  '0000-00-00 00:00:00' AFTER  `publish_up` ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};
	
		/*************************************/
		/* Mise à jour de la table Marqueurs */
		/*************************************/
		$query = "SHOW COLUMNS FROM `#__gmapfp_marqueurs` LIKE 'marker_width'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp_marqueurs` ADD  `marker_width` INT( 4 ) UNSIGNED DEFAULT '0';";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `marker_width` = '20' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `marker_width` = '32' WHERE  url LIKE 'mapfiles/ms' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `marker_width` = '23' WHERE  url LIKE 'd_map_xpin' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `marker_width` = '12' WHERE  url LIKE 'ridefinder' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp_marqueurs` LIKE 'marker_height'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp_marqueurs` ADD  `marker_height` INT( 4 ) UNSIGNED DEFAULT '0';";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `marker_height` = '34' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `marker_height` = '32' WHERE  url LIKE 'mapfiles/ms' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `marker_height` = '39' WHERE  url LIKE 'd_map_xpin' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `marker_height` = '20' WHERE  url LIKE 'ridefinder' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};
		
		$query = "SHOW COLUMNS FROM `#__gmapfp_marqueurs` LIKE 'centre_x'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp_marqueurs` ADD  `centre_x` INT( 4 ) UNSIGNED DEFAULT '0';";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `centre_x` = '10' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `centre_x` = '16' WHERE  url LIKE 'mapfiles/ms' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `centre_x` = '11' WHERE  url LIKE 'd_map_xpin' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `centre_x` = '6' WHERE  url LIKE 'ridefinder' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};

		$query = "SHOW COLUMNS FROM `#__gmapfp_marqueurs` LIKE 'centre_y'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp_marqueurs` ADD  `centre_y` INT( 4 ) UNSIGNED DEFAULT '0';";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `centre_y` = '34' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `centre_y` = '32' WHERE  url LIKE 'mapfiles/ms' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `centre_y` = '39' WHERE  url LIKE 'd_map_xpin' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `centre_y` = '20' WHERE  url LIKE 'ridefinder' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};
		
		$query = "SHOW COLUMNS FROM `#__gmapfp_marqueurs` LIKE 'url_shadow'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp_marqueurs` ADD  `url_shadow` TEXT;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `url_shadow` = '//www.google.com/mapfiles/shadow50.png' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};
		
		$query = "SHOW COLUMNS FROM `#__gmapfp_marqueurs` LIKE 'shadow_width'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp_marqueurs` ADD  `shadow_width` INT( 4 ) UNSIGNED DEFAULT '0';";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `shadow_width` = '34' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		};
		
		$query = "SHOW COLUMNS FROM `#__gmapfp_marqueurs` LIKE 'shadow_height'";
		$db->setQuery( $query );
		$list_id = $db->loadObject();
		if (empty($list_id)) {
			$query = "ALTER TABLE  `#__gmapfp_marqueurs` ADD  `shadow_height` INT( 4 ) UNSIGNED DEFAULT '0';";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
			$query = "UPDATE `#__gmapfp_marqueurs` SET `shadow_height` = '37' ;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}

			$query = "ALTER TABLE  `#__gmapfp_marqueurs` CHANGE  `url`  `url` TEXT NOT NULL;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}		
		};

		/**********************************/
		/* Mise à jour de la table Custom */
		/**********************************/
			$query = "CREATE TABLE IF NOT EXISTS `#__gmapfp_params_custom_fields` (
				  `id` int(11) NOT NULL auto_increment,
				  `nom` varchar(255) DEFAULT NULL,
				  `items` text DEFAULT NULL,
				  `nom originel` varchar(100) DEFAULT NULL,
				  PRIMARY KEY  (`id`)
				) ENGINE=MyISAM;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}		
	
			$query = "INSERT INTO `#__gmapfp_params_custom_fields` VALUES
				('', '', '','Non utilisé'),
				('', '', '','Non utilisé'),
				('', '', '','Non utilisé'),
				('', '', '','Non utilisé'),
				('', '', '','Non utilisé'),
				('', '', '','Non utilisé'),
				('', '', '','Nom'),
				('', '', '','Non utilisé'),
				('', '', '','Non utilisé'),
				('', '', '','Non utilisé'),
				('', '', '','Message'),
				('', '', '','Horaires & Prix'),
				('', '', '','Categorie'),
				('', '', '','Non utilisé');";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}
		
		/***************************************/
		/* Mise à jour de la table Classements */
		/***************************************/
			$query = "CREATE TABLE IF NOT EXISTS `#__gmapfp_classements` (
				  `id` int(11) NOT NULL AUTO_INCREMENT,
				  `nom` text NOT NULL,
				  `cat` int(2) NOT NULL,
				  `img` text NOT NULL,
				  `ordering` int(11) NOT NULL,
				  `published` tinyint(1) NOT NULL DEFAULT '0',
				  `language` char(7) NOT NULL,
				  `filtrable` tinyint(1) NOT NULL,
				  PRIMARY KEY (`id`)
				) ENGINE=MyISAM;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}		
			
			if ($langue == 'fr')
				$query = "INSERT INTO `#__gmapfp_classements` (`id`, `nom`, `cat`, `img`, `ordering`, `published`, `language`) VALUES
					('', '1 etoile', 1, '1etoile.gif', 6, 1, '*'),
					('', 'TV', 3, 'chambre_tv.jpg', 29, 1, '*'),
					('', 'Gite de france', 1, 'gitesdefrance.png', 11, 1, '*'),
					('', 'Garage ferme', 3, 'garage_ferme.jpg', 21, 1, '*'),
					('', 'Animaux', 3, 'animaux.jpg', 22, 1, '*'),
					('', 'CB', 3, 'carte_bleue.jpg', 23, 1, '*'),
					('', 'Cheques vacances', 3, 'cheque_vacances.jpg', 24, 1, '*'),
					('', 'Climatisation', 3, 'climatisation.jpg', 25, 1, '*'),
					('', 'Piscine', 3, 'piscine.jpg', 26, 1, '*'),
					('', 'Restaurant', 3, 'restaurant.jpg', 27, 1, '*'),
					('', 'Wifi', 3, 'wifi.jpg', 28, 1, '*'),
					('', '2 etoiles', 1, '2etoiles.gif', 7, 1, '*'),
					('', '3 etoiles', 1, '3etoiles.gif', 8, 1, '*'),
					('', '4 etoiles', 1, '4etoiles.gif', 9, 1, '*'),
					('', '5 etoiles', 1, '5etoiles.gif', 10, 1, '*'),
					('', '1 epis', 1, '1epis.gif', 12, 1, '*'),
					('', '2 epis', 1, '2epis.gif', 13, 1, '*'),
					('', '3 epis', 1, '3epis.gif', 14, 1, '*'),
					('', '4 epis', 1, '4epis.gif', 15, 1, '*'),
					('', '5 epis', 1, '5epis.gif', 16, 1, '*'),
					('', '1 clef', 1, '1clef.gif', 17, 1, '*'),
					('', '2 clefs', 1, '2clefs.gif', 18, 1, '*'),
					('', '3 clefs', 1, '3clefs.gif', 19, 1, '*'),
					('', '4 clefs', 1, '4clefs.gif', 20, 1, '*'),
					('', 'Label tourisme handicap', 2, 'label-tourisme-handicap.jpg', 1, 1, '*'),
					('', 'Handicap Moteur', 2, 'handicap-moteur.gif', 2, 1, '*'),
					('', 'Handicap Mental', 2, 'handicap-mental.gif', 3, 1, '*'),
					('', 'Handicap Auditif', 2, 'handicap-auditif.gif', 4, 1, '*'),
					('', 'Handicap Visuel', 2, 'handicap-visuel.gif', 5, 1, '*');";
			if ($langue != 'fr')
				$query = "INSERT INTO `#__gmapfp_classements` (`id`, `nom`, `cat`, `img`, `ordering`, `published`, `language`) VALUES
					('', '1 star', 1, '1etoile.gif', 6, 1, '*'),
					('', 'TV', 3, 'chambre_tv.jpg', 29, 1, '*'),
					('', 'Cottage France', 1, 'gitesdefrance.png', 11, 1, '*'),
					('', 'Secure garage', 3, 'garage_ferme.jpg', 21, 1, '*'),
					('', 'Pets', 3, 'animaux.jpg', 22, 1, '*'),
					('', 'CB', 3, 'carte_bleue.jpg', 23, 1, '*'),
					('', 'Holiday vouchers', 3, 'cheque_vacances.jpg', 24, 1, '*'),
					('', 'Airconditioning', 3, 'climatisation.jpg', 25, 1, '*'),
					('', 'Swimming pool', 3, 'piscine.jpg', 26, 1, '*'),
					('', 'Restaurant', 3, 'restaurant.jpg', 27, 1, '*'),
					('', 'Wifi', 3, 'wifi.jpg', 28, 1, '*'),
					('', '2 stars', 1, '2etoiles.gif', 7, 1, '*'),
					('', '3 stars', 1, '3etoiles.gif', 8, 1, '*'),
					('', '4 stars', 1, '4etoiles.gif', 9, 1, '*'),
					('', '5 stars', 1, '5etoiles.gif', 10, 1, '*'),
					('', '1 ear', 1, '1epis.gif', 12, 1, '*'),
					('', '2 ears', 1, '2epis.gif', 13, 1, '*'),
					('', '3 ears', 1, '3epis.gif', 14, 1, '*'),
					('', '4 ears', 1, '4epis.gif', 15, 1, '*'),
					('', '5 ears', 1, '5epis.gif', 16, 1, '*'),
					('', '1 key', 1, '1clef.gif', 17, 1, '*'),
					('', '2 keys', 1, '2clefs.gif', 18, 1, '*'),
					('', '3 keys', 1, '3clefs.gif', 19, 1, '*'),
					('', '4 keys', 1, '4clefs.gif', 20, 1, '*'),
					('', 'Label tourism handicap', 2, 'label-tourisme-handicap.jpg', 1, 1, '*'),
					('', 'Motor handicap', 2, 'handicap-moteur.gif', 2, 1, '*'),
					('', 'Mental handicap', 2, 'handicap-mental.gif', 3, 1, '*'),
					('', 'Hearing handicap', 2, 'handicap-auditif.gif', 4, 1, '*'),
					('', 'Visual handicap', 2, 'handicap-visuel.gif', 5, 1, '*');";
				$db->setQuery($query);
				$db->query();
				if ($db->getErrorNum()) {
					exit($db->stderr());
				}
			
		//Création des tables gmapfp_extension_...
			$query = "CREATE TABLE IF NOT EXISTS `#__gmapfp_extension_type` (
				 `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
				 `nom` varchar(255) NOT NULL,
				 `alias` varchar(255) NOT NULL,
				 `description` varchar(255) NOT NULL,
				 `filtrer` tinyint(1) NOT NULL,
				 `filtre_label` varchar(100) NOT NULL,
				 `recherche` tinyint(1) NOT NULL,
				 `type` tinyint(2) NOT NULL,
				 `parametres` text NOT NULL,
				 `position` tinyint(2) NOT NULL,
				 `for_cat` int(11) NOT NULL,
				 `catid` text NOT NULL,
				 `form_separator` varchar(50) NOT NULL,
				 `view_separator` varchar(50) NOT NULL,
				 `published` tinyint(1) NOT NULL,
				 `access` int(11) NOT NULL,
				 `ordering` int(11) NOT NULL,
				 PRIMARY KEY (`id`)
				) ENGINE=MyISAM;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}		
			
			$id = 0;
			//récupère les données de la table custom
			$query = "SELECT * 
				FROM  `#__gmapfp_params_custom_fields`";
			$db->setQuery( $query );
			$customs_field = $db->loadObjectList('id');
			//détection si le champ tel est utilisé
			$query = "SELECT id, tel
				FROM  `#__gmapfp` 
				WHERE tel <> '' AND tel IS NOT NULL;";
			$db->setQuery( $query );
			$results = $db->loadObjectList();
			if ($results) {//crée ce champ en champ paramètrable
				$id++;
				$query = "INSERT INTO `#__gmapfp_extension_type`
					(`nom`, `alias`, `description`, `filtrer`, `recherche`, `type`, `parametres`, `position`, `published`, `access`, `ordering`) ";
				if ($langue == 'fr') { $nom = 'Téléphone'; } else { $nom = 'Phone'; }
				if ($customs_field[8]->nom != '') $nom = addslashes($customs_field[8]->nom);
				if ($langue == 'fr') {
					$query .= "VALUES ('".$nom."', 'tel', 'numéro de téléphone', 0, 0, 0, '', 2, 1, 1, 0);";
				} else {
					$query .= "VALUES ('".$nom."', 'phone', 'phone number', 0, 0, 0, '', 2, 1, 1, 0);";
				}
				$db->setQuery($query);
				$db->query();
				if ($db->getErrorNum()) {
					exit($db->stderr());
				}	
				$query = "SELECT id
					FROM  `#__gmapfp_extension_type` 
					WHERE nom = '".$nom."';";
				$db->setQuery( $query );
				$filed_id = $db->loadObject();

				if ($filed_id) {//reporte les données
					$query = ' ALTER TABLE `#__gmapfp` '.
							'CHANGE `tel` `field_'.$filed_id->id.'` '.
							' TEXT NOT NULL AFTER `pictos` ';
					$db->setQuery($query);
					$db->query();
					if ($db->getErrorNum()) {
						exit($db->stderr());
					}		
				}
			}

			//détection si le champ tel2 est utilisé
			$query = "SELECT id, tel2
				FROM  `#__gmapfp` 
				WHERE tel2 <> '' AND tel2 IS NOT NULL;";
			$db->setQuery( $query );
			$results = $db->loadObjectList();
			if ($results) {//crée ce champ en champ paramétrable
				$id++;
				$query = "INSERT INTO `#__gmapfp_extension_type`
					(`nom`, `alias`, `description`, `filtrer`, `recherche`, `type`, `parametres`, `position`, `published`, `access`, `ordering`) ";
				if ($langue == 'fr') { $nom = 'Téléphone 2'; } else { $nom = 'Phone 2'; }
				if ($customs_field[9]->nom != '') $nom = addslashes($customs_field[9]->nom);
				if ($langue == 'fr') {
					$query .= "VALUES ('".$nom."', 'tel2', '2ème numéro de téléphone', 0, 0, 0, '', 2, 1, 1, 0);";
				} else {
					$query .= "VALUES ('".$nom."', 'phone2', 'second phone number', 0, 0, 0, '', 2, 1, 1, 0);";
				}
				$db->setQuery($query);
				$db->query();
				if ($db->getErrorNum()) {
					exit($db->stderr());
				}		
				$query = "SELECT id
					FROM  `#__gmapfp_extension_type` 
					WHERE nom = '".$nom."';";
				$db->setQuery( $query );
				$filed_id = $db->loadObject();

				if ($filed_id) {//reporte les données
					$query = ' ALTER TABLE `#__gmapfp` '.
							'CHANGE `tel2` `field_'.$filed_id->id.'` '.
							' TEXT NOT NULL AFTER `pictos` ';
					$db->setQuery($query);
					$db->query();
					if ($db->getErrorNum()) {
						exit($db->stderr());
					}		
				}
			}
					
			//détection si le champ fax est utilisé
			$query = "SELECT id, fax
				FROM  `#__gmapfp` 
				WHERE fax <> '' AND fax IS NOT NULL;";
			$db->setQuery( $query );
			$results = $db->loadObjectList();
			if ($results) {//crée ce champ en champ paramètrable
				$id++;
				$query = "INSERT INTO `#__gmapfp_extension_type`
					(`nom`, `alias`, `description`, `filtrer`, `recherche`, `type`, `parametres`, `position`, `published`, `access`, `ordering`) ";
				$nom = 'Fax';
				if ($customs_field[10]->nom != '') $nom = addslashes($customs_field[10]->nom);
				if ($langue == 'fr') {
					$query .= "VALUES ('".$nom."', 'fax', 'numéro de fax', 0, 0, 0, '', 2, 1, 1, 1);";
				} else {
					$query .= "VALUES ('".$nom."', 'fax', 'fax number', 0, 0, 0, '', 2, 1, 1, 1);";
				}
				$db->setQuery($query);
				$db->query();
				if ($db->getErrorNum()) {
					exit($db->stderr());
				}		
				$query = "SELECT id
					FROM  `#__gmapfp_extension_type` 
					WHERE nom = '".$nom."';";
				$db->setQuery( $query );
				$filed_id = $db->loadObject();

				if ($filed_id) {//reporte les données
					$query = ' ALTER TABLE `#__gmapfp` '.
							'CHANGE `fax` `field_'.$filed_id->id.'` '.
							' TEXT NOT NULL AFTER `pictos` ';
					$db->setQuery($query);
					$db->query();
					if ($db->getErrorNum()) {
						exit($db->stderr());
					}		
				}
			}

		//Création des la table __gmapfp_extension_lang...
			$query = "CREATE TABLE IF NOT EXISTS `#__gmapfp_extension_lang` (
				 `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
				 `typeid` int(11) NOT NULL,
				 `langue` varchar(5) NOT NULL,
				 `nom` varchar(255) NOT NULL,
				 `parametres` text NOT NULL,
				 `filtre_label` varchar(100) NOT NULL,
				 PRIMARY KEY (`id`)
				) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}		
	}

	function affiche_bienvenue($install) {
		$lang		= JFactory::getLanguage();
		$langue		= substr((@$lang->getTag()),0,2);
		if ($langue!='fr') $langue = 'en';

		if ($langue=='fr') {
			if ($install == 1) {
				echo "<h1>GMapFP Installation</h1>";
			}else{
				echo "<h1>GMapFP Mise &agrave; jour</h1>";
			};
			?>
			<a href='http://pro.gmapfp.org/fr/' target='_blank'><img src='../administrator/components/com_gmapfp/images/gmapfp_logo.png' title='Visit&eacute; le site : Pro.GMapFP.org' alt='Visit&eacute; le site : Pro.GMapFP.org' style='float:left; margin: 2px 25px 2px 0px;'/></a>
			<p>Bienvenue sur GMapFP v<?php echo $this->release?> !</p>
			<p>Avant de commencer, je vous invite, si ce n'est pas d&eacute;j&agrave; fait, &agrave; d&eacute;couvrir toutes les possibilit&eacute;s de se composant et de son ou ses plugins sur son <a target="_blank" href="http://pro.gmapfp.org/fr">Site officiel</a></p>
			<p>Au revoir, et bonne continuation avec GMapFP</p>
			<br />
			<br />
			<br />
			<?php
		} else {
			if ($install == 1) {
				echo "<h1>GMapFP Installation</h1>";
			}else{
				echo "<h1>GMapFP Upgrade</h1>";
			};
			?>
			<a href='http://pro.gmapfp.org/en/' target='_blank'><img src='../administrator/components/com_gmapfp/images/gmapfp_logo.png' title='Visité le site : Pro.GMapFP.org' alt='Visited the site : Pro.GMapFP.org' style='float:left; margin: 2px 25px 2px 0px;'/></a>
			<p>Welcome on v<?php echo $this->release?> GMapFP !</p>
			<p>Before starting, I invite you, if this isn't already made, to discovery all the possibilities of this component and thisd plugin on its <a target="_blank" href="http://www.pro.gmapfp.org/en">Official Site</a>.</p>
			<p>Goodbye, and good continuation with GMapFP</p>
			<?php
		}
	}
	/**
	 * method to run after an install/update/uninstall method
	 *
	 * @return void
	 */
	function postflight($type, $parent)
	{
		// $parent is the class calling this method
		// $type is the type of change (install, update or discover_install)
		if ($type == 'install') {
	
			//Installation du fichier des images
			$path = JPATH_SITE;
			$foldersource = $path .'/media/com_gmapfp/imagesfolder/';
			$folderdest = $path .'/images/gmapfp/';
			// die(print_r($foldersource));
			JFolder::copy($foldersource, $folderdest, '', true);
			JFolder::delete($foldersource);
		
			$db = JFactory::getDBO();
			/*mise à jour des paramètres par défaut*/
			$query = 'UPDATE #__extensions SET params=\'{
	"gmapfp_height":"500",
	"gmapfp_width":"100%",
	"gmapfp_auto":"1","gmapfp_centre_lat":"",
	"gmapfp_centre_lng":"","gmapfp_zoom_admin":"10",
	"gmapfp_type_admin":"roadmap","gmapfp_zoom":"0",
	"gmapfp_zoom_lightbox_carte":"0","gmapfp_zoom_lightbox_imprimer":"0",
	"gmapfp_auto_zoom_maxi":"13","gmapfp_auto_other":"1","gmapfp_normal":"1",
	"gmapfp_satellite":"1","gmapfp_hybrid":"1",
	"gmapfp_Tilt45":"1","gmapfp_physic":"1",
	"gmapfp_choix_affichage_carte":"1",
	"gmapfp_mapcontrol":"1","gmapfp_scalecontrol":"1",
	"gmapfp_mousewheel":"1","gmapfp_logo":"1","gmapfp_zzoom":"1",
	"gmapfp_plus_info":"1","gmapfp_enable_traffic":"0",
	"gmapfp_enable_pano_photos":"0","gmapfp_enable_weather":"1",
	"gmapfp_unite_temperature":"CELSIUS","gmapfp_fullscreen":"1",
	"gmapfp_fullscreen_Z_max":"div_style.zIndex= 2000;",
	"gmapfp_fullscreen_Z_min":"div_style.zIndex= 1;",
	"gmapfp_geolocalisation":"1","gmapfp_geolocalisation_bp":"1",
	"gmapfp_clustering":"0","gmapfp_clustering_styles":"4",
	"gmapfp_clustering_zmax":"14","gmapfp_clustering_gridSize":"null",
	"gmapfp_template":"default","gmapfp_template_article":"default",
	"gmapfp_default_item":"","gmapfp_eventcontrol":"1",
	"gmapfp_width_bulle_GMapFP":"400","gmapfp_min_height_bulle_GMapFP":"150",
	"gmapfp_max_height_bulle_GMapFP":"350","affichage":"0",
	"gmapfp_taille_bulle_cesure":"200","gmapfp_html_bubble":"0",
	"gmapfp_plus_detail":"1","gmapfp_AutoPan":"0",
	"target":"0","gmapfp_hauteur_lightbox":"400",
	"gmapfp_largeur_lightbox":"700","gmapfp_auto_ouvrir_titre":"1",
	"gmapfp_itineraire":"0","gmapfp_km_miles":"0",
	"gmapfp_travel_mode":"1","gmapfp_bike_option":"0",
	"gmapfp_auto_complete":"1","gmapfp_streetView":"1",
	"gmapfp_height_sv":"300","gmapfp_afficher_intro_italique":"1",
	"gmapfp_zipcode_ville":"1","show_category":"1",
	"show_create_date":"1","show_modify_date":"1",
	"show_author":"1","show_hit":"1","show_map_icon":"1",
	"gmapfp_afficher_horaires_prix":"1","gmapfp_msg":"1",
	"show_print_icon":"1","gmapfp_filtre":"1","gmapfp_filtre_ville":"1",
	"gmapfp_filtre_departement":"1","gmapfp_filtre_pays":"1",
	"gmapfp_filtre_categories":"1","gmapfp_filtre_search":"1",
	"gmapfp_show_bp_init_filtre":"0","gmapfp_filtre_classement":"1",
	"gmapfp_filtre_label":"1","gmapfp_filtre_picto":"1",
	"gmapfp_ajax":"0","gmapfp_ajax_recentre":"0",
	"gmapfp_afficher_captcha":"1","captcha_type":"0",
	"email_copy":"1","gmapfp_recaptcha_color":"blackglass",
	"gmapfp_recaptcha_key_public":"","gmapfp_recaptcha_key_private":"",
	"gmapfp_crop":"1","gmapfp_jfile_thumbs":"0",
	"gmapfp_jpeg_quality":"60","gmapfp_num_galerie":"1",
	"gmapfp_view_all_img":"1","gmapfp_ajust_main":"0",
	"gmapfp_hauteur_img_main":"600","gmapfp_largeur_img_main":"800",
	"gmapfp_hauteur_img":"100","gmapfp_largeur_img":"100",
	"gmapfp_hauteur_img_art":"250","gmapfp_largeur_img_art":"250",
	"gmapfp_ajust_main_gal":"0","gmapfp_hauteur_main_gal":"600",
	"gmapfp_largeur_main_gal":"800","gmapfp_hauteur_img_gal":"80",
	"gmapfp_largeur_img_gal":"80","gmapfp_del_img":"1",
	"gmapfp_del_galerie":"1","gmapfp_geoXML":"",
	"gmapfp_compa_trad_joom25":"0","gmapfp_jcomments":"1",
	"gmapfp_news":"1","gmapfp_licence":"1","gmapfp_autocomplete_adresse":"0",
	"gmapfp_autocomplete_adresse_dep":"0","gmapfp_nom":"",
	"gmapfp_nom_categorie":"","gmapfpadresse1_view":"1",
	"gmapfpadresse2_view":"1","gmapfp_cp_view":"1",
	"gmapfp_ville_view":"1","gmapfp_departement_view":"1",
	"gmapfp_pays_view":"1","gmapfp_email_view":"1",
	"gmapfp_web_view":"1","gmapfp_message":"","gmapfp_message_view":"1",
	"gmapfp_horaires_prix":"","gmapfp_prix_view":"1",
	"gmapfp_classements_view":"1","gmapfp_labels_view":"1",
	"gmapfp_pictos_view":"1"	
	}\' WHERE name=\'com_gmapfp\'';
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}

			//Insertion des catégories exemples
			$this->createcat('GMapFP cat exemple');

			//Insertion des exemples
			$query = "SELECT id FROM `#__categories` WHERE `extension`='com_gmapfp';";
			$db->setQuery($query);
			$cat = $db->loadColumn();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}

			if (!empty($cat[0])) {
				$query = "INSERT INTO `#__gmapfp` (`id`, `nom`, `alias`, `adresse`, `adresse2`, `ville`, `departement`, `codepostal`, `pay`, `email`, `web`, `img`, `album`, `introtext`, `fulltext`, `horaires_prix`, `link`, `article_id`, `icon`, `icon_label`, `glng`, `glat`, `gzoom`, `catid`, `created_by`, `published`, `access`, `checked_out`, `metadesc`, `metakey`, `metadata`, `hits`, `version`, `modified`, `modified_by`, `created`, `publish_up`, `publish_down`, `ordering`, `attribs`, `index_marqueur`, `language`, `classements`, `labels`, `pictos`) VALUES
					(1, 'L&rsquo;usine du Canal', 'lusine-du-canal', 'Rue de Nestin', '', 'Fay-aux-Loges', 'Loiret', '45450', 'France', '', '', '42__dscf0019.jpg', 0, '<p>\r\n	Cette ancienne usine fournissait de l&rsquo;&eacute;lectricit&eacute; aux sous-stations de pompage. Les pompes permettaient de remonter l&rsquo;eau du bief aval vers le bief amont, pour ne pas perdre l&rsquo;eau lors d&rsquo;une &eacute;clus&eacute;e, &aacute; partir de la Loire vers le Bief de Partage.</p>', '', '', '', 0, '', '', '2.15050976573184', '47.93703880815916', '12', ".$cat[0].", 42, 1, 1, 0, '', '', '{\"robots\":\"\"}', 0, 3, '2011-08-22 12:22:41', 42, '2011-08-22 12:05:57', '2011-08-22 12:05:57', '0000-00-00 00:00:00', 2, NULL, 3, '*', '', '', ''),
					(2, 'Restaurant', 'restaurant', 'sa rue', '', 'sa vile', 'Var', '', 'France', '', '', '42__restaurant.jpg', 0, '<p>Belle salle pouvant accepter unne trentaine de couverts, ...</p>', '', '<p>\r\n	Ouvert tous les jours de la semaine.</p>\r\n<p>\r\n	De 18h00 à 23h00.</p>\r\n<p>\r\n	&nbsp;</p>\r\n<p>\r\n	Menu à partir de 30€</p>', '', 0, '', '', '6.237594700000045', '43.46764599999999', '10', ".$cat[0].", 42, 1, 1, 0, '', '', '{\"robots\":\"\"}', 0, 2, '2011-08-22 12:32:33', 42, '2011-08-22 12:22:51', '2011-08-22 12:22:51', '0000-00-00 00:00:00', 1, NULL, 20, '*', '13', ',26,27', '7,8,9,12');";
				$db->setQuery($query);
				$db->query();
				if ($db->getErrorNum()) {
					exit($db->stderr());
				}
			}
		}
		
		$this->update_extensions();
		
		$this->affiche_bienvenue($type == 'install');
	
		@mail('webmaster@gmapfp.org','GMapFP v'.$this->release.' '.$type,$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],'From:webmaster@gmapfp.org');
		//echo '<p>' . JText::_('COM_GMAPFP_POSTFLIGHT_' . $type . '_TEXT') . '</p>';
	}

	function createcat($nom) 
	{
		// Initialize a new category
		/** @type  JTableCategory  $category  */
		$category = JTable::getInstance('Category');

		// Check if the Uncategorised category exists before adding it
		if (!$category->load(array('extension' => 'com_gmapfp', 'title' => $nom)))
		{
			$category->extension = 'com_gmapfp';
			$category->title = $nom;
			$category->description = '';
			$category->published = 1;
			$category->access = 1;
			$category->params = '{"category_layout":"","image":""}';
			$category->metadata = '{"author":"","robots":""}';
			$category->metadesc = '';
			$category->metakey = '';
			$category->language = '*';
			$category->checked_out_time = JFactory::getDbo()->getNullDate();
			$category->version = 1;
			$category->hits = 0;
			$category->modified_user_id = 0;
			$category->checked_out = 0;

			// Set the location in the tree
			$category->setLocation(1, 'last-child');

			// Check to make sure our data is valid
			if (!$category->check())
			{
				JFactory::getApplication()->enqueueMessage(JText::sprintf('COM_GMAPFP_ERROR_INSTALL_CATEGORY', $category->getError()));

				return;
			}

			// Now store the category
			if (!$category->store(true))
			{
				JFactory::getApplication()->enqueueMessage(JText::sprintf('COM_GMAPFP_ERROR_INSTALL_CATEGORY', $category->getError()));

				return;
			}

			// Build the path for our category
			$category->rebuildPath($category->id);
		}
		
	}
	
	public function getAssoc()
	{
		return false;
	}

	public function getTable($type = 'Category', $prefix = 'JTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}
	
	public function getState()
	{
		return 0;
	}
	
	public function setState()
	{
		return;
	}
	
	public function getName()
	{
		return 0;
	}
	
	public function setName()
	{
		return;
	}
	
	public function cleanCache()
	{
		return ;
	}
	
	function preflight( $type, $parent ) {
        // Installing component manifest file version
        $this->release = $parent->get( "manifest" )->version;
	}
	
	private function update_extensions() {
		jimport( 'joomla.filesystem.folder' );
		$filedest = JPATH_ROOT;
		$new_folder = JPATH_ROOT.'/plugins/extension/gmapfp';
		JFolder::create($new_folder); //CHMOD 755 par défaut
		
		$filesource = JPATH_ADMINISTRATOR .'/components/com_gmapfp/extensions/plugins/extension/gmapfp';
		JFolder::copy($filesource, $new_folder, '', true);
		
		$filesource = JPATH_ADMINISTRATOR .'/components/com_gmapfp/extensions';
		JFolder::delete($filesource);
		
		$db = JFactory::getDBO();

		//déclare le plugin de mise à jour de la table des mise à jour si non déjà fait.
		$query = "SELECT extension_id FROM `#__extensions` WHERE `name`='plg_extension_gmapfp' AND `type`='plugin' AND `folder`='extension' AND `element`='gmapfp';";
		$db->setQuery($query);
		$id = $db->loadResult();
		if ($db->getErrorNum()) {
			exit($db->stderr());
		}

		if (empty($id)) {
			$query = "INSERT INTO `#__extensions` (`name`, `type`, `element`, `folder`, `enabled`, `access`, `manifest_cache`) ".
				"VALUES ('plg_extension_gmapfp', 'plugin', 'gmapfp', 'extension', 1, 1, '{\"name\":\"plg_extension_gmapfp\",\"type\":\"plugin\",\"creationDate\":\"May 2010\",\"author\":\"Fabrice4821\",\"copyright\":\"Copyright (C) 2005 - 2017 Open Source Matters. All rights reserved.\",\"authorEmail\":\"support@gmapfp.org\",\"authorUrl\":\"www.gmapfp.org\",\"version\":\"3.0.0\",\"description\":\"PLG_EXTENSION_GMAPFP_XML_DESCRIPTION\",\"group\":\"\",\"filename\":\"gmapfp\"}');";
			$db->setQuery($query);
			$db->query();
			if ($db->getErrorNum()) {
				exit($db->stderr());
			}	
		}
	}
}