<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.126pro
	* Creation date: Fvrier 2021
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;
jimport( 'joomla.filesystem.folder' ); 
jimport( 'joomla.filesystem.file' );

class GMapFPControllerDropFiles extends JControllerLegacy
{

    protected $allowed_ext = array('jpg','jpeg','png','gif');

    public function upload_image(){
		// Check for request forgeries
		if (!JSession::checkToken('request')) {
 			$this->exit_upload(false, JText::_( 'JINVALID_TOKEN'));
		}
	
		$lang = JFactory::getLanguage();
		$lang->load('com_media');

		$app 		= JFactory::getApplication(); 
		$config 	= JComponentHelper::getParams('com_gmapfp');
		$params 	= JComponentHelper::getParams('com_media');
		$user		= JFactory::getUser();
		$userid		= $user->get('id');
		require_once( JPATH_COMPONENT_ADMINISTRATOR.'/libraries/imagemagic.php' );
		$image_magic = new GMapFPImageMagic;

		$folder = JPATH_ROOT.'/images/gmapfp/';
		$folder = JPath::clean($folder);
		
		
        $type_image = array(".gif",".jpg",".jpeg",".png",".bmp"); 
		$loaderror = false;
		
		$file = $this->input->files->get('image1', '', 'array');

        $ext = strrchr($file['name'],'.');
        $ext = strtolower($ext);
        if (!in_array( $ext, $type_image )) 
 			$this->exit_upload(false, JText::_( 'GMAPFP_BAD_EXT'));

		if (!JFactory::getUser()->authorise('core.create', 'com_gmapfp') and !JFactory::getUser()->authorise('core.edit', 'com_gmapfp') and !JFactory::getUser()->authorise('core.edit.own', 'com_gmapfp'))
		{
 			$this->exit_upload(false, JText::_('JLIB_APPLICATION_ERROR_CREATE_NOT_PERMITTED'));
		}

		// Total length of post back data in bytes.
		$contentLength = (int) $_SERVER['CONTENT_LENGTH'];

		// Instantiate the media helper
		$mediaHelper = new JHelperMedia;

		// Maximum allowed size of post back data in MB.
		$postMaxSize = $mediaHelper->toBytes(ini_get('post_max_size'));

		// Maximum allowed size of script execution in MB.
		$memoryLimit = $mediaHelper->toBytes(ini_get('memory_limit'));

		// Check for the total size of post back data.
		if (($postMaxSize > 0 && $contentLength > $postMaxSize)
			|| ($memoryLimit != -1 && $contentLength > $memoryLimit))
		{
 			$this->exit_upload(false, JText::_( 'COM_MEDIA_ERROR_WARNUPLOADTOOLARGE'));
		}

		$uploadMaxSize = $params->get('upload_maxsize', 0) * 1024 * 1024;
		$uploadMaxFileSize = $mediaHelper->toBytes(ini_get('upload_max_filesize'));

		$file['name']     = JFile::makeSafe($file['name']);
        $file['name'] = str_replace(" ","_",$file['name']);
		if (($file['error'] == 1)
			|| ($uploadMaxSize > 0 && $file['size'] > $uploadMaxSize)
			|| ($uploadMaxFileSize > 0 && $file['size'] > $uploadMaxFileSize))
		{
			// File size exceed either 'upload_max_filesize' or 'upload_maxsize'.
 			$this->exit_upload(false, JText::_( 'COM_MEDIA_ERROR_WARNFILETOOLARGE'));
		}

		if (!isset($file['name']))
		{
			// No filename (after the name was cleaned by JFile::makeSafe)
 			$this->exit_upload(false, JText::_( 'COM_MEDIA_INVALID_REQUEST'));
		}
		
		// Set FTP credentials, if given
		JClientHelper::setCredentialsFromRequest('ftp');
		JPluginHelper::importPlugin('content');
		
		if (!$mediaHelper->canUpload($file, 'com_media'))
		{
			// The file can't be uploaded
			$msg = $app->getMessageQueue();
			$this->exit_upload(false, $msg[0]);
		}
		
		if (strlen($file['tmp_name']) > 0 and $file['name'] != "none"){	
			//si je n'ai pas dj ce fichier, je le copie		
            if(!is_file($folder.strtolower($userid.'__'.$file['name'])))
				if (!$config->get('gmapfp_ajust_main', 0)) {
					if (!JFile::upload($_FILES['image1']['tmp_name'], $folder.strtolower($userid.'__'.$file['name'])))
					{
						// Error in upload
						JLog::add('Controller GMapFP => upload_image(), Error on upload:  => '.$folder.strtolower($userid.'__'.$file['name']), JLog::ERROR, 'com_gmapfp');
						$this->exit_upload(false, JText::_('GMAPFP_UPLOAD_NOK').'1');
					}
				} else {
					$miniature_ok = $image_magic->imageMagic($file['tmp_name'], $folder.strtolower($userid.'__'.$file['name']), $config->get('gmapfp_largeur_img_main', 800), $config->get('gmapfp_hauteur_img_main', 600), 0, null, $errorMsg);
				}
			else $loaderror=true;				
			if($loaderror) {
				$msg = JText::_( 'GMAPFP_UPLOAD_NOK').' => '.strtolower($file['name']).JText::_( 'GMAPFP_EXIST');
				$this->exit_upload(false,$msg);
			} else { 
				//creation des miniatures
				$filein = $folder.strtolower($userid.'__'.$file['name']);
				$errorMsg = '';

				//cre la miniature pour la carte
				if (!is_dir($folder.'thumbsGMap')){
					JFolder::create($folder.'thumbsGMap');
					@JFile::write($folder.'thumbsGMap/index.html', "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>");
				}
				$fileout = $folder.'thumbsGMap/'.strtolower($userid.'__'.$file['name']);				
				$miniature_ok = $image_magic->imageMagic($filein, $fileout, $config->get('gmapfp_largeur_img', 100), $config->get('gmapfp_hauteur_img', 100), $config->get('gmapfp_crop', 1), null, $errorMsg);
				if ($errorMsg) {
					$this->exit_upload(false,$errorMsg);
				}
				//cre la miniature pour l'article
				if (!is_dir($folder.'thumbsArt')){
					JFolder::create($folder.'thumbsArt');
					@JFile::write($folder.'thumbsArt/index.html', "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>");
				}
				$fileout = $folder.'thumbsArt/'.strtolower($userid.'__'.$file['name']);				
				$miniature_ok = $image_magic->imageMagic($filein, $fileout, $config->get('gmapfp_largeur_img_art', 250), $config->get('gmapfp_hauteur_img_art', 250), $config->get('gmapfp_crop', 1), null, $errorMsg);
				
				if ($errorMsg) {
					$this->exit_upload(false,$errorMsg);
				} else {
					$this->exit_upload(true,strtolower($userid.'__'.$file['name']));
				}
			}
		}
		$this->exit_upload(false,'Nom de fichier non dfini');
    }

	function file_upload_galerie() {
		// Check for request forgeries
		if (!JSession::checkToken('request')) {
 			$this->exit_upload(false, JText::_( 'JINVALID_TOKEN'));
		}

		$config 	= JComponentHelper::getParams('com_gmapfp');
		$params 	= JComponentHelper::getParams('com_media');
		
		$file = $this->input->files->get('image1', '', 'array');
		$id 		= (int)$this->input->get( 'cid');
		$path = COM_GMAPFP_IMAGES_FOLDER.'/GA'.$id.'/';

		$type_image = $params->get( 'image_extensions', 'bmp,gif,jpg,png,jpeg' );
		$type_image = explode(',', $type_image);;
		
		if (empty($file)){
 			$this->exit_upload(false, JText::_( 'GMAPFP_SELECT_PICTURE'));
		}

		// Vrifies si image
        $ext = strrchr($file['name'],'.');
        $ext = strtolower($ext);
        $ext = substr($ext, 1);
        if (!in_array( $ext, $type_image )) 
        {
 			$this->exit_upload(false, JText::_( 'GMAPFP_NOT_PICTURE'));
        }

		if (!JFactory::getUser()->authorise('core.create', 'com_gmapfp') and !JFactory::getUser()->authorise('core.edit', 'com_gmapfp') and !JFactory::getUser()->authorise('core.edit.own', 'com_gmapfp'))
		{
 			$this->exit_upload(false, JText::_('JLIB_APPLICATION_ERROR_CREATE_NOT_PERMITTED'));
		}

		// Total length of post back data in bytes.
		$contentLength = (int) $_SERVER['CONTENT_LENGTH'];

		// Instantiate the media helper
		$mediaHelper = new JHelperMedia;

		// Maximum allowed size of post back data in MB.
		$postMaxSize = $mediaHelper->toBytes(ini_get('post_max_size'));

		// Maximum allowed size of script execution in MB.
		$memoryLimit = $mediaHelper->toBytes(ini_get('memory_limit'));

		// Check for the total size of post back data.
		if (($postMaxSize > 0 && $contentLength > $postMaxSize)
			|| ($memoryLimit != -1 && $contentLength > $memoryLimit))
		{
 			$this->exit_upload(false, JText::_( 'COM_MEDIA_ERROR_WARNUPLOADTOOLARGE'));
		}

		$uploadMaxSize = $params->get('upload_maxsize', 0) * 1024 * 1024;
		$uploadMaxFileSize = $mediaHelper->toBytes(ini_get('upload_max_filesize'));

		$file['name'] = JFile::makeSafe($file['name']);
        $file['name'] = str_replace(" ","_",$file['name']);

		if (($file['error'] == 1)
			|| ($uploadMaxSize > 0 && $file['size'] > $uploadMaxSize)
			|| ($uploadMaxFileSize > 0 && $file['size'] > $uploadMaxFileSize))
		{
			// File size exceed either 'upload_max_filesize' or 'upload_maxsize'.
 			$this->exit_upload(false, JText::_( 'COM_MEDIA_ERROR_WARNFILETOOLARGE'));
		}
		if (!isset($file['name']))
		{
			// No filename (after the name was cleaned by JFile::makeSafe)
 			$this->exit_upload(false, JText::_( 'COM_MEDIA_INVALID_REQUEST'));
		}
		
		// Set FTP credentials, if given
		JClientHelper::setCredentialsFromRequest('ftp');
		JPluginHelper::importPlugin('content');

		if (!$mediaHelper->canUpload($file, 'com_media'))
		{
			// The file can't be uploaded
			$msg = $app->getMessageQueue();
			$this->exit_upload(false, $msg[0]);
		}

		if (isset($file['name'])) {
			$filepath = JPath::clean($path.strtolower($file['name']));

			if (JFile::exists($filepath)) {
				// REDIRECT
				$this->exit_upload(false, JText::_( 'GMAPFP_ALREADY_EXIST'));
			}

			require_once( JPATH_COMPONENT_ADMINISTRATOR.'/libraries/imagemagic.php' );
			$GMapFPImageMagic_class = new GMapFPImageMagic;

			if ($config->get('gmapfp_ajust_main_gal', 0)) {
					$miniature_ok = $GMapFPImageMagic_class->imageMagic($file['tmp_name'], $filepath, $config->get('gmapfp_largeur_main_gal', 800), $config->get('gmapfp_hauteur_main_gal', 600), 0, null, $errorMsg);
			} else {
				if (!JFile::upload($file['tmp_name'], $filepath))
				{
					// Error in upload
					JLog::add('Controller GMapFP => file_upload_galerie(), Error on upload:  => '.$filepath, JLog::ERROR, 'com_gmapfp');
					$this->exit_upload(false, JText::_( 'GMAPFP_UPLOAD_NOK'));
				}
			}
				
			//cre la miniature
			$filein = $filepath;
			$fileout = $path.'thumbs/'.strtolower($file['name']);				
			$miniature_ok = $GMapFPImageMagic_class->imageMagic($filein, $fileout, $config->get('gmapfp_largeur_img_gal', 80), $config->get('gmapfp_hauteur_img_gal', 80), $config->get('gmapfp_crop', 1), null, $errorMsg);
			//**
			$this->exit_upload(true, array('id' => $id, 'file' => $file['name']));
		}
		$this->exit_upload(false, 'Invalid Request');
    }

	function exit_upload($status,$datas='') {
		$response = array('response'=>$status,'datas'=>$datas);            
		echo json_encode($response);
		JFactory::getApplication()->close();
	}
	
	protected function authoriseUser($action)
	{
		if (!JFactory::getUser()->authorise('core.' . strtolower($action), 'com_media'))
		{
			// User is not authorised
			return false;
		}

		return true;
	}
}
?>
