<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.115pro
	* Creation date: Octobre 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPControllerEditLieux extends GMapFPController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask('add', 'edit');
		$this->registerTask('save_copie', 'save');
		$this->registerTask('apply', 'save');
	}

	function edit()
	{
		$this->input->set( 'view', 'editlieux' );
		$this->input->set( 'layout', 'edit_form'  );

		parent::display();
	}

	function soumission()
	{
		$this->input->set( 'view', 'editlieux' );
		$this->input->set( 'layout', 'soumission'  );

		parent::display();
	}

	function infos()
	{
		$this->input->set( 'view', 'editlieux' );
		$this->input->set( 'layout', 'infos_form'  );

		parent::display();
	}

	function save()
	{
		// Check for request forgeries
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		$app    = JFactory::getApplication();

		$post = $this->input->post;
		$task = $this->getTask();
		
		if ($post->get('id')!=0)
			if (!JFactory::getUser()->authorise('core.edit', 'com_gmapfp') and !JFactory::getUser()->authorise('core.edit.own', 'com_gmapfp'))
				return $app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
		else
			if (!JFactory::getUser()->authorise('core.create', 'com_gmapfp'))
				return $app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
				
		$model = $this->getModel('editlieux');

		$returnid=$model->store();
		if ($returnid>0) {
			$model->checkin($returnid);
			$msg = JText::_( 'GMAPFP_SAVED' );
		} else {
			$msg = JText::_( 'GMAPFP_SAVED_ERROR' );
		}

		if ($task == 'apply'){
			//apply
			$link = JRoute::_('index.php?option=com_gmapfp&view=editlieux&layout=edit_form&controller=editlieux&task=edit&cid='.$returnid,false);
		} else {
			//save
			$link = JRoute::_('index.php?option=com_gmapfp&view=gestionlieux&controller=gestionlieux&task=view',false);
		}
		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg);
	}

	function submit()
	{
		// Check for request forgeries
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));

		$session 	= JFactory::getSession();
		$app	 	= JFactory::getApplication(); 
		$params 	= $app->getParams('com_gmapfp');
		$itemid    	= (int) $this->input->get('Itemid'); 

 		if (!JFactory::getUser()->authorise('core.create', 'com_gmapfp'))
			return $app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$post = $this->input->post;

		//gestion du captcha 
		$user   = JFactory::getUser();
		if ($params->get('gmapfp_submit_captcha')&&!$user->get('gid')) { 
			if($post->get("recaptcha_challenge_field") OR $post->get('keystring')){
				$redirect = "index.php?option=com_gmapfp&view=editlieux&layout=soumission";
				switch ($params->get('captcha_type')) {
				case 1 :
					require_once(JPATH_COMPONENT.'/libraries/recaptcha/recaptchalib.php');
					$resp = recaptcha_check_answer ($params->get('gmapfp_recaptcha_key_private'),
												$this->input->server->get("REMOTE_ADDR"),
												$post->get("recaptcha_challenge_field"),
												$post->get("recaptcha_response_field"));
					
					if (!$resp->is_valid) {
					// What happens when the CAPTCHA was entered incorrectly
					$msg = "The reCAPTCHA wasn't entered correctly. Go back and try it again." .
						 "(reCAPTCHA said: " . $resp->error . ")";
							$app->enqueueMessage($msg, 'error');
							$link = JRoute::_($redirect, false);
							$this->setRedirect($link, "");
							return false;
							//$captacha=false;
					}
					break;
				default :
					if ($session->get('gmapfp-captcha-code') != $post->get('keystring')){
						$app->enqueueMessage(JText::_('GMAPFP_CAPTCHA'), 'error');
						$link = JRoute::_($redirect, false);
						$this->setRedirect($link, "");
						return false;
						//$captacha=false;
					}
				}
			}
			$session->set('gmapfp-captcha-code', null);
		};
		
		$model    = $this->getModel('editlieux');
		$returnid = $model->store();
		if ($returnid>0) {
			$msg = JText::_( 'GMAPFP_SUBMIT' );
		} else {
			$msg = JText::_( 'GMAPFP_SUBMIT_ERROR' );
		}
		
		//redirection vers article selectionn	
		$return = '';
		if ($params->get('redirection')){
			$return = $params->get('redirection');
		}
		if (!JURI::isInternal($return)) {
			$return = '';
		}

		if ($return) {
			include_once (JPATH_BASE.'/components/com_content/helpers/route.php');
			$link = JRoute::_(ContentHelperRoute::getArticleRoute($return, 0, 0),false);
		}else{
			$link = base64_decode($post->get('return'));
		}
		$this->setRedirect($link, $msg);
	}

	function galerie()
	{
		$this->input->set( 'view', 'editlieux' );
		$this->input->set( 'layout', 'media_list'  );

		parent::display();
	}

	function cancel()
	{
		$model 		= $this->getModel('editlieux');
		$recordId 	= $this->input->get( 'id', '', 'int' );

		if ($model->checkin($recordId) === false)
		{
			// Check-in failed, go back to the record and display a notice.
			$this->setError(JText::sprintf('JLIB_APPLICATION_ERROR_CHECKIN_FAILED', $model->getError()));
			$this->setMessage($this->getError(), 'error');

			$this->setRedirect(JRoute::_('index.php?option=com_gmapfp&controller=gestionlieux&task=view', false));

			return false;
		}

		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( JRoute::_('index.php?option=com_gmapfp&view=gestionlieux&controller=gestionlieux&task=view',false), $msg );
	}

	function edit_upload()
	{
		$this->input->set( 'view', 'editlieux' );
		$this->input->set( 'layout', 'upload_form'  );

		parent::display();
	}

	function file_delete()
	{
		// Check for request forgeries
		// JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		$app    = JFactory::getApplication();

		if (!JFactory::getUser()->authorise('core.edit', 'com_gmapfp') and !JFactory::getUser()->authorise('core.edit.own', 'com_gmapfp'))
			return $app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		// Get some data from the request
		$id 	= (int) $this->input->get('cid');
		$files	= $this->input->get( 'rm', array(), '', 'array' );
		// Initialize variables
		$ret = 'succes';

		if (count($files)) {
			jimport( 'joomla.filesystem.file' );
			foreach ($files as $file)
			{
				//efface image
				$fullPath = JPath::clean(COM_GMAPFP_IMAGES_FOLDER.'/GA'.$id.'/'.$file);
				if (is_file($fullPath)) {
					$ret |= !JFile::delete($fullPath);
				}
				//efface miniature
				$fullPath = JPath::clean(COM_GMAPFP_IMAGES_FOLDER.'/GA'.$id.'/thumbs/'.$file);
				if (is_file($fullPath)) {
					$ret |= !JFile::delete($fullPath);
				}
			}
		}
		$link="index.php?option=com_gmapfp&controller=editlieux&task=galerie&tmpl=component&cid=".$id;
		$this->setRedirect($link, $ret, 'message');
	}

	function file_add_infos()
	{
		// Check for request forgeries
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		$app    = JFactory::getApplication();
		
		if (!JFactory::getUser()->authorise('core.edit', 'com_gmapfp') and !JFactory::getUser()->authorise('core.edit.own', 'com_gmapfp'))
			return $app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$config 		= JComponentHelper::getParams('com_gmapfp');

		// Get some data from the request
 		$post	= $this->input->post;

		$ret = JText::_('GMAPFP_SAVED');

		if ($post->get('id') and $post->get('file')) {
			jimport( 'joomla.filesystem.file' );
			jimport( 'joomla.filesystem.folder' );
			
			$folder = JPATH_ROOT.'/images/gmapfp/GA'.$post->get('id').'/infos';

			if (!is_dir($folder)){
				JFolder::create($folder);
				$buffer = "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>";
				@JFile::write($folder.'/index.html', $buffer);
			}

			$xml_file = substr($post->get('file'), 0, -(strlen(JFile::getExt($post->get('file')))+1));
			$xml_file .= '.xml';
			$buffer = "<infos>\n<titre>".$post->get('titre', '', 'string')."</titre>\n<description>".$post->get('description', '', 'string')."</description>\n</infos>";
			@JFile::write($folder.'/'.$xml_file, $buffer);
		} else {
			$ret ='def file_add_infos';
		}
		$link="index.php?option=com_gmapfp&controller=editlieux&task=galerie&tmpl=component&cid=".$post->get('id');
		$this->setRedirect($link, $ret, 'message');
	}
}
?>
