<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.109pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPControllerGmapfpAjax extends GMapFPController
{
	function __construct()
	{
		parent::__construct();
	}

	function rebuilt()
	{
		$app = JFactory::getApplication(); 
        $params = clone($app->getParams('com_gmapfp'));
		setlocale(LC_NUMERIC, 'C'); //dfini le sparateur dcimal comme tant un point. Pour fct float.

		if ($params->get('gmapfp_log', 0)) {
			jimport('joomla.log.log');
			JLog::addLogger(
				array('text_file' => 'com_gmapfp.log.php'),
				JLog::ALL,
				array('com_gmapfp')
			);		
		}
		
		//Test si les paramtres filtres seront passs par l'adresse ou par raffraichissement de la page
		$ajax_mode    = $this->input->get('ajax_mode_', 0, 'INT'); 
		if ($params->get('gmapfp_log', 0)) JLog::add('category => GMapFP:rebuilt()-> ajax_mode, message => '.$ajax_mode.'_time:='.time(), JLog::INFO, 'com_gmapfp');

		//rcupre les valeurs des paramtre de filtre en ajax
		$values = $this->input->get('values_', '', 'string'); 
		$values	= trim($values);
		if ($params->get('gmapfp_log', 0)) JLog::add('category => GMapFP:rebuilt()-> values, message => '.$values, JLog::INFO, 'com_gmapfp');

		$model = $this->getModel('gmapfp');
		$model->set_ajax($ajax_mode);
		$places = $model->make_places($values);
		//places[0] = lieux; places[1] = map_num; places[2] = filtres; places[3] = kml_categories
		$datas = '[';
		$direction = array();

		$cn = 0;
		$points = '[';
		if ($places[0])
		foreach ($places[0] as $place) {
			if ($cn) $points .= ', ';
			$cn++;
			$lat = (float)$place[1];
			$lng = (float)$place[2];
			if ($lat>89 || $lat<-89) {$lat = 0; $lng = 0;}
			if ($lng>360 || $lng<-360) {$lat = 0; $lng = 0;}
			$points .= '[';
			//preg_replace('/[\x00-\x1F\x80-\xFF]/', '', $toto) => supprime les caratres non ascii de la chaine de caractre
			$points .= (int)$place[0].', '.$lat.', '.$lng.', '.$place[3].', "'.$place[4].'", "'.$place[5].'", '.$place[6].', "'.$place[7].'", "'.$place[8].'", ';
			$points .= '["'.$place[9][0].'", '.$place[9][1].', '.$place[9][2].', '.$place[9][3].', '.$place[9][4].', "'.$place[9][5].'", '.$place[9][6].', '.$place[9][7].', '.$place[9][8].', '.$place[9][9].', '.$place[9][10].']';
			$points .= ', "'.$place[10].'"';
			$points .= ']';
			
			if ($lat && $lng)
				$direction[strtolower($place[7])] = '["'.$lat.','.$lng.','.(int)$place[0].'","'.$place[7].'"]';
		}
		$points .= ']';
		
		//lments pour les filtres
		$array_filtres = array();
		$filtres = array();
		if (@$places[2][0])
		foreach ($places[2][0] as $key => $filtre) {
			$filtres[] = "'filtre".$key."'";
			$array_filtres[] = $filtre;
		}
		
		//lments pour les kml_categories
		$kml_categories = array();
		if (count($places[3]))
		foreach ($places[3] as $key => $filtre) {
			$kml_categories[] = "['".(int)$key."','".$filtre."']";
		}
		
		//trier les lment pour la direction
		ksort($direction);
		array_unshift($direction, '["","'.str_replace('&nbsp;', ' ', JText::_( 'GMAPFP_CHOIX_DE' )).'"]', '["","'.str_replace('&nbsp;', ' ', JText::_( 'GMAPFP_CHOIX_VERS' )).'"]');
		
		$result = '['.$points.',['.implode(', ', $filtres).'],['.implode(', ', $array_filtres).'],['.implode(', ', $direction).'], ['.implode(', ', $kml_categories).']]';
		
		if ($params->get('gmapfp_log', 0)) JLog::add('category => GMapFP:rebuilt()-> result, message => '.$cn++.'->'.$result, JLog::INFO, 'com_gmapfp');

		header('Content-Type: text/html;charset=utf-8'); 
		echo $result;
		
		// Close the application
		JFactory::getApplication()->close();
	}

}
?>
