<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.117pro
	* Creation date: Juin 2018
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;
use Joomla\CMS\Captcha\Captcha;

class GMapFPControllerGmapfpContact extends GMapFPController
{
	function __construct()
	{
		parent::__construct();

	}

	function submit()
	{
		$session 	= JFactory::getSession();
		$app 		= JFactory::getApplication(); 
		$Itemid		= $this->input->get('Itemid', '', 'int'); 
		
		$sent = false;
        $params = clone($app->getParams('com_gmapfp'));

		JSession::checkToken() or jexit( 'Invalid Token' );

		$db			= JFactory::getDBO();
		$SiteName	= $app->getCfg('sitename');

		$default	= JText::_('GMAPFP_EMAIL_RECU_DE').' '.$SiteName;
		$contactId	= $this->input->post->get('id', '', 'int'); 
		$name		= $this->input->post->get('nom', '', 'string'); 
		$email		= $this->input->post->get('email', '', 'string'); 
		$subject	= $this->input->post->get('subject', $default, 'string'); 
		$emailCopy	= $this->input->post->get('email_copy', 0, 'string'); 
		$redirect	= $this->input->post->get('redirect', '', 'string'); 

		// SPAM
		if ($this->input->post->get('name', '', 'string') != '') { 
			$msg = "SPAM";
				$app->enqueueMessage($msg, 'error');
			$link = JRoute::_($redirect, false);
			$this->setRedirect($link, "");
			return false;
		}

		 // load the contact details
		$model		= $this->getModel('gmapfp');
		$model->set_id($contactId);
		$contact_array	= $model->getGMapFPList();
		$contact	= $contact_array[0];
		$body		= '';
		$page_link	= substr(JUri::base(),0,-1).JRoute::_(GMapFPHelperRoute::getArticleRoute($contact->slug), false);

		//traite les champs perso s'il exist
		if (JFile::exists(JPATH_COMPONENT."/helpers/mail/email_fields.xml")) {
			$language = JFactory::getLanguage();
			$language->load('com_gmapfp_mail', JPATH_COMPONENT."/helpers/mail/");
			$xml_str = file_get_contents(JPATH_COMPONENT."/helpers/mail/email_fields.xml");
			$xml_data = simplexml_load_string($xml_str);
			foreach ($xml_data->div1->children() as $child) {
				$body .= JText::_( $child->attributes()->send )."\n";
				$variable = (string)$child->children()->attributes()->name;
				$title = (string)$child->children()->attributes()->title;
				$body .= JText::_($title) . ' ' . $this->input->post->get( $variable, '', 'string' )."\n";
			}
			foreach ($xml_data->div2->children() as $child) {
				$body .= JText::_( $child->attributes()->send )."\n";
				$variable = (string)$child->children()->attributes()->name;
				$title = (string)$child->children()->attributes()->title;
				$body .= JText::_($title) . ' ' . $this->input->post->get( $variable, '', 'string' )."\n";
			}
		} else {
			$body		.= $this->input->post->get( 'message', '', 'string' );
		}

		$email   	= JStringPunycode::emailToPunycode($email);
		// Input validation
		if  (!$this->_validateInputs( $contact, $email, $subject, $body ) ) {
			$app->enqueueMessage($this->getError(), 'error');
			return false;
		}

		//gestion du captcha 
		$user   = JFactory::getUser();
		if (!$user->get('id')) { 
			switch ($params->get('captcha')) {
			case "1" :
				if ($session->get('gmapfp-captcha-code') != $this->input->post->get('keystring')){
					$app->enqueueMessage(JText::_('GMAPFP_CAPTCHA'), 'error');
					$link = JRoute::_($redirect, false);
					$this->setRedirect($link, "");
					return false;
					//$captacha=false;
				}
				break;
			default :
				$captchaSet = $params->get('captcha', JFactory::getApplication()->get('captcha', '0'));
				foreach (JPluginHelper::getPlugin('captcha') as $plugin)
				{
					if ($captchaSet === $plugin->name)
					{
						$captcha = Captcha::getInstance($plugin->name, array('namespace' => 'captcha'));
						$res = $captcha->CheckAnswer($this->input->post->get("gmapfp_captcha"));
						if(!$res){
							$msg = "CAPTCHA wasn't correctly.";
							$app->enqueueMessage($msg, 'error');
							$link = JRoute::_($redirect, false);
							$this->setRedirect($link, "");
							return false;
							//$captacha=false;
						}						
						
						break;
					}
				}
				break;
			}
			$session->set('gmapfp-captcha-code', '');
		};

		// $MailFrom = $app->get('mailfrom');
		// $FromName = $app->get('fromname');


		// Prepare email body
		$bodymail 	= JText::_('GMAPFP_EMAIL_RECU_DE').' '.$name."\n";
		$bodymail 	.= JText::_('GMAPFP_EMAIL_RECU_PAR').' '.$page_link."\n";
		$bodymail 	.= "\r\n\r\n".stripslashes($body);

		$mail = JFactory::getMailer();
		$mail->addRecipient( $contact->email );
		$mail->addReplyTo($email, $name);
		// $mail->setSender(array($mailfrom, $fromname));
		$mail->setSender(array($email, $name));
		// $mail->setSubject( $FromName.': '.$subject );
		$mail->setSubject( $subject );
		$mail->setBody( $bodymail );
		$sent = $mail->Send();


		// check whether email copy function activated
		if ( $emailCopy and $sent)
		{
			$copyText 		= JText::_('GMAPFP_COPIE_DE').' '.$SiteName.' '.$contact->nom;
			$copyText 		.= "\r\n\r\n".$body;
			$copySubject 	= JText::_('GMAPFP_COPIE_DE')." ".$subject;

			$mail = JFactory::getMailer();

			$mail->addRecipient( $email );
			$mail->addReplyTo($email, $name);
			// $mail->setSender( array( $MailFrom, $FromName ) );
			$mail->setSender( array( $email, $name ) );
			$mail->setSubject( $copySubject );
			$mail->setBody( $copyText );
			$sent = $mail->Send();
		}
		if ($sent) {
			$msg = JText::_( 'GMAPFP_EMAIL_MERCI');
		} else {
			$msg = JText::_( 'GMAPFP_SUBMIT_ERROR' );
		}

		$link = JRoute::_($redirect, false);
		$this->setRedirect($redirect, $msg);
	}

	function _validateInputs( $contact, $email, $subject, $body )
	{
		$session 	= JFactory::getSession();

		$sessionCheck 	= 1 ;
		$sessionName	= $session->getName();
		if  ( $sessionCheck ) {
			if ( $this->input->cookie->get($sessionName) == '' ) {
				$this->setError( JText::_('JERROR_ALERTNOAUTHOR') );
				return false;
			}
		}

		// test to ensure that only one email address is entered
		$check = explode( '@', $email );
		if ( strpos( $email, ';' ) || strpos( $email, ',' ) || strpos( $email, ' ' ) || count( $check ) > 2 ) {
			$this->setError( JText::_( 'GMAPFP_EMAIL_VALID', true ) );
			return false;
		}

		return true;
	}

}
?>
