<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.133pro
	* Creation date: Aot 2023
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class Define_ModelGMapFP
{
	static function define_gmapfp($ajax, $option = array('CSS', 'LIGHTBOX', 'APIV3')) 
	{
		$app	= JFactory::getApplication();
		$Itemid	   	= $app->input->get('Itemid');
        if ($app->isSite()) { //sinon bloc l'inderxation du finder
			$params		= clone($app->getParams('com_gmapfp'));
			$doc		= JFactory::getDocument();
			$head_data 	= $doc->getHeadData();
			$lang		= JFactory::getLanguage(); 
			$tag_lang=$lang->getTag();
			if (($tag_lang!='en-AU') AND ($tag_lang!='en-GB') AND ($tag_lang!='pt-BR') AND ($tag_lang!='pt-PT') AND ($tag_lang!='zh-CN') AND ($tag_lang!='zh-TW'))
				{$tag_lang=(substr($lang->getTag(),0,2)); };
			
			// Dfinition de JUri::base() sans tenir compte du paramtre $config->get('live_site') de la config principale
			$uri = JUri::getInstance();
			$base['prefix'] = $uri->toString(array('scheme', 'host', 'port'));
			if (strpos(php_sapi_name(), 'cgi') !== false && !ini_get('cgi.fix_pathinfo') && !empty($_SERVER['REQUEST_URI']))
				$script_name = $_SERVER['PHP_SELF'];
			else $script_name = $_SERVER['SCRIPT_NAME'];
			$base['path'] = rtrim(dirname($script_name), '/\\');
			$Base_URL = $base['prefix'] . $base['path'] . '/';
			
			if (!defined( '_JOS_GMAPFP_BASE_URL' ))
				define('_JOS_GMAPFP_BASE_URL', $Base_URL);
			
			//test smartphone
			if (!defined( '_JOS_GMAPFP_SMARTPHONE' )) {
				$smartphone = false;
				$ua = $_SERVER['HTTP_USER_AGENT'];
				if (preg_match('/iphone/i',$ua) || preg_match('/android/i',$ua) || preg_match('/blackberry/i',$ua) || preg_match('/symb/i',$ua) || preg_match('/ipad/i',$ua) || preg_match('/ipod/i',$ua) || preg_match('/phone/i',$ua) )
				{
					$smartphone = true;
				}
				define('_JOS_GMAPFP_SMARTPHONE', $smartphone);
			}

			//Ajout JQuery si non exist
			JHtml::_('jquery.framework');	
			
		   //Insertion des enttes GMapFP si non dj fait.
			if (!defined( '_JOS_GMAPFP_CSS' ) and in_array('CSS', $option))
			{
				/** verifi que la fonction n'est dfini qu'une faois */
				define( '_JOS_GMAPFP_CSS', 1 );
		
				$doc->addStyleSheet( $Base_URL.'media/com_gmapfp/css/main_gmapfp.css'); 
				$doc->addStyleSheet( $Base_URL.'media/com_gmapfp/css/gmapfp.css'); 
			}
			
			if (!defined( '_JOS_GMAPFP_LIGHTBOX' ) and in_array('LIGHTBOX', $option))
			{
				/** verifi que la fonction n'est dfini qu'une faois */
				define( '_JOS_GMAPFP_LIGHTBOX', 1 );   
				$script = '			
				<script type="text/javascript">
				';
				
				//Fentre modale Joomla
				if ($params->get('gmapfp_fancybox', 0)) {
					JHTML::_('behavior.modal', 'a.gmapfp_modal_frame');
					$doc->addStyleSheet( $Base_URL.'components/com_gmapfp/floatbox/floatbox.css');
					$doc->addScript( $Base_URL.'components/com_gmapfp/floatbox/floatbox.js');
				} else {
					$doc->addStyleSheet( $Base_URL.'media/com_gmapfp/css/jquery.fancybox.min.css');
					$doc->addScript( $Base_URL.'media/com_gmapfp/js/jquery.fancybox.min.js');
				}
				$script .= '
					jQuery(document).ready( function(){';
				if ($params->get('gmapfp_fancybox', 0)) {
					//lightbox native joomla
					$script .= '
						larg_fenetre = (document.documentElement.clientWidth);
						haut_fenetre = (document.documentElement.clientHeight);';
					
					//fenetre principale
					$largeur = $params->get('gmapfp_largeur_lightbox', '1200px');
					if (substr($largeur, -2) == 'px') {
						$script .= '
							gmapfp_largeur_lightbox = '.substr($largeur, 0, -2).';';
					}
					elseif (substr($largeur, -1) == '%') {
						$script .= '
							tmp = larg_fenetre / 100 * '.substr($largeur, 0, -1).';
							gmapfp_largeur_lightbox = tmp.round();';
					}
					else {
						$script .= '
							gmapfp_largeur_lightbox = '.(int)$largeur.';';
					}
					$hauteur = $params->get('gmapfp_hauteur_lightbox', '800px');
					if (substr($hauteur, -2) == 'px') {
						$script .= '
							gmapfp_hauteur_lightbox = '.substr($hauteur, 0, -2).';';
					}
					elseif (substr($hauteur, -1) == '%') {
						$script .= '
							tmp = haut_fenetre / 100 * '.substr($hauteur, 0, -1).';
							gmapfp_hauteur_lightbox = tmp.round();';
					}
					else {
						$script .= '
							gmapfp_hauteur_lightbox = '.(int)$hauteur.';';
					}

					//fenetre galerie photo
					$largeur = $params->get('gmapfp_lb_width_gallery', '1200px');
					if (substr($largeur, -1) == '%') {
						$script .= '
							tmp = larg_fenetre / 100 * '.substr($largeur, 0, -1).';
							gmapfp_lb_width_gallery = tmp.round();';
					} else 
						$script .= '
							gmapfp_lb_width_gallery = '.substr($largeur, 0, -2).';';
					$hauteur = $params->get('gmapfp_lb_height_gallery', '800px');
					if (substr($hauteur, -1) == '%') {
						$script .= '
							tmp = haut_fenetre / 100 * '.substr($hauteur, 0, -1).';
							gmapfp_lb_height_gallery = tmp.round();';
					} else 
						$script .= '
							gmapfp_lb_height_gallery = '.substr($hauteur, 0, -2).';';

					//fenetre itemrating
					$largeur = $params->get('gmapfp_lb_width_itemrating', '600px');
					if (substr($largeur, -1) == '%') {
						$script .= '
							tmp = larg_fenetre / 100 * '.substr($largeur, 0, -1).';
							gmapfp_lb_width_itemrating = tmp.round();';
					} else 
						$script .= '
							gmapfp_lb_width_itemrating = '.substr($largeur, 0, -2).';';
					$hauteur = $params->get('gmapfp_lb_height_itemrating', '250px');
					if (substr($hauteur, -1) == '%') {
						$script .= '
							tmp = haut_fenetre / 100 * '.substr($hauteur, 0, -1).';
							gmapfp_lb_height_itemrating = tmp.round();';
					} else 
						$script .= '
							gmapfp_lb_height_itemrating = '.substr($largeur, 0, -2).';';

					//icon horaire et prix
					$largeur = $params->get('gmapfp_lb_width_h_p', '1200px');
					if (substr($largeur, -1) == '%') {
						$script .= '
							tmp = larg_fenetre / 100 * '.substr($largeur, 0, -1).';
							gmapfp_lb_width_h_p = tmp.round();';
					} else 
						$script .= '
							gmapfp_lb_width_h_p = '.substr($largeur, 0, -2).';';
					$hauteur = $params->get('gmapfp_lb_height_h_p', '800px');
					if (substr($hauteur, -1) == '%') {
						$script .= '
							tmp = haut_fenetre / 100 * '.substr($hauteur, 0, -1).';
							gmapfp_lb_height_h_p = tmp.round();';
					} else 
						$script .= '
							gmapfp_lb_height_h_p = '.substr($hauteur, 0, -2).';';

					//icon carte
					$largeur = $params->get('gmapfp_lb_width_map', '1200px');
					if (substr($largeur, -1) == '%') {
						$script .= '
							tmp = larg_fenetre / 100 * '.substr($largeur, 0, -1).';
							gmapfp_lb_width_map = tmp.round();';
					} else 
						$script .= '
							gmapfp_lb_width_map = '.substr($largeur, 0, -2).';';
					$hauteur = $params->get('gmapfp_lb_height_map', '800px');
					if (substr($hauteur, -1) == '%') {
						$script .= '
							tmp = haut_fenetre / 100 * '.substr($hauteur, 0, -1).';
							gmapfp_lb_height_map = tmp.round();';
					} else 
						$script .= '
							gmapfp_lb_height_map = '.substr($hauteur, 0, -2).';';
					
					//icon email
					$largeur = $params->get('gmapfp_lb_width_msg', '1200px');
					if (substr($largeur, -1) == '%') {
						$script .= '
							tmp = larg_fenetre / 100 * '.substr($largeur, 0, -1).';
							gmapfp_lb_width_msg = tmp.round();';
					} else 
						$script .= '
							gmapfp_lb_width_msg = '.substr($largeur, 0, -2).';';
					$hauteur = $params->get('gmapfp_lb_height_msg', '800px');
					if (substr($hauteur, -1) == '%') {
						$script .= '
							tmp = haut_fenetre / 100 * '.substr($hauteur, 0, -1).';
							gmapfp_lb_height_msg = tmp.round();';
					} else 
						$script .= '
							gmapfp_lb_height_msg = '.substr($hauteur, 0, -2).';';
					
					//icon lien exterieur
					$largeur = $params->get('gmapfp_lb_width_link', '1200px');
					if (substr($largeur, -1) == '%') {
						$script .= '
							tmp = larg_fenetre / 100 * '.substr($largeur, 0, -1).';
							gmapfp_lb_width_link = tmp.round();';
					} else 
						$script .= '
							gmapfp_lb_width_link = '.substr($largeur, 0, -2).';';
					$hauteur = $params->get('gmapfp_lb_height_link', '800px');
					if (substr($hauteur, -1) == '%') {
						$script .= '
							tmp = haut_fenetre / 100 * '.substr($hauteur, 0, -1).';
							gmapfp_lb_height_link = tmp.round();';
					} else 
						$script .= '
							gmapfp_lb_height_link = '.substr($hauteur, 0, -2).';';
				} else { //fancybox
					//contenu
					$script .= '
							jQuery("a.gmapfp_modal_frame.gmapfp_article_link").fancybox({
								toolbar  : false,
								smallBtn : true,
								iframe : {
									preload : false,
									css : {
										width : \''.$params->get('gmapfp_largeur_lightbox', '1200px').'\',
										height : \''.$params->get('gmapfp_hauteur_lightbox', '800px').'\'
									}
								}
							});
					';
					//galerie photo
					$script .= '
							jQuery("a.gmapfp_modal_frame.gmapfp_gallery").fancybox({
								toolbar  : false,
								smallBtn : true,
								iframe : {
									preload : false,
									css : {
										width : \''.$params->get('gmapfp_lb_width_gallery', '1200px').'\',
										height : \''.$params->get('gmapfp_lb_height_gallery', '800px').'\'
									}
								}
							});
					';
					//itemrating
					$script .= '
							jQuery("a.gmapfp_modal_frame.gmapfp_ir").fancybox({
								toolbar  : false,
								smallBtn : true,
								iframe : {
									preload : false,
									css : {
										width : \''.$params->get('gmapfp_lb_width_itemrating', '1200px').'\',
										height : \''.$params->get('gmapfp_lb_height_itemrating', '800px').'\'
									}
								}
							});
					';
					//JComment
					$script .= '
							jQuery("a.gmapfp_modal_frame.gmapfp_jc").fancybox({
								toolbar  : false,
								smallBtn : true,
								iframe : {
									preload : false,
									css : {
										width : \''.$params->get('gmapfp_lb_width_itemrating', '1200px').'\',
										height : \''.$params->get('gmapfp_lb_height_itemrating', '800px').'\'
									}
								}
							});
					';
					//horaire et prix
					$script .= '
							jQuery("a.gmapfp_modal_frame.gmapfp_hp").fancybox({
								toolbar  : false,
								smallBtn : true,
								iframe : {
									preload : false,
									css : {
										width : \''.$params->get('gmapfp_lb_width_h_p', '1200px').'\',
										height : \''.$params->get('gmapfp_lb_height_h_p', '800px').'\'
									}
								}
							});
					';
					//carte
					$script .= '
							jQuery("a.gmapfp_modal_frame.gmapfp_carte").fancybox({
								toolbar  : false,
								smallBtn : true,
								iframe : {
									preload : false,
									css : {
										width : \''.$params->get('gmapfp_lb_width_map', '1200px').'\',
										height : \''.$params->get('gmapfp_lb_height_map', '800px').'\'
									}
								}
							});
					';
					//email
					$script .= '
							jQuery("a.gmapfp_modal_frame.gmapfp_email").fancybox({
								toolbar  : false,
								smallBtn : true,
								iframe : {
									preload : false,
									css : {
										width : \''.$params->get('gmapfp_lb_width_msg', '1200px').'\',
										height : \''.$params->get('gmapfp_lb_height_msg', '800px').'\'
									}
								}
							});
					';
					//lien exterieur
					$script .= '
							jQuery("a.gmapfp_modal_frame.gmapfp_el").fancybox({
								toolbar  : false,
								smallBtn : true,
								iframe : {
									preload : false,
									css : {
										width : \''.$params->get('gmapfp_lb_width_link', '1200px').'\',
										height : \''.$params->get('gmapfp_lb_height_link', '800px').'\'
									}
								}
							});
					';
					//divers old
					$script .= '
							jQuery(".lightboxgmafp").fancybox({
								toolbar  : false,
								smallBtn : true
							});
					';
				}
				
				$script .= '
					})
				</script>';
				$doc->addCustomTag($script);

			}
			
			if (!defined( '_JOS_GMAPFP_APIV3' ) and in_array('APIV3', $option))
			{
				/** verifi que la fonction n'est dfini qu'une faois */
				define( '_JOS_GMAPFP_APIV3', 1 );
				//&region=GB //pour ameliorer la zone de recherche d'une adresse
				$librarie = array();
				$librarie[] = 'places'; //obligatoire pour la localisation sur la carte lors de la soumission ou ajout en frontend
				//if ($params->get('gmapfp_plus_info', 1) or $params->get('gmapfp_enable_pano_photos', 1)) 		$librarie[] = 'panoramio';
				$libraries= "";
				if (count($librarie) > 0) {
					$libraries = '&amp;libraries=';
					$libraries .= implode(',', $librarie);
				}
				$key = $params->get('gmapfp_google_key');
				$doc->setMetaData( "viewport", "initial-scale=1.0, user-scalable=no");
				$doc->addScript( '//maps.googleapis.com/maps/api/js?language='.$tag_lang.$libraries.'&amp;v=3.53&amp;key='.$key);
				$doc->addScriptDeclaration( "var base_url_gmapfp = '".$Base_URL."';"."\n");
				$doc->addScript( $Base_URL.'media/com_gmapfp/js/map.js');

				//clustering
				if ($params->get('gmapfp_clustering', 1)) {
					$doc->addScript( $Base_URL.'media/com_gmapfp/js/markerclusterer.js', $type = "text/javascript", $defer = true);
					$doc->addScript( $Base_URL.'media/com_gmapfp/js/style_clusters.js', $type = "text/javascript", $defer = true);
				}

				//ajax
				if ($ajax) {
					$recentre = '0';
					if ($params->get('gmapfp_ajax_recentre', 0)) $recentre = '1';
					$doc->addCustomTag( '<script type="text/javascript">
					
					var GMapFP_Request_Variable = new Array();

					function GMapFP_Send_Request(map_num) {
						eval(\'gmapfp_recentre\'+map_num+\' = '.$recentre.';\');
						eval(\'marker\'+map_num+\' = new Array();\');
						eval(\'infowindow\'+map_num+\' = new Array();\');
						eval(\'marker_precedent\'+map_num+\' = 0;\');
						eval(\'initialise_gmapfp\'+map_num+\'();\');
					}
				</script>');
				}
				if ($params->get('gmapfp_geolocalisation', 1)) 	{
					$geo_bp = '';
					$doc->addScript( $Base_URL.'media/com_gmapfp/js/geometa.js');
					if ($params->get('gmapfp_geolocalisation_bp', 1))
						$geo_bp = '
							function GMapFP_Geolocal(num) {
								if (canPrepareGeolocation) {
									document.getElementById("info_geolocalisation" + num).style.display = "block";
									canPrepareGeolocation = false;
									prepareGeolocation();
									doGeolocation();
								}
							}
						';
					$doc->addCustomTag( '<script type="text/javascript"> 
						var GMapFP_num = new Array(); 
						var GMapFP_active_map = new Array(); 
						var GMapFP_active_bounds = new Array(); 
						var canPrepareGeolocation = true;
						'.$geo_bp.'
					</script>');
					$doc->addCustomTag( '<script type="text/javascript">
						  function positionError(err) {
							var msg;
							switch(err.code) {
							  case err.UNKNOWN_ERROR:
								msg = "'.JText::_('GMAPFP_GEOLOCAL_ENABLE_FIND').'";
								break;
							  case err.PERMISSION_DENINED:
								msg = "'.JText::_('GMAPFP_GEOLOCAL_PERMISSION_DENIED').'";
								break;
							  case err.POSITION_UNAVAILABLE:
								msg = "'.JText::_('GMAPFP_GEOLOCAL_UNKNOWN').'";
								break;
							  case err.BREAK:
								msg = "'.JText::_('GMAPFP_GEOLOCAL_ATTEMPT_FIND').'";
								break;
							  default:
								msg = "'.JText::_('GMAPFP_GEOLOCAL_NOT_SUPPORTED').'";
							}
							for (i = 0; i <= GMapFP_num.length - 1; i++) {
								document.getElementById(\'info_geolocalisation\' + GMapFP_num).innerHTML = msg;
							}
						  }

						  function positionSuccess(position) {
							// Centre the map on the new location
							var coords = position.coords || position.coordinate || position;
							var latLng = new google.maps.LatLng(coords.latitude, coords.longitude);
							var markerTitle = \''.JText::_('GMAPFP_GEOLOCAL_WHY_THERE').'\';
							
							for (i = 0; i <= GMapFP_num.length - 1; i++) {
								document.getElementById(\'info_geolocalisation\' + GMapFP_num[i]).innerHTML = \''.JText::_('GMAPFP_GEOLOCAL_LOOKING_FOR').' <strong>\' +
									coords.latitude + \', \' + coords.longitude + \'</strong>...\';
								if (!geoloca_ajout_otpion) {
									geoloca_ajout_otpion = true;
									//eval(\'jQuery("#select_from\' + GMapFP_num[i] + \' option[value]").remove();\');
									coordonnees = coords.latitude + "," + coords.longitude + ",0";
									eval(\'jQuery("#select_from\' + GMapFP_num[i] + \' option").first().remove();\');
									eval(\'jQuery("#select_from\' + GMapFP_num[i] + \'").prepend(new Option("'.JText::_('GMAPFP_GEOLOCAL_MY_POSITION').'", coordonnees));\');
									eval(\'jQuery("#select_from\' + GMapFP_num[i] + \'").prepend(new Option("'.str_replace('&nbsp;', ' ', JText::_('GMAPFP_CHOIX_DE')).'", ""));\');
									eval(\'jQuery("#select_to\' + GMapFP_num[i] + \' option").first().remove();\');
									eval(\'jQuery("#select_to\' + GMapFP_num[i] + \'").prepend(new Option("'.JText::_('GMAPFP_GEOLOCAL_MY_POSITION').'", coordonnees));\');
									eval(\'jQuery("#select_to\' + GMapFP_num[i] + \'").prepend(new Option("'.str_replace('&nbsp;', ' ', JText::_('GMAPFP_CHOIX_VERS')).'", ""));\');
								}
							}

							// And reverse geocode.
							(new google.maps.Geocoder()).geocode({latLng: latLng}, function(resp) {
								  var place = "'.JText::_('GMAPFP_GEOLOCAL_SOMEWHERE').'";
								  if (resp[0]) {
									  var bits = [];
									  for (var i = 0, I = resp[0].address_components.length; i < I; ++i) {
										  var component = resp[0].address_components[i];
										  if (contains(component.types, \'political\')) {
											  bits.push(\'<strong>\' + component.long_name + \'</strong>\');
											}
										}
										if (bits.length) {
											place = bits.join(\' > \');
										}
										markerTitle = "\'" + resp[0].formatted_address + "\'";
									}
									for (i = 0; i <= GMapFP_num.length - 1; i++) {
										document.getElementById(\'info_geolocalisation\' + GMapFP_num[i]).innerHTML = \''.JText::_('GMAPFP_GEOLOCAL_YOU_ARE').'\' + place;
									}
								for (i = 0; i <= GMapFP_num.length - 1; i++) {
									myCarteGMapFP = GMapFP_active_map[i];
									myboundsGMapFP = GMapFP_active_bounds[i];
									//myCarteGMapFP.setCenter(latLng);
									myboundsGMapFP.extend(latLng);
									myCarteGMapFP.fitBounds(myboundsGMapFP);
									var image_marker = new google.maps.MarkerImage(
										"'.JURI::root().'images/gmapfp/marqueurs/cible.png",
										new google.maps.Size(32, 32),
										new google.maps.Point(0,0),
										new google.maps.Point(16, 16)
									);
									var marker = new google.maps.Marker({
										map: myCarteGMapFP,
										position: latLng,
										title: markerTitle,
										icon: image_marker
									});
								}
							});
						  }
						
					</script>');

				}
			}
		}
	}
}
?>
