<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.111pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

abstract class GMapFPHelperRoute
{
	protected static $lookup;
	protected static $id;

	public static function getArticleRoute($id, $catids = array(), $language = 0)
	{
		$lang	= '';
		$db		= JFactory::getDBO();
		$app 	= JFactory::getApplication('site');
		$site 	= ($app->isSite() == 'site');
		
		if ($site) $params = $app->getParams('com_gmapfp');

		if (!is_array($catids)) $catids = explode(',', $catids); // tableau de catgorie
		
		$needles = array(
			'id'  => (int) $id
		);

		//Create the link
		if (empty($catids)) {
			$query	= $db->getQuery(true);
			$query->select('catid');
			$query->from('#__gmapfp');
			$query->where('id='.(int)$id);
			$db->setQuery($query);
			$catids = $db->loadResult();
			$catids = explode(',', $catids);
		}

		if (!empty($catids) and $site) {
			$tmp = array();
			$needles['catid'] = array();
			//recherche les catgories parentes
			foreach($catids as $catid) {
				$categories = JCategories::getInstance('GMapFP');
				$category = $categories->get((int)$catid);
				if($category)
				{
					$tmp = array_merge($category->getPath(), $tmp);
				}
			}
			//santise le tableau
			foreach($tmp as $key => $catid) {
				if (!in_array($catid, $needles['catid']))
					$needles['catid'][] = $catid;
			}
			unset($tmp);
			$needles['catid'] = array_reverse($needles['catid']);
		}
		self::$id = $id;

		if ($language && $language !== '*' && JLanguageMultilang::isEnabled())
		{
			$lang .= '&lang=' . $language;
		}
		
		$alias = '';
		if ($item = self::_findItem($needles)) {
			if (array_key_exists('id', $item)) 
				$link = 'index.php?&Itemid='.$item['id'].$lang;
			elseif (array_key_exists('catid', $item)) {
				if(!strpos($id, ':')) $alias = ':'.self::_alias($id);
				$link = 'index.php?option=com_gmapfp&view=gmapfp&layout=article&map_id='.$id.$alias.'&Itemid='.$item['catid'].$lang;
			}
			elseif (array_key_exists('all', $item)) {
				if(!strpos($id, ':')) $alias = ':'.self::_alias($id);
				$link = 'index.php?option=com_gmapfp&view=gmapfp&layout=article&map_id='.$id.$alias.'&Itemid='.$item['all'].$lang;
			}
		} else {
			if(!strpos($id, ':')) $alias = ':'.self::_alias($id);
			$link = 'index.php?option=com_gmapfp&view=gmapfp&layout=article&map_id='.$id.$alias.''.$lang;
		}

		return $link;
	}

	public static function getCategoryRoute($catid, $display = '', $language = 0)
	{
		$lang = '';
		$needles = array();
		if ($language && $language !== '*' && JLanguageMultilang::isEnabled())
		{
			$lang .= '&lang=' . $language;
		}

		$link = 'index.php?option=com_gmapfp&view=gmapfp&map_catid='.$catid.$lang;
		
		//recherche si cat appartient a un groupe
		if (!empty($catids)) {
			$needles['catid'] = array();
			foreach($catids as $catid) {
				$categories = JCategories::getInstance('GMapFP');
				$category = $categories->get((int)$catid);
				if($category)
				{
					$needles['catid'] = array_merge($needles['catid'], array_reverse($category->getPath()));
				}
			}
		}

		$view = '&view=gmapfp';
		if ($display  = 'list') $view = '&view=gmapfplist';

		//Create the link
		if ($item = self::_findItem($needles)) {
			if (array_key_exists('catid', $item)) $link = 'index.php?option=com_gmapfp'.$view.'&map_catid='. $id.'&Itemid='.$item['catid'].$lang;
			elseif (array_key_exists('all', $item)) $link = 'index.php?option=com_gmapfp'.$view.'&map_catid='. $id.'&Itemid='.$item['all'].$lang;
		}

		return $link;
	}

	protected static function _findItem($needles = null)
	{
		$app		= JFactory::getApplication();
		$menus		= $app->getMenu('site');
		$views		= array('gmapfp', 'gmapfplist', 'gmapfplistcomplex');

		//priorit au menu actif
		$active = $menus->getActive();
		if ($active && $active->component == 'com_gmapfp' && isset($active->query['view']) && in_array($active->query['view'], $views)) {
			if (isset($active->query['layout']) and $active->query['layout'] == 'article') {
				if($active->params->get('id') == $needles['id']) return array('all'=>$active->id);
			} else {
				$tmp = null;
				//ajoute les options de filtre que le menu active peut avoir
				if ($where = $active->params->get('gmapfp_filtre_sql', '')) {
					$tmp[$active->id]['where'] = $where;
				}
				if ($catid	= $active->params->get('catid')) {
					$tmp[$active->id]['catid'] = $catid;
				}
				
				//test si le menu active poscde cet id	
				if (self::_idExist($needles['id'], $tmp, $active->id)) {
					return array('all'=>$active->id);
				}
			}
		}

		// Prepare the reverse lookup array.
		if (self::$lookup === null)
		{
			self::$lookup = array();

			$component	= JComponentHelper::getComponent('com_gmapfp');
			$items		= $menus->getItems('component_id', $component->id);

			foreach ($items as $item)
			{
				if (isset($item->query) && isset($item->query['view']))
				{
					$view = $item->query['view'];
					if (in_array($view, $views)) {
						$params = $item->params;
						
						$where = $params->get('gmapfp_filtre_sql', '');
						$canAddIt = 1;
						if ($where) {
							// self::$lookup['where'][$where] = $item->id;
							self::$lookup[$item->id]['where'] = $where;
							$canAddIt = (strpos($where, 'a.catid')===false);
						}
						$recursive	= $params->get('recursive');
						if (!$recursive) {
							self::$lookup[$item->id]['non-recursive'] = '1';
						}
						$catid	= $params->get('catid');
						if ($catid && $canAddIt) {
							// self::$lookup['catid'][$catid] = $item->id;
							self::$lookup[$item->id]['catid'] = $catid;
							self::$lookup['catid'][$catid][] = $item->id;
						}
						$id	= $params->get('id');
						if ($id) {
							self::$lookup['id'][$id] = $item->id;
						}
						if (!$id and !$catid and !$where) {
							self::$lookup['all'][] = $item->id;
						}
					}
				}
			}
		}
		// die(print_r($needles));
		// die(print_r(self::$lookup));
		
		//recherche par article, catgories et tout.
		if ($needles)
		{
			foreach ($needles as $type => $ids)
			{
				if (isset(self::$lookup[$type]) && ($type == 'id' || $type == 'catid' || $type == 'all'))
				{
					if (is_array($ids)) {
						foreach($ids as $id)
						{
							if (isset(self::$lookup[$type][(int)$id])) {
								if (is_array($tmps = self::$lookup[$type][(int)$id]))
									foreach ($tmps as $tmp) {
										if (self::_idExist($needles['id'], self::$lookup, $tmp)) { 
											return array($type => $tmp);
										}
									}
								else 
									if (self::_idExist($needles['id'], self::$lookup, self::$lookup[$type][(int)$id])) { 
										return array($type => self::$lookup[$type][(int)$id]);
									}
							}
						}
					} else {
						if (isset(self::$lookup[$type][(int)$ids])) {
							if (self::_idExist($needles['id'], self::$lookup, self::$lookup[$type][(int)$ids])) {
								return array($type => self::$lookup[$type][(int)$ids]);
							}
						}
					}
				}
			}
			
			if (isset(self::$lookup['all']))
				return array('all' => self::$lookup['all'][0]);
		}

		return null;
	}

	protected static function _idExist($lieu_id = null, $options = null, $menuId = null) {
		$db			= JFactory::getDBO();
		
		$query	= $db->getQuery(true);
		$query
			->select('a.id as mon_id')
			->from('#__gmapfp as a')
			->join('LEFT OUTER', $db->quoteName('#__gmapfp_marqueurs', 'm') . ' ON (' . $db->quoteName('a.index_marqueur') . ' = ' . $db->quoteName('m.id') . ')')
			->join('LEFT OUTER', $db->quoteName('#__content', 'c') . ' ON (' . $db->quoteName('a.article_id') . ' = ' . $db->quoteName('c.id') . ')')
			->join('LEFT OUTER', $db->quoteName('#__users', 'v') . ' ON (' . $db->quoteName('v.id') . ' = ' . $db->quoteName('a.created_by') . ')');

		if (isset($options[$menuId]['catid'])){
			if (isset($options[$menuId]['non-recursive']))
				$query->where('(a.catid LIKE "'.$options[$menuId]['catid'].',%"'.' OR a.catid LIKE "%,'.$options[$menuId]['catid'].',%"'.' OR a.catid LIKE "%,'.$options[$menuId]['catid'].'"'.' OR a.catid = "'.$options[$menuId]['catid'].'")');
			else {
				$catids = self::enfants_catid($options[$menuId]['catid']);
				// die(print_r($catids));
				foreach ($catids as $catid)
					$whereOr[] = '(a.catid LIKE "'.$catid.',%"'.' OR a.catid LIKE "%,'.$catid.',%"'.' OR a.catid LIKE "%,'.$catid.'"'.' OR a.catid = "'.$catid.'")';
				$query->where('('.implode(' OR ', $whereOr).')');
			}
		}

		if (isset($options[$menuId]['where'])) $query->where($options[$menuId]['where']);

		$db->setQuery($query);
		$ids = $db->loadObjectList('mon_id');
		
		return (isset($ids[$lieu_id])); 
	}
	
	protected static function enfants_catid($id)
	{
		$ids[] = $id;
		//renvoie tous les enfants de $id tri par parent et ordre alphabtique
		$count_ids = count($ids);
		
		for ($i = 0; $i < $count_ids; $i++) {
			if (self::_enfant($ids[$i]))
				$ids = array_merge(array_slice($ids, 0, $i+1), self::_enfant($ids[$i]), array_slice($ids, $i+1));
			$count_ids = count($ids);
		}

		return $ids;
	}
	
	protected static function _enfant($id)
	{
		$db	= JFactory::getDBO();
		$query = "SELECT id" .
				"\n FROM #__categories" .
				"\n WHERE parent_id = ".$id .
				"\n AND extension = 'com_gmapfp'" .
				"\n AND published = true" .
				"\n ORDER BY title";
    	$db->setQuery( $query );
		$result = $db->loadColumn();
		return $result;
	}

	protected static function _alias($lieu_id) {
		$db			= JFactory::getDBO();
		
		$query	= $db->getQuery(true);
		$query
			->select('alias')
			->from('#__gmapfp')
			->where('id='.$lieu_id);
		$db->setQuery($query);
		return  $db->loadResult();
	}
}
?>
