<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.109pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPSend_Mail
{
	static public function sendmail($id, $message_sujet = '', $message_objet = '', $plublier = 0, $front_end = false)
	{
		$app	 	= JFactory::getApplication(); 
		$params 	= $app->getParams();
		$mail 		= JFactory::getMailer();
		$user 		= JFactory::getUser();
		$user_property = $user->getProperties();
		if ($user_property['id']==0) {
			$user_property['username']='guest';
			$config = JFactory::getConfig();
			$user_property['email'] = $config->get('mailfrom');
		}

		$url = "http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];

		$mySubject = $message_sujet;
		$myMessage = $message_objet." \n";
		if ($front_end) {
			$myMessage.= 'http://'.$_SERVER['SERVER_NAME']."/index.php?option=com_gmapfp&view=editlieux&layout=edit_form&controller=editlieux&task=edit&cid=".$id."\n\n";
		} else {
			$myMessage.= 'http://'.$_SERVER['SERVER_NAME']."/administrator/index.php?option=com_gmapfp&controller=gmapfp&task=edit&cid[]=".$id."\n\n";
		}
		$myMessage.= JText::_('GMAPFP_BY_USER')." ".$user_property['username'];

		if ($plublier) {
			$myMessage.= "\n\n".JText::_('GMAPFP_MERCI_PUBLIER');
		}
		$email_emetteur = $user_property['email'];
		$nom_emetteur	= $_SERVER['SERVER_NAME'];

		if (is_array($params->get('moderateur'))) {
			foreach ($params->get('moderateur') as $moderateur) {
				$user	= JFactory::getUser($moderateur);
				$user_property = $user->getProperties();
				$email_recepteur = $user_property['email'];
				$nom_recepteur	= '';
				//
				$mail->addRecipient($email_recepteur);
				$mail->addReplyTo($email_recepteur, $nom_recepteur);
			}
		} else {
			$email_recepteur	= JFactory::getUser($params->get('moderateur'));
			$email_recepteur_property = $email_recepteur->getProperties();
			$email_recepteur = $email_recepteur_property['email'];
			$nom_recepteur	= '';
			//
			$mail->addRecipient($email_recepteur);
			$mail->addReplyTo($email_recepteur, $nom_recepteur);
		}

		//de
		$mail->setSender(array($email_emetteur, $nom_emetteur));
		//
		$mail->addRecipient($email_recepteur);
		$mail->addReplyTo($email_recepteur, $nom_recepteur);
		$mail->setSubject($mySubject);
		$mail->setBody($myMessage);
		$sent = $mail->Send();
		return $sent;
	}

	static public function sendmail_remerciement($myRecipient, $id = '', $nom = '', $cat = '')
	{
		if ($email_recepteur = (string) $myRecipient) {
			$app 		= JFactory::getApplication(); 
			$params 	= $app->getParams();
			$mail 		= JFactory::getMailer();

			$email_recepteur= (string) $myRecipient;
			$nom_recepteur	= $nom;

			if (is_array($params->get('moderateur'))) {
				foreach ($params->get('moderateur') as $moderateur) {
					$user	= JFactory::getUser($moderateur);
					$user_property = $user->getProperties();
					$email_emetteur = $user_property['email'];
					$nom_emetteur	= $_SERVER['SERVER_NAME'];
					//de
					$mail->setSender(array($email_emetteur, $nom_emetteur));
				}
			} else {
				$user	= JFactory::getUser($params->get('moderateur'));
				$user_property = $user->getProperties();
				$email_emetteur = $user_property['email'];
				$nom_emetteur	= $_SERVER['SERVER_NAME'];
				//de
				$mail->setSender(array($email_emetteur, $nom_emetteur));
			}

			$mySubject 		= $params->get('gmapfp_submit_confirmation_sujet');
			$myMessage		= JText::sprintf($params->get('gmapfp_submit_confirmation_text'), $id, $nom, $cat);

			//
			$mail->addRecipient($email_recepteur);
			$mail->addReplyTo($email_recepteur, $nom_recepteur);
			$mail->setSubject($mySubject);
			$mail->setBody($myMessage);
			$sent = $mail->Send();
			
			return $sent;
		}
		return true;
	}
}
