<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.125pro
	* Creation date: Dcembre 2020
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPModelEditLieux extends JModelLegacy
{
	var $_list;
	var $_label;
	var $_classement;
	var $_picto;

	function __construct()
	{
		parent::__construct();
		$document	= JFactory::getDocument();
		$mainframe 	= JFactory::getApplication(); 
		$array 		= $mainframe->input->get('cid',  array(0), 'array');
		require_once(JPATH_ADMINISTRATOR.'/components/com_gmapfp/models/helpers/champs.php');

		if(array_key_exists(0, $array))
			$this->setId((int)$array[0]);
		
		//Insertion des enttes GMapFP si non dj fait.
        if (!defined( '_JOS_GMAPFP_CSS' ))
        {
            /** verifi que la fonction n'est dfini qu'une faois */
            define( '_JOS_GMAPFP_CSS', 1 );
    
            $document->addStyleSheet( JURI::base().'media/com_gmapfp/css/main_gmapfp.css'); 
            $document->addStyleSheet( JURI::base().'media/com_gmapfp/css/gmapfp.css'); 
        }
	}

	function _buildQuery()
	{
		$query = ' SELECT * '
			. ' FROM #__gmapfp_marqueurs where published = 1 ORDER BY nom '
		;

		return $query;
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
		$this->_datacustom = null;
	}

	function getChamps($id_lieu = '', $view = array())
	{
		return Champs::get($id_lieu, $view);
	}
	
	function &getData()
	{
		// Load the data si pas tache "nouveau lieu"
		if (empty( $this->_data) and $this->get('state')->task!='add') {
			$query = ' SELECT c.*, v.name AS last_editor FROM #__gmapfp AS c '.
					'  LEFT JOIN #__users AS v ON v.id = c.modified_by' .
					'  WHERE c.id = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$createdate = JFactory::getDate();
			$this->_data = new stdClass();
			$this->_data->id = 0;
			$this->_data->nom = null;
			$this->_data->alias = null;
			$this->_data->sef = null;
			$this->_data->adresse = null;
			$this->_data->adresse2 = null;
			$this->_data->codepostal = null;
			$this->_data->ville = null;
			$this->_data->departement = null;
			$this->_data->pay = null;
			$this->_data->email = null;
			$this->_data->web = null;
			$this->_data->img = null;
			$this->_data->album = null;
			$this->_data->introtext = null;
			$this->_data->fulltext = null;
			$this->_data->horaires_prix = null;
			$this->_data->link = null;
			$this->_data->article_id = null;
			$this->_data->icon = null;
			$this->_data->icon_label = null;
			$this->_data->glat = null;
			$this->_data->glng = null;
			$this->_data->gzoom = null;
			$this->_data->kml = null;
			$this->_data->catid = null;
			$this->_data->created_by = null;
			$this->_data->published = null;
			$this->_data->featured = null;
			$this->_data->access = 1;
			$this->_data->checked_out = null;
			$this->_data->metadesc = null;
			$this->_data->metakey = null;
			$this->_data->metadata = null;
			$this->_data->hits = 0;
			$this->_data->version = 0;
			$this->_data->modified = null;
			$this->_data->modified_by = 0;
			$this->_data->created = $createdate->toSql();
			$this->_data->publish_up = "";
			$this->_data->publish_down = "";
			$this->_data->ordering = 0;		
			$this->_data->attribs = null;	
			$this->_data->index_marqueur = 0;	
			$this->_data->language = null;
			$this->_data->classements = null;
			$this->_data->labels = null;
			$this->_data->pictos = null;
		}
		
		if (JString::strlen($this->_data->fulltext) > 1) {
			$this->_data->text = $this->_data->introtext . "<hr id=\"system-readmore\" />" . $this->_data->fulltext;
		} else {
			$this->_data->text = $this->_data->introtext;
		}

		return $this->_data;
	}

	function &getClassements()
	{
		if (empty( $this->_label )) {
			$query = ' SELECT * FROM #__gmapfp_classements WHERE (cat = 2) AND (published = 1) ORDER BY ordering ';
			$this->_label = $this->_getList( $query );
		}

		if (empty( $this->_classement )) {
			$query = ' SELECT * FROM #__gmapfp_classements WHERE (cat = 1) AND (published = 1) ORDER BY ordering ';
			$this->_classement = $this->_getList( $query );
		}

		if (empty( $this->_picto )) {
			$query = ' SELECT * FROM #__gmapfp_classements WHERE (cat = 3) AND (published = 1) ORDER BY ordering ';
			$this->_picto = $this->_getList( $query );
		}
		$lists['labels'] = $this->_label;
		$lists['classements'] = $this->_classement;
		$lists['pictos'] = $this->_picto;
		return $lists;
	}

	function &getCustom()
	{
		// Load the data
		if (empty( $this->_datacustom )) {
			$query = ' SELECT * FROM #__gmapfp_params_custom_fields  ';
			$this->_datacustom = $this->_getList( $query );
		}

		$result = $this->_datacustom;
		return $result;
	}

	function &getMarqueurs()
	{
		if (empty( $this->_list ))
		{
			$query = $this->_buildQuery();
			$this->_list = $this->_getList( $query );
		}

		$result = $this->_list;
		return $result;
	}

	function &getExistingSubmit($created_by, $created, $nom)
	{
		$query = " SELECT id "
			. " FROM #__gmapfp "
			. " WHERE created_by='".$created_by."'"
			. " and nom=".$this->_db->quote($nom)
			. " and created>='".$created."'"
		;
		
		$result = array_key_exists('0', $this->_getList( $query ));
		return $result;
	}

	function &getUser($id)
	{
		$query = ' (SELECT created_by '
			. ' FROM #__gmapfp '
			. ' WHERE id='.$id.')'
		;
		$query = ' SELECT username, email '
			. ' FROM #__users '
			. ' WHERE id='.$query
		;
        $this->_db->setQuery( $query );
        $user = $this->_db->loadObject();

		return $user;
	}

	function store()
	{
		// Check for request forgeries
		JSession::checkToken() or jexit( 'Invalid Token' );

		$app 		= JFactory::getApplication(); 
		$params 	= $app->getParams('com_gmapfp');
		$row 		= $this->getTable('GMapFP', 'GMapFPTable');
		$user		= JFactory::getUser();
		$nullDate	= $this->_db->getNullDate();
    	$_layout 	= $app->input->get('layout', "", 'string');
		$datenow 	= JFactory::getDate();
		$config 	= JFactory::getConfig();
		$tzoffset 	= $config->get('offset');
		$task		= $app->input->get('task');
		$data		= $_POST;
		

		//traitement des listes
		if (array_key_exists('labels', $data)) $data['labels'] = implode(',', $data['labels']);
		if (array_key_exists('classements', $data)) $data['classements'] = implode(',', $data['classements']);
		if (array_key_exists('pictos', $data)) $data['pictos'] = implode(',', $data['pictos']);

		if (is_array($data['catid'])) $data['catid'] = implode(',', $data['catid']);

		// Prepare the content for saving to the database
		$this->saveGMapfpPrep( $row );

		//dpublie sur modification par un utilisateur
		if ($params->get('gmapfp_unpiblish_after_update', 0)) {
			$data['published'] = 0;
		}
		
		if ($task == 'save_copie') {
			$this->checkin($data['id']);
			$data['published'] = 0;
			$data['nom'] = JText::_('GMAPFP_COPIE_DE').$data['nom'];
			$data['id'] = '';
			$data['created'] = $datenow->tosql();
			
		}
		
		// Bind the form fields to the table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		//Traite les champs perso dont le rsultat est un tableau (ne retourne pas le champ si vide !)		
		$query = ' SELECT id FROM #__gmapfp_extension_type '.
				'  WHERE (type = 3 OR type = 6 OR type = 10)'.
				'  AND published = 1';
		$this->_db->setQuery( $query );
		$tableau = $this->_db->loadColumn();
		foreach ($tableau as $id_field_array) {
			$champ_form = 'perso_field_'.$id_field_array;
			$champ_sql = 'field_'.$id_field_array;
			$value = $app->input->post->get( $champ_form, array(), 'array' );
			$row->$champ_sql = implode(',', $value);
		}

		// sanitise id field
		$row->id = (int) $row->id;

		$isNew = true;
		// Are we saving from an item edit?
		if ($row->id) {
			$isNew = false;
			$row->modified 		= $datenow->tosql();
			$row->modified_by 	= $user->get('id');
		} else {
			$row->created_by 	= $user->get('id');
		}

		if (empty($row->created))
			$row->created 		= $datenow->tosql();

		// Handle never unpublish date
		if (!$row->publish_up) $row->publish_up = $nullDate;
		else $row->publish_up = JFactory::getDate($row->publish_up, $tzoffset)->tosql();

		if (!$row->publish_down) $row->publish_down = $nullDate;
		else $row->publish_down = JFactory::getDate($row->publish_down, $tzoffset)->tosql();

			//traitement spcifique au formulaire de soumission
		if ($_layout=='soumission'){
			//fin de publication automatique
			if (((int)$params->get('gmapfp_temps_publication', 0))>0){
				$temps = (int)$params->get('gmapfp_temps_publication');
				$date = $datenow;
				$date = $date->toUnix() + ($temps*3600*24);
				$row->publish_down = JFactory::getDate($date, $tzoffset)->tosql();
			}
			//forage publication automatique
			if ($params->get('gmapfp_submit_validation_admin', 0)){
				$row->published = true;
			}
		}

		// Increment the content version number
		$row->version++;
		
		// Make sure the record not already exists
		$date_created = JFactory::getDate($row->created);
		$date_created = $date_created->toUnix() - 4;
		$date_created = JFactory::getDate($date_created);
		$date_created = $date_created->toSql();
		$Field_exist = $this->getExistingSubmit($row->created_by, $date_created, $row->nom);	

		if (($Field_exist)and(!$row->id)) return true;
		// Make sure the record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}

		//traite les champs perso. 
		//Ceux qui accepte des balise html		
		$query = ' SELECT id FROM #__gmapfp_extension_type '.
				'  WHERE (type = 2 OR type = 1)'.
				'  AND published = 1';
		$this->_db->setQuery( $query );
		$editeurs = $this->_db->loadColumn();
		//Ceux qui sont des datetime		
		$query = ' SELECT id FROM #__gmapfp_extension_type '.
				'  WHERE (type = 15)'.
				'  AND published = 1';
		$this->_db->setQuery( $query );
		$datetime = $this->_db->loadColumn();
		//Ceux qui sont des date		
		$query = ' SELECT id FROM #__gmapfp_extension_type '.
				'  WHERE (type = 9)'.
				'  AND published = 1';
		$this->_db->setQuery( $query );
		$date_type = $this->_db->loadColumn();

		$mes_valeurs = array();
		foreach ($data as $key => $value) {
			if (substr($key, 0, 11) == 'perso_field') {
				//si checkbox, ou list, ou radio buton, ou ...
				$search = array("\r", "\n", "\t", "\0", " ", "\x0B");
				if (is_array($value)) $value = implode("\r\n", str_replace($search, '', $value));
				//si editeur
				if (in_array(substr($key, 12), $editeurs)) {
					$value = $app->input->get( $key, '', 'raw' );
					$value = str_replace( '<br>', '<br />', $value );
				}
				if (in_array(substr($key, 12), $datetime) and !empty($value)) {
					$config = JFactory::getConfig();
					$tzoffset = $config->get('offset');
					$date = JFactory::getDate($value, $tzoffset);
					$value = $date->tosql();
				}
				if (in_array(substr($key, 12), $date_type) and !empty($value)) {
					// ne pas tenir compte du time zone offset sur l'enregistrement des dates
					$date = JFactory::getDate($value);
					$value = $date->tosql();
				}
				$mes_valeurs[] = '`field_'.substr($key, 12).'` = '.$this->_db->quote($value);
			}
		}
		if ($mes_valeurs) {
			$query = 'UPDATE `#__gmapfp` '.
				' SET '.implode(',', $mes_valeurs).
				' WHERE id = '.$row->id;
			$this->_db->setQuery( $query );
			if (!$this->_db->query())
			{
				die(print_r($this->_db->getErrorMsg()));
			}
		}

		//dtecte la catgorie si besoin
		if ($params->get('gmapfp_submit_envoie_mail_admin', 0) or $params->get('gmapfp_submit_envoie_mail_user_builder', "")!="") {
			$wheres = array();
			$catids = explode(',', $row->catid);
			foreach ($catids as $catid) {	
				$wheres[] = '(id LIKE "'.$catid.',%"'.' OR id LIKE "%,'.$catid.',%"'.' OR id LIKE "%,'.$catid.'"'.' OR id = "'.$catid.'")';
			}

			$query = ' SELECT title'.
					' FROM #__categories'.
					' WHERE '.implode(' AND ', $wheres);
			$this->_db->setQuery( $query );
			$categorie = $this->_db->loadColumn();
		}
		
		//envoie d'un message d'avertissement au contact dsign
		if ($params->get('gmapfp_submit_envoie_mail_admin', 0)) {
			//$sendmail = $this->sendmail($row->id);
			require_once (JPATH_COMPONENT.'/helpers/send_mail.php');
			if ($_layout=='soumission') { 
				GMapFPSend_Mail::sendmail($row->id, JText::_('GMAPFP_NEW_SUBMIT'), JText::sprintf('GMAPFP_NEW_SUBMIT2', $row->nom, implode(', ', $categorie)), !$config->get('gmapfp_temps_publication'), $config->get('gmapfp_submit_envoie_mail_link', 0));
			} else {
				if ($isNew) {
					GMapFPSend_Mail::sendmail($row->id, JText::_('GMAPFP_NEW_LIEU_SUBMIT'), JText::sprintf('GMAPFP_NEW_LIEU_SUBMIT2', $row->nom, implode(', ', $categorie)), 0, $config->get('gmapfp_submit_envoie_mail_link', 0));
				} else {
					GMapFPSend_Mail::sendmail($row->id, JText::_('GMAPFP_UPDATE_LIEU_SUBMIT'), JText::sprintf('GMAPFP_UPDATE_LIEU_SUBMIT2', $row->nom, implode(', ', $categorie)), 0, $config->get('gmapfp_submit_envoie_mail_link', 0));
				}
			}
		}

		//envoie d'un message de confirmation ou de remerciement
		if ($params->get('gmapfp_submit_envoie_mail_user_builder', "") and $_layout=='soumission') {
			require_once (JPATH_COMPONENT.'/helpers/send_mail.php');
			$champ = $params->get('gmapfp_submit_envoie_mail_user_builder');
			GMapFPSend_Mail::sendmail_remerciement($row->$champ, $row->id, $row->nom, implode(', ', $categorie));
		}

		// attribut le n 1  ordering et dcale les autres n
		if (!$row->reorder()) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}
		
		$result = $row->id.':'.$row->alias;
		
		//SEF en base, traite le champ
		if ($params->get('gmapfp_sef_cached')) {
			$map_link=JRoute::_(GMapFPHelperRoute::getArticleRoute($result, $row->catid), false);
			$query = 'UPDATE #__gmapfp SET sef = "'.$map_link.'" WHERE id = '.$row->id;
			$this->_db->setQuery($query);
			$this->_db->execute();
		}
		
		return $result;
	}

	function saveGMapFPPrep( &$row )
	{
		$mainframe 	= JFactory::getApplication(); 
		// Get submitted text from the request variables
		$text_horaires_prix = $mainframe->input->get( 'text_horaires_prix', '', 'raw');
		$text_message		= $mainframe->input->get( 'text_message', '', 'raw');
		$text_link			= $mainframe->input->get( 'text_link', '', 'string');

		// Clean text for xhtml transitional compliance
		$text_horaires_prix		= str_replace( '<br>', '<br />', $text_horaires_prix );
		$text_message		= str_replace( '<br>', '<br />', $text_message );
		$text_link		= str_replace( '\\', '/', $text_link );

		// Search for the {readmore} tag and split the text up accordingly.
		$pattern = '#<hr\s+id=("|\')system-readmore("|\')\s*\/*>#i';
		$tagPos	= preg_match($pattern, $text_message);

		if ( $tagPos == 0 )
		{
			$row->introtext	= $text_message;
			$row->fulltext = '';
		} else
		{
			list($row->introtext, $row->fulltext) = preg_split($pattern, $text_message, 2);
		}

		$row->horaires_prix	= $text_horaires_prix;
		$row->link	= $text_link;

		//sauvegardel'id de l'utilisateur
		if (!$row->created_by) {
			$user		= JFactory::getUser();
			$row->created_by = $user->get('id');
		}

		return true;
	}
	
    function getImages()
    {
        jimport( 'joomla.filesystem.file' );
        jimport( 'joomla.filesystem.folder' );
		$mainframe 	= JFactory::getApplication(); 
		// Get submitted text from the request variables
		$images     = array ();
		$id 		= $mainframe->input->get('cid', array(0), 'array');
		$id 		= (int)$id[0];
		if ($id==0) return false;
		$basePath = COM_GMAPFP_IMAGES_FOLDER.'/GA'.$id;
//die(print_r($basePath));
		// Cre le rpertoire s'il n'exist pas
		$buffer = "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>";
		if (!JFolder::exists($basePath)) {
			JFolder::create($basePath);
			JFile::write($basePath."/index.html", $buffer);
		}
		if (!JFolder::exists($basePath.'/thumbs')) {
			JFolder::create($basePath.'/thumbs');
			JFile::write($basePath.'/thumbs/index.html', $buffer);
		}
        // Get the list of files and folders from the given folder
        $fileList   = JFolder::files($basePath);
//die(print_r('ok23'));

        // Iterate over the files if they exist
        if ($fileList !== false) {
            foreach ($fileList as $file)
            {
                if (is_file($basePath.'/'.$file) && substr($file, 0, 1) != '.' && strtolower($file) !== 'index.html') {
                    $tmp = new JObject();
                    $tmp->name = $file;
                    $tmp->path_relative = COM_GMAPFP_IMAGES_HTTP.'/GA'.$id;
                    $tmp->path = JPath::clean($basePath.'/'.$file);
                    $tmp->size = filesize($tmp->path);
                    $tmp->size = round($tmp->size/1024, 2);

                    $ext = strtolower(JFile::getExt($file));
                    switch ($ext)
                    {
                        // Image
                        case 'jpg':
                        case 'png':
                        case 'gif':
                        case 'xcf':
                        case 'odg':
                        case 'bmp':
                        case 'jpeg':
                            $info = @getimagesize($tmp->path);
                            $tmp->width     = @$info[0];
                            $tmp->height    = @$info[1];
                            $tmp->type      = @$info[2];
                            $tmp->mime      = @$info['mime'];

                            if (($info[0] > 60) || ($info[1] > 60)) {

								if ($tmp->width > $tmp->height) {
									$percentage = (60 / $tmp->width);
								} else {
									$percentage = (60 / $tmp->height);
								}
						
								//gets the new value and applies the percentage, then rounds the value
								$tmp->width = round($tmp->width * $percentage);
								$tmp->height = round($tmp->height * $percentage);
                            }
                 			//lecture des infos exif du fichier image
							$xml = substr($file, 0, -(strlen(JFile::getExt($file))+1));
							$xml .= '.xml';

							if (JFile::exists($basePath.'/infos/'.$xml)) {
								$xml_str = file_get_contents($basePath.'/infos/'.$xml);
								$xml_data = new SimpleXMLElement($xml_str);
									$tmp->titre = (string) $xml_data->titre;
									$tmp->description = (string) $xml_data->description;
							} else {
									$tmp->titre = '';
									$tmp->description = '';
							}
                 			$images[] = $tmp;
                            break;
                    }
                }
            }
        }
        return $images;
    }
	
	public function checkin($pk = null)
	{
		// Only attempt to check the row in if it exists.
		if ($pk)
		{
			$user = JFactory::getUser();
			if (!$user->get('id')) $user_id = 1;
				else $user_id = $user->get('id');

			// Get an instance of the row to checkin.
			$table = $this->getTable('GMapFP', 'GMapFPTable');
			if (!$table->load($pk))
			{
				$this->setError($table->getError());
				return false;
			}

			// Check if this is the user having previously checked out the row.
			if ($table->checked_out > 0 && $table->checked_out != $user_id && !$user->authorise('core.admin', 'com_checkin'))
			{
				$this->setError(JText::_('JLIB_APPLICATION_ERROR_CHECKIN_USER_MISMATCH'));
				return false;
			}

			// Attempt to check the row in.
			if (!$table->checkin($pk))
			{
				$this->setError($table->getError());
				return false;
			}
		}

		return true;
	}

	public function checkout($pk = null)
	{
		// Only attempt to check the row in if it exists.
		if ($pk)
		{
			$user = JFactory::getUser();
			if (!$user->get('id')) $user_id = 1;
				else $user_id = $user->get('id');

			// Get an instance of the row to checkout.
			$table = $this->getTable('GMapFP', 'GMapFPTable');
			if (!$table->load($pk))
			{
				$this->setError($table->getError());
				return false;
			}

			// Check if this is the user having previously checked out the row.
			if ($table->checked_out > 0 && $table->checked_out != $user_id)
			{
				$this->setError(JText::_('JLIB_APPLICATION_ERROR_CHECKOUT_USER_MISMATCH'));
				return false;
			}

			// Attempt to check the row out.
			if (!$table->checkout($user_id, $pk))
			{
				$this->setError($table->getError());
				return false;
			}
		}

		return true;
	}

	function PaneName()
	{	
		$query = ' SELECT id, nom FROM #__gmapfp_extension_type '.
				'  WHERE type = 14 AND published = 1'.
				' ORDER BY ordering';
		$this->_db->setQuery( $query );
		return $this->_db->loadAssocList('id');

	}
}
?>
