<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.134pro
	* Creation date: Septembre 2023
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPModelGMapFP extends JModelLegacy
{
	private $_id = null;
	private $_ids = null;
	private $_catid = null;
	private $_id_perso = null;
	private $_cat_datas = null; //data des catgories GMapFP
	
	private $_cat_parent = null;
	private $_cat_items = null;
	private $num = 0;
	
	private $ajax = false;
	private $ajax_fields_filters = array();
	private $params = '';
	private $is_map = false;
	
	private $DataFilterList = null;
	
    function __construct() 
    { 
        parent::__construct(); 
		$app = JFactory::getApplication('site');
		$params = $app->getParams('com_gmapfp');
		if (empty($params)) {
			$params = JComponentHelper::getParams('com_gmapfp'); 
		}
				// ini_set('memory_limit', '1024M');

		if ($params->get('gmapfp_sef_cached') and $this->check_sef_cahe()) {
			$uri    = JURI::getInstance(); 
			$return_url = $uri->toString();  
			$this->buil_sef_cache($return_url);
		}

		if ($params->get('gmapfp_log', 0)) {
			jimport('joomla.log.log');
		}

        $this->_catid = $app->input->get('map_catid', $params->get('catid', 0 ,'int'), 'int');
		
        $this->_id = $params->get('id', $app->input->get('map_id', 0, 'int')); 
        $this->_ids = $app->input->get('map_ids', '', 'string');
		
        $this->_id_perso = '';
		$this->_total   = null; 
        $this->_result  = null; 
        $this->_result_personnalisation = null; 
        $this->_num_marqueurs = 0;
		$this->getCategories();

        JHtmlBehavior::framework();
	}
	
	public function set_id($value)
	{
		$this->_id = $value;
		return true;
	}
	
	public function set_ids($value)
	{
		$this->_ids = $value;
		return true;
	}
	
	public function set_catid($value)
	{
		$this->_catid = $value;
		return true;
	}
	
	public function get_num()
	{
		return $this->num;
	}
	
	function set_ajax($value)
	{
		$this->ajax = $value;
		return true;
	}
	function set_ajax_fields_filters($value)
	{
		$this->ajax_fields_filters[] = $value;
		return true;
	}
	function get_ajax_fields_filters()
	{
		return $this->ajax_fields_filters;
	}
	
	function enfants_catid($id)
	{
		$app = JFactory::getApplication();
		$params = $app->getParams();

		$ids[] = $id;
		if ($params->get('recursive', 1)) {
			//renvoie tous les enfants de $id tri par parent et ordre alphabtique
			$count_ids = count($ids);
			
			for ($i = 0; $i < $count_ids; $i++) {
				if ($this->_enfant($ids[$i]))
					$ids = array_merge(array_slice($ids, 0, $i+1), $this->_enfant($ids[$i]), array_slice($ids, $i+1));
				$count_ids = count($ids);
			}
		}

		return $ids;
	}

	function _enfant($id)
	{
		$db	= JFactory::getDBO();
		$query = "SELECT id" .
				"\n FROM #__categories" .
				"\n WHERE parent_id = ".$id .
				"\n AND extension = 'com_gmapfp'" .
				"\n AND published = true" .
				"\n ORDER BY title";
    	$db->setQuery( $query );
		$result = $db->loadColumn();
		return $result;
	}
	
    function hit()
    {
        if ($this->_id)
        {
            $article =  $this->getTable('GMapFP', 'GMapFPTable');
            $article->hit($this->_id);
            return true;
        }
        return false;
    }

    function getCustom()
    {
        $query = 'SELECT id, nom' .
                ' FROM #__gmapfp_params_custom_fields';
        $results = $this->_getList( $query );
        return $results;
    }
    
    function getClassements($cat)
    {
        $db = JFactory::getDBO();
        $query = ' SELECT id, nom, img' .
                ' FROM #__gmapfp_classements'.
				' WHERE published = 1'.
				' AND cat = '.$cat.
				' ORDER BY ordering';
        $db->setQuery( $query );
        //$results = $db->loadAssocList('id', 'img');
        $results = $db->loadObjectList('id');
        //$results = $this->_getListArray( $query );
		//die(print_r($results));
        return $results;
    }
    
	function getDataFilterList($search_module = false)
	{
		if ($search_module or empty($this->DataFilterList)) {
			$mainframe	= JFactory::getApplication(); 
			$params		= clone($mainframe->getParams('com_gmapfp'));
			$db 		= JFactory::getDBO();
			$wheres 	= array ();
			$now    	= JFactory::getDate();
			$nullDate 	= $db->getNullDate();

			//filtre par langue
			$tag = JFactory::getLanguage()->getTag();
			$join = '';
			$case = '';
			$parametres = ', a.parametres, a.nom as label, a.filtre_label as filtre_label';
			if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
				$wheres[] ='(c.langue = ' . $db->Quote($tag).' OR c.langue IS NULL)';
				$join = ' LEFT OUTER JOIN #__gmapfp_extension_lang AS c on a.id = c.typeid';
				$case = ', CASE WHEN CHAR_LENGTH(c.nom) THEN c.nom ELSE a.nom END as label, '.
					' CASE WHEN CHAR_LENGTH(c.parametres) THEN c.parametres ELSE a.parametres END as parametres, '.
					' CASE WHEN CHAR_LENGTH(c.filtre_label) THEN c.filtre_label ELSE a.filtre_label END as filtre_label ';
				$parametres = '';
			}
			
			// Filter by access level.
				$user	= JFactory::getUser();
				$groups	= implode(',', $user->getAuthorisedViewLevels());
				$wheres[] = '(a.access IN ('.$groups.') or (a.access = ""))';
			//}
			
			$wheres[] = 'a.published = 1';
			$wheres[] = 'a.filtrer >= 1';
			
			//ne garde que les champs pouvant tre filtr
			$where_ors[] = 'a.type = 0';
			$where_ors[] = 'a.type = 3';
			$where_ors[] = 'a.type = 4';
			$where_ors[] = 'a.type = 5';
			$where_ors[] = 'a.type = 6';
			$where_ors[] = 'a.type = 9';
			$where_ors[] = 'a.type = 17';
			$where_ors[] = 'a.type = 20';
			$wheres[] = '('.implode( '  OR ', $where_ors ).')';

			//filtre par catgories
			if ($filtre = $params->get('catid', '')) {
				$wheres[] = '((a.for_cat = 1 AND (a.catid LIKE "'.$filtre.',%"'.' OR a.catid LIKE "%,'.$filtre.',%"'.' OR a.catid LIKE "%,'.$filtre.'"'.' OR a.catid = "'.$filtre.'")) OR a.for_cat = 0)';
				unset ($filtre);
			}

			//fait la liste des types prrenseigns
			$query = ' SELECT a.id, a.nom, a.alias, a.type, a.filtrer '.$parametres.
					$case.
					' FROM #__gmapfp_extension_type as a'.
					$join.
					' WHERE ' . implode( '  AND ', $wheres ).
					' ORDER BY a.ordering';


			$db->setQuery( $query );
			$results = $db->loadObjectList();

			// n'affiche que les valeurs utilises dans la table principale
			$wheres = array();
			$wheres[] = 'a.published = 1';
			$wheres[] = 'c.published = 1';
			
			// Filter by access level.
				$user	= JFactory::getUser();
				$groups	= implode(',', $user->getAuthorisedViewLevels());
				$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';
				$wheres[] ='(c.access IN ('.$groups.') or (c.access = ""))';
			//}

			$wheres[] = '( a.publish_up is NULL OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
			$wheres[] = '( a.publish_down is NULL OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

			// Filter by featured
			switch($params->get('featured', 0)){
				case 1:
					$wheres[] = 'a.featured = 0';
					break;
				case 2:
					$wheres[] = 'a.featured = 1';
					break;
			}
			
			// Filter by language
			if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
				$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
				$wheres[] ='c.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
			}

			if (!$search_module && $this->_catid) {
				$_catids = $this->enfants_catid($this->_catid);
				foreach ($_catids as $_catid)
				{
					$wheresOr[] = 'a.catid = '.$_catid.'';
				}
				$wheres[] = '('.implode( "\n OR ", $wheresOr).')';
			};
			
			foreach ($results as $key => $result) {
				$old_parameters = explode("\r\n", $result->parametres);
				$query = ' SELECT DISTINCT field_'.$result->id.', a.id'.
					' FROM #__gmapfp as a'.
					' LEFT OUTER JOIN #__categories AS c on a.catid = c.id'.
					' WHERE '.implode( '  AND ', $wheres ).
					' GROUP BY field_'.$result->id;
				$db->setQuery( $query );
				$field_datas = $db->loadObjectList();
			
			// if (key($field_datas[0])!='field_9') die(print_r($field_datas));
				$parametres = array();
				if ($result->type != 0) {
					$values = array();
					foreach ($field_datas as $field) {
						$temps = 'field_'.$result->id;
						if (trim($field->$temps, " \t\n\r\0\x0B") != '')
							$values = array_merge($values, explode("\r\n",$field->$temps));
					}
					unset ($temps, $field_datas);
					$values = array_unique($values);
				// die(print_r($values));

					$cn = 0;
					foreach ($values as $value) {
						if ($value != '')
							if ($result->type != 0)
								foreach ( $old_parameters as $old_parameter ) {
									if ( strpos( $old_parameter, $value.'::') === 0 ) {
										$parametres[] = $old_parameter;
									}
								}
							else {
								$parametres[] = $result->id.'::'.$value;
								$cn++;
							}
					}
					$results[$key]->parametres = implode("\r\n",$parametres);
					unset($values, $value);
				} else {
					foreach($field_datas AS $field) {
						$field_name = 'field_'.$result->id;
						$parametres[] = $field->id.'::'.$field->$field_name;
					}
					$results[$key]->parametres = implode("\r\n",$parametres);
					unset($field, $field_name);
				}
			}
			if (!$search_module) $this->DataFilterList = $results;
			return $results;
		} else
			return $this->DataFilterList;
	}

	/* $hide contient les nom des champs  ne pas intgrer*/
	function getFilterList($option, $Itemid, $hide=array(), $only_array=false)
	{
		$mainframe	= JFactory::getApplication();
        $config		= clone($mainframe->getParams('com_gmapfp'));
		$lists		= array ();
		$search		= array ();
        $db = JFactory::getDBO();

		if ($this->ajax) $action = 'GMapFP_Ajax_Request_Filter(this);'; else $action = 'adminForm_GMapFP_filtre.submit();';
		
		$results = array();
		if (!in_array('utilisateur', $hide))
			$results = $this->getDataFilterList();

		if ($results) {
			foreach ($results as $result) {
				switch ($result->type) {
					/*case 9:
						$filtre = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_field_'.$result->id, 'filtre_field_'.$result->id, '', 'int' );
						if  ($result->filtrer == 1) {
					$output = '<label>'.$result->filtre_label.'</label>';
					$output .= JHtml::calendar($filtre, 'filtre_field_'.$result->id, 'filtre_field_'.$result->id, '%d-%m-%Y', array('style'=>'width: 60px !important;'));
							$valeurs = array();
								$lists['_field_'.$result->id] = $output;
						}
						break;*/
					case 0:
					case 3:
					case 4:
					case 5:
					case 6:
					case 17:
					case 20:
						$filtre = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_field_'.$result->id, 'filtre_field_'.$result->id, '', 'int' );
						if  ($result->filtrer == 1) {
							$valeurs = array();
								$cn = 0;
								$params = explode("\r\n", $result->parametres);
								foreach($params as $param) {
									$cn++;
									$valeurs[iconv('UTF-8', 'ASCII//TRANSLIT//IGNORE', substr(strstr($param, '::', 0),2))] = JHTML::_('select.option', strstr($param, '::', 1), substr(strstr($param, '::', 0),2) );
								}
								ksort($valeurs);
								array_unshift($valeurs, JHTML::_('select.option', '', '-- '.$result->filtre_label.' --' ));
							if ($only_array) {
								$tmp_list2 = array();
								foreach ($valeurs as $tmp_list) {
									$tmp_list2[] = "['".str_replace("'", "\'", $tmp_list->value)."', '".str_replace("'", "\'", $tmp_list->text)."']";
								}
								$lists['_field_'.$result->id] = '['.implode(', ', $tmp_list2).']';
								unset($tmp_list, $tmp_list2, $valeurs);
							}else
							if ($cn>1) {
								$lists['_field_'.$result->id] = JHTML::_('select.genericlist', $valeurs, 'filtre_field_'.$result->id, 'size="1" disabled class="inputbox" onchange="'.$action.'"', 'value', 'text', $filtre );
							}
						} else {
							$cn = 0;
							$MonTableau = "";
							$MonTableau2 = "";
							$params = explode("\r\n", $result->parametres);
							foreach($params as $param) {
								//die(print_r($param));
								$MonTableau .= "myArray".$result->id."[".$cn."] = '".str_replace("'", "\'", $param)."';"."\r\n";
								$MonTableau2 .= "myArrayResult".$result->id."[".$cn."] = '".($cn + 1)."';"."\r\n";
								$cn++;
							}
							$ma_list = '<div onkeydown="return moveSelection'.$result->id.'()">';
							$ma_list .= "<label>".$result->filtre_label."</label><br />\r\n";
							$old_valeur = '';
							if ($filtre) $old_valeur = $params[$filtre - 1];
							$ma_list .= '<input type="text" autocomplete="off" id="text_field_'.$result->id.'" onkeyup="window.setTimeout(\'refreshList'.$result->id.'();\', 10); return getGMapFPEnterKey'.$result->id.'()" onblur="getGMapFPValueKey'.$result->id.'()" value="'.$old_valeur.'"/>'."\r\n";
							$ma_list .= '<div id="liste'.$result->id.'" class="gmapfp_list_intel"></div>'."\r\n";
							$ma_list .= '<input type="hidden" name="filtre_field_'.$result->id.'" id="filtre_field_'.$result->id.'" value="'.$filtre.'"/>'."\r\n";
							$ma_list .= '<script type="text/javascript">
								 <!--
									var selIndex'.$result->id.' = 0;
									var nbMatch'.$result->id.' = 0;
									var myArray'.$result->id.' = new Array();
									var myArrayResult'.$result->id.' = new Array();
									var content'.$result->id.' = "";
									var old'.$result->id.' = "";
									var old_filtre'.$result->id.' = "'.$old_valeur.'";
								';
							$ma_list .= $MonTableau;
							$ma_list .= $MonTableau2;
							unset ($ma_list2);
							$ma_list .= " 	function fillInput".$result->id."(i)
 	{
   document.getElementById('text_field_".$result->id."').value = myArray".$result->id."[i];
   document.getElementById('filtre_field_".$result->id."').value = myArrayResult".$result->id."[i];
   document.getElementById('liste".$result->id."').style.display= 'none';
   document.getElementById('text_field_".$result->id."').focus();
			document.adminForm_GMapFP_filtre.submit();
 	}
 	function refreshList".$result->id."()
 	{
   if(document.getElementById('text_field_".$result->id."').value != old".$result->id.")
   {
   	old".$result->id."=document.getElementById('text_field_".$result->id."').value;
   document.getElementById('filtre_field_".$result->id."').value = '';
   	document.getElementById('liste".$result->id."').innerHTML = '';
   	if (document.getElementById('text_field_".$result->id."').value.length > 0)
   	{
     nbMatch".$result->id." = 0;
     content".$result->id."='';
     for (var i=0; i < myArray".$result->id.".length; i++)
     {
     	if (myArray".$result->id."[i].slice(0, document.getElementById('text_field_".$result->id."').value.length).toUpperCase() == document.getElementById('text_field_".$result->id."').value.toUpperCase())
     	{
       nbMatch".$result->id."++;
       content".$result->id." += '<div name=\"' + myArrayResult".$result->id."[i] + '\" id=\"gmapfp_list".$result->id."_index' + nbMatch".$result->id." + '\" class=\"result\" onclick=\"fillInput".$result->id."(' + i + ')\">' + myArray".$result->id."[i] + '</div>';
     	}
     }
     if (nbMatch".$result->id.")
     {
     	document.getElementById('liste".$result->id."').innerHTML = content".$result->id.";
     	document.getElementById('liste".$result->id."').style.display = 'block';
     	selIndex".$result->id."=0;
     }
     else
     	document.getElementById('liste".$result->id."').style.display = 'none';
   	}
   	else
   	{
     document.getElementById('liste".$result->id."').style.display = 'none';
   	}
   }
 	}
 	function moveSelection".$result->id."()
 	{
   if (event.keyCode == 40)
   {
   	if (selIndex".$result->id." > 0 && selIndex".$result->id." < nbMatch".$result->id.")
   	{
     document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").className = 'gmapfp_intel_nofocus ';
   	}
   	if (selIndex".$result->id." < nbMatch".$result->id.")
   	{
     selIndex".$result->id."++;
     document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").className = 'gmapfp_intel_focus ';
     document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").focus();
   	}
   	return false;
   }
   else if (event.keyCode == 38)
   {
   	if (selIndex".$result->id." > 1)
   	{
     document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").className = 'gmapfp_intel_nofocus ';
   	}
   	if (selIndex".$result->id." > 1 && selIndex".$result->id." <= nbMatch".$result->id.")
   	{
     selIndex".$result->id."--;
     document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").className = 'gmapfp_intel_focus ';
   	}
   	return false;
   }
   return getGMapFPEnterKey".$result->id."();
 	}
 	function getGMapFPEnterKey".$result->id."()
 	{
   if (event.keyCode == 13)
   {
   	if (selIndex".$result->id." > 0)
   	{
     document.getElementById('text_field_".$result->id."').value = document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").innerText;
     document.getElementById('filtre_field_".$result->id."').value = document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").getAttribute('name');
     document.getElementById('liste".$result->id."').style.display = 'none';
     old".$result->id."=document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").innerText
	 			document.adminForm_GMapFP_filtre.submit();
   	}
   	return false;
   }
   else
   {
   	return true;
   }
 	}
 	function getGMapFPValueKey".$result->id."()
 	{
			setTimeout('getGMapFPValueKeyOK".$result->id."()', 500);
	}
 	function getGMapFPValueKeyOK".$result->id."()
 	{
		if (document.getElementById('liste".$result->id."').style.display == 'block' && document.getElementById('filtre_field_".$result->id."').value == '')
		{
			document.getElementById('filtre_field_".$result->id."').value = document.getElementById('gmapfp_list".$result->id."_index1').getAttribute('name');
     		document.getElementById('liste".$result->id."').style.display = 'none';
   			document.getElementById('text_field_".$result->id."').value = document.getElementById('gmapfp_list".$result->id."_index1').innerText;
		}
		if (document.getElementById('text_field_".$result->id."').value == '')
		{
			document.getElementById('filtre_field_".$result->id."').value = '';
		}
		if (document.getElementById('text_field_".$result->id."').value != old_filtre".$result->id.")
		{
		document.adminForm_GMapFP_filtre.submit();
		}
	}

 -->
 </script>
";
							$ma_list .= "</div>"."\r\n";
							$lists['_field_'.$result->id] = $ma_list;
						}
						break;
				}
			}
		}

        if (!in_array('classement', $hide) and $config->get('gmapfp_filtre_classement', 1)) {
			$filtreclassements = array();
			$filtreclassements[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_CLASSEMENT_FILTRE' ).' --' );
			$cn = 0;
			foreach($this->getlistclassement(1) as $temp) {
				if ($temp['nom']) {
					$cn++;
					$filtreclassements[] = JHTML::_('select.option', $temp['id'], $temp['nom'] );
				};
			}
			$filtreclassement = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_classement', 'filtre_classement', '', 'int' );
			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtreclassements as $tmp_list) {
					$tmp_list2[] = "['".$tmp_list->value."', '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_classement'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtreclassements);
			}else
			if ($cn>1) {
				$lists['_classement'] = JHTML::_('select.genericlist', $filtreclassements, 'filtre_classement', 'size="1" class="inputbox" disabled onchange="'.$action.'"', 'value', 'text', $filtreclassement );
			}
		}

        if (!in_array('label', $hide) and $config->get('gmapfp_filtre_label', 1)) {
			$filtreclassements = array();
			$filtreclassements[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_LABEL_FILTRE' ).' --' );
					$cn = 0;
					foreach($this->getlistclassement(2) as $temp) {
						if ($temp['nom']) {
							$cn++;
							$filtreclassements[] = JHTML::_('select.option', $temp['id'], $temp['nom'] );
						};
					}
			$filtreclassement = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_label', 'filtre_label', '', 'int' );
			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtreclassements as $tmp_list) {
					$tmp_list2[] = "['".$tmp_list->value."', '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_label'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtreclassements);
			}else
			if ($cn>1) {
				$lists['_label'] = JHTML::_('select.genericlist', $filtreclassements, 'filtre_label', 'size="1" class="inputbox" disabled onchange="'.$action.'"', 'value', 'text', $filtreclassement );
			}
		}

        if (!in_array('picto', $hide) and $config->get('gmapfp_filtre_picto', 1)) {
			$filtreclassements = array();
			$filtreclassements[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_PICTO_FILTRE' ).' --' );
					$cn = 0;
					foreach($this->getlistclassement(3) as $temp) {
						if ($temp['nom']) {
							$cn++;
							$filtreclassements[] = JHTML::_('select.option', $temp['id'], $temp['nom'] );
						};
					}
			$filtreclassement = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_picto', 'filtre_picto', '', 'int' );
			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtreclassements as $tmp_list) {
					$tmp_list2[] = "['".$tmp_list->value."', '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_picto'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtreclassements);
			}else
			if ($cn>1) {
				$lists['_picto'] = JHTML::_('select.genericlist', $filtreclassements, 'filtre_picto', 'size="1" class="inputbox" disabled onchange="'.$action.'"', 'value', 'text', $filtreclassement );
			}
		}

        if (!in_array('ville', $hide) and $config->get('gmapfp_filtre_ville', 1)) {
			$filtrevilles = array();
			$filtrevilles[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_VILLE_FILTRE' ).' --' );
					$cn = 0;
					$doublon_filtre ='';
					foreach($this->getlistville() as $temp) {
						if ($temp['ville']) {
							$mon_texte = trim(mb_strtoupper($temp['ville'], 'UTF-8'));
							if ($mon_texte!=$doublon_filtre) {
								$cn++;
								$filtrevilles[] = JHTML::_('select.option', $temp['id'], $mon_texte );
								$doublon_filtre=$mon_texte;
							}
						};
					}
			$filtreville = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_ville', 'filtre_ville', '', 'int' );
			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtrevilles as $tmp_list) {
					$tmp_list2[] = "['".$tmp_list->value."', '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_ville'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtrevilles);
			}else
			if ($cn>1) {
				$lists['_ville'] = JHTML::_('select.genericlist', $filtrevilles, 'filtre_ville', 'size="1" class="inputbox" disabled onchange="'.$action.'"', 'value', 'text', $filtreville );
			}
		}

        if (!in_array('departement', $hide) and $config->get('gmapfp_filtre_departement', 1)) {
			$filtredepartements = array();
			$filtredepartements[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_DEPARTEMENT_FILTRE' ).' --' );
					$cn = 0;
					$doublon_filtre ='';
					foreach($this->getlistdepartement() as $temp) {
						if ($temp['departement']) {
							$mon_texte = trim(mb_strtoupper($temp['departement'], 'UTF-8'));
							if ($mon_texte!=$doublon_filtre) {
								$cn++;
								$filtredepartements[] = JHTML::_('select.option', $temp['id'], $mon_texte );
								$doublon_filtre=$mon_texte;
							}
						};
					}
			$filtredepartement = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_departement', 'filtre_departement', '', 'int' );
			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtredepartements as $tmp_list) {
					$tmp_list2[] = "['".$tmp_list->value."', '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_departement'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtredepartements);
			}else
			if ($cn>1) {
				$lists['_departement'] = JHTML::_('select.genericlist', $filtredepartements, 'filtre_departement', 'size="1" class="inputbox" disabled onchange="'.$action.'"', 'value', 'text', $filtredepartement );
			}
		}

        if (!in_array('pays', $hide) and $config->get('gmapfp_filtre_pays', 1)) {
			$filtrepayss = array();
			$filtrepayss[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_PAYS_FILTRE' ).' --' );
					$cn = 0;
					$doublon_filtre ='';
					foreach($this->getlistpays() as $temp) {
						if ($temp['pay']) {
							$mon_texte = trim(mb_strtoupper($temp['pay'], 'UTF-8'));
							if ($mon_texte!=$doublon_filtre) {
								$cn++;
								$filtrepayss[] = JHTML::_('select.option', $temp['id'], $mon_texte );
								$doublon_filtre=$mon_texte;
							}
						};
					}
			$filtrepays = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_pay', 'filtre_pay', '', 'int' );
			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtrepayss as $tmp_list) {
					$tmp_list2[] = "['".$tmp_list->value."', '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_pay'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtrepayss);
			}else
			if ($cn>1) {
				$lists['_pay'] = JHTML::_('select.genericlist', $filtrepayss, 'filtre_pay', 'size="1" class="inputbox" disabled onchange="'.$action.'"', 'value', 'text', $filtrepays );
			}
		}

        if (!in_array('categories', $hide) and $config->get('gmapfp_filtre_categories', 1)) {
			$root = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_CATEGORIE_FILTRE' ).' --' );
			$filtrecategories = $this->getlistcategorie();
			array_unshift($filtrecategories, $root);
					$cn = 0;
					foreach($filtrecategories as $temp) {
							if (empty($temp->disable)) $cn++;
					}
			$filtrecategorie = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_catid', 'filtre_catid', $config->get('catid_filtre', ''), 'int' );
			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtrecategories as $tmp_list) {
					$tmp_list2[] = "['".$tmp_list->value."', '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_catid'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtrecategories);
			}else
			if ($cn>2) {
				$lists['_catid'] = JHTML::_('select.genericlist', $filtrecategories, 'filtre_catid', 'size="1" class="inputbox" disabled onchange="'.$action.'"', 'value', 'text', $filtrecategorie );
			}
		}

        if (!in_array('search', $hide) and $config->get('gmapfp_filtre_search', 1)) {
			$search_gmapfp = $mainframe->getUserStateFromRequest( $option.$Itemid.'search_gmapfp', 'search_gmapfp', '',    'string' );
			$search['search_gmapfp'] = $search_gmapfp;
		}
		// die(print_r($lists));
		return array($lists, $search);
	}
	
    function getChamps($id)
    {
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
        $db = JFactory::getDBO();

 		//filtre par langue
		$mainframe	= JFactory::getApplication();
        $params		= clone($mainframe->getParams('com_gmapfp'));
		$tag = JFactory::getLanguage()->getTag();
		$join = '';
		$case = '';
		$parametres = ', a.parametres, a.nom as label';
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='(c.langue = ' . $db->Quote($tag).' OR c.langue IS NULL)';
			$join = ' LEFT OUTER JOIN #__gmapfp_extension_lang AS c on a.id = c.typeid';
			$case = ', CASE WHEN CHAR_LENGTH(c.nom) THEN c.nom ELSE a.nom END as label, '.
                ' CASE WHEN CHAR_LENGTH(c.parametres) THEN c.parametres ELSE a.parametres END as parametres ';
			$parametres = '';
		}
		
		$wheres[] ='a.published = 1';
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';

       $db = JFactory::getDBO();
        $query = ' SELECT a.alias, a.description, a.position, a.for_cat, a.catid, a.ordering, a.type, a.field_separator, a.view_separator, a.id'.$parametres.
                $case.
                ' FROM #__gmapfp_extension_type as a'.
        		$join.
                ' WHERE ' . implode( '  AND ', $wheres ).
				' ORDER BY a.ordering';
        $db->setQuery( $query );
        $results = $db->loadObjectList('id');
		//die(print_r($query));

		if ($results)
		foreach ($results as $key => $result) {
			if (!in_array($result->type, array(21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37))) {
				$query = ' SELECT id, `field_'.$key.'`, catid'.
						' FROM #__gmapfp'.
						' WHERE id = '.$id;
				$db->setQuery( $query );
				$valeur = $db->loadAssoc();
				$check_cat = array_intersect (explode(',' ,$valeur['catid']), explode(',' ,$result->catid));
			}
			$results[$key]->valeur = '';
			if(!$result->for_cat or !empty($check_cat))
			switch ($result->type) {
				case 0 :
				case 1 :
				case 2 :
				case 9 :
				case 10:
				case 11:
				case 12:
				case 13:
				case 15:
				case 16:
				case 17:
				case 18:
				case 19:
				case 20:
					$results[$key]->valeur = $valeur['field_'.$key];
					break;
				case 3 :
				case 4 :
				case 5 :
				case 6 :
					$monTableauIndexs = explode("\n", trim($valeur['field_'.$key]));
					if (count($monTableauIndexs)) {
						$monTableauValeurs = array();
						foreach (explode("\n", $results[$key]->parametres) as $monTableauValeur) {
							$monTableauValeurs[substr($monTableauValeur, 0, strpos($monTableauValeur, '::', 0))] = substr(strstr($monTableauValeur, '::', 0),2);
						}
						$valeur = array();
						foreach ($monTableauIndexs as $monTableauIndex) {
							$monTableauIndex = trim($monTableauIndex);
							if ($monTableauIndex!='' && array_key_exists($monTableauIndex, $monTableauValeurs)) {
								$valeur[] = $monTableauValeurs[$monTableauIndex];
							}
						}
						$results[$key]->valeur = implode("\n", $valeur);
					}
					break;
				case 7 :
				case 8 :
					$results[$key]->valeur = $results[$key]->parametres;
					break;
			}
		}

       return $results;
    }
    
    function _getWhereFilters($param)
    {
		$mainframe = JFactory::getApplication(); 
		$Itemid	   = $mainframe->input->get('Itemid');
		$option	   = $mainframe->input->get('option');
        $params = clone($mainframe->getParams('com_gmapfp'));
		$wheres = array();
		
		if ($this->ajax and $param == -1) {
			$filtreville = '';
			$filtredepartement = '';
			$filtrepays = '';
			$filtrecategorie = '';
			$where_cats = array();
			if ($this->ajax_fields_filters)
			foreach ($this->ajax_fields_filters as $ajax_filter) {
				//if (substr($ajax_filter, strpos($ajax_filter, '=') + 1) != '0')
					switch (substr($ajax_filter, 0, 3)) {
						case 'vil' :
							$wheres[] = 'a.ville = \''.addslashes($this->_getVilleByID(substr($ajax_filter, strpos($ajax_filter, '=') + 1))).'\'';
							break;
						case 'dep' :
							$wheres[] = 'a.departement = \''.addslashes($this->_getDepartementByID(substr($ajax_filter, strpos($ajax_filter, '=') + 1))).'\'';
							break;
						case 'pay' :
							$wheres[] = 'a.pay = \''.addslashes($this->_getPaysByID(substr($ajax_filter, strpos($ajax_filter, '=') + 1))).'\'';
							break;
						case 'cat' :
							// $where_cats[] = 'a.catid = \''.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'\'';
							$where_cats[] = '(a.catid LIKE "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.catid LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.' OR a.catid LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.catid = "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.')';
							break;
						case 'cla' :
							$wheres[] = '(a.classements LIKE "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.classements LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.' OR a.classements LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.classements = "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.')';
							break;
						case 'lab' :
							$wheres[] = '(a.labels LIKE "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.labels LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.' OR a.labels LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.labels = "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.')';
							break;
						case 'pic' :
							$wheres[] = '(a.pictos LIKE "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.pictos LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.' OR a.pictos LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.pictos = "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.')';
							break;
					}
			}
			if ($where_cats) $wheres[] = '('.implode(' or ',$where_cats).')';
		} else {
			$filtreville = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_ville', 'filtre_ville', '', 'int' );
			$filtredepartement = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_departement', 'filtre_departement', '', 'int' );
			$filtrepays = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_pay', 'filtre_pay', '', 'int' );
			$filtrecategorie = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_catid', 'filtre_catid', $params->get('catid_filtre', ''), 'int' );
			$filtreclassement = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_classement', 'filtre_classement', '', 'int' );
			$filtrelabel = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_label', 'filtre_label', '', 'int' );
			$filtrepicto = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_picto', 'filtre_picto', '', 'int' );
		
			if ((!empty($filtreville)) and ($param != 6))
				$wheres[] = 'a.ville = \''.addslashes($this->_getVilleByID($filtreville)).'\'';
			if ((!empty($filtredepartement)) and ($param != 7))
				$wheres[] = 'a.departement = \''.addslashes($this->_getDepartementByID($filtredepartement)).'\'';
			if ((!empty($filtrepays)) and ($param != 8))
				$wheres[] = 'a.pay = \''.addslashes($this->_getPaysByID($filtrepays)).'\'';
			if ((!empty($filtrecategorie)) and ($param != 9))
				$wheres[] = '(a.catid LIKE "'.$filtrecategorie.',%"'.' OR a.catid LIKE "%,'.$filtrecategorie.'"'.' OR a.catid LIKE "%,'.$filtrecategorie.',%"'.' OR a.catid = "'.$filtrecategorie.'"'.')';
			if ((!empty($filtreclassement)))
				$wheres[] = '(a.classements LIKE "'.$filtreclassement.',%"'.' OR a.classements LIKE "%,'.$filtreclassement.'"'.' OR a.classements LIKE "%,'.$filtreclassement.',%"'.' OR a.classements = "'.$filtreclassement.'"'.')';
			if ((!empty($filtrelabel)))
				$wheres[] = '(a.labels LIKE "'.$filtrelabel.',%"'.' OR a.labels LIKE "%,'.$filtrelabel.'"'.' OR a.labels LIKE "%,'.$filtrelabel.',%"'.' OR a.labels = "'.$filtrelabel.'"'.')';
			if ((!empty($filtrepicto)))
				$wheres[] = '(a.pictos LIKE "'.$filtrepicto.',%"'.' OR a.pictos LIKE "%,'.$filtrepicto.'"'.' OR a.pictos LIKE "%,'.$filtrepicto.',%"'.' OR a.pictos = "'.$filtrepicto.'"'.')';
		}

		//traitement des filtres customs
		$results = $this->getDataFilterList();
		if ($results)
			foreach ($results as $result) {
				if ($params->get('gmapfp_log', 0) and $wheres) JLog::add('category => GMapFP:_getWhereFilters/result, message => result->id = '.$result->id, JLog::INFO, 'com_gmapfp');
				$filtre = '';
				if ($params->get('gmapfp_log', 0) and $wheres) JLog::add('category => GMapFP:_getWhereFilters/result, message => ajax = '.$this->ajax, JLog::INFO, 'com_gmapfp');
				if ($this->ajax_fields_filters and $params->get('gmapfp_log', 0) and $wheres) JLog::add('category => GMapFP:_getWhereFilters/result, message => ajax_fields_filters = '.implode('///', $this->ajax_fields_filters), JLog::INFO, 'com_gmapfp');
				if ($this->ajax and $this->ajax_fields_filters) {
					foreach ($this->ajax_fields_filters as $ajax_filter) {
				if ($params->get('gmapfp_log', 0) and $wheres) JLog::add('category => GMapFP:_getWhereFilters/result, message => ajax_filter = '.$ajax_filter, JLog::INFO, 'com_gmapfp');
						if (substr($ajax_filter, 0, strpos($ajax_filter, '=')) == 'field_'.$result->id) {
							$filtre = substr($ajax_filter, strpos($ajax_filter, '=') + 1);
							if ($params->get('gmapfp_log', 0) and $wheres) JLog::add('category => GMapFP:_getWhereFilters/result, message => filtre = '.$filtre, JLog::INFO, 'com_gmapfp');
							break;
						}
					}
				} else {
					$filtre = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_field_'.$result->id, 'filtre_field_'.$result->id, '', 'int' );
				}
				if ($params->get('gmapfp_log', 0) and $wheres) JLog::add('category => GMapFP:_getWhereFilters/result, message => filtre = '.$filtre.' / Result->type = '.$result->type, JLog::INFO, 'com_gmapfp');
				if (!empty($filtre)) {
					if ($result->type == '0') {
						if ($param != 10) $wheres[] = 'a.field_'.$result->id.' = "'.self::get_field_value($result->id, $filtre).'"';
					} else {
						$wheres[] = '(a.field_'.$result->id.' LIKE "'.$filtre.'\r\n%"'.' OR a.field_'.$result->id.' LIKE "%\n'.$filtre.'\r\n%"'.' OR a.field_'.$result->id.' LIKE "%\r\n'.$filtre.'"'.' OR a.field_'.$result->id.' = "'.$filtre.'"'.')';
					}
				}   
			}
		if ($params->get('gmapfp_log', 0) and $wheres) JLog::add('category => GMapFP:_getWhereFilters/wheres, message => Ajax = '.($this->ajax and $param == -1).' __ '.implode(',', $wheres).'_time:='.time(), JLog::INFO, 'com_gmapfp');
        //die(print_r($wheres));
		if (@$wheres) {return $wheres;}else{return false;};
    }

	private function get_field_value($field_id, $gmapfp_id)
	{
        $db     	= JFactory::getDBO();
		
		$query = 'SELECT field_'.$field_id.
				' FROM #__gmapfp' .
				' WHERE id = '.$gmapfp_id;
		$db->setQuery( $query );
		return $db->loadResult();
	}
	
    function _getWhereQuery()
    {
		$mainframe	= JFactory::getApplication(); 
		$Itemid		= $mainframe->input->get('Itemid');
		$option		= $mainframe->input->get('option');
        $db     	= JFactory::getDBO();
        $params 	= clone($mainframe->getParams('com_gmapfp'));
		$search_gmapfp = '';

		//debug
		if ($params->get('gmapfp_log', 0)) JLog::add('category => GMapFP:make_places/_getWhereQuery, message => $this->ajax = '.$this->ajax, JLog::INFO, 'com_gmapfp');
        //detection de la prsence de JoomFish
        $file = JPATH_ADMINISTRATOR.'/components/com_joomfish/joomfish.php';
        if(!file_exists($file)) {
        //Recherche directe dans la base de donne. Pas possible avec JoomFish car traduction faite a la restitution des donnes dans la base.
			if ($this->ajax and $this->ajax_fields_filters) {
				foreach ($this->ajax_fields_filters as $ajax_filter) {
					if (substr($ajax_filter, 0, 6) === 'search') {
						$search_gmapfp = substr($ajax_filter, strpos($ajax_filter, '=') + 1);
						if ($params->get('gmapfp_log', 0)) JLog::add('category => GMapFP:make_places/_getWhereQuery, message => champ search detect = '.$ajax_filter.' / '.substr($ajax_filter, 0, 6).' / '.$search_gmapfp.'_time:='.time(), JLog::INFO, 'com_gmapfp');
						break;
					}
				}
			} else {
				$search_gmapfp = $mainframe->getUserStateFromRequest( $option.$Itemid.'search_gmapfp', 'search_gmapfp', '',    'string' );
			}
			$search_gmapfp = JString::strtolower($search_gmapfp);

            if ($search_gmapfp) {
				$words = explode( ' ', $search_gmapfp );
				$wheres1 = array();
				
				//recherche des champs pesro  utiliser pour la recherche pas mots cls
				$query = 'SELECT id' .
						' FROM #__gmapfp_extension_type' .
						' WHERE recherche = 1';
				$db->setQuery( $query );
				$result_champs_persos = $db->loadObjectList('id');
				
				foreach ($words as $word) {
					$word		= $db->quote( '%'.$db->escape( $word, true ).'%', false );
					$wheres2 	= array();
					$wheres2[] 	= 'a.nom LIKE '.$word;
					$wheres2[] 	= 'a.introtext LIKE '.$word;
					$wheres2[] 	= 'a.fulltext LIKE '.$word;
					$wheres2[] 	= 'a.adresse LIKE '.$word;
					$wheres2[] 	= 'a.adresse2 LIKE '.$word;
					$wheres2[] 	= 'a.codepostal LIKE '.$word;
					$wheres2[] 	= 'a.ville LIKE '.$word;
					$wheres2[] 	= 'a.departement LIKE '.$word;
					$wheres2[] 	= 'a.pay LIKE '.$word;
					$wheres2[] 	= 'a.horaires_prix LIKE '.$word;
					$wheres2[] 	= 'a.metakey LIKE '.$word;
					$wheres2[] 	= 'a.metadesc LIKE '.$word;
					if ($result_champs_persos)
						foreach ($result_champs_persos as $champ_perso => $value) {
							$wheres2[] 	= 'a.field_'.$champ_perso.' LIKE '.$word;
						}
					$wheres1[] 	= implode( ' OR ', $wheres2 );
				}
				$wheres[] = '(' . implode( ') AND (', $wheres1 ) . ')';
            }
        };

        $result = $this->_getWhereFilters(-1);
		if ($result)
            $wheres[] = implode( "\n  AND ", $result);

		if (@$wheres) {return $wheres;}else{return false;};
    }
		
    function getWhereQueryMenu()
	{
		$app		= JFactory::getApplication(); 
        $params 	= $app->getParams('com_gmapfp');
		$wheres		= array();
       
		$user_where = $params->get('gmapfp_filtre_sql');
		if (!empty($user_where))
			$wheres[] = '('.$user_where.')';
        
		$user_where = $params->get('gmapfp_filtre_sql_map');
		if (!empty($user_where) and $this->is_map)
			$wheres[] = '('.$user_where.')';
        
		$user_where = $params->get('gmapfp_filtre_sql_liste');
		if (!empty($user_where) and !$this->is_map)
			$wheres[] = '('.$user_where.')';

		if (@$wheres) {return $wheres;}else{return false;};
    }

    public function _getQuery()
    {
		$app		= JFactory::getApplication();
		$Itemid		= $app->input->get('Itemid');
        $params		= $app->getParams('com_gmapfp');

        $tri = $params->get('orderby_pri');

		$tag = JFactory::getLanguage()->getTag();

        $db     = JFactory::getDBO();
        $now    = JFactory::getDate();
        $nullDate = $db->getNullDate();
		$wheres = array();
        
		$user_order = $params->get('gmapfp_order_by');
		if (!empty($user_order))
			$order = $user_order;
		else
			switch ($tri) {
			case 'alpha' :
				$order = "a.nom";
				break;
			case 'ralpha' :
				$order = "a.nom DESC";
				break;
			case 'ville' :
				$order = "a.ville, a.nom";
				break;
			case 'rville' :
				$order = "a.ville DESC, a.nom DESC";
				break;
			case 'pays' :
				$order = "a.pay, a.departement, a.ville, a.nom";
				break;
			case 'rpays' :
				$order = "a.pay DESC, a.departement DESC, a.ville DESC, a.nom DESC";
				break;
			case 'paysvilles' :
				$order = "a.pay, a.ville, a.nom";
				break;
			case 'rpaysvilles' :
				$order = "a.pay DESC, a.ville DESC, a.nom DESC";
				break;
			case 'order' :
				$order = "a.ordering";
				break;
			case 'created_date' :
				$order = "a.created, a.nom";
				break;
			case 'published_date' :
				$order = "a.publish_up, a.nom";
				break;
			case 'modifed_date' :
				$order = "a.modified, a.nom";
				break;
			default :
				$order = "";
				break;
			}
		
		$tmp_img = $params->get('blank_image', 'non_disponible.gif');
		$tmp_img = 'blank/' . $tmp_img;
        $select = 'a.*,'.
		//ligne spcial JoomFish et title pour ItemRating
				' a.id as key1,  m.id as key3, v.id as key4, c.id as key5, "" as title,'.
				' IF(a.img="", "'.$tmp_img.'", a.img) as img,'.
                ' m.url as m_url, m.marker_width as m_width, m.marker_height as m_height, m.centre_x as m_x, m.centre_y as m_y, m.url_shadow as m_shadow, m.shadow_width as m_s_width, m.shadow_height as m_s_height, m.optimized as m_optimized, '.
				' v.email as author_email,  v.name as author, '.
				' c.catid as article_id, '.
                ' (SELECT d.alias FROM #__categories AS d WHERE d.id=c.catid) as article_alias , '.
                ' (SELECT d.id FROM #__categories AS d WHERE d.id=c.catid) as article_id , '.
                ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as article_slug, '.
                ' CONCAT(c.introtext, c.fulltext) as article_text, '.
                ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug ';
        $from   = '#__gmapfp AS a';
        $joins[] = 'LEFT OUTER JOIN #__gmapfp_marqueurs AS m ON a.index_marqueur = m.id';
        $joins[] = 'LEFT OUTER JOIN #__content AS c ON a.article_id = c.id';
        $joins[] = 'LEFT OUTER JOIN #__users AS v ON v.id = a.created_by';

        $wheres[] = 'a.published = 1';
        $wheres[] = '(m.published = 1 OR a.index_marqueur = 0 OR a.index_marqueur IS NULL)';
        
		// Filter by access level.
			$user	= JFactory::getUser();
			$groups	= implode(',', $user->getAuthorisedViewLevels());
			$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';
		//}

        $wheres[] = '( a.publish_up is NULL OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down is NULL OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

		// Filter by featured
		switch($params->get('featured', 0)){
			case 1:
				$wheres[] = 'a.featured = 0';
				break;
			case 2:
				$wheres[] = 'a.featured = 1';
				break;
		}
		
		// Filter by language
		if ($app->isSite() && $app->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}

        $autorise_filtre = true;
		//si il faut afficaher un id, on ne fait pas de filtre sur les catgories afin dviter d'afficher une page 404 suite  un problme de route Joomla
		if (!empty($this->_id)){
			$wheres[] = 'a.id = '.$this->_id.'';
        	$autorise_filtre = false; //si affichage d'un id de place demander, n'active pas les filtre car demande module ou autre.
        } else {
			if ($this->_catid) {
				$_catids = $this->enfants_catid($this->_catid);
				foreach ($_catids as $_catid)
				{
					$wheresOr[] = '(a.catid LIKE "'.$_catid.',%"'.' OR a.catid LIKE "%,'.$_catid.',%"'.' OR a.catid LIKE "%,'.$_catid.'"'.' OR a.catid = "'.$_catid.'")';
				}
				$wheres[] = '('.implode( "\n OR ", $wheresOr).')';
			}

			//rcupre les infos des filtres des paramtres du menu
			$result = $this->getWhereQueryMenu();
			if ($result)
				$wheres[] = implode( "\n  AND ", $result);
        };
		
		//affiche les infos du carnet de voyage
		$orderbyfield ='';
		if (!$this->_catid and !$this->_id and $this->_ids){
			$ids = explode(',', $this->_ids);
			$wheresOr = array();
			foreach($ids as $id) {
				$wheresOr[] = 'a.id = '.$id.'';
			}
            $wheres[] = '('.implode( "\n OR ", $wheresOr).')';
			$orderbyfield = ' ORDER BY FIELD('.$db->quoteName("a.id").', "'.implode('","',  $ids).'")';
		}
		
        //recupre les infos des filtres si actif 
        if ((($params->get('gmapfp_filtre')>=1) or $this->ajax) and $autorise_filtre) {
            if ($params->get('gmapfp_filtre', 0) == 1 or !file_exists(JPATH_SITE.'/components/com_search_gmapfp/models/search.php')) {
				$result = $this->_getWhereQuery();
				if ($result)
					$wheres[] = implode( "\n  AND ", $result);
			} else {
				require_once(JPATH_SITE.'/components/com_search_gmapfp/models/search.php');
				$search_model = new Search_GMapFPModelSearch;
				$return_search_filter = $search_model->getWhere(1);
				if (!empty($return_search_filter)){
					$search_filter = $return_search_filter[0];
					if ($search_filter)
						$wheres[] = implode( "\n  AND ", $search_filter);
					//si filtre par rayon autour d'un point, calcul la distance en km
					if ($return_search_filter[2]) {
						$select .= $return_search_filter[2];
						if ($order) $order = 'distance, '.$order;
						else $order = 'distance';
					}
				}
			}
        }
		// die(print_r($select));
		if ($order) $order = "\n ORDER BY ".$order;
		
        $query = "SELECT " . $select .
                "\n FROM " . $from .
                "\n " . implode ( ' ', $joins ) .
                "\n WHERE " . implode( "\n  AND ", $wheres ).
                $order.$orderbyfield;
		// die(print_r($wheres));
		// die(print_r($query));
        return $query;
    }

    //utilis dans affichage "Catgories" et dans "Ligne de Bus"
	function getQuery_Cat_Displayed()
    {
		$mainframe = JFactory::getApplication(); 
        $params = clone($mainframe->getParams('com_gmapfp'));
		$tag 	= JFactory::getLanguage()->getTag();
        $tri = $params->get('orderby_pri');

        $db     = JFactory::getDBO();
        $now    = JFactory::getDate();
        $nullDate = $db->getNullDate();

		// Filter by access level.
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';
        
		// Filter by language
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}
        
		$user_where = $params->get('gmapfp_filtre_sql');
		if (!empty($user_where))
			$wheres[] = '('.$user_where.')';

        $select = 'a.catid';
		$from   = '#__gmapfp AS a';

        $wheres[] = 'a.published = 1';
        $wheres[] = '( a.publish_up is NULL OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down is NULL OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

		if ($this->_catid) {
        	$_catids = $this->enfants_catid($this->_catid);
            foreach ($_catids as $_catid)
            {
				$wheresOr[] = '(a.catid LIKE "'.$_catid.',%"'.' OR a.catid LIKE "%,'.$_catid.',%"'.' OR a.catid LIKE "%,'.$_catid.'"'.' OR a.catid = "'.$_catid.'")';
            }
            $wheres[] = '('.implode( "\n OR ", $wheresOr).')';
        };

        if (!empty($this->_id))
        {
            $wheres[] = 'a.id = '.$this->_id.'';
        };

        //recupre les infos des filtre si actif 
        if ($params->get('gmapfp_filtre')>=1) {
			if ($params->get('gmapfp_filtre', 0) == 1) {
				$result = $this->_getWhereQuery();
				if ($result)
					$wheres[] = implode( "\n  AND ", $result);
			} else {
				require_once('/components/com_search_gmapfp/models/search.php');
				$search_model = new Search_GMapFPModelSearch;
				$search_filter = $search_model->getWhere(1);
				$search_filter = $search_filter[0];
				if ($search_filter)
					$wheres[] = implode( "\n  AND ", $search_filter);
			}
        }

        $query = "SELECT " . $select .
                "\n FROM " . $from .
                "\n WHERE " . implode( "\n  AND ", $wheres );
        $results = $this->_getList( $query );

		$cats = array();
		$return = array();
		foreach($results as $result) {
			$info_cat = new stdclass;
			$tmps = explode(',', $result->catid);
			foreach($tmps as $tmp){
				if(!in_array($tmp, $cats)) {
					$cats[] = $tmp;
					$info_cat->catid = $tmp;
					$info_cat->title = $this->_cat_datas[$tmp]->title;
					$info_cat->catalias = $this->_cat_datas[$tmp]->catalias;
					$info_cat->cat_params = $this->_cat_datas[$tmp]->cat_params;
					$return[$this->_cat_datas[$tmp]->lft] = $info_cat;
				}
			}
		}
		ksort($return); //Tri les catgorie par ordre
		return $return;
    }
	
    function getCats_Items()
	{
		if(!is_array($this->_cat_items) OR !count($this->_cat_items))
		{
			$app = JFactory::getApplication();
			$menu = $app->getMenu();
			$active = $menu->getActive();
			$params = new JRegistry();
			if($active)
			{
				$params->loadString($active->params);
			}

			$options = array();
			$options['countItems'] = 0;
			$categories = JCategories::getInstance('GMapFP', $options);
			$this->_cat_parent = $categories->get($params->get('catid', 'root'));
			if(is_object($this->_cat_parent))
			{
				$this->_cat_items = $this->_cat_parent->getChildren();
			} else {
				$this->_cat_items = false;
			}
		}

		return $this->_cat_items;
	}

	public function getCats_Parent()
	{
		if(!is_object($this->_cat_parent))
		{
			$this->getCats_Items();
		}
		return $this->_cat_parent;
	}

	function getCatInfos($element, $id)
	{
		$db	= JFactory::getDBO();
		$query = "SELECT ".$element.
				"\n FROM #__categories" .
				"\n WHERE id = ".$id;
    	$db->setQuery( $query );
		$result = $db->loadColumn();
		return $result;
	}

    function setId_Perso($id='')
    {
		$this->_id_perso = $id;
	}
	
    function getPersonnalisation($id='')
    {
		if (!empty($id))
			$this->_id_perso = $id;

		if ($this->_id_perso) {
			$db = JFactory::getDBO();
			$query = "SELECT *" .
					"\n FROM #__gmapfp_personnalisation" .
					"\n WHERE id = '".$this->_id_perso."'";

			if (empty($this->_result_personnalisation))
			{
				$db->setQuery( $query );
				$this->_result_personnalisation = $db->loadObject();
			}
        }
		return @$this->_result_personnalisation;
    }
    
    function getTotal()
    {
        // Lets load the content if it doesn't already exist
        if (empty($this->_total))
        {
			$query = $this->_getQuery();
            $this->_total = $this->_getListCount($query);
        }
        return $this->_total;
    }
    
    function _getQueryPlugin( $options, $where_field='' )
    {
		$mainframe 	= JFactory::getApplication(); 
        $db         = JFactory::getDBO();
        $now    	= JFactory::getDate();
        $nullDate 	= $db->getNullDate();

		if (!empty($options)){	
			foreach ($options as $option)
				{
					$wheresOr[]= 'a.id = \''.$option.'\'';
				}
			$wheres[]="(".implode( "\n OR ", $wheresOr ).")";
		}
		if (!empty($where_field)) {$wheres[]=$where_field;}

        $select = 'a.*, '.
		//ligne spcial JoomFish
				' a.id as key1, m.id as key3, v.id as key4, c.id as key5,'.
                ' m.url as m_url, m.marker_width as m_width, m.marker_height as m_height, m.centre_x as m_x, m.centre_y as m_y, m.url_shadow as m_shadow, m.shadow_width as m_s_width, m.shadow_height as m_s_height, '.
				' v.email as author_email,  v.name as author, '.
				' c.catid as article_id, '.
                ' (SELECT d.alias FROM #__categories AS d WHERE d.id=c.catid) as article_alias , '.
                ' (SELECT d.id FROM #__categories AS d WHERE d.id=c.catid) as article_id , '.
                ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as article_slug, '.
                ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug ';
        $from   = '#__gmapfp AS a';
        $joins[] = 'LEFT OUTER JOIN #__gmapfp_marqueurs AS m on a.index_marqueur = m.id';
        $joins[] = 'LEFT OUTER JOIN #__content AS c on a.article_id = c.id';
        $joins[] = 'LEFT OUTER JOIN #__users AS v ON v.id = a.created_by';

        $wheres[] = 'a.published = 1';
		//supprimer pour cause de marqueur par dfaut qui n'existe pas!
        //$wheres[] = 'm.published = 1';
        
		// Filter by access level.
		//if ($access = $this->getState('filter.access')) {
			$user	= JFactory::getUser();
			$groups	= implode(',', $user->getAuthorisedViewLevels());
			$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';
		//}

        $wheres[] = '( a.publish_up is NULL OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down is NULL OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

        $query = "SELECT " . $select .
                "\n FROM " . $from .
                "\n " . implode ( ' ', $joins ) .
                "\n WHERE " . implode( "\n  AND ", $wheres );
		return $query;
    }
    
    function _getQueryPluginCatid( $options, $where_field='' )
    {
        $db         = JFactory::getDBO();

        foreach ($options as $option)
        {
			$wheresOr[] = '(a.catid LIKE "'.$option.',%"'.' OR a.catid LIKE "%,'.$option.',%"'.' OR a.catid LIKE "%,'.$option.'"'.' OR a.catid = "'.$option.'")';
        }
        $wheres[]="(".implode( "\n OR ", $wheresOr ).")";
		if (!empty($where_field)) {$wheres[]=$where_field;}

        $select = 'a.*, c.catid as article_id, '.
		//ligne spcial JoomFish
				' a.id as key1, m.id as key3, c.id as key5,'.
                ' m.url as m_url, m.marker_width as m_width, m.marker_height as m_height, m.centre_x as m_x, m.centre_y as m_y, m.url_shadow as m_shadow, m.shadow_width as m_s_width, m.shadow_height as m_s_height, '.
                ' (SELECT d.alias FROM #__categories AS d WHERE d.id=c.catid) as article_alias , '.
                ' (SELECT d.id FROM #__categories AS d WHERE d.id=c.catid) as article_id , '.
                ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug, '.
                ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as article_slug ';
        $from   = '#__gmapfp AS a';
        $joins[] = 'LEFT OUTER JOIN #__gmapfp_marqueurs AS m on a.index_marqueur = m.id';
        $joins[] = 'LEFT OUTER JOIN #__content AS c on a.article_id = c.id';

        $wheres[] = 'a.published = 1';

		// Filter by access level.
		//if ($access = $this->getState('filter.access')) {
			$user	= JFactory::getUser();
			$groups	= implode(',', $user->getAuthorisedViewLevels());
			$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';
		//}

        $query = "SELECT " . $select .
                "\n FROM " . $from .
                "\n " . implode ( ' ', $joins ) .
                "\n WHERE " . implode( "\n  AND ", $wheres );

        return $query;
    }
    
    public function getGMapFPList()
    {
        $db     = JFactory::getDBO();
		$query  = $this->_getQuery();
		$result = $this->_getList( $query );
		$this->_total = count($result);
        return $result;
    }
    
    function getView()
    {
		$app			= JFactory::getApplication(); 
		$input			= $app->input;
		$Itemid			= $input->get('Itemid', '', 'int');
		$map_layout		= $input->get('layout', '', 'string'); 
		$flag			= $input->get('flag', ($map_layout=="article"), 'int');

		$doc			= JFactory::getDocument();
		
		//pour liaision avec module de recherche, utilie le numro du menu si affichage GMapFP, sinon numro alatoire.
		$menus	= $app->getMenu('site');
		$active = $menus->getActive();
		if (is_object($active) and property_exists($active, 'component') and $active->component == 'com_gmapfp') {
			$this->num		= $active->component_id;
		} else {
			$this->num		= rand();
		}

		// ajout du lien de contenu des infos des places pour la carte
		if ($map_layout) $map_layout = '&map_layout='.$map_layout;
		if ($flag) $flag = '&flag='.$flag; else $flag = '';
		if ($ids = $input->get('map_ids', '', 'string')) $flag .= '&map_ids='.$ids;
		if ($id = $input->get('map_id', '', 'int')) $flag .= '&map_id='.$id;
		if ($catid = $input->get('map_catid', '', 'int')) $flag .= '&map_catid='.$catid;
		$lng = '';
		$tmp = JURI::getInstance();
		$base = $tmp->getHost();
		if ($input->get->get('lang', null) and $base<>'localhost' and $base<>'127.0.0.1') $lng = '&lang='.$input->get->get('lang').'/';
		unset($tmp, $base);
		$ajax_url = "index.php?option=com_gmapfp&controller=gmapfpajax&task=rebuilt".$flag."&Itemid=".$Itemid.$lng;
		$doc->addCustomTag( '<script type="text/javascript">
			var GMapFP_Ajax_Url'.$this->num.'="'.$ajax_url.'";
		</script>');

		$map    = $this->getCarte('', '', 0, 0, 0, $this->num, '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, '');

        return $map;
    }

    //Integration des donnes du plugin
    function getViewPlugin($ids, $num, $Hmap='0', $Lmap='0', $Zmap='0', $Itin='0', $bar_PSM='0', $bar_z_nav='0', $Ech='0', $click_over='0', $MZoom='0', $ZZoom='0', $map_phy='0', $map_nor='0', $map_sat='0', $map_hyb='0', $map_choix='0', $kml_file='0', $map_earth='0', $map_centre_lng='0', $map_centre_lat='0', $plugcatids = '', $More='0', $map_centre_id='0', $where='', $plus_detail='0')
    {
 		$app 		= JFactory::getApplication();
		$config 	= $app->getParams('com_gmapfp');//parametre de l'item
		$itemid 	= $app->input->get('Itemid', 	0, 'int');
		$_layout 	= $app->input->get('layout', '', 'string');
		$flag       = $app->input->get('flag',($_layout=="article"), 'int');
		$itineraire = $app->input->get('itineraire', 0, 'int');

		//rechercher du centrage d'un id
        if ($map_centre_id!=0) {
            $map_centre_ids[]=$map_centre_id;
            $query  = $this->_getQueryPlugin($map_centre_ids);
            $result = $this->_getList( $query );
			if ($result) {
				$map_centre_lng = $result[0]->glng;
				$map_centre_lat = $result[0]->glat;
				if ($Zmap==0) {
					$Zmap = $result[0]->gzoom;
				};
			}
        }

        //recherche des catgories des groupes de catgories
        if ($plugcatids!=0) {
			$catids = array();
            foreach ($plugcatids as $plugcatid) {
				$catids = array_merge($catids, $this->enfants_catid($plugcatid));
            };
        }else{
            $catids = array();
        };

		//appel de la carte
		$map    = $this->getCarte('', '', $map_centre_lat, $map_centre_lng, 1, $num, $Hmap, $Lmap, $Zmap, $Itin, $bar_PSM, $bar_z_nav, $Ech, $click_over, $MZoom, $ZZoom, $map_phy, $map_nor, $map_sat, $map_hyb, $map_choix, $kml_file, $map_earth, $More, '', $plus_detail);

		//JURI::base(false). => ajouter pour fonctionnement correcte avec sh404sef
		$ajax_url = "index.php?option=com_gmapfp&controller=gmapfpajax&task=rebuilt&flag=".$flag."&Itemid=".$itemid;
		// ajout du lien de contenu des infos des places pour la carte
		$ajax_url .= '&map_num='.$num;
		if ($ids) $ajax_url .= '&map_ids='.implode(',', $ids);
		if ($catids) $ajax_url .= '&map_cats='.implode(',', $catids);
		if ($where) $ajax_url .= '&map_where='.$where;
		if ($click_over) $ajax_url .= '&map_click_over='.$click_over;
		if ($plus_detail) $ajax_url .= '&map_plus_detail='.$plus_detail;

		$doc	= JFactory::getDocument();
		$doc->addCustomTag( '<script type="text/javascript">
			var GMapFP_Ajax_Url'.$num.'="'.$ajax_url.'";
		</script>');

		$return = $map['map'];
		if ((($config->get('gmapfp_itineraire') == 1) and ($Itin == 0)) or ($Itin == 1) or $itineraire) {
			$return .= '<legend style="float:left;">'.JText::_( 'GMAPFP_DIRECTION' ).'</legend>';
			$return .= $map['iti'];
		}

		return $return;
    }
    
    function getCarte ($rows, $NU_2 = false, $glat_plugin = '', $glng_plugin = '', $plugin = '', $num = '', $Hmap = '', $Lmap = '', $Zmap = '',  $Itin='0', $bar_PSM='0', $bar_z_nav='0', $Ech='0', $event_control='0', $MZoom='0', $ZZoom='0', $map_phy='0', $map_nor='0', $map_sat='0', $map_hyb='0', $map_choix='0', $kml_file='0', $map_earth='0', $More='0', $NU_1='', $plus_detail='0')
    {
		require_once(JPATH_ROOT.'/components/com_gmapfp/helpers/define.php');
		Define_ModelGMapFP::define_gmapfp($this->ajax);

		$app 		= JFactory::getApplication();
		//$config 	= JComponentHelper::getParams('com_gmapfp');//parametre du composant
		$config 	= $app->getParams('com_gmapfp');//parametre de l'item
		$doc		= JFactory::getDocument();
		
		$itineraire = $app->input->get('itineraire', 0, 'int');
		$affichage  = $app->input->get('affichage', '0', 'string');
		$itemid 	= $app->input->get('Itemid', 	0, 'int');
		$_layout 	= $app->input->get('layout', '', 'string');
		$flag       = $app->input->get('flag',($_layout=="article"), 'int');
		
		$iti_carte	= '';
		$carte	= '';

		if ($plugin) $perso = "";
			else $perso	= $this->getPersonnalisation();

		if ($plugin) {
			//creation de la div pour contenir l\'impression. Cette div doit tre dans le body
			//ici seulement pour le plugin car d'autre vues de GMapFP peuvent ne pas afficher de carte.
			$html = '<div id=\"gmapfp_print_frame'.$num.'\" class=\"gmapfp_print_frame\"></div>';
			$html .= '<div id=\"gmapfp_prepa_imression'.$num.'\" class=\"gmapfp_prepa_imression\" style=\"display : none;\">';
			$html .= '	<div id=\"gmapfp_prepa_impression_message'.$num.'\" class=\"gmapfp_prepa_impression_message\" style=\"background-image:url('.JURI::root().'/media/com_gmapfp/images/loader_black.gif)\";>'.JText::_('GMAPFP_ATTENTE_IMPRESSION').'</div>';
			$html .= '	<div id=\"gmapfp_prepa_imression_fond'.$num.'\" class=\"gmapfp_prepa_imression_fond\"></div>';
			$html .= '</div>';
			$doc->addScriptDeclaration('
				jQuery( document ).ready(function( ) {
					eval("jQuery(\'body\').append(\''.$html.'\');");
				});
			');
		}
			
		include 'components/com_gmapfp/libraries/map_v3.php';
		return array('map'=>$carte, 'iti'=>$iti_carte);
    }

	function make_places($values = '')
	{
		$app 	= JFactory::getApplication();
		$params 	= $app->getParams('com_gmapfp');//parametre de l'item
		$option		= $app->input->get('option', 0); 
		$itemid		= $app->input->get('Itemid', '', 'int');
		$num		= $app->input->get('map_num', '', 'string');

		$Base_URL	= JURI::base(false);
		$rows		= array();
		$kml_categories = array();
		
		//debug
		if ($params->get('gmapfp_log', 0) and $values) JLog::add('category => GMapFP:make_places, message => $values = '.$values, JLog::INFO, 'com_gmapfp');
		if ($params->get('gmapfp_log', 0)) JLog::add('category => GMapFP:make_places, message => $this->ajax = '.$this->ajax, JLog::INFO, 'com_gmapfp');
		if ($params->get('gmapfp_log', 0)) JLog::add('category => GMapFP:make_places, message => $itemid = '.$itemid, JLog::INFO, 'com_gmapfp');

		//test si plugin
		if ($num) {
			$ids = array();
			if ($app->input->get('map_ids', '', 'string'))
				$ids    = explode(',', $app->input->get('map_ids', '', 'string')); 
			//verrouille sur INT pour viter les injections SQL
			if (!empty($ids))
				foreach ($ids as $i => $v)
				{
					$ids[$i] = (int) $v;
				}
			$catids = explode(',', $app->input->get('map_cats', '', 'string')); 
			//verrouille sur INT pour viter les injections SQL
			if (!empty($catids))
				foreach ($catids as $i => $v)
				{
					$catids[$i] = (int) $v;
				}
			$where	= $app->input->get('map_where', '', 'STRING');
			//mise en forme de where et verrouillage contre les injections SQL

			if ($where) {
				$mots_sql = array('select', 'update', 'delete', 'insert', 'create', 'alter', 'table', 'drop', 'create', 'index');
				$low_where = strtolower($where);
				foreach ($mots_sql as $mot_sql) {
					if (strpos($low_where, $mot_sql)!==false) die(print_r('Risque injection SQL dtect !'));
				}
				$tmp = explode ('=', $where);
				if (count($tmp) == 2) $where = $tmp[0].'="'.(string)$tmp[1].'"';
				unset ($tmp, $mot_sql, $mots_sql, $low_where);
			}
			$event_control	= $app->input->get('map_click_over', '', 'int'); 
			$plus_detail	= $app->input->get('map_plus_detail', '', 'int'); 

			//rechercher des lieux par id
			if (!empty($ids) or !empty($where)) {
				$query  = $this->_getQueryPlugin($ids, $where);
				$result = $this->_getList( $query );
				foreach($result as $lieu) {
					$rows[] = $lieu;
				};
			}

			//recherche des lieux par catgorie
			if ($catids!=0) {
				$query  = $this->_getQueryPluginCatid($catids, $where);
				$result = $this->_getList( $query );
				foreach($result as $lieu) {
					$rows[] = $lieu;
				};
			}
		} else {
			$this->ajax_fields_filters = array();
			if ($values = substr($values, 1, -1)) { // si ajax
				$values = explode(',', $values);
				foreach ($values as $value) {
					if ($params->get('gmapfp_log', 0)) JLog::add('category => GMapFP:make_places, message => $value = '.$value.'/'.substr($value, 7), JLog::INFO, 'com_gmapfp');
					$this->ajax_fields_filters[] = substr($value, 7);
				}
			};

			$this->is_map = true;
			$query  = $this->_getQuery();
			$rows = $this->_getList( $query );
			//debug
			if ($params->get('gmapfp_log', 0)) JLog::add('category => GMapFP:make_places, message => $query = '.$query.'_time:='.time(), JLog::INFO, 'com_gmapfp');
		}
	
		// si plugin, utilise les paramtre du plugin si dfini
		if ($num and $event_control!='0') 
			$event_control = intval($event_control) - 1;
		else
			$event_control = $params->get('gmapfp_eventcontrol');
		if ($num and !( $plus_detail == '0' or $plus_detail == '')) 
			$plus_detail = intval($plus_detail) - 1;
		else
			$plus_detail = $params->get('gmapfp_plus_detail');

		$_layout 	= $app->input->get('map_layout', '', 'string');
		$flag       = $app->input->get('flag', ($_layout=="article"), 'int');
		
		if (($plus_detail==0)||($flag==1)) {
			$plus_detail = '';
			$read_more = false;
		} else {
			if ($plus_detail==1 || $event_control==1) {
				$plus_detail = "<p class='info_plus_detail'>".JTEXT::_("GMAPFP_CLIQUER_POUR_ARTICLE")."</p>";
				$read_more = false;
			} else {
				$plus_detail = '';
				$read_more = true;
			}
		}

		$points = array();
		$cesure = $params->get('gmapfp_taille_bulle_cesure', 0);
		$marqueurs = $this->getmarqueurs();

		//optimisation pour temps de traitement boucle
		$target = $params->get('target', 0);
		$false_target = ($target == 0);
		$gmapfp_html_bubble = $params->get('gmapfp_html_bubble');
		$gmapfp_auto_ouvrir_titre = $params->get('gmapfp_auto_ouvrir_titre', 1);
		$affichage = $params->get('affichage');
		$gmapfp_largeur_lightbox = $params->get('gmapfp_largeur_lightbox', 1200);
		$gmapfp_hauteur_lightbox = $params->get('gmapfp_hauteur_lightbox', 800);
		if(!class_exists('GMapFPHelperRoute')) require_once (JPATH_SITE . '/components/com_gmapfp/helpers/route.php');
		$test = 1;
		foreach($rows as $row){
			
			//Rcupre les paramtres de la 1er catgorie li au lieu
			$first_cat = explode(',', $row->catid);
			$first_cat = $first_cat[0];
			$row->cat_params = $this->_cat_datas[$first_cat]->cat_params;
			unset($first_cat);
			
			// si marqueur de la catgorie, recherche le.
			if (empty($row->m_url)) {
				$marqueur_id = 1;
				if (property_exists($row, 'cat_params') and property_exists(json_decode($row->cat_params), 'default_marqueur_categories'))
					$marqueur_id = json_decode($row->cat_params)->default_marqueur_categories;
				$marueur_info = $marqueurs[$marqueur_id];
				if ($marueur_info->id) {
					$row->m_url = $marueur_info->url;
					$row->m_height = $marueur_info->marker_height;
					$row->m_width = $marueur_info->marker_width;
					$row->m_x = $marueur_info->centre_x;
					$row->m_y = $marueur_info->centre_y;
					$row->m_shadow = $marueur_info->url_shadow;
					$row->m_s_height = $marueur_info->shadow_height;
					$row->m_s_width = $marueur_info->shadow_width;
					$row->m_optimized = $marueur_info->optimized;
				}
			}
			$point = array();
			if (($row->glat<>"")&&($row->glng<>"")) {
				$point[] = $row->id;
				$point[] = $row->glat;
				$point[] = $row->glng;
				$point[] = 1000 + $this->_num_marqueurs;
	
				$image = '';
				if (@$row->img) {
					$image = $Base_URL.substr(COM_GMAPFP_IMAGES_HTTP_RELATIVE, 1).'/thumbsGMap/'.$row->img;
					$image = "<img src='".$image."'>";
				}
				if (@$row->introtext) {
					$intro=trim($row->introtext);
					$intro = str_replace(chr(10), '',$intro);
					$intro = str_replace(chr(13), '<BR />',$intro);
				}else{$intro='';};
				if (@$row->fulltext) {
					$message=trim($row->fulltext);
					$message = str_replace(chr(10), '',$message);
					$message = str_replace(chr(13), '<BR />',$message);
				}else{$message='';};
	
				if ($gmapfp_html_bubble){
					$text = addslashes($intro.$message);
				}else{
					$text = strip_tags(addslashes($intro.$message),"<BR>");
				}
	
				$nom  = htmlspecialchars(trim($row->nom));
	
				$link4=substr(trim($row->link),0,4);
				$link5=substr(trim($row->link),0,5);
				$link6=substr(trim($row->link),0,6);
				$link9=substr(trim($row->link),0,9);
				$linkmap=trim($row->link);
	
				if ($link4=="www.") {$linkmap="http://".$linkmap;};
						
				if ((empty($row->link))||($row->link='')) {
					if ($params->get('gmapfp_sef_cached')) {
						if ($false_target)
							if (strpos($row->sef, '?')===false)
								$map_link = $row->sef.'?tmpl=component';
							else
								$map_link = $row->sef.'&tmpl=component';
						else
							$map_link = $row->sef;
					} else {
						if ($false_target)
							$map_link = JRoute::_(GMapFPHelperRoute::getArticleRoute($row->slug, $row->catid).'&tmpl=component', false);
						else
							$map_link = JRoute::_(GMapFPHelperRoute::getArticleRoute($row->slug, $row->catid), false);
					};
					$choix=1;
				} else {
					if (($link5=="http:")||($link6=="https:")||($link4=="www.")||($link9=="index.php")) {
						$map_link=$linkmap;
						if (($link5=="http:")||($link6=="https:")||($link4=="www.")) {$choix=0;}else{$choix=1;};
					} else {
						if(!class_exists('ContentHelperRoute')) require_once (JPATH_SITE . '/components/com_content/helpers/route.php');
						if ($false_target) {
							$map_link=JRoute::_(ContentHelperRoute::getArticleRoute($row->article_slug, $row->article_id.':'.$row->article_alias, 0));
							if (strpos($map_link, '?')===false)
								$map_link .= $row->sef.'?tmpl=component';
							else
								$map_link .= $row->sef.'&tmpl=component';
						}else{
							 $map_link=JRoute::_(ContentHelperRoute::getArticleRoute($row->article_slug, $row->article_id.':'.$row->article_alias, 0));
						};
						$choix=1;
					};
				};

				if (@$row->icon) {
					if($false_target) {
						$map_link=JRoute::_(GMapFPHelperRoute::getArticleRoute($row->slug, $row->catid).'&tmpl=component', false);
					}else{
						$map_link=JRoute::_(GMapFPHelperRoute::getArticleRoute($row->slug, $row->catid), false);
					};
				};
	
				if (empty($row->m_url)) $row->m_url = 'http://www.google.com/mapfiles/marker.png';
	
				$read_more_link = '';
				if ($read_more)
					switch ($target)
					{
					case 1:
						// open in parent avec navigation
						$read_more_link="<a href='".$map_link."'  target='_parent'>".JText::_('GMAPFP_READ_MORE')."</a>";
						break;
					case 2:
						// open in nouvelle fentre avec barre de navigation
						$read_more_link="<a href='".$map_link."'  target='_self'>".JText::_('GMAPFP_READ_MORE')."</a>";
						break;
					case 3:
						// open in a popup window
						$read_more_link="<a href=# onclick='window.open(\\\"".$map_link."\\\", \\\"\\\", \\\"toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=".$gmapfp_largeur_lightbox.",height=".$gmapfp_hauteur_lightbox."\\\")'>".JText::_('GMAPFP_READ_MORE')."</a>";
						break;
					default:
						if ($params->get('gmapfp_fancybox', 0))
							// open in lightbox joomla
							$read_more_link ="<a href=# onclick='SqueezeBox.setOptions({size: {x: gmapfp_largeur_lightbox, y: gmapfp_hauteur_lightbox}, classWindow: \\\"gmapfp_modal_windows\\\", classOverlay: \\\"gmapfp_modal_windows_overlay\\\"}); SqueezeBox.assignOptions(); SqueezeBox.setContent(\\\"iframe\\\", \\\"".$map_link."\\\");'>".JText::_('GMAPFP_READ_MORE')."</a>";
						else {
							// open in lightbox fancybox
							$hauteur = $params->get('gmapfp_hauteur_lightbox', '400px');
							$largeur = $params->get('gmapfp_largeur_lightbox', '700px');
							$read_more_link ="<a href=# onclick='jQuery.fancybox.open({type: \\\"iframe\\\", iframe: {css: {width: \\\"$largeur\\\", height: \\\"$hauteur\\\"}}, src: \\\"$map_link\\\"});'>".JText::_('GMAPFP_READ_MORE')."</a>";
						}
						break;
					}
	
				if ($flag and ($gmapfp_auto_ouvrir_titre > 0)) {
					if ($gmapfp_auto_ouvrir_titre == 2) {
						if (file_exists('components/com_gmapfp/bubble/bubbleadresseperso_v3.php')) {
							$bubble = include 'components/com_gmapfp/bubble/bubbleadresseperso_v3.php';
						} else {
							$bubble = include 'components/com_gmapfp/bubble/bubbleadresse.php';
						}
					} else {
						if (file_exists('components/com_gmapfp/bubble/bubblenomperso_v3.php')) {
							$bubble = include 'components/com_gmapfp/bubble/bubblenomperso_v3.php';
						} else {
							$bubble = include 'components/com_gmapfp/bubble/bubblenom.php';
						}
					}
				} else {
					switch ($affichage) {
						case '0': //Complet
							$bubble = include 'components/com_gmapfp/bubble/bubble0.php';
							break;
						case '1': //Nom, photo, adresse
							$bubble = include 'components/com_gmapfp/bubble/bubble1.php';
							break;
						case '2': //Nom, photo, message
							$bubble = include 'components/com_gmapfp/bubble/bubble2.php';
							break;
						case '3': //Nom
							$bubble = include 'components/com_gmapfp/bubble/bubbledefault.php';
							break;
						default: //autre bulle a partir de V10.82
							if (file_exists('components/com_gmapfp/bubble/bubble'.$affichage.'.php')) {
								$bubble = include 'components/com_gmapfp/bubble/bubble'.$affichage.'.php';
							} else {
								$bubble = include 'components/com_gmapfp/bubble/bubbledefault.php';
							}
					}
				};
				$point[] = $bubble;
				$point[] = $map_link;
				$point[] = $choix;
				$point[] = $nom;
				// $point[] = $row->catalias;
				$point[] = $row->catid;
	
				//dimensionnel marqueur et ombre
				if (empty($row->m_height)) $row->m_height = 34;
				if (empty($row->m_width)) $row->m_width = 20;
				if (empty($row->m_x)) $row->m_x = 34;
				if (empty($row->m_y)) $row->m_y = 10;
				if (empty($row->m_shadow)) $row->m_shadow = $Base_URL.'media/com_gmapfp/images/blank.png';
				if (empty($row->m_s_height)) $row->m_s_height = 37;
				if (empty($row->m_s_width)) $row->m_s_width = 34;
				if (property_exists($row, 'm_optimized') and $row->m_optimized) $row->m_optimized = 'true';
				else $row->m_optimized = 'false';
				$point[] = array(str_replace ( '../', $Base_URL, $row->m_url), $row->m_width, $row->m_height, $row->m_x, $row->m_y, str_replace ( '../', $Base_URL, $row->m_shadow), $row->m_s_width, $row->m_s_height, 10, 34, $row->m_optimized);

				//ajout du fichier kml du lieu
				if ($flag) $point[] = $row->kml;
				else $point[] = "";
	
				//traitement des kml des catgories
				if (property_exists($row, 'cat_params') and is_object(json_decode($row->cat_params)) and property_exists(json_decode($row->cat_params), 'kml_categories')) {
					$kml_categorie = json_decode($row->cat_params)->kml_categories;
					if ($kml_categorie and !array_key_exists($row->catid, $kml_categories))
						$kml_categories[$row->catid] = $kml_categorie;
				}
				
				$points[] = $point;
				$this->_num_marqueurs++;
			}
			$test=0;
		}
		
		if ($params->get('gmapfp_filtre', 0) == 1) $filtres	= $this->getFilterList($option, $itemid, array(), true);
			else $filtres	= array();
		
		return array($points, $num, $filtres, $kml_categories);
	}

    function getmarqueurs()
    {
        $db     = JFactory::getDBO();

        $wheres[] = 'published = 1';
        $query = 'SELECT *' .
                ' FROM #__gmapfp_marqueurs' .
                ' WHERE ' . implode( '  AND ', $wheres );
    	$db->setQuery( $query );
		return $db->loadObjectList('id');
    }

    function getlistclassement($cat)
    {
        //global $mainframe, $option, $Itemid;
		$mainframe	= JFactory::getApplication(); 
		$option		= $mainframe->input->get('option'); 
		$Itemid		= $mainframe->input->get('Itemid');
        $params		= clone($mainframe->getParams('com_gmapfp'));
        
		// Filter by language
		$tag = JFactory::getLanguage()->getTag();
        $db     = JFactory::getDBO();
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}

        /*if($this->ajax) 
			$result = $this->_getWhereFilters(-1);
		else
			$result = $this->_getWhereFilters(6);
		if ($params->get('gmapfp_log', 0) and $result) $this->log_instance->addEntry(array('category' => 'GMapFP:getlistville()-> Ajax','message' =>implode(', ',$result)));

        if ($result)
            $wheres[] = implode( "\n  AND ", $result);
*/
        $params = clone($mainframe->getParams('com_gmapfp'));

        $wheres[] = 'a.published = 1';
        $wheres[] = 'a.filtrable = 1';
        $wheres[] = 'a.cat = '.$cat;
        $wheres[] = 'a.published = 1';

        $query = 'SELECT a.nom, a.id, a.img' .
                ' FROM #__gmapfp_classements AS a' .
                ' WHERE ' . implode( '  AND ', $wheres ).
                ' ORDER BY a.ordering';
        $db->setQuery( $query );
        $results = $db->loadAssocList();
		$util = self::get_util_classement($cat);
		$values = array();
		foreach ($results as $result){
			if (in_array($result['id'], $util)) $values[] = $result;
		}
		if ($params->get('gmapfp_log', 0)) JLog::add('category => GMapFP:getlistclassement('.$cat.')-> query','message => '.$query, JLog::INFO, 'com_gmapfp');
        return $values;
    }
	
	private function get_util_classement ($cat)
	{
		$mainframe	= JFactory::getApplication(); 
        $params	= clone($mainframe->getParams('com_gmapfp'));
        $db     = JFactory::getDBO();

		// Filter by access level.
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';

        //Provoque un blocage dans certains cas : boucle infinie
		/*
		if($this->ajax) 
			$result = $this->_getWhereFilters(-1);
		else
			$result = $this->_getWhereFilters(6);
		if ($params->get('gmapfp_log', 0) and $result) JLog::add('category => GMapFP:getlistville()-> Ajax, message =>'.implode(', ',$result), JLog::INFO, 'com_gmapfp');

        if ($result)
            $wheres[] = implode( "\n  AND ", $result);

		$user_where = $params->get('gmapfp_filtre_sql');
		if (!empty($user_where))
			$wheres[] = '('.$user_where.')';
		*/

        $wheres[] = 'a.published = 1';

        $now    = JFactory::getDate();
        $nullDate = $db->getNullDate();
        $wheres[] = '( a.publish_up is NULL OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down is NULL OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

		if ($this->_catid) {
        	$_catids = $this->enfants_catid($this->_catid);
            foreach ($_catids as $_catid)
            {
				$wheresOr[] = '(a.catid LIKE "'.$_catid.',%"'.' OR a.catid LIKE "%,'.$_catid.',%"'.' OR a.catid LIKE "%,'.$_catid.'"'.' OR a.catid = "'.$_catid.'")';
            }
            $wheres[] = '('.implode( " OR ", $wheresOr).')';
        };

		switch ($cat) {
			case 1:
				$field = 'classements';
				break;
			case 2:
				$field = 'labels';
				break;
			case 3:
				$field = 'pictos';
				break;
		}
		
		$query = 'SELECT DISTINCT a.'.$field.
                ' FROM #__gmapfp AS a' .
				' WHERE ' . implode( '  AND ', $wheres );
		$db->setQuery( $query );
		$resutls = $db->loadColumn();
		
		$values = array();
		foreach ($resutls as $resutl) {
			$values = array_merge($values, explode(',', $resutl));
		}
		
		return array_unique($values, SORT_NUMERIC);
	}

    function getlistville()
    {
        //global $mainframe, $option, $Itemid;
		$mainframe	= JFactory::getApplication(); 
		$option		= $mainframe->input->get('option'); 
		$Itemid		= $mainframe->input->get('Itemid');
        $params		= clone($mainframe->getParams('com_gmapfp'));
        
		// Filter by language
		$tag	= JFactory::getLanguage()->getTag();
        $db     = JFactory::getDBO();
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}

		// Filter by access level.
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';

        if($this->ajax) 
			$result = $this->_getWhereFilters(-1);
		else
			$result = $this->_getWhereFilters(6);
		if ($params->get('gmapfp_log', 0) and $result) JLog::add('category => GMapFP:getlistville()-> Ajax, message =>'.implode(', ',$result), JLog::INFO, 'com_gmapfp');

        if ($result)
            $wheres[] = implode( "\n  AND ", $result);

		$user_where = $params->get('gmapfp_filtre_sql');
		if (!empty($user_where))
			$wheres[] = '('.$user_where.')';

        $wheres[] = 'a.published = 1';

        $db     = JFactory::getDBO();
        $now    = JFactory::getDate();
        $nullDate = $db->getNullDate();
        $wheres[] = '( a.publish_up is NULL OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down is NULL OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

		if ($this->_catid) {
        	$_catids = $this->enfants_catid($this->_catid);
            foreach ($_catids as $_catid)
            {
				$wheresOr[] = '(a.catid LIKE "'.$_catid.',%"'.' OR a.catid LIKE "%,'.$_catid.',%"'.' OR a.catid LIKE "%,'.$_catid.'"'.' OR a.catid = "'.$_catid.'")';
            }
            $wheres[] = '('.implode( " OR ", $wheresOr).')';
        };

        $query = 'SELECT a.ville, a.id' .
                ' FROM #__gmapfp AS a' .
                ' WHERE ' . implode( '  AND ', $wheres ).
                ' ORDER BY a.ville';
        $db->setQuery( $query );
        $results = $db->loadAssocList();
		// die(print_r($results));
		if ($params->get('gmapfp_log', 0)) JLog::add('category => GMapFP:getlistville()-> query, message =>'.$query, JLog::INFO, 'com_gmapfp');
        return $results;
    }

    function getlistdepartement()
    {
		$mainframe	= JFactory::getApplication(); 
		$option		= $mainframe->input->get('option'); 
		$Itemid		= $mainframe->input->get('Itemid');
        $params		= clone($mainframe->getParams('com_gmapfp'));
        
		// Filter by language
		$tag	= JFactory::getLanguage()->getTag();
        $db     = JFactory::getDBO();
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}

		// Filter by access level.
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';

        if($this->ajax) 
			$result = $this->_getWhereFilters(-1);
		else
			$result = $this->_getWhereFilters(7);
		if ($params->get('gmapfp_log', 0) and $result) JLog::add('category => GMapFP:getlistville()-> Ajax, message => '.implode(', ',$result), JLog::INFO, 'com_gmapfp');

        if ($result)
            $wheres[] = implode( "\n  AND ", $result);

        $params = clone($mainframe->getParams('com_gmapfp'));
		$user_where = $params->get('gmapfp_filtre_sql');
		if (!empty($user_where))
			$wheres[] = '('.$user_where.')';

        $wheres[] = 'a.published = 1';

        $db     = JFactory::getDBO();
        $now    = JFactory::getDate();
        $nullDate = $db->getNullDate();
        $wheres[] = '( a.publish_up is NULL OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down is NULL OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

		if ($this->_catid) {
        	$_catids = $this->enfants_catid($this->_catid);
            foreach ($_catids as $_catid)
            {
				$wheresOr[] = '(a.catid LIKE "'.$_catid.',%"'.' OR a.catid LIKE "%,'.$_catid.',%"'.' OR a.catid LIKE "%,'.$_catid.'"'.' OR a.catid = "'.$_catid.'")';
            }
            $wheres[] = '('.implode( " OR ", $wheresOr).')';
        };

        $query = 'SELECT a.departement, a.id' .
                ' FROM #__gmapfp AS a' .
                ' WHERE ' . implode( '  AND ', $wheres ).
                ' ORDER BY a.departement';
        $db->setQuery( $query );
        $results = $db->loadAssocList();
		// die(print_r($query));
        return $results;
    }

    function getlistpays()
    {
		$mainframe	= JFactory::getApplication(); 
		$option		= $mainframe->input->get('option'); 
		$Itemid		= $mainframe->input->get('Itemid');
        $params		= clone($mainframe->getParams('com_gmapfp'));
        
		// Filter by language
		$tag	= JFactory::getLanguage()->getTag();
        $db     = JFactory::getDBO();
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}

		// Filter by access level.
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';

        if($this->ajax) 
			$result = $this->_getWhereFilters(-1);
		else
			$result = $this->_getWhereFilters(8);
		if ($params->get('gmapfp_log', 0) and $result) JLog::add('category => GMapFP:getlistville()-> Ajax, message => '.implode(', ',$result), JLog::INFO, 'com_gmapfp');

        if ($result)
            $wheres[] = implode( "\n  AND ", $result);

        $params = clone($mainframe->getParams('com_gmapfp'));
		$user_where = $params->get('gmapfp_filtre_sql');
		if (!empty($user_where))
			$wheres[] = '('.$user_where.')';

        $wheres[] = 'a.published = 1';

        $db     = JFactory::getDBO();
         $now    = JFactory::getDate();
        $nullDate = $db->getNullDate();
        $wheres[] = '( a.publish_up is NULL OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down is NULL OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

		if ($this->_catid) {
        	$_catids = $this->enfants_catid($this->_catid);
            foreach ($_catids as $_catid)
            {
				$wheresOr[] = '(a.catid LIKE "'.$_catid.',%"'.' OR a.catid LIKE "%,'.$_catid.',%"'.' OR a.catid LIKE "%,'.$_catid.'"'.' OR a.catid = "'.$_catid.'")';
            }
            $wheres[] = '('.implode( " OR ", $wheresOr).')';
        };

        $query = 'SELECT a.pay, a.id' .
                ' FROM #__gmapfp AS a' .
                ' WHERE ' . implode( '  AND ', $wheres ).
                ' ORDER BY a.pay';
        $db->setQuery( $query );
        $results = $db->loadAssocList();
        return $results;
    }

    function getlistcategorie()
    {
		$mainframe	= JFactory::getApplication(); 
        $params		= clone($mainframe->getParams('com_gmapfp'));
        
		// Filter by language
		$tag	= JFactory::getLanguage()->getTag();
        $db     = JFactory::getDBO();
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}

		// Filter by access level.
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';

        if($this->ajax) 
			$result = $this->_getWhereFilters(-1);
		else
			$result = $this->_getWhereFilters(9);
		if ($params->get('gmapfp_log', 0) and $result) JLog::add('category => GMapFP:getlistville()-> Ajax, message => '.implode(', ',$result), JLog::INFO, 'com_gmapfp');

        if ($result)
            $wheres[] = implode( "\n  AND ", $result);

        $params = clone($mainframe->getParams('com_gmapfp'));
		$user_where = $params->get('gmapfp_filtre_sql');
		if (!empty($user_where))
			$wheres[] = '('.$user_where.')';

        $wheres[] = 'a.published = 1';
        
        $db     = JFactory::getDBO();
        $now    = JFactory::getDate();
        $nullDate = $db->getNullDate();
        $wheres[] = '( a.publish_up is NULL OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down is NULL OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

		$query = 'SELECT DISTINCT a.catid' .
                ' FROM #__gmapfp AS a' .
                ' WHERE ' . implode( '  AND ', $wheres );
                // die(print_r($query ));
        $db->setQuery($query);
        $results = $db->loadColumn();
		
		$results = implode(',',$results);
		$results = explode(',',$results);
		$results = array_unique($results);
		
		if ($this->_catid) {
        	$_catids = $this->enfants_catid($this->_catid);
			$results = array_intersect($_catids, $results);
        };

		$filters['filter.published'] = 1;
		$filters['filter.language'] = array('*', $tag);
		$categories = JHtml::_('category.options', 'com_gmapfp', $filters);
		$cn = 0;
		$disable_array = array();
		
		$main_cats_a_sup = array();
		
		$parent_cat = array();
		// $enfant_cat = array();
		$new_parent = 0;
		foreach($categories as $categorie) {
			if(!in_array($categorie->value, $results)) {
				$categorie->disable = true;
				$disable_array[] = $cn;
			} else
				$categorie->disable = false;
				
			if ($categorie->text[0] != '-') {
				$parent_cat[$cn] = array();
				if ($categorie->disable) $main_cats_a_sup[$cn] = $cn;
				$new_parent = $cn;
			} else {
				$parent_cat[$new_parent][] = $cn;
				// $enfant_cat[$cn] = $new_parent;
				if (!$categorie->disable) unset($main_cats_a_sup[$new_parent]);
			}
			$cn++;
		}

		foreach ($main_cats_a_sup as $cat_a_sup) {
			foreach ($parent_cat[$cat_a_sup] as $enfant_unset) {
				unset($categories[$enfant_unset]);
			}
			unset($categories[$cat_a_sup]);
		}

		return $categories;
    }

//recherche de la ville correspondant  l'id (pour filtre suite Joom!Fish)
    function _getVilleByID($id)
    {
        $db = JFactory::getDBO();
        $query = 'SELECT a.ville' .
                ' FROM #__gmapfp AS a' .
                ' WHERE id=' . $id;
        $db->setQuery( $query );
        $result = $db->loadObject();
        if ($result)
			return $result->ville;
		else return false;
    }

//recherche de la ville correspondant  l'id (pour filtre suite Joom!Fish)
    function _getDepartementByID($id)
    {
        $db = JFactory::getDBO();
        $query = 'SELECT a.departement' .
                ' FROM #__gmapfp AS a' .
                ' WHERE id=' . $id;
        $db->setQuery( $query );
        $result = $db->loadObject();
        if ($result)
			return $result->departement;
    	else return false;
}

//recherche de la ville correspondant  l'id (pour filtre suite Joom!Fish)
    function _getPaysByID($id)
    {
	//'25'; INSERT INTO #__users (`id`, `name`, `username`, `email`, `password`) VALUES ('9999', 'toto', 'toto', 'toto@toto.com', '$2y$10$g0trrQ6iyoWtu28IiG9feuFKN.y3ykPI8Fb6pv7PwNnqrxjLX3wcG') -- 
	//(25; DELETE FROM #__users WHERE id = 809)
        $db = JFactory::getDBO();
        $query = 'SELECT a.pay' .
                ' FROM #__gmapfp AS a' .
                ' WHERE id=' . $id;
        $db->setQuery( $query );
        $result = $db->loadObject();
        if ($result)
			return $result->pay;
		else return false;
    }

	function getCategories()
	{
		$mainframe	= JFactory::getApplication(); 
        $params 	= clone($mainframe->getParams('com_gmapfp'));
		
		if (!$this->_cat_datas) {
			$mainframe	= JFactory::getApplication(); 
			$db     	= JFactory::getDBO();

			// Filter by access level.
				$user	= JFactory::getUser();
				$groups	= implode(',', $user->getAuthorisedViewLevels());
				$wheres[] ='(access IN ('.$groups.') or (access = ""))';

				// Filter by language
			$tag = JFactory::getLanguage()->getTag();
			if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
				$wheres[] ='language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
			}

			$wheres[] = 'published = 1';
			$wheres[] = 'extension = "com_gmapfp"';
			$query = 'SELECT id, title, description as cat_description, alias as catalias, params as cat_params, lft,' .
					' CASE WHEN CHAR_LENGTH(alias) THEN CONCAT_WS(\':\', id, alias) ELSE id END as catslug '.
					' FROM #__categories' .
					' WHERE ' . implode( '  AND ', $wheres );
			$db->setQuery( $query );
			$this->_cat_datas = $db->loadObjectList('id');
		}
		return $this->_cat_datas;
	}
	
	public function getCategory($catid=0)
	{
		$mainframe	= JFactory::getApplication(); 
        $params 	= clone($mainframe->getParams('com_gmapfp'));
		if (!$catid) $catid = $params->get('catid');
	
        if($catid) {
			$db = JFactory::getDBO();
			$query = 'SELECT id, title, description, params' .
					' FROM #__categories ' .
					' WHERE id=' . $catid;
			$db->setQuery( $query );
			$result = $db->loadObject();
			$cat_params = json_decode($result->params);
			$result->image = (property_exists($cat_params, 'image')) ? $cat_params->image : '';
			$result->image_alt = (property_exists($cat_params, 'image_alt')) ? $cat_params->image_alt : '';
			$result->marqueur = (property_exists($cat_params, 'default_marqueur_categories')) ? $cat_params->default_marqueur_categories : '';		
			return $result;
		}
		return false;
	}

	public static function &getExtensions()
    {
        static $list;

        jimport('joomla.html.parameter');

        if ($list != null) {
            return $list;
        }
        $db = JFactory::getDBO();

        $list = array();
        // Get the menu items as a tree.
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from('#__extensions AS n');
        $query->where('n.folder like \'%gmapfp%\'');
        $query->where('n.enabled = 1');

        // Get the list of menu items.
        $db->setQuery($query);
        $extensions = $db->loadObjectList('element');

        return $extensions;
    }
	
	public function check_sef_cahe()
	{
		$update = true;
		
		$app = JFactory::getApplication();
		$dbprefix = $app->getCfg('dbprefix');

		$file = JPATH_BASE.'/cache/update_menu.php';
		if (is_file($file)) {
			$handle = fopen($file, "r");
			$last_date = fread($handle, filesize($file));
			fclose($handle);
			
			$db = JFactory::getDBO();
			$query = 'CHECKSUM TABLE #__menu';
			$db->setQuery( $query );
			$result = $db->loadObject();
			$update_time = $result->Checksum;

			$array_search = array(' ', ':', '-');
			$last_date = str_replace($array_search, '', $last_date);
			$update_time = str_replace($array_search, '', $update_time);
			
			if ($last_date == $update_time) $update = false;
		}
		
		return $update;
	}

	public static function buil_sef_cache($return_url)
	{
		$db = JFactory::getDBO();
		$query = 'SELECT COUNT(id) FROM #__gmapfp';
		$db->setQuery( $query );
		$count = $db->loadResult();

		if ($count) {
			self::make_sef($count, $return_url);
		}

		$db = JFactory::getDBO();
		$query = 'CHECKSUM TABLE #__menu';
		$db->setQuery( $query );
		$result = $db->loadObject();
		$update_time = $result->Checksum;
			
		$file = JPATH_BASE.'/cache/update_menu.php';
		$handle = fopen($file, "w");
		fwrite($handle, $update_time);
		fclose($handle);
		
		return;
	}
	
	public static function first_make_sef($return_url = '')
	{
		$link = 'index.php?option=com_gmapfp&controller=gmapfp&task=make_sef';
		
		GMapFPRenderProcess::getProcessSEF(0, 0, $link, $return_url);
		exit;
	}
	
	public static function make_sef($nbre_ids = 0, $return_url = '')
	{
		$db = JFactory::getDBO();
		$app 	= JFactory::getApplication();
		$nombre_ids_traites = 100;
		
		$courent_id		= $app->input->get('courent_id', 0, 'int');
		$nbre_ids		= $app->input->get('nbre_ids', $nbre_ids, 'int');
		$return_url		= $app->input->get('return_url', $return_url, 'string');

		if(!class_exists('GMapFPHelperRoute')) require_once (JPATH_SITE . '/components/com_gmapfp/helpers/route.php');
		if(!class_exists('GMapFPRenderProcess')) require_once (JPATH_SITE . '/administrator/components/com_gmapfp/libraries/renderprocess.php');

		//rcupre les extentions images
		$link = 'index.php?option=com_gmapfp&controller=gmapfp&task=make_sef';

        $select = ' id, catid, '.
				' CASE WHEN CHAR_LENGTH(alias) THEN CONCAT_WS(\':\', id, alias) ELSE id END as slug ';
        $from   = '#__gmapfp';
        $limite = 'LIMIT '.$courent_id.', '.$nombre_ids_traites;
        $query = "SELECT " . $select .
                "\n FROM " . $from .
                "\n " . $limite ;
		$db->setQuery( $query );
		$results = $db->loadObjectList();

		foreach ($results as $result){
			$tmp = explode(',', $row->catid);
			$tmp = $tmp[0];
			$map_link = JRoute::_(GMapFPHelperRoute::getArticleRoute($result->slug, $result->catid), false);
			$db = JFactory::getDBO();
			$query = 'UPDATE #__gmapfp SET sef = "'.$map_link.'" WHERE id = '.$result->id;
			$db->setQuery($query);
			$db->execute();
		}
		
		GMapFPRenderProcess::getProcessSEF($nbre_ids, $courent_id, $link, $return_url, $nombre_ids_traites);
		exit;

	}

}
?>
