<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.120pro
	* Creation date: Dcembre 2020
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class GMapFPViewEditLieux extends JViewLegacy
{
	protected $item;
	protected $params;
	protected $layout;
	protected $tmpl;

	function display($tpl = null)
	{
		$app 		= JFactory::getApplication(); 
		$Itemid    	= $app->input->get('Itemid'); 
		$option    	= $app->input->get('option'); 
		$layout 	= $app->input->get('layout', '', 'string');
		$this->tmpl	= ($app->input->get('tmpl', '') == 'component');

		$document	= JFactory::getDocument();
		$user   	= JFactory::getUser();
		$cid    	= $app->input->get('cid',  array(0), 'array'); 
		$Base_URL	= JURI::base();

		$config_media 	= JComponentHelper::getParams('com_media');
		$params 		= clone($app->getParams('com_gmapfp'));

		//gestion des droits
		require_once JPATH_COMPONENT_ADMINISTRATOR.'/helpers/gmapfp.php';
		$canDo	= GMapFPHelper::getActions();
		// Make sure you are logged in and have the necessary access rights
		if ((!$canDo->get('core.create') and !(int)$cid[0]) || ((int)$cid[0] > 0 and (!$canDo->get('core.edit') && !$canDo->get('core.edit.own')))) {
				$link = JRoute::_('index.php?option=com_users&view=login&Itemid='.$Itemid, false);
				$returnURL = JUri::current();
				$fullURL = new JURI($link);
				$fullURL->setVar('return', base64_encode($returnURL));
				$link = $fullURL->toString();
				$app->redirect($link);
			return;
		}

		//dectection si android pour affichage de lditeur par dfaut ou d'une zone textearea
		$user_agent = $_SERVER['HTTP_USER_AGENT'];
		define('GMAPFP_ANDROID', stristr($user_agent,'iPhone') || stristr($user_agent,'iPod') || stristr($user_agent,'android'));

		$lang = JFactory::getLanguage(); 
		$tag_lang=(substr($lang->getTag(),0,2)); 
		
		//Insertion des enttes GMapFP si non dj fait.
		require_once JPATH_COMPONENT.'/helpers/define.php';
		Define_ModelGMapFP::define_gmapfp(0, array('LIGHTBOX', 'APIV3'));
		        
		JHtml::_('jquery.framework');	
        $document->addStyleSheet('components/com_gmapfp/assets/dropfiles.css');
	    $document->addScript( 'components/com_gmapfp/assets/jquery.filedrop.js');
	    $document->addScript( 'components/com_gmapfp/assets/bootbox.min.js');
		
		JText::script('GMAPFP_BROWSER_NOT_SUPPORT_HTML5');
		JText::script('GMAPFP_TOO_MANY_FILES');
		JText::script('GMAPFP_FILE_TOO_LARGE');
		JText::script('GMAPFP_FILE_TYPE_NOT_ALLOWED');
		JText::script('GMAPFP_EXTENSION_TYPE_NOT_ALLOWED');
		JText::script('GMAPFP_ONLY_IMAGE_ALLOWED');
		JText::script('GMAPFP_ALREADY_EXIST');

		/**
		* Affichage de la barre de menu
		**/
        $document->addStyleSheet( $Base_URL.'media/com_gmapfp/css/editlieux/icon.css');
        $document->addStyleSheet( $Base_URL.'media/com_gmapfp/css/editlieux/general.css');
        $document->addStyleSheet( $Base_URL.'media/com_gmapfp/css/editlieux/medialist-thumbs.css');

		$items		= $this->get('Data');
		$marqueurs	= $this->get('Marqueurs');
		$custom		= $this->get('Custom');
		$galerie    = $this->get('images');
		$isNew		= ($items->id < 1);
		$lists 		= $this->get('Classements');

		if (!($canDo->get('core.edit') || ($canDo->get('core.edit.own') and ((($user->id == $items->created_by and (int)$cid[0] == $items->id)) or ($items->id == 0)))||($canDo->get('core.create') and !(int)$cid[0]))){
			$app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR').' (diag = '.$params->get('gmapfp_manage_all', 0).'_'.$user->id.'_'.$items->created_by.'_'.$items->id.')' , 'error');
			$app->setHeader('status', 403, true);
			return;
		}

		if ($lists['labels']) {
			$list = $lists['labels'];
			$labels = array();
			//$labels[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_SELECT_ITEM' ).' --' );
			$cn = 0;
			$required ='';
			if ($params->get("gmapfp_submit_labels")){$required="required";}
			
			foreach($list as $temp) {
				$cn++;
				$labels[] = JHTML::_('select.option', $temp->id, $temp->nom );
			}
			if ($cn>=1) {
				$lists['labels'] = JHTML::_('select.genericlist', $labels, 'labels[]', 'style ="size="5" class="inputbox '.$required.'" multiple="multiple"', 'value', 'text', explode(',', $items->labels) );
			}
			unset ($list);
		}
		
		if ($lists['classements']) {
			$list = $lists['classements'];
			$classements = array();
			//$classements[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_SELECT_ITEM' ).' --' );
			$cn = 0;
			$required ='';
			if ($params->get("gmapfp_submit_classements")){$required="required";}
			
			foreach($list as $temp) {
				$cn++;
				$classements[] = JHTML::_('select.option', $temp->id, $temp->nom );
			}
			if ($cn>=1) {
				$lists['classements'] = JHTML::_('select.genericlist', $classements, 'classements[]', 'size="5" class="inputbox '.$required.'" multiple="multiple"', 'value', 'text', explode(',', $items->classements) );
			}
			unset ($list);
		}
		
		if ($lists['pictos']) {
			$list = $lists['pictos'];
			$pictos = array();
			//$pictos[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_SELECT_ITEM' ).' --' );
			$cn = 0;
			$required ='';
			if ($params->get("gmapfp_submit_pictos")){$required="required";}
			
			foreach($list as $temp) {
				$cn++;
				$pictos[] = JHTML::_('select.option', $temp->id, $temp->nom );
			}
			if ($cn>=1) {
				$lists['pictos'] = JHTML::_('select.genericlist', $pictos, 'pictos[]', 'size="5" class="inputbox '.$required.'" multiple="multiple"', 'value', 'text', explode(',', $items->pictos) );
			}
			unset ($list);
		}

		jimport('joomla.language.helper');
		$List_langue['*'] = JText::_('JALL_LANGUAGE');
		$List_langue = array_merge($List_langue, JLanguageHelper::createLanguageList('', constant('JPATH_SITE'), true, true));
		$lists['langue'] = JHtml::_('select.genericlist', $List_langue, 'language', 'size="1" class="inputbox"', 'value', 'text', '*');

		// build list of categories
		if ($layout=='soumission')
		{
			$catids = array();
			$cn = 0;
			$listcategories = JHtml::_('category.options', 'com_gmapfp');
			$Les_catid = $params->get('catids');
			foreach($listcategories as $temp) {
				if (empty($Les_catid)){
						$cn++;
						$catids[] = JHTML::_('select.option', $temp->value, $temp->text );
				} else {
					if (in_array($temp->value, $Les_catid, true)) {
						$cn++;
						$catids[] = JHTML::_('select.option', $temp->value, $temp->text );
					}
				}
			}
			if ($cn>=1) {
				$lists['catid'] = JHTML::_('select.genericlist', $catids, 'catid[]', 'size="4" multiple="multiple" class="inputbox required" onchange="display_catid_field();"', 'value', 'text', '' );
			}
		}
		
		if ($layout=='edit_form')
		{
			$catids = array();
			$catids[] = JHTML::_('select.option', '0', '-- '.JText::_( 'GMAPFP_SELECT_ITEM' ).' --' );
			$cn = 0;
			$listcategories = JHtml::_('category.options', 'com_gmapfp');
			$Les_catid = $params->get('gmapf_categories_selected');
			foreach($listcategories as $temp) {
				if (empty($Les_catid)){
						$cn++;
						$catids[] = JHTML::_('select.option', $temp->value, $temp->text );
				} else {
					if (in_array($temp->value, $Les_catid, true)) {
						$cn++;
						$catids[] = JHTML::_('select.option', $temp->value, $temp->text );
					}
				}
			}
			if ($cn>=1) {
				$lists['catid'] = JHTML::_('select.genericlist', $catids, 'catid[]', 'size="4" multiple="multiple" class="inputbox required" onchange="display_catid_field();"', 'value', 'text', explode(',', $items->catid) );
			}

			$langues = array();
			$langues[] = JHTML::_('select.option', '*', JText::_( 'JALL_LANGUAGE' ) );
			$listlangue = JHtml::_('contentlanguage.existing');
			foreach($listlangue as $temp) {
				$cn++;
				$langues[] = JHTML::_('select.option', $temp->value, $temp->text );
			}
			if ($cn>=1) {
				$lists['langue'] = JHTML::_('select.genericlist', $langues, 'language', 'size="1" class="inputbox"', 'value', 'text', $items->language );
			}
		
			$lists['access'] = JHTML::_('access.level', 'access', intval( $items->access ), '', false, false);
		};

		//creation de la liste des images principales
		jimport( 'joomla.filesystem.folder' );
		$imageFiles = JFolder::files( JPATH_SITE.'/images/gmapfp' );
        $directory	= JURI::base().'images/gmapfp/thumbsArt/';
		$javascript	= 'onchange="changeDisplayImage('."'".$directory."'".');"';
		$images 	= array(  JHTML::_('select.option',  '', '- '. JText::_( 'Select Image' ) .' -' ) );
		$extensions = "bmp|gif|jpg|jpeg|png";
		$userid		= $user->id;
		if ($params->get("gmapfp_view_all_img", 1)) {
			$image_existe = true;
			foreach ( $imageFiles as $file ) {
			   if ( preg_match( "#$extensions#i", $file ) ) {
			   		$name = strstr($file, '__');
					if ($name)
						$images[] = JHTML::_('select.option',  $file, substr($name, 2 ));
					else
						$images[] = JHTML::_('select.option',  $file);
				}
			}
		} else {
			$image_existe = false;
			foreach ( $imageFiles as $file ) {
			   if ( (preg_match( "#$extensions#i", $file ))AND((substr($file, 0, strlen($userid)+2) == $userid.'__' )OR($file=='blank.png')) ) {
					if ($file=='blank.png') {
						$images[] = JHTML::_('select.option',  $file);
					} else {
						$images[] = JHTML::_('select.option',  $file, substr($file, strlen($userid)+2 ));
						if ($file == $items->img) $image_existe = true;
					}
				}
			}
		};
		if (!$image_existe) {
			foreach ( $imageFiles as $file ) {
				if ($file == $items->img) {
			   		$name = strstr($file, '__');
					if ($name)
						$images[] = JHTML::_('select.option',  $file, substr($name, 2 ));
					else
						$images[] = JHTML::_('select.option',  $file);
					break;
				}
			}
		}
		$required ='';
		if ($params->get('gmapfp_submit_picture')) $required = "required";
		$lists['images'] = JHTML::_('select.genericlist',  $images, 'img', 'class="inputbox '.$required.'" size="1" '. $javascript, 'value', 'text', $items->img );
		//**

		if ($layout != 'media_list') {
			$model = $this->getModel();
			$this->extension_fields = $model->getChamps($items->id, $params->get('choix_view_champs_selected'));
			$this->pane_name = $model->PaneName();
		}

		$droits = array();
		$droits['core.edit.state'] = $canDo->get('core.edit.state');
		$droits['core.create'] = $canDo->get('core.create');
		
		$this->canDo = $droits;
		$this->config_media = $config_media;
		$this->custom =	$custom;
		$this->items = $items;
		$this->marqueurs = $marqueurs;
		$this->params = $params;
		$this->lists = $lists;
		$this->galerie = $galerie;
		$this->total = $this->get( 'Total' );

		$this->_prepareDocument();

		parent::display($tpl);
	}

	/**
	 * Prepares the document
	 */
	protected function _prepareDocument()
	{
		$app		= JFactory::getApplication();
		$menus		= $app->getMenu();
		$pathway	= $app->getPathway();
		$title		= null;
		
		if($this->layout == "article") {
			$article = true;
			$this->item = $this->lieux[0];
		} else {
			$article = false;
			$this->item = "";
		}

		// Because the application sets a default page title,
		// we need to get it from the menu item itself
		$menu = $menus->getActive();

		if ($menu)
		{
			$this->params->def('page_heading', $this->params->get('page_title', $menu->title));
		}
		else
		{
			$this->params->def('page_heading', JText::_('JGLOBAL_ARTICLES'));
		}

		$title = $this->params->get('page_title', '');

		// Check for empty title and add site name if param is set
		if (empty($title))
		{
			$title = $app->get('sitename');
		}
		elseif ($app->get('sitename_pagetitles', 0) == 1)
		{
			$title = JText::sprintf('JPAGETITLE', $app->get('sitename'), $title);
		}
		elseif ($app->get('sitename_pagetitles', 0) == 2)
		{
			$title = JText::sprintf('JPAGETITLE', $title, $app->get('sitename'));
		}

		if (empty($title))
		{
			$title = $this->item->nom;
		}
		$this->document->setTitle($title);

		if ($this->params->get('menu-meta_description'))
		{
			$this->document->setDescription($this->params->get('menu-meta_description'));
		}

		if ($this->params->get('menu-meta_keywords'))
		{
			$this->document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
		}

		if ($this->params->get('robots'))
		{
			//$this->document->setMetadata('robots', $this->params->get('robots'));
		}
	}

    function setImage($index = 0)
    {
        if (isset($this->galerie[$index])) {
            $this->_tmp_img = $this->galerie[$index];
        } else {
            $this->_tmp_img = new JObject;
        }
    }

}
