<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.109pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPViewGestionLieux extends JViewLegacy
{
	protected $item;
	protected $params;
	protected $layout;
	protected $tmpl;

	function display($tpl = null)
	{
		$app	= JFactory::getApplication(); 
		$Itemid		= (int) $app->input->get('Itemid'); 
		$option		= $app->input->get('option'); 
		$this->tmpl	= ($app->input->get('tmpl', '') == 'component');

		$document	= JFactory::getDocument();
		$user   	= JFactory::getUser();
		$params 	= $app->getParams();

		//gestion des droits
		require_once JPATH_COMPONENT_ADMINISTRATOR.'/helpers/gmapfp.php';
		$canDo	= GMapFPHelper::getActions();

		// Make sure you are logged in and have the necessary access rights
		if (!$canDo->get('core.create') and !$canDo->get('core.delete') and !$canDo->get('core.edit') and !$canDo->get('core.edit.own') and !$canDo->get('core.edit.state')) {
				$link = JRoute::_('index.php?option=com_users&view=login&Itemid='.$Itemid, false);
				$returnURL = JUri::current();
				$fullURL = new JURI($link);
				$fullURL->setVar('return', base64_encode($returnURL));
				$link = $fullURL->toString();
				$app->redirect($link);
			return;
		}

		// Get data from the model
		$items		= $this->get( 'Data');
        $total      = $this->get( 'Total' );
		
        // Parametres
        $params->def('nombre_articles',  20);

        $limitstart = $app->input->get('limitstart', 0, 'int');
        $default_limit = $params->get('nombre_articles');
        $limit = $app->getUserStateFromRequest($option.$Itemid.'.limit', 'limit', $default_limit, 'int');

        $app->input->set('limit', (int) $limit);

        jimport('joomla.html.pagination');
        $pagination = new JPagination($total, $limitstart, $limit);

		$document->addCustomTag('<link rel="stylesheet" href="'.$this->baseurl.'/media/com_gmapfp/css/editlieux/icon.css" type="text/css" media="screen" />');
		$document->addCustomTag('<link rel="stylesheet" href="'.$this->baseurl.'/media/com_gmapfp/css/editlieux/general.css" type="text/css" media="screen" />');

		$filtrevilles = array();
		$filtrevilles[] = JHTML::_('select.option', 0, '-- '.JText::_( 'GMAPFP_VILLE_FILTRE' ).' --' );
				foreach($this->get('listville') as $temp) {
					$filtrevilles[] = JHTML::_('select.option', $temp->ville );
				}

		$filtredepartements = array();
		$filtredepartements[] = JHTML::_('select.option', 0, '-- '.JText::_( 'GMAPFP_DEPARTEMENT_FILTRE' ).' --' );
				foreach($this->get('listdepartement') as $temp) {
					$filtredepartements[] = JHTML::_('select.option', $temp->departement );
				}
		
		$filtrepays = array();
		$filtrepays[] = JHTML::_('select.option', 0, '-- '.JText::_( 'GMAPFP_PAYS_FILTRE' ).' --' );
				foreach($this->get('listpays') as $temp) {
					$filtrepays[] = JHTML::_('select.option', $temp->pay );
				}
		
		$filtrecategories = array();
		$filtrecategories[] = JHTML::_('select.option', '0', '-- '.JText::_( 'GMAPFP_CATEGORIE_FILTRE' ).' --' );
		$cn = 0;
		$listcategories = JHtml::_('category.options', 'com_gmapfp');
		$Les_catid = $params->get('gmapf_categories_selected');
		foreach($listcategories as $temp) {
			if (empty($Les_catid)){
					$cn++;
					$filtrecategories[] = JHTML::_('select.option', $temp->value, $temp->text );
			} else {
				if (in_array($temp->value, $Les_catid, true)) {
					$cn++;
					$filtrecategories[] = JHTML::_('select.option', $temp->value, $temp->text );
				}
			}
		}

		$filter_order		= $app->getUserStateFromRequest( $option.$Itemid.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir 	= $app->getUserStateFromRequest( $option.$Itemid.'filter_order_Dir', 	'filter_order_Dir', 	'', 											'word');
		$search				= $app->getUserStateFromRequest( $option.$Itemid.'search', 			'search', 				'',												'string' );
		$filtreville 		= $app->getUserStateFromRequest( $option.$Itemid.'filtreville', 		'filtreville', 			'-- '.JText::_( 'GMAPFP_VILLE' ).' --', 		'string' );
		$filtredepartement 	= $app->getUserStateFromRequest( $option.$Itemid.'filtredepartement', 'filtredepartement', 	'-- '.JText::_( 'GMAPFP_DEPARTEMENT' ).' --', 	'string' );
		$filtrepay		 	= $app->getUserStateFromRequest( $option.$Itemid.'filtrepay', 		'filtrepay', 			'-- '.JText::_( 'GMAPFP_PAYS' ).' --', 			'string' );
		$filtrecategorie 	= $app->getUserStateFromRequest( $option.$Itemid.'filtrecategorie', 	'filtrecategorie', 		0, 	'string' );

		$lists['ville'] 		= JHTML::_('select.genericlist', $filtrevilles, 'filtreville', 'size="1" class="inputbox" onchange="form.submit()"', 'value', 'text', $filtreville );
		$lists['departement'] 	= JHTML::_('select.genericlist', $filtredepartements, 'filtredepartement', 'size="1" class="inputbox" onchange="form.submit()"', 'value', 'text', $filtredepartement );
		$lists['pays'] 			= JHTML::_('select.genericlist', $filtrepays, 'filtrepay', 'size="1" class="inputbox" onchange="form.submit()"', 'value', 'text', $filtrepay );
		//$lists['categorie'] 	= JHTML::_('list.category',  'filtrecategorie', $option, intval( $filtrecategorie ), 'onchange="form.submit()"');
		$lists['categorie'] 	= JHTML::_('select.genericlist', $filtrecategories, 'filtrecategorie', 'size="1" class="inputbox" onchange="form.submit()"', 'value', 'text', $filtrecategorie );

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		// search filter
		$lists['search'] = $search;

		$this->canDo = $canDo;
		$this->lists = $lists;
		$this->items =	$items;
		$this->pagination = $pagination;
		$this->params = $params;
		$this->total = $total;
		$this->categories	= $this->get('Categories');

		JHtmlBehavior::framework();

		$this->_prepareDocument();

		parent::display($tpl);
	}
	/**
	 * Prepares the document
	 */
	protected function _prepareDocument()
	{
		$app		= JFactory::getApplication();
		$menus		= $app->getMenu();
		$pathway	= $app->getPathway();
		$title		= null;
		
		if($this->layout == "article") {
			$article = true;
			$this->item = $this->lieux[0];
		} else {
			$article = false;
			$this->item = "";
		}

		// Because the application sets a default page title,
		// we need to get it from the menu item itself
		$menu = $menus->getActive();

		if ($menu)
		{
			$this->params->def('page_heading', $this->params->get('page_title', $menu->title));
		}
		else
		{
			$this->params->def('page_heading', JText::_('JGLOBAL_ARTICLES'));
		}

		$title = $this->params->get('page_title', '');

		// Check for empty title and add site name if param is set
		if (empty($title))
		{
			$title = $app->get('sitename');
		}
		elseif ($app->get('sitename_pagetitles', 0) == 1)
		{
			$title = JText::sprintf('JPAGETITLE', $app->get('sitename'), $title);
		}
		elseif ($app->get('sitename_pagetitles', 0) == 2)
		{
			$title = JText::sprintf('JPAGETITLE', $title, $app->get('sitename'));
		}

		if (empty($title))
		{
			$title = $this->item->nom;
		}
		$this->document->setTitle($title);

		if ($this->params->get('menu-meta_description'))
		{
			$this->document->setDescription($this->params->get('menu-meta_description'));
		}

		if ($this->params->get('menu-meta_keywords'))
		{
			$this->document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
		}

		if ($this->params->get('robots'))
		{
			//$this->document->setMetadata('robots', $this->params->get('robots'));
		}
	}

}
