<?php 
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.125pro
	* Creation date: Novembre 2020
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die; 

//fonction pour execution des plugins dans la personnalisation
$dispatcher = JEventDispatcher::getInstance(); 
JPluginHelper::importPlugin('content'); 

?>

<?php if ($this->params->get('show_page_heading', 1)) : ?>
<div class="componentheading<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
<h1>
	<?php echo $this->escape($this->params->get('page_heading')); ?>
</h1>
</div>
<?php endif; ?>

<?php if (($this->params->get('show_description', 1) || $this->params->def('show_description_image', 1)) && $this->params->def('catid')) : ?>
	<div class="category-desc">
	<?php if ($this->params->get('show_description_image') && $this->category->image) : ?>
		<img src="<?php echo $this->category->image; ?>" alt="<?php echo $this->category->image_alt; ?>"/>
	<?php endif; ?>
	<?php if ($this->params->get('show_description') && $this->category->description) : ?>
		<?php echo JHtml::_('content.prepare', $this->category->description, '', 'com_gmapfp.category'); ?>
	<?php endif; ?>
	<div class="clr"></div>
	</div>
<?php endif; ?>

<?php
echo '<div class="gmapfp">';

if ($this->params->get('gmapfp_filtre')==1) {
	if (isset($this->perso->intro_filtre)) {
		echo '<div class="gmapfp_intro_filtre">'.JHtml::_('content.prepare', $this->perso->intro_filtre).'</div>';
	}
	$ajax = '';
	if ($this->ajax) $ajax = '_ajax';
	require(JPATH_SITE.'/components/com_gmapfp/views/gmapfp/tmpl/item_filtre'.$ajax.'.php');
};

if ((($this->params->get('type_affichage'))==0)||(($this->params->get('type_affichage'))==2)) : 
	echo '<div style="overflow: auto; width: 100%;">';
	echo $this->map['map'];
	if ($this->map['iti']) {
		echo '<legend style="float:left;">'.JText::_( 'GMAPFP_DIRECTION' ).'</legend>';
		echo $this->map['iti'];
	}
	echo '</div>';
	echo '<p class="map_separator">&nbsp</p>';
endif;
if (isset($this->perso->intro_detail)) {
	echo '<div class="gmapfp_intro_detail">'.JHtml::_('content.prepare', $this->perso->intro_detail).'</div>';
}

//Verifier si un fichier article_template existe
$template = '';
if (($this->params->get('gmapfp_template')) and (is_file(JPATH_SITE.'/components/com_gmapfp/views/gmapfp/tmpl/'.$this->params->get('gmapfp_template').'_default.php'))) {
	$template = $this->params->get('gmapfp_template');
	$this->_layout=$template;
	echo JViewLegacy::Display('default');
	$this->_layout='default';
} else {

	$span_count = 0;
	echo '<div class="blog'.$this->params->get('pageclass_sfx').' gmapfp gmapfp-'.$this->params->get('gmapfp_template', 'default').'">';
	 
	if (($this->params->get('type_affichage')<>2)&&($this->params->get('nombre_articles'))) {
		if (substr($this->params->get('gmapfp_template'), 0, 4) == 'span') {
			$span_type = (int) substr($this->params->get('gmapfp_template'), 4);
			$span_value = 12 / $span_type;
			echo "<div class='row-fluid rstpl-m-bot row-0 clearfix'>";
			// echo "<div class=\"items-row cols-".(int) $span_type." row-" . $span_count . " row-fluid clearfix\">";
			//ajustement automatique de la hauteur de toutes les images
			$document = JFactory::getDocument();
			$document->addScriptDeclaration('
				//Ajuste hauteur main img gmapfp
				jQuery( window ).load(function() {
					update_height (".gmapfp_auto_height_main_img", "img");
				});
				jQuery( window ).resize(function() {
					update_height (".gmapfp_auto_height_main_img", "img");
				});
				//Ajuste hauteur titre gmapfp
				jQuery( window ).load(function() {
					update_height (".gmapfp_titre", ".gmapfp_largeur_titre");
				});
				jQuery( window ).resize(function() {
					update_height (".gmapfp_titre", ".gmapfp_largeur_titre");
				});
				//Ajuste hauteur detail gmapfp
				jQuery( window ).load(function() {
					update_height (".gmapfp_auto_height_detail", ".article-info");
				});
				jQuery( window ).resize(function() {
					update_height (".gmapfp_auto_height_detail", ".article-info");
				});
				//Ajuste hauteur corp gmapfp
				jQuery( window ).load(function() {
					update_height (".rstpl-box-content", ".description");
				});
				jQuery( window ).resize(function() {
					update_height (".rstpl-box-content", ".description");
				});
				function update_height (conteneur, contenant) {
					var max_heigt = 0;
					jQuery(conteneur).each(function(j, item) {
						jQuery(item).height("800px");
					})
					jQuery(conteneur + " " + contenant).each(function(j, item) {
						if (jQuery(item).height() > max_heigt)
							max_heigt = jQuery(item).height();
					})
					jQuery(conteneur).each(function(j, item) {
						jQuery(item).height(max_heigt);
					})
				}
			');
		}
		for ($i = $this->pagination->limitstart; $i < ($this->pagination->limitstart + $this->params->get('nombre_articles')); $i++) : 
			if ($i >= $this->total) : break; endif;

			if (substr($this->params->get('gmapfp_template'), 0, 4) == 'span') {
				$row = (int)(($span_count + 1) / $span_value);
				if ($span_count and floor($span_count/$span_type) == $span_count/$span_type) {
					echo "</div>";
					echo "<div class='row-fluid rstpl-m-bot row-".$row." clearfix'>";
					// echo "<div class=\"items-row cols-".(int) $span_type." row-" . $row. " row-fluid clearfix\">";
				} 
				$this->column = ( $span_count % $span_type) + 1; 
				$span_count++;
			}
			
			$this->lieu = $this->getItem($i, $this->params);
			$this->champs = $this->getChamps($i); 
			//$this->lieu =& $this->lieux[$i];

			// Ajout des vnements
			$this->lieu->event = new stdClass;
			$offset = 0;
			$results = $dispatcher->trigger('onGMapFPAfterIcon', array('com_gmapfp.article', &$this->lieu, &$this->params, $offset));
			$this->lieu->event->afterDisplayIcon = trim(implode("\n", $results));

			$results = $dispatcher->trigger('onGMapFPAfterTitle', array('com_gmapfp.liste', &$this->lieu, &$this->params, $offset));
			$this->lieu->event->afterDisplayTitle = trim(implode("\n", $results));

			$results = $dispatcher->trigger('onGMapFPBeforeDisplay', array('com_gmapfp.liste', &$this->lieu, &$this->params, $offset));
			$this->lieu->event->beforeDisplayContent = trim(implode("\n", $results));

			$results = $dispatcher->trigger('onGMapFPAfterDisplay', array('com_gmapfp.liste', &$this->lieu, &$this->params, $offset));
			$this->lieu->event->afterDisplayContent = trim(implode("\n", $results));

			//affichage du dtail d'un lieu
			$template = '';
			if (($this->params->get('gmapfp_template')) and (is_file(JPATH_SITE.'/components/com_gmapfp/views/gmapfp/tmpl/tmpl_'.$this->params->get('gmapfp_template').'_article.php'))) {
			$template = '_'.$this->params->get('gmapfp_template');
			}			
			$this->_layout='tmpl'.$template;
			echo JViewLegacy::Display('article');
			$this->_layout='default';
		endfor;
		if (substr($this->params->get('gmapfp_template'), 0, 4) == 'span') {
			echo "</div>";
		}
	} else $i = $this->pagination->limitstart;
	?>
	</div>
	
	<?php if (($this->params->get('show_pagination'))&&(($this->params->get('type_affichage'))<>2)) : ?>
			<div class="pagination">
				<?php echo $this->pagination->getPagesLinks(); ?>
			</div>
	<?php endif; ?>
	<?php if (($this->params->get('show_pagination_results'))&&(($this->params->get('type_affichage'))<>2)) : ?>
			<div class="pagination">
				<?php echo $this->pagination->getPagesCounter(); ?>
			</div>
	<?php endif;
}
if (isset($this->perso->conclusion_detail)) {
	echo '<div class="gmapfp_conclusion_detail">'.JHtml::_('content.prepare', $this->perso->conclusion_detail).'</div>';
}

if (($this->params->get('type_affichage'))==1) : 
	echo '<div style="overflow: auto; width: 100%;">';
	echo $this->map['map'];
	if ($this->map['iti']) {
		echo '<legend style="float:left;">'.JText::_( 'GMAPFP_DIRECTION' ).'</legend>';
		echo $this->map['iti'];
	}
	echo '</div>';
endif;

if ($this->params->get('gmapfp_licence')) : ?>
<table class="gmapfp">
    <tr>
        <td valign="top" align="center">
            <?php echo JText::_('GMAPFP_COPYRIGHT'); ?>
        </td>
    </tr>
</table>
<?php endif; ?>
</div>