<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.123pro
	* Creation date: septembre 2019
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die; 
		
$dispatcher	= JEventDispatcher::getInstance();

$min_height = '';
if ($this->params->get('gmapfp_article_onglets', 1)) 
	$min_height = " min-height:".$this->params->get('gmapfp_height')."px;";

echo '<div class="gmapfp" id="gmapfp_article" itemscope itemtype="http://schema.org/Place">';
	$document   = JFactory::getDocument();
	$app		= JFactory::getApplication();

	foreach ($this->lieux as $lieu) { 
	// insertion du lien canonique pour viter l'indexation par les robbots des lien comporant le "tmpl=component"
		$link =JRoute::_('index.php?option=com_gmapfp&view=gmapfp&layout=article&map_id='.$lieu->slug, false);
		$document->addCustomTag( '<link rel="canonical" href="'.$link.'" />');
		
		$this->lieu = $this->getItem(0, $this->params);
		$this->champs = $this->getChamps(0); 

		// Ajout des vnements
		$this->lieu->event = new stdClass;
		$offset = 0;
		$results = $dispatcher->trigger('onGMapFPAfterIcon', array('com_gmapfp.article', &$this->lieu, &$this->params, $offset));
		$this->lieu->event->afterDisplayIcon = trim(implode("\n", $results));

		$results = $dispatcher->trigger('onGMapFPAfterTitle', array('com_gmapfp.article', &$this->lieu, &$this->params, $offset));
		$this->lieu->event->afterDisplayTitle = trim(implode("\n", $results));

		$results = $dispatcher->trigger('onGMapFPBeforeDisplay', array('com_gmapfp.article', &$this->lieu, &$this->params, $offset));
		$this->lieu->event->beforeDisplayContent = trim(implode("\n", $results));

		$results = $dispatcher->trigger('onGMapFPAfterDisplay', array('com_gmapfp.article', &$this->lieu, &$this->params, $offset));
		$this->lieu->event->afterDisplayContent = trim(implode("\n", $results));

		$this->path = COM_GMAPFP_IMAGES_FOLDER."/GA".$lieu->id;
		$this->path2 = COM_GMAPFP_IMAGES_HTTP."/GA".$lieu->id.'/';
		$this->path_thumbs = COM_GMAPFP_IMAGES_HTTP."/GA".$lieu->id."/thumbs/";

		if ($app->get('MetaAuthor') == '1' && $lieu->author)
		{
			$this->document->setMetaData('author', $lieu->author);
		}

		if ($lieu->metadesc) {
			$document->setDescription( $lieu->metadesc );
		}
		if ($lieu->metakey) {
			$document->setMetadata('keywords', $lieu->metakey);
		}
		
		$catids = explode(',', $lieu->catid);
		$cat_title = array();
		foreach ($catids as $catid) {
			$cat_title[] = $this->categories[$catid]->title;
		}
		$document->setTitle(@$lieu->ville.' : '.$lieu->nom.' ('.implode(', ', $cat_title).')');
		$mdata = new JRegistry($this->lieu->metadata);
		$mdata = $mdata->toArray();
		foreach ($mdata as $k => $v)
		{
			if ($v) {
				$document->setMetadata($k, $v);
			}
		}
	?>
		<div id="enregistrement">
			<?php
				//affichage du dtail d'un lieu
				$template = '';
				if (($this->params->get('gmapfp_template_article')) and (is_file(JPATH_SITE.'/components/com_gmapfp/views/gmapfp/tmpl/tmpl_'.$this->params->get('gmapfp_template_article').'_article.php'))) {
					$template = '_'.$this->params->get('gmapfp_template_article');
				}			
				$this->_layout='tmpl'.$template;
				echo JViewLegacy::Display('article');
				$this->_layout='default';
			?>
		</div>
	<?php       
		//recherche premier onglet existant
		$active = '';
		if ($this->lieu->introtext!=null)
			$active = array('active' => 'description');
		elseif (!array_search(22, array_column($this->champs, 'type')) and ($this->lieu->horaires_prix!=null)&&($this->lieu->params->get('gmapfp_afficher_horaires_prix_onglet')==1))
			$active = array('active' => 'horaires');
		elseif ($this->getFirstPane())
			$active = array('active' => 'perso_pane_'.$this->getFirstPane());
		elseif (!array_search(21, array_column($this->champs, 'type')) and $this->lieu->params->get('show_map_onglet')==1 and $this->lieu->glat!='' and $this->lieu->glng!='')
			$active = array('active' => 'carte');
		elseif (!$active and !array_search(24, array_column($this->champs, 'type')) and ($this->lieu->email!=null) and ($this->params->get('gmapfp_msg_onglet')==1))
			$active = array('active' => 'message');
		
		echo JHtml::_('bootstrap.startTabSet', 'gmapfp_pane', $active);
		//description
		if ($this->lieu->introtext!=null) {
			if ($this->custom[10]->nom) {
				$titre = $this->custom[10]->nom;
			}else{
				$titre = JText::_('GMAPFP_MESSAGE');
			}
			if (!array_search(29, array_column($this->champs, 'type'))) {
				echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'description', $titre);
					echo "<div style='width:100%;".$min_height." max-height:100%;'  itemprop='description'>";
						if ($this->params->get('gmapfp_afficher_intro_italique')==1) { ?>
							<span><em><?php echo JHtml::_('content.prepare', $this->lieu->introtext); ?></em><?php echo JHtml::_('content.prepare', $this->lieu->fulltext); ?></span><?php ;
						} else { ?>
							<span><?php echo JHtml::_('content.prepare', $this->lieu->introtext); echo JHtml::_('content.prepare', $this->lieu->fulltext); ?></span><?php ;
						}
					echo "</div>";
				echo JHtml::_('bootstrap.endTab');
			}
		}
		//horaires et prix si non dans les onglets perso
		if (!array_search(22, array_column($this->champs, 'type')) and ($this->lieu->horaires_prix!=null) and ($this->lieu->params->get('gmapfp_afficher_horaires_prix_onglet')==1)) {
			if ($this->custom[11]->nom) {
				$h_p = $this->custom[11]->nom;
			}else{
				$h_p = JText::_('GMAPFP_HORAIRES_PRIX');
			}
			echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'horaires', JText::_( $h_p ));
				echo "<div style='width:100%;".$min_height." max-height:100%;' >";
					echo JHtml::_('content.prepare', $this->lieu->horaires_prix);
				echo "</div>";
			echo JHtml::_('bootstrap.endTab');
		}
		//onglet perso
		echo $this->getChampsHtml(0, 1);
		//champ custom en onglet
		echo $this->getChampsHtml(5, 1);
		//onglet galerie si non dans les onglets perso
		if (!array_search(23, array_column($this->champs, 'type')) and $this->params->get('show_gallery_onlet')) {
			$this->setLayout('item_galerie_v'.$this->lieu->params->get('gmapfp_num_galerie', 3));
			echo $this->loadTemplate();
		}
		//onglet email si non dans les onglets perso
		if (!array_search(24, array_column($this->champs, 'type')) and ($this->lieu->email!=null)and($this->lieu->params->get('gmapfp_msg_onglet')==1)) {
			echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'message', JText::_( 'GMAPFP_DISPLAY_MSG' ));
				echo "<div style='width:100%;".$min_height." max-height:100%;' >";
				$this->_layout='item';
				echo JViewLegacy::Display('msg');
				$this->_layout='default';
				echo "</div>";
			echo JHtml::_('bootstrap.endTab');
		}
		//onglet lien externe si non dans les onglets perso
		if (!array_search(25, array_column($this->champs, 'type'))) {
			$link4=substr($this->lieu->link,0,4);
			$link5=substr($this->lieu->link,0,5);
			$link9=substr($this->lieu->link,0,9);
			$link10=substr($this->lieu->link,0,10);
			$linkok=0;
			if ((!empty($this->lieu->icon))||(!$this->lieu->icon='')) {
				if ((int)$this->lieu->article_slug >= 1) {
					$linkok=2;
				};
				if (($link5=="http:")||($link4=="www.")||($link9=="index.php")) {
					$linkmap=$this->lieu->link;
					if ($link4=="www.") {$linkmap="http://".$linkmap;};
					if ($link10=="index.php?") {$linkmap=JURI::base().$linkmap."&tmpl=component";};
					$linkok=1;
				};
			};
			if ($linkok&&($this->lieu->icon<>'')) {
				if (!$this->lieu->icon_label) {
					$label = $this->lieu->icon;
				}else{
					$label = $this->lieu->icon_label;
				}
				echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'lien_ext', $label);
					if ($linkok == 1) {
						echo "<iframe style='".$min_height." width:100%;' src='".$linkmap."'><a href='".$linkmap."'>SELFHTML</a></iframe>";
					} else {
						echo "<div style='".$min_height." width:100%;' >";
							echo JHtml::_('content.prepare', $this->lieu->article_text);
						echo "</div>";
					};
				echo JHtml::_('bootstrap.endTab');
			}
		}
		//onglet JComments si non dans les onglets perso
		  $jcomments =  JPATH_SITE.'/components/com_jcomments/jcomments.php';
		  if (!array_search(26, array_column($this->champs, 'type')) and (file_exists($jcomments))and($this->params->get('gmapfp_jcomments'))) {
			require_once($jcomments);
			echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'JComments', JText::_( 'GMAPFP_JCOMMENT' ));
				echo '<div style="clear: both;">';
				echo JComments::showComments($lieu->id, 'com_gmapfp', $lieu->nom);
				echo '</div>';
			echo JHtml::_('bootstrap.endTab');
		  }
		//carte si non dans les onglets perso
		if (!array_search(21, array_column($this->champs, 'type')) and $this->lieu->params->get('show_map_onglet')==1 and $this->lieu->glat!='' and $this->lieu->glng!='') {
			echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'carte', JText::_( 'GMAPFP_CARTE' ));
				echo '<div id="mapmap" itemprop="geo" itemscope itemtype="http://schema.org/GeoCoordinates">'."\n";
				echo ' <meta itemprop="latitude" content="'.$this->lieu->glat.'" />'."\n";
				echo ' <meta itemprop="longitude" content="'.$this->lieu->glng.'" />'."\n";
				echo $this->map['map'];
				if ($this->map['iti']) {
					echo '<legend style="float:left;">'.JText::_( 'GMAPFP_DIRECTION' ).'</legend>';
					echo $this->map['iti'];
				}
				echo '</div>';
			echo JHtml::_('bootstrap.endTab');
		}
		//onglet ItemRating si non dans les onglets perso
		  $itemrating =  JPATH_SITE.'/components/com_itemrating/itemrating.php';
		  if (!array_search(27, array_column($this->champs, 'type')) and (file_exists($itemrating))and($this->params->get('gmapfp_itemrating_show', 3) == 3 or $this->params->get('gmapfp_itemrating_show', 3) == 2)) {
			echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'itemrating', JText::_( 'GMAPFP_RATING' ));
				echo '<div style="clear: both;">';
				$this->_layout='item';
				echo JViewLegacy::Display('ratingitem');
				$this->_layout='default';
				echo '</div>';
			echo JHtml::_('bootstrap.endTab');
		  }

		echo JHtml::_('bootstrap.endTabSet');
		//champs perso sous onglets
		echo $this->getChampsHtml(7, 1);
	};
?>
</div>
