<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.125pro
	* Creation date: Décembre 2020
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die('Restricted access'); 

$row	= $this->lieu;
$config	= $row->params;
$champs = $this->champs;

$this->path = COM_GMAPFP_IMAGES_FOLDER."/GA".$row->id;
$this->path2 = COM_GMAPFP_IMAGES_HTTP."/GA".$row->id.'/';
$this->path_thumbs = COM_GMAPFP_IMAGES_HTTP."/GA".$row->id."/thumbs/";

$titre = JPATH_ROOT.'/components/com_gmapfp/views/gmapfp/tmpl/tmpl_titre_article.php';

//fonction pour execution des plugins
$dispatcher = JEventDispatcher::getInstance(); 
JPluginHelper::importPlugin('content'); 

$min_height = '';
if ($this->params->get('gmapfp_article_onglets', 1)) $min_height = "min-height:".$config->get('gmapfp_height')."px;";

?>
<div id="gmapfp_article" class="row-fluid gmapfp gmapfp_table<?php echo $this->params->get('pageclass_sfx');?>">
	<?php //include $titre; ?>
	<div class="article-tools">
		<?php
			echo '<meta itemprop="dateCreated" content="'.substr($row->created, 0, 10).'">';
			if ( $this->params->get( 'show_create_date' )) {
				echo '<span class="createdate">'.JHTML::_('date',  $row->created,  JText::_('DATE_FORMAT_LC2') ).'&nbsp;&nbsp;</span>';
			}
			if (($row->author!=null)&&($this->params->get('show_author')==1)) {
				echo '<span class="createby" itemprop="author">'.$row->author.'</span>';
			}
			if ( $this->params->get( 'show_hit' )) {
				echo '<span>&nbsp;&nbsp;|&nbsp;&nbsp;'.JText::_('JGLOBAL_HITS').': '.$row->hits.'</span>';
			}
		?>
	</div>
	<div class="row-fluid">
		<div class="gmapfp_titre span8">
			<?php 
				echo '<h1 itemprop="name" style="display: inline-block;">';
				echo $row->nom;
				echo '</h1>';
				//si affichage d'un article ou d'une catégorie d'article, n'affiche pas le nom de la catégorie
				if ( $this->params->get( 'show_category' )) {
					if (($layout!='categorie')) {
						$catids = explode(',', $row->catid);
						$cat_title = array();
						foreach ($catids as $catid) {
							$cat_title[] = $this->categories[$catid]->title;
						}

						echo '<div style="display: inline-block;"><h4>('.implode(', ', $cat_title).')</h4></div>';
					};
				}
			?>
		</div>
		<div class="gmapfp_icon span4">
			<?php echo $row->event->afterDisplayIcon; ?>
		</div>
	</div>
	<?php echo $row->event->afterDisplayTitle; ?>
	
	<div class="gmapfp_detail">
		<?php 
		echo '<div class="span4 colone1">';
			// champs avant adresse
			echo $this->getChampsHtml(0);
				
			echo '<div class="separateur1"></div>';
			// adresse
			if (!array_search(31, array_column($this->champs, 'type'))) {
				echo JLayoutHelper::render('adresse', array('params' => $this->params, 'row' => $row), JPATH_ROOT.'/components/com_gmapfp/layouts');
			}
			
			echo '<div class="separateur2"></div>';
			// champs après adresse
			echo $this->getChampsHtml(1);
				
			echo '<div class="separateur3"></div>';
			// champs classements / labels et picots
			if (!array_search(34, array_column($this->champs, 'type'))) {
				echo JLayoutHelper::render('classements', array('params' => $this->params, 'row' => $row, 'lists' => $this->lists), JPATH_ROOT.'/components/com_gmapfp/layouts');
			}
			if (!array_search(33, array_column($this->champs, 'type'))) {
				echo JLayoutHelper::render('labels', array('params' => $this->params, 'row' => $row, 'lists' => $this->lists), JPATH_ROOT.'/components/com_gmapfp/layouts');
			}
			if (!array_search(32, array_column($this->champs, 'type'))) {
				echo JLayoutHelper::render('pictos', array('params' => $this->params, 'row' => $row, 'lists' => $this->lists), JPATH_ROOT.'/components/com_gmapfp/layouts');
			}

			echo '<div class="separateur4"></div>';
			// champs avant email
			echo $this->getChampsHtml(2);

			echo '<div class="separateur5"></div>';
			// champs email et web
			if (!array_search(30, array_column($this->champs, 'type'))) {
				echo JLayoutHelper::render('main_email', array('params' => $this->params, 'row' => $row), JPATH_ROOT.'/components/com_gmapfp/layouts');
			}
			if (!array_search(35, array_column($this->champs, 'type'))) {
				echo JLayoutHelper::render('site_web', array('params' => $this->params, 'row' => $row), JPATH_ROOT.'/components/com_gmapfp/layouts');
			}

			echo '<div class="separateur6"></div>';
			// champs après web
			echo $this->getChampsHtml(3);

			echo '<div class="separateur7"></div>';
			// map
			if ($this->lieu->params->get('show_map_onglet')==1 and $this->lieu->glat!='' and $this->lieu->glng!='') {
				echo '<div id="mapmap" itemprop="geo" itemscope itemtype="http://schema.org/GeoCoordinates">'."\n";
				echo ' <meta itemprop="latitude" content="'.$this->lieu->glat.'" />'."\n";
				echo ' <meta itemprop="longitude" content="'.$this->lieu->glng.'" />'."\n";
				echo $this->map['map'];
				echo '</div>';
			}
			
				echo '<div class="separateur8"></div>';
			//avant description
			echo $this->getChampsHtml(4);

		echo '</div>';
		echo '<div class="span8 colonne2">';
			$this->startTab = false;
			// recherche les photos de la galerie
			require(JPATH_SITE.'/components/com_gmapfp/views/gmapfp/tmpl/item_galerie_v'.$this->lieu->params->get('gmapfp_num_galerie', 2).'.php');
			// début onglets
			// active le premier onglet existant
			$active = '';
			if ($this->lieu->introtext!=null)
				$active = array('active' => 'description');
			elseif (($this->lieu->horaires_prix!=null)&&($this->lieu->params->get('gmapfp_afficher_horaires_prix')==1))
				$active = array('active' => 'horaire');
			else
				$active = array('active' => 'perso_pane_'.$this->getFirstPane());

			if (!$active and ($this->lieu->email!=null)and($this->params->get('gmapfp_msg')==1))
				$active = array('active' => 'message');
				
			echo JHtml::_('bootstrap.startTabSet', 'gmapfp_pane', $active);
			//description
			if ($this->lieu->introtext!=null) {
				if ($this->custom[10]->nom) {
					$h_p = $this->custom[10]->nom;
				}else{
					$h_p = JText::_('GMAPFP_MESSAGE');
				}
				echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'description', $h_p);
					echo "<div style='width:100%;".$min_height." max-height:100%;'  itemprop='description'>";
					$modules = new stdClass();
					$modules->id = $this->lieu->id;
					$modules->introtext = "";
					$modules->text = $this->lieu->introtext;
					$modules->fulltext = $this->lieu->fulltext;
					JPluginHelper::importPlugin('content');
					$results = $dispatcher->trigger('onContentPrepare', array ('com_gmapfp.article', &$modules, &$params, 0));
						if ($this->params->get('gmapfp_afficher_intro_italique')==1) { ?>
							<span><em><?php echo $modules->text; ?></em><?php echo $modules->fulltext; ?></span><?php ;
						} else { ?>
							<span><?php echo $modules->text; echo $modules->fulltext; ?></span><?php ;
						}
					echo "</div>";
				echo JHtml::_('bootstrap.endTab');
			}
			//horaires et prix
			if (($this->lieu->horaires_prix!=null)&&($this->lieu->params->get('gmapfp_afficher_horaires_prix')==1)) {
				if ($this->custom[11]->nom) {
					$h_p = $this->custom[11]->nom;
				}else{
					$h_p = JText::_('GMAPFP_HORAIRES_PRIX');
				}
				echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'horaire', JText::_( $h_p ));
					echo "<div style='width:100%;".$min_height." max-height:100%;' >";
					$modules = new stdClass();
					$modules->id = $this->lieu->id;
					$modules->introtext = "";
					$modules->text = $this->lieu->horaires_prix;
					$modules->fulltext = $this->lieu->horaires_prix;
					JPluginHelper::importPlugin('content');
					$results = $dispatcher->trigger('onContentPrepare', array ('com_gmapfp.article', &$modules, &$params, 0));
					echo $modules->text;
					echo "</div>";
				echo JHtml::_('bootstrap.endTab');
			}
			//onglet perso
			echo $this->getChampsHtml(0, 1);
			//champ custom en onglet
			echo $this->getChampsHtml(5, 1);
			//email
			if (($this->lieu->email!=null)and($this->params->get('gmapfp_msg')==1)) {
				echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'message', JText::_( 'GMAPFP_DISPLAY_MSG' ));
					echo "<div style='width:100%;".$min_height." max-height:100%;' >";
					$this->_layout='item';
					echo JViewLegacy::Display('msg');
					$this->_layout='default';
					echo "</div>";
				echo JHtml::_('bootstrap.endTab');
			}
			//insertion du lien externe
			$link4=substr($this->lieu->link,0,4);
			$link5=substr($this->lieu->link,0,5);
			$link9=substr($this->lieu->link,0,9);
			$link10=substr($this->lieu->link,0,10);
			$linkok=0;
			if ((!empty($this->lieu->icon))||(!$this->lieu->icon='')) {
				if ($this->lieu->article_slug >= 1) {
					$linkok=2;
				};
				if (($link5=="http:")||($link4=="www.")||($link9=="index.php")) {
					$linkmap=$this->lieu->link;
					if ($link4=="www.") {$linkmap="http://".$linkmap;};
					if ($link10=="index.php?") {$linkmap=JURI::base().$linkmap."&tmpl=component";};
					$linkok=1;
				};
			};
			if ($linkok&&($this->lieu->icon <> '')) {
				if (!$this->lieu->icon_label) {
					$label = $this->lieu->icon;
				}else{
					$label = $this->lieu->icon_label;
				}
				echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'lien_ext', $label);
					if ($linkok == 1) {
						echo "<iframe style='".$min_height." width:100%;' src='".$linkmap."'><a href='".$linkmap."'>SELFHTML</a></iframe>";
					} else {
						echo "<div style='".$min_height." width:100%;' >".$this->lieu->article_text."</div>";
					};
				echo JHtml::_('bootstrap.endTab');
			}

			//insertion de JComments
			  $jcomments =  JPATH_SITE.'/components/com_jcomments/jcomments.php';
			  if ((file_exists($jcomments))and($this->params->get('gmapfp_jcomments'))) {
				require_once($jcomments);
				echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'JComments', JText::_( 'GMAPFP_JCOMMENT' ));
					echo '<div style="clear: both;">';
					echo JComments::showComments($this->lieu->id, 'com_gmapfp', $this->lieu->nom);
					echo '</div>';
				echo JHtml::_('bootstrap.endTab');
			  }

			//insertion de ItemRating
			  $itemrating =  JPATH_SITE.'/components/com_itemrating/itemrating.php';
			  if ((file_exists($itemrating))and($this->params->get('gmapfp_itemrating_show', 3) == 3 or $this->params->get('gmapfp_itemrating_show', 3) == 2)) {
				echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'itemrating', JText::_( 'GMAPFP_RATING' ));
					echo '<div style="clear: both;">';
					$this->_layout='item';
					echo JViewLegacy::Display('ratingitem');
					$this->_layout='default';
					echo '</div>';
				echo JHtml::_('bootstrap.endTab');
			  }

			//insertion de Itinéraire
			$iti = $this->map['iti'];
			  if ($iti and $this->lieu->params->get('show_map_onglet')) {
				echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'iti', JText::_( 'GMAPFP_DIRECTION' ));
					echo '<div style="clear: both;">';
					echo $iti;
					echo '</div>';
				echo JHtml::_('bootstrap.endTab');
			  }

			echo JHtml::_('bootstrap.endTabSet');
			// fin onglets
		echo '</div>';


?>
<div class="clearboth"></div>
<?php
		
		?>
	<?php echo $row->event->beforeDisplayContent; ?>
</div>
<div class="clearboth"></div>