<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.123pro
	* Creation date: Septembre 2019
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die; 

$app	= JFactory::getApplication(); 
$layout	= $app->input->get('layout', '', '', 'str');
$view	= $app->input->get('view', '', '', 'str');

$is_article = (($layout == 'article') or ($view == 'gmapfpcontact'));

$row=$this->lieu;
$champs = $this->champs;

//fonction pour execution des plugins
$dispatcher = JEventDispatcher::getInstance(); 
JPluginHelper::importPlugin('content'); 

$titre = JPATH_ROOT.'/components/com_gmapfp/views/gmapfp/tmpl/tmpl_titre_article.php';

?>
<div class="gmapfp item-page<?php echo $this->params->get('pageclass_sfx')?>">
	<?php include $titre; ?>
		<?php
			//si affichage d'un article ou d'une catgorie d'article, n'affiche pas le nom de la catgorie
			if ( $this->params->get( 'show_category' )) {
				if (($layout!='article')&&($layout!='categorie')) {
					$catids = explode(',', $row->catid);
					$cat_title = array();
					foreach ($catids as $catid) {
						$cat_title[] = $this->categories[$catid]->title;
					}
					echo '<h4>('.implode(', ', $cat_title).')</h4>';
				};
			}
			
			if ($is_article) {
				if (!array_search(33, array_column($this->champs, 'type'))) {
					echo JLayoutHelper::render('labels', array('params' => $this->params, 'row' => $row, 'lists' => $this->lists), JPATH_ROOT.'/components/com_gmapfp/layouts');
				}
			}
		?>
	<div class="gmapfp_detail">
		<div class="gmapfp_taille1 pull-left">
			<?php
				//affichage de l'image principale si non raffecte
				if (!$is_article or !array_search(28, array_column($this->champs, 'type'))) {
					echo JLayoutHelper::render('main_img', array('params' => $this->params, 'row' => $row, 'article' => $is_article), JPATH_ROOT.'/components/com_gmapfp/layouts');
				}
			?>
		</div>
		<div class="gmapfp_taille2 pull-left">
			<?php
			echo $this->getChampsHtml(0);
			if (!array_search(31, array_column($this->champs, 'type'))) {
				echo JLayoutHelper::render('adresse', array('params' => $this->params, 'row' => $row), JPATH_ROOT.'/components/com_gmapfp/layouts');
			}
			echo $this->getChampsHtml(1);
			?>
		</div>
		<div class="pull-left">
			<?php
			echo $this->getChampsHtml(2);
			if (!array_search(30, array_column($this->champs, 'type'))) {
				echo JLayoutHelper::render('main_email', array('params' => $this->params, 'row' => $row), JPATH_ROOT.'/components/com_gmapfp/layouts');
			}
			if (!array_search(35, array_column($this->champs, 'type'))) {
				echo JLayoutHelper::render('site_web', array('params' => $this->params, 'row' => $row), JPATH_ROOT.'/components/com_gmapfp/layouts');
			}
			echo $this->getChampsHtml(3);
			?>
		</div>
	</div>
	<div class="clearboth"></div>
	<?php echo $row->event->beforeDisplayContent; ?>
	<?php if ($layout!='article') {?>
		<div class="gmapfp_article">
			<?php
				if ($row->introtext!=null) {
					if ($this->custom[10]->nom) {
						echo '<label>'.$this->custom[10]->nom.'</label>';
					}else{
						echo '<label>'.JText::_('GMAPFP_MESSAGE').'</label>';
					}
					echo '<span>'.JHtml::_('content.prepare', $row->introtext).'</span>';
				};
				if ($row->fulltext!=null) {
					echo '<p class="readmore">';
					echo $a.' btn">'.'<span class="icon-chevron-right"></span>'.JText::_('GMAPFP_LIRE_SUITE').'</a>';
					echo '</p>';
				}; 
			?>
		</div>
	<?php } else { 
			if (!array_search(32, array_column($this->champs, 'type'))) {
				echo JLayoutHelper::render('pictos', array('params' => $this->params, 'row' => $row, 'lists' => $this->lists), JPATH_ROOT.'/components/com_gmapfp/layouts');
			}
	?>
		<div class="gmapfp_article">
			<?php
				echo $this->getChampsHtml(4);
				if (!array_search(29, array_column($this->champs, 'type'))) {
					echo JLayoutHelper::render('description', array('params' => $this->params, 'row' => $row), JPATH_ROOT.'/components/com_gmapfp/layouts');
				}
			?>
		</div>
	<?php 
	} ?>
</div>
<?php echo $row->event->afterDisplayContent; ?>
<div class="clearboth article_separator">&nbsp;</div>
