<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.131pro
	* Creation date: Septembre 2022
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/
defined('_JEXEC') or die;
JPluginHelper::importPlugin('gmapfp'); 

use Joomla\CMS\Captcha\Captcha;

//Ne pas utiliser JPATH_COMPONENT. Sinon bug avec l'utilisation du com_gmapfp_search
require_once(JPATH_ROOT.'/components/com_gmapfp/helpers/champs.php');

JLoader::register('GMapFPHelper', JPATH_ROOT . '/components/com_gmapfp/helpers/helper.php');
JLoader::load('GMapFPHelper');

class GMapFPViewGMapFP extends GMapFPChampsGMapFP
{
	protected $item;
	protected $params;
	protected $layout;
	protected $tmpl;
	protected $path;
	protected $path2;
	protected $path_thumbs;
	protected $startTab;

	function display($tpl = null)
    {
	// ne fonctionne pas avec le rafraichissement Ajax !!!
	// ne fonctionne pas correctement en bas de page !!!
		//JHtml::_('formbehavior.chosen', 'select');	
		
		$app	= JFactory::getApplication();
		$input	= $app->input;
		$Itemid		= $input->get('Itemid'); 
		$option		= $input->get('option'); 
		$this->tmpl	= ($input->get('tmpl', '') == 'component');

        $params 	= clone($app->getParams('com_gmapfp'));
        $model      = $this->getModel(); 

		$language	= JFactory::getLanguage();
		if ($language->isRTL ()) $this->float = 'float:right;';
			else $this->float = 'float:left;';
		
		//n'active ajax que s'il y a que la carte
		$ajax = ($params->get('gmapfp_filtre') and $params->get('gmapfp_ajax', 0) and $params->get('type_affichage', 0) == 2);
		
		//recupre les infos des cookies si demande d'impression
		if (!$input->get('map_id', 0, 'int') && $this->getLayout() == 'print_article' AND $input->cookie->get('gmapfp_itin_id', null)) {
			$model->set_id($input->cookie->get('gmapfp_itin_id'));
		}
		
		$model->set_ajax($ajax);
        $lieux      = $model->getGMapFPList();

		if ($params->get('gmapfp_filtre') == 1)
			$this->filtres		= $model->getFilterList($option, $Itemid, array());
		//die(print_r($lists));
		$lists['classements']	= $model->getClassements(1);
		$lists['labels']		= $model->getClassements(2);
		$lists['pictos']		= $model->getClassements(3);
		
        // Parametres
        $params->def('nombre_articles',         4);
        $params->def('show_headings',           1);
        $params->def('show_pagination',         1);
        $params->def('show_pagination_results', 1);
        $params->def('show_pagination_limit',   1);
        $params->def('filter',                  1);

        $limitstart = $input->get('limitstart', 0, 'int');
        $default_limit = $params->get('nombre_articles');
        $limit = $app->getUserStateFromRequest($option.$Itemid.'.limit', 'limit', $default_limit, 'int');

        $input->set('limit', (int) $limit);

        $total      = $this->get( 'Total' );
        jimport('joomla.html.pagination');
        $pagination = new JPagination($total, $limitstart, $limit);

		//incremente le hit
		if (($this->getLayout() == 'article') && ($limitstart == 0))
		{
			$model->hit();
		}

        //ajout du fil d'actualit
        if($params->get('show_feed_link', 1) == 1)
        {
            $link   = '&format=feed&limitstart=';
            $attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
            $this->document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
            $attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
            $this->document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
        }

		$lieu = array();
        $this->lieu = $lieu;	 
		
		/*
		 * Handle the breadcrumbs
		 * Fil d'Arianne
		 */
		$menus = $app->getMenu();
		$menu  = $menus->getActive();
		$pathway	= $app->getPathway();
		$this->layout = $input->get('layout');
		
		$in_active_menu = true;
		if ($menu && array_key_exists('layout', $menu->query)) $in_active_menu = false;

		if (($this->layout == 'article') and $in_active_menu) {
			if (@$lieux[0] and count($lieux) == 1)
				$pathway->addItem($lieux[0]->nom, '');
			else {
				$app->enqueueMessage(JText::_('COM_GMAPFP_PLACE_NOT_FOUND'), 'error');
				$app->setHeader('status', 404, true);
				return false;
			}
		}
		/********/

		$model->setId_Perso($params->get('id_perso'));
        $this->perso 	= $model->getPersonnalisation();
        $this->ajax 	= $ajax;	        
        $this->map 		= $model->getView();	
		$this->num		= $model->get_num();
        $this->custom 	= $model->getCustom();
        $this->lieux 	= $lieux;
        $this->pagination = $pagination;
        $this->params 	= $params;
        $this->total 	= $total;
        $this->lists 	= $lists;
		$this->categories = $model->getCategories();
		if ($this->params->def('catid'))
			$this->category = $model->getCategory($this->params->get('catid'));

		//creation de la div pour contenir l\'impression. Cette div doit tre dans le body
		$html = '<div id=\"gmapfp_print_frame'.$this->num.'\" class=\"gmapfp_print_frame\"></div>';
		$html .= '<div id=\"gmapfp_prepa_impression\" class=\"gmapfp_prepa_impression\" style=\"display : none;\">';
		$html .= '	<div id=\"gmapfp_prepa_impression_message\" class=\"gmapfp_prepa_impression_message\" style=\"background-image:url('.JURI::root().'/media/com_gmapfp/images/loader_black.gif)\">'.JText::_('GMAPFP_ATTENTE_IMPRESSION').'</div>';
		$html .= '	<div id=\"gmapfp_prepa_impression_fond\" class=\"gmapfp_prepa_impression_fond\"></div>';
		$html .= '</div>';
		$this->document->addScriptDeclaration('
			jQuery( document ).ready(function( ) {
				eval("jQuery(\'body\').append(\''.$html.'\');");
			});
		');
			
		if ($lieux) $this->_prepareDocument();
		else echo JText::_('GMAPFP_AUCUNE_INFO');
		
        parent::display($tpl);
		
 		if (!$this->params->get('gmapfp_article_onglets', 1)) {
			$this->document->addScriptDeclaration('
				jQuery( document ).ready(function( ) {
					jQuery(".tab-pane").css(\'display\',\'block\');
					jQuery("#gmapfp_paneTabs li a").removeAttr(\'data-toggle\');
				});
			');
		}
   }   

	/**
	 * Prepares the document
	 */
	protected function _prepareDocument()
	{
		$app		= JFactory::getApplication();
		$menus		= $app->getMenu();
		$pathway	= $app->getPathway();
		$title		= null;

		if($this->layout == "article") {
			$article = true;
			$this->item = $this->lieux[0];
		} else {
			$article = false;
			$this->item = "";
		}

		// Because the application sets a default page title,
		// we need to get it from the menu item itself
		$menu = $menus->getActive();

		if (isset($menu->title))
		{
			$this->params->def('page_heading', $this->params->get('page_title', $menu->title));
		}
		else
		{
			$this->params->def('page_heading', JText::_('JGLOBAL_ARTICLES'));
		}

		if ($article and $menu and array_key_exists('view', $menu->query) and $menu->query['view'] != 'article') {
			$catids = explode(',', $this->item->catid);
			$cat_title = array();
			foreach ($catids as $catid) {
				$cat_title[] = $this->categories[$catid]->title;
			}
			if ($this->params->get('show_ville_in_title'))
				$title = $this->item->ville.' : '.$this->item->nom.' ('.implode(', ', $cat_title).')';
			else
				$title = $this->item->nom.' ('.implode(', ', $cat_title).')';
		} else {
			$title = $this->params->get('page_title', '');
		}
		
		// Check for empty title and add site name if param is set
		if (empty($title))
		{
			$title = $app->get('sitename');
		}
		elseif ($app->get('sitename_pagetitles', 0) == 1)
		{
			$title = JText::sprintf('JPAGETITLE', $app->get('sitename'), $title);
		}
		elseif ($app->get('sitename_pagetitles', 0) == 2)
		{
			$title = JText::sprintf('JPAGETITLE', $title, $app->get('sitename'));
		}

		if (empty($title))
		{
			$title = $this->item->nom;
		}
		$this->document->setTitle($title);

		if ($this->params->get('menu-meta_description'))
		{
			$this->document->setDescription($this->params->get('menu-meta_description'));
		}

		if ($this->params->get('menu-meta_keywords'))
		{
			$this->document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
		}

		if ($this->params->get('robots'))
		{
			//$this->document->setMetadata('robots', $this->params->get('robots'));
		}
	}

	function &getItem($index = 0, $params='')
	{
		jimport( 'joomla.html.parameter' );

		if (array_key_exists($index, $this->lieux)) {
			$item = $this->lieux[$index];
			
			// Get the page/component configuration and article parameters
			$item->params = clone($params);
			$aparams = new JRegistry($item->attribs);

			// Merge article parameters into the page configuration
			$item->params->merge($aparams);
		} else
			$item = new stdClass();
			
		return $item;
	}

	function &getChamps($index = 0, &$params = '')
	{
		jimport( 'joomla.html.parameter' );
        $model      = $this->getModel(); 

		$champ 		= $this->lieux[$index]->id;
		$champs     = $model->getChamps($champ);
		if (!$champs)  $champs = array();
		
		return $champs;
	}
}
?>
