<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.132pro
	* Creation date: Novembre 2022
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die; 

$dispatcher	= JEventDispatcher::getInstance();
$lieu = $this->lieu;
$cat_title = array();

if ($this->params->get('show_page_heading', 1)) : ?>
<div class="componentheading<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
<h1>
	<?php echo $this->escape($this->params->get('page_heading')); ?>
</h1>
</div>
<?php endif;

if (!$lieu) : ?>
<div id="form_error" class="error">
	<?php echo JText::_( 'GMAPFP_LIEUX_INCOMPATIBLE' ); ?>
</div>
<?php 
	return false;
endif;

echo '<div class="gmapfp" id="gmapfp_article">';
//Verifier si un fichier article_template existe
$template = '';
if (false) {
	$template = $this->params->get('gmapfp_template_article');
	$this->_layout=$template;
	echo JViewLegacy::Display('article');
	$this->_layout='default';
} else {
	$document = JFactory::getDocument();
	
	$lieu =& $this->getItem($this->params);
	$this->champs =& $this->getChamps(0);

	// Ajout des vnements
	$lieu->event = new stdClass;
	$offset = 0;
	$results = $dispatcher->trigger('onGMapFPAfterIcon', array('com_gmapfp.article', &$lieu, &$this->params, $offset));
	$lieu->event->afterDisplayIcon = trim(implode("\n", $results));

	$results = $dispatcher->trigger('onGMapFPAfterTitle', array('com_gmapfp.article', &$lieu, &$this->params, $offset));
	$lieu->event->afterDisplayTitle = trim(implode("\n", $results));

	$results = $dispatcher->trigger('onGMapFPBeforeDisplay', array('com_gmapfp.article', &$lieu, &$this->params, $offset));
	$lieu->event->beforeDisplayContent = trim(implode("\n", $results));

	$results = $dispatcher->trigger('onGMapFPAfterDisplay', array('com_gmapfp.article', &$lieu, &$this->params, $offset));
	$lieu->event->afterDisplayContent = trim(implode("\n", $results));

	if (property_exists($lieu, 'metadesc') and $lieu->metadesc) {
        $document->setDescription( $lieu->metadesc );
    }
    if (property_exists($lieu, 'metakey') and $lieu->metakey) {
        $document->setMetadata('keywords', $lieu->metakey);
    }
    if (property_exists($lieu, 'catid') and $lieu->catid) {
		$catids = explode(',', $lieu->catid);
		$cat_title = array();
		foreach ($catids as $catid) {
			$cat_title[] = $this->categories[$catid]->title;
		}
	}
    $document->setTitle(@$lieu->ville.' : '.$lieu->nom.' ('.implode(', ', $cat_title).')');
	$mdata = new JRegistry($lieu->metadata);
	$mdata = $mdata->toArray();
	foreach ($mdata as $k => $v)
	{
		if ($v) {
			$document->setMetadata($k, $v);
		}
	}
	echo '<div id="enregistrement">';
		//affichage du dtail d'un lieu
		$template = '';
		if (($this->params->get('gmapfp_template_article')) and (is_file(JPATH_SITE.'/components/com_gmapfp/views/gmapfp/tmpl/tmpl_'.$this->params->get('gmapfp_template_article').'_article.php'))) {
			$template = '_'.$this->params->get('gmapfp_template_article');
		}			
		$template = '';
		require(JPATH_SITE.'/components/com_gmapfp/views/gmapfp/tmpl/tmpl'.$template.'_article.php');
	echo '</div>';
	
	if ($lieu->email) {
		echo '<div class="gmapfp">';
			echo $this->loadTemplate('form');
		echo '</div>';
	} else {
		JError::raiseWarning(100, JText::_('GMAPFP_EMAIL_RECEPTEUR'));
	}
	
	echo JHtml::_('bootstrap.startTabSet', 'gmapfp_pane', array('active' => 'carte'));
	//carte
	if  ($this->params->get('show_map_onglet')) {
		echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'carte', JText::_( 'GMAPFP_CARTE' ));
			echo '<div id="mapmap">';
					echo $this->map['map'];
					if ($this->map['iti']) {
						echo '<legend style="float:left;">'.JText::_( 'GMAPFP_DIRECTION' ).'</legend>';
						echo $this->map['iti'];
					};
			echo '</div>';
		echo JHtml::_('bootstrap.endTab');
	}
	//horaires et prix
	if (($lieu->horaires_prix!=null)&&($lieu->params->get('gmapfp_afficher_horaires_prix_onglet')==1)) {
		if ($this->custom[11]->nom) {
			$h_p = $this->custom[11]->nom;
		}else{
			$h_p = JText::_('GMAPFP_HORAIRES_PRIX');
		}
		echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'horaire', JText::_( $h_p ));
			echo "<div style='width:100%; height:".$this->params->get('gmapfp_height')."px;' >";
				echo $lieu->horaires_prix;
			echo "</div>";
		echo JHtml::_('bootstrap.endTab');
	}
	//onglet perso
	echo $this->getChampsHtml(0, 1);
	//champ custom
	echo $this->getChampsHtml(5, true);
	//galerie
	if ($this->params->get('show_gallery_onlet')) {
		$this->path = COM_GMAPFP_IMAGES_FOLDER."/GA".$lieu->id;
		$this->path2 = COM_GMAPFP_IMAGES_HTTP."/GA".$lieu->id.'/';
		$this->path_thumbs = COM_GMAPFP_IMAGES_HTTP."/GA".$lieu->id."/thumbs/";

		$this->addTemplatePath(JPATH_SITE.'/components/com_gmapfp/views/gmapfp/tmpl');
		$this->setLayout('item_galerie_v'.$lieu->params->get('gmapfp_num_galerie', 3));
		echo $this->loadTemplate();
	}
	//insertion du lien externe
	$link4=substr($lieu->link,0,4);
	$link5=substr($lieu->link,0,5);
	$link9=substr($lieu->link,0,9);
	$link10=substr($lieu->link,0,10);
	$linkok=0;
	if ((!empty($lieu->icon))||(!$lieu->icon='')) {
		if ($lieu->article_slug>=1) {
			require_once JPATH_SITE . '/components/com_content/helpers/route.php';
			$linkmap=JRoute::_(ContentHelperRoute::getArticleRoute($lieu->article_slug, $lieu->article_id.':'.$lieu->article_alias, 0));
			$linkmap .= '?&tmpl=component';
			$linkok=1;
		};
		if (($link5=="http:")||($link4=="www.")||($link9=="index.php")) {
			$linkmap=$lieu->link;
			if ($link4=="www.") {$linkmap="http://".$linkmap;};
			if ($link10=="index.php?") {$linkmap=JURI::base().$linkmap."&tmpl=component";};
			$linkok=1;
		};
	};
	if ($linkok&&($lieu->icon<>'')) {
		if (!$lieu->icon_label) {
			$label = $lieu->icon;
		}else{
			$label = $lieu->icon_label;
		}
		echo $pane->startPanel($label,'lien_ext');
			echo "<iframe width='100%' height='".$this->params->get('gmapfp_height')."px' src='".$linkmap."'><a href='".$linkmap."'>SELFHTML</a></iframe>";
		echo JHtml::_('bootstrap.endTab');
	}

    //insertion de JComments
      $jcomments =  JPATH_SITE.'/components/com_jcomments/jcomments.php';
      if ((file_exists($jcomments))and($this->params->get('gmapfp_jcomments'))) {
        require_once($jcomments);
		echo JHtml::_('bootstrap.addTab', 'gmapfp_pane', 'JComments', JText::_( 'GMAPFP_JCOMMENT' ));
			echo '<div style="clear: both;">';
			echo JComments::showComments($lieu->id, 'com_gmapfp', $lieu->nom);
			echo '</div>';
		echo JHtml::_('bootstrap.endTab');
      }

	echo JHtml::_('bootstrap.endTabSet');
	//champs perso sous onglets
	echo $this->getChampsHtml(7, 1);
};?>
</div>
<?php if ($this->params->get('gmapfp_licence')) : ?>
    <div class="copyright" align="center">
        <br />
        <?php echo JText::_( 'GMAPFP_COPYRIGHT' );?>
    </div>
<?php endif; ?>
