<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.130pro
	* Creation date: Mai 2022
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;
JPluginHelper::importPlugin('gmapfp'); 

use Joomla\CMS\Captcha\Captcha;

//Ne pas utiliser JPATH_COMPONENT. Sinon bug avec l'utilisation du com_gmapfp_search
require_once(JPATH_ROOT.'/components/com_gmapfp/helpers/champs.php');

JLoader::register('GMapFPHelper', JPATH_ROOT . '/components/com_gmapfp/helpers/helper.php');
JLoader::load('GMapFPHelper');

class GMapFPViewGMapFPContact extends GMapFPChampsGMapFP
{
	protected $path;
	protected $path2;
	protected $path_thumbs;
	protected $startTab;

    function display($tpl = null)
    {
		$mainframe = JFactory::getApplication(); 
		$Itemid    = $mainframe->input->get('Itemid'); 
		$option    = $mainframe->input->get('option'); 
		$layout    = 'default';

        $document   = JFactory::getDocument();

        $params = clone($mainframe->getParams('com_gmapfp'));
        $model      = $this->getModel(); 

		$language	= JFactory::getLanguage();
		if ($language->isRTL ()) $this->float = 'float:right;';
			else $this->float = 'float:left;';
		
		//n'active ajax que s'il y a que la carte
		$model->set_ajax(false);

        // Parametres
        $params->def('show_headings',           1);

        //ajout du fil d'actualit
        /*if($params->get('show_feed_link', 1) == 1)
        {
            $link   = '&format=feed&limitstart=';
            $attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
            $document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
            $attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
            $document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
        }*/

        $custom     = $model->getCustom();
		$perso		= $model->getPersonnalisation($params->get('id_perso'));
        $lieux      = $model->getGMapFPList();
       	$map        = $model->getView();
		$lists['classements']	= $model->getClassements(1);
		$lists['labels']		= $model->getClassements(2);
		$lists['pictos']		= $model->getClassements(3);

		JHTML::_('behavior.formvalidation');

        $this->lists = $lists;
        $this->custom = $custom;
        $this->map = $map;	        
		$this->num	= $model->get_num();
        $this->lieu = $lieux[0];
        $this->lieux = $lieux;
        $this->perso = $perso;
        $this->params = $params;
		$this->categories	= $model->getCategories();

		if ($this->params->get('menu-meta_description'))
			$document->setDescription($this->params->get('menu-meta_description'));
		if ($this->params->get('menu-meta_keywords'))
			$document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
		if ($this->params->get('robots'))
			$document->setMetadata('robots', $this->params->get('robots'));

		//creation de la div pour contenir l\'impression. Cette div doit tre dans le body
		$html = '<div id=\"gmapfp_print_frame'.$this->num.'\" class=\"gmapfp_print_frame\"></div>';
		$html .= '<div id=\"gmapfp_prepa_impression\" class=\"gmapfp_prepa_impression\" style=\"display : none;\">';
		$html .= '	<div id=\"gmapfp_prepa_impression_message\" class=\"gmapfp_prepa_impression_message\" style=\"background-image:url('.JURI::root().'/media/com_gmapfp/images/loader_black.gif)\">'.JText::_('GMAPFP_ATTENTE_IMPRESSION').'</div>';
		$html .= '	<div id=\"gmapfp_prepa_impression_fond\" class=\"gmapfp_prepa_impression_fond\"></div>';
		$html .= '</div>';
		$document->addScriptDeclaration('
			jQuery( document ).ready(function( ) {
				eval("jQuery(\'body\').append(\''.$html.'\');");
			});
		');

        parent::display($tpl);
   }   

	function &getItem($index = 0, $params = array())
	{
		jimport( 'joomla.html.parameter' );

		$item 		= $this->lieu;
		$item->params = array();
		$aparams = new JRegistry($item->attribs);
		// Get the page/component configuration and article parameters
		if ($params)	{
			$item->params = clone($params);
			// Merge article parameters into the page configuration
			$item->params->merge($aparams);
		} else 
			$item->params = $aparams;

		return $item;
	}

	function &getChamps($index = 0, &$params = array())
	{
		jimport( 'joomla.html.parameter' );
        $model      = $this->getModel(); 

		$champ 		= $this->lieux[$index]->id;
        $champs     = $model->getChamps($champ);
		if (!$champs)  $champs = array();
		
		return $champs;
	}
}
?>
