<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.117pro
	* Creation date: Juin 2018
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die; 

//fonction pour execution des plugins dans la personnalisation
$dispatcher = JDispatcher::getInstance(); 
JPluginHelper::importPlugin('content'); 
$doc 	= JFactory::getDocument(); 

$css = "
#gmapfp_close_liste, #gmapfp_open_liste {
	position: absolute;
    top: 50px;
    left: 0;
    line-height: 15px;
    font-size: 20px;
	padding: 0 7px;
	cursor: pointer;
}
.gmapfp_enveloppe_liste {
	overflow:auto;
	border-bottom:10px solid #006FE9; 
	border-top:10px solid #006FE9; 
	border-left: 2px solid #006FE9;
	border-radius: 10px 0 0 10px;
	background-color:rgba(255, 255, 255, 0.8);
	min-height: 100px;
}
.liste_position {
	vertical-align: top; 
	position:absolute; 
	top:90px; 
	right:5px; 
	width:250px;
}
.hid_liste{
	width:25px;
}
.gmapfp_liste {
	padding-left: 20px;
}
.gmapfp_liste img {
	padding: 5px;
}
.hidden {
    display: none;
    visibility: hidden;
}
";
$doc->addStyleDeclaration($css);

$js = "
	jQuery(window).on('load',  function() {
		jQuery('#gmapfp_close_liste').click (
			function() {
				jQuery('#gmapfp_close_liste').addClass('hidden');
				jQuery('#gmapfp_open_liste').removeClass('hidden');
				jQuery('.gmapfp_liste').addClass('hidden');
				jQuery('.liste_position').addClass('hid_liste');
			}
		);
		jQuery('#gmapfp_open_liste').click (
			function() {
				jQuery('#gmapfp_open_liste').addClass('hidden');
				jQuery('#gmapfp_close_liste').removeClass('hidden');
				jQuery('.gmapfp_liste').removeClass('hidden');
				jQuery('.liste_position').removeClass('hid_liste');
			}
		);
	});
";
$doc->addScriptDeclaration($js);

?>
<script language="javascript" type="text/javascript">
	function liste_event( marker, liste_action, marker_index ) {
		google.maps.event.trigger(marker, liste_action);
	}
</script>
<?php 

if ($this->params->get('show_page_heading', 1)) : ?>
<div class="componentheading<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
	<h1>
		<?php echo $this->escape($this->params->get('page_heading')); ?>
	</h1>
</div>
<?php endif; ?>

<?php if (($this->params->get('show_description', 1) || $this->params->def('show_description_image', 1)) && $this->params->def('catid')) : ?>
	<div class="category-desc">
	<?php if ($this->params->get('show_description_image') && $this->category->image) : ?>
		<img src="<?php echo $this->category->image; ?>" alt="<?php echo $this->category->image_alt; ?>"/>
	<?php endif; ?>
	<?php if ($this->params->get('show_description') && $this->category->description) : ?>
		<?php echo JHtml::_('content.prepare', $this->category->description, '', 'com_gmapfp.category'); ?>
	<?php endif; ?>
		<div class="clr"></div>
	</div>
<?php endif; ?>

<?php
//affichage des filtres
if ($this->params->get('gmapfp_filtre')==1) {
	if (isset($this->perso->intro_filtre)) {
		$article = new stdClass();
		$article->text=@$this->perso->intro_filtre; 
		$results = $dispatcher->trigger('onPrepareContent', array (& $article, & $this->params, 0)); 
		echo '<div class="gmapfp_intro_filtre">'.$article->text.'</div>';
	}
	require(JPATH_SITE.'/components/com_gmapfp/views/gmapfp/tmpl/item_filtre.php');
};
?>
<div class="blog<?php echo $this->params->get('pageclass_sfx'); ?> gmapfp" style="position:relative;">
    <?php
	echo '<div class="map_position">';
		echo $this->map['map'];
		if ($this->map['iti']) {
			echo '<legend style="float:left;">'.JText::_( 'GMAPFP_DIRECTION' ).'</legend>';
			echo $this->map['iti'];
		}
	echo '</div>';
	//listing
	?>
	<div class="liste_position">
		<div class="gmapfp_enveloppe_liste">
			<div class="gmapfp_liste" style="<?php echo 'height:'.($this->params->get('gmapfp_height')-190).'px; '; ?>">
			<?php 
				if (isset($this->perso->intro_detail)) {
					$article = new stdClass();
					$article->text=@$this->perso->intro_detail; 
					$results = $dispatcher->trigger('onContentPrepare', array ('com_gmapfp', & $article, & $this->params, 0)); 
					echo $article->text;
				}
				$compte = 0;
				$index_list = 0;
				$decale=false;
				$nbre_col	= (int)$this->params->get('gmapfp_nombre_col' ,1);
			
				echo '<ul style="list-style: none; margin:0;">';
					foreach ($this->lieux as $row) : ?>
						<li class="gmapfp_article_listing2_<?php $index_list++; echo (($index_list%2) XOR $decale); ?>">
							<?php 
							if (empty($row->glat)or empty($row->glng)) {
								echo '<span class="sidebar">';
							}else{
								echo '<span class="sidebar" onmouseover=\'liste_event(marker'.$this->num.'['.$compte.'],"mouseover",'.$compte.')\' onmousedown=\'liste_event(marker'.$this->num.'['.$compte.'],"mousedown",'.$compte.')\' onmouseup=\'liste_event(marker'.$this->num.'['.$compte.'],"mouseup",'.$compte.')\' onmouseout=\'liste_event(marker'.$this->num.'['.$compte.'],"mouseout",'.$compte.')\' >';
								$compte ++;
							};
							$affichage = "";
							if ($this->params->get('gmapfp_view_puce', 1) == 1) {
								if (!$row->m_url) $row->m_url = $this->get_default_marqueur($row->catid);
								$affichage='<img src="'.str_replace('..', JUri::root(), $row->m_url).'">';
							}
							if ($this->params->get('gmapfp_view_puce', 1) == 2 and $row->img) {
								$affichage='<img style="width:'.$this->params->get('gmapfp_thumb_size', 60).'px;" src="'.str_replace('..', JUri::root(), 'images/gmapfp/thumbsGMap/'.$row->img).'">';
							}
							if ($this->params->get('gmapfp_view_ville'))
								$affichage .= $row->ville." : ";
							echo $affichage.$row->nom; 
							?>
							</span>
						</li>
						<?php 
					endforeach;?>
				</ul>
			</div>
			<div id="gmapfp_close_liste">
				\<br/>/
			</div>
			<div id="gmapfp_open_liste" class="hidden">
				/<br/>\
			</div>
		</div>
	</div>
</div>
<?php
if (isset($this->perso->conclusion_detail)) {
	$article = new stdClass();
	$article->text=@$this->perso->conclusion_detail; 
    $results = $dispatcher->trigger('onContentPrepare', array ('com_gmapfp', & $article, & $this->params, 0)); 
	echo $article->text;
}
?>
<?php if ($this->params->get('gmapfp_licence')) : ?>
	<div style="vertical-align: top; text-align: center">
		<?php echo JText::_('GMAPFP_COPYRIGHT'); ?>
	</div>
<?php endif; ?>