<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.121pro
	* Creation date: Dcembre 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die; 

//fonction pour execution des plugins dans la personnalisation
$dispatcher = JEventDispatcher::getInstance(); 
JPluginHelper::importPlugin('content'); 
			//ajustement automatique de la hauteur de toutes les images
			$document = JFactory::getDocument();
			$document->addScriptDeclaration('
				//Ajuste hauteur main img gmapfp
				jQuery( window ).load(function() {
					update_height (".gmapfp_auto_height_main_img", "img");
				});
				jQuery( window ).resize(function() {
					update_height (".gmapfp_auto_height_main_img", "img");
				});
				//Ajuste hauteur titre gmapfp
				jQuery( window ).load(function() {
					update_height (".gmapfp_titre", ".gmapfp_largeur_titre");
				});
				jQuery( window ).resize(function() {
					update_height (".gmapfp_titre", ".gmapfp_largeur_titre");
				});
				//Ajuste hauteur detail gmapfp
				jQuery( window ).load(function() {
					update_height (".gmapfp_auto_height_detail", ".article-info");
				});
				jQuery( window ).resize(function() {
					update_height (".gmapfp_auto_height_detail", ".article-info");
				});
				//Ajuste hauteur corp gmapfp
				jQuery( window ).load(function() {
					update_height (".rstpl-box-content", ".description");
				});
				jQuery( window ).resize(function() {
					update_height (".rstpl-box-content", ".description");
				});
				function update_height (conteneur, contenant) {
					var max_heigt = 0;
					jQuery(conteneur).each(function(j, item) {
						jQuery(item).height("800px");
					})
					jQuery(conteneur + " " + contenant).each(function(j, item) {
						if (jQuery(item).height() > max_heigt)
							max_heigt = jQuery(item).height();
					})
					jQuery(conteneur).each(function(j, item) {
						jQuery(item).height(max_heigt);
					})
				}
			');
			$document->addScriptDeclaration('
				var map_null = false;
				function liste_event( marker, liste_action, marker_index, map_index) {
					if (marker.map == null) {
						map_null = true;
						var tmp_map = eval("carteGMapFP"+map_index);
						marker.setMap(tmp_map);
					}
					google.maps.event.trigger(marker, liste_action);
					if (liste_action != "mouseover" && map_null) {
						marker.setMap(null);
						map_null = false;
					}
				}
			');

if ($this->params->get('show_page_heading', 1)) : ?>
<div class="componentheading<?php echo $this->escape($this->params->get('pageclass_sfx')); ?>">
	<h1>
		<?php echo $this->escape($this->params->get('page_heading')); ?>
	</h1>
</div>
<?php endif; ?>

<?php if (($this->params->get('show_description', 1) || $this->params->def('show_description_image', 1)) && $this->params->def('catid')) : ?>
	<div class="category-desc">
	<?php if ($this->params->get('show_description_image') && $this->category->image) : ?>
		<img src="<?php echo $this->category->image; ?>" alt="<?php echo $this->category->image_alt; ?>"/>
	<?php endif; ?>
	<?php if ($this->params->get('show_description') && $this->category->description) : ?>
		<?php echo JHtml::_('content.prepare', $this->category->description, '', 'com_gmapfp.category'); ?>
	<?php endif; ?>
		<div class="clr"></div>
	</div>
<?php endif; ?>

<?php
//affichage des filtres
if ($this->params->get('gmapfp_filtre')==1) {
	if (isset($this->perso->intro_filtre)) {
		$article = new stdClass();
		$article->text=@$this->perso->intro_filtre; 
		$results = $dispatcher->trigger('onPrepareContent', array (& $article, & $this->params, 0)); 
		echo '<div class="gmapfp_intro_filtre">'.$article->text.'</div>';
	}
	require(JPATH_SITE.'/components/com_gmapfp/views/gmapfp/tmpl/item_filtre.php');
};
?>
<div class="blog<?php echo $this->params->get('pageclass_sfx'); ?> gmapfp row-fluid">
    <?php
	//carte en dessous du listing
	if ($this->params->get('gmapfp_position_liste')==2) {
		echo '<div class="map_position">';
			echo $this->map['map'];
			if ($this->map['iti']) {
				echo '<legend style="float:left;">'.JText::_( 'GMAPFP_DIRECTION' ).'</legend>';
				echo $this->map['iti'];
			}
		echo '</div>';
    };
	//carte  gauche du listing
	if ($this->params->get('gmapfp_position_liste')==1) {
		echo '<div class="span'.(12 - $this->params->get('gmapfp_width_list')).'">';
			echo $this->map['map'];
			if ($this->map['iti']) {
				echo '<legend style="float:left;">'.JText::_( 'GMAPFP_DIRECTION' ).'</legend>';
				echo $this->map['iti'];
			}
		echo '</div>';
	};
	//listing
	$span = '';
	if ($this->params->get('gmapfp_position_liste')==0 or $this->params->get('gmapfp_position_liste')==1) $span = 'span'.$this->params->get('gmapfp_width_list');
	?>
	<div class="<?php echo $span; ?>" style="vertical-align: top;" >
		<div class="intro_gmapfp_liste" >
		<?php 
			if (isset($this->perso->intro_detail)) {
				$article = new stdClass();
				$article->text=@$this->perso->intro_detail; 
				$results = $dispatcher->trigger('onContentPrepare', array ('com_gmapfp', & $article, & $this->params, 0)); 
				echo $article->text;
			}
		?>
		</div>
		<div class="gmapfp_enveloppe_liste" style="overflow:auto; <?php 
			if ($this->params->get('gmapfp_position_liste')<2) { 
				echo 'max-height:'.($this->params->get('gmapfp_height')+0).'px; '; 
			} ?>
		">
			<div class="gmapfp_liste" >
			<?php 
				$compte = 0;
				$index_list = 0;
				$this->decale=false;
				$nbre_col	= (int)$this->params->get('gmapfp_nombre_col' ,1);
			
				$span = '';
				if ($this->params->get('gmapfp_nombre_col', 1) > 1) $span = 'span'.(12 / $this->params->get('gmapfp_nombre_col', 1));
				echo '<div class="gmapfp_liste_ligne row-fluid">';
				
				for ($i = 0; $i < count($this->lieux); $i++) : 
				// foreach ($this->lieux as $row) : 
				?>
					<div class="gmapfp_article_listing_<?php $index_list++; echo (int)(($index_list%2) XOR $this->decale).' '; ?> <?php echo $span; ?> cols-<?php echo $this->params->get('gmapfp_nombre_col'); ?>">
						<?php 

						$this->lieu = $this->getItem($i, $this->params);
						// $this->champs = $this->getChamps($i); 

						// Ajout des vnements
						$this->lieu->event = new stdClass;
						$offset = 0;
						$results = $dispatcher->trigger('onGMapFPAfterIcon', array('com_gmapfp.article', &$this->lieu, &$this->params, $offset));
						$this->lieu->event->afterDisplayIcon = trim(implode("\n", $results));

						$results = $dispatcher->trigger('onGMapFPAfterTitle', array('com_gmapfp.liste', &$this->lieu, &$this->params, $offset));
						$this->lieu->event->afterDisplayTitle = trim(implode("\n", $results));

						$results = $dispatcher->trigger('onGMapFPBeforeDisplay', array('com_gmapfp.liste', &$this->lieu, &$this->params, $offset));
						$this->lieu->event->beforeDisplayContent = trim(implode("\n", $results));

						$results = $dispatcher->trigger('onGMapFPAfterDisplay', array('com_gmapfp.liste', &$this->lieu, &$this->params, $offset));
						$this->lieu->event->afterDisplayContent = trim(implode("\n", $results));
			
						if (empty($this->lieu->glat)or empty($this->lieu->glng)) {
							$this->event = "";
						}else{
							$this->event = "onmouseover=\"liste_event(marker$this->num[$compte],'mouseover',$compte, $this->num)\"" ;
							$this->event .= "onmousedown=\"liste_event(marker$this->num[$compte],'mousedown',$compte, $this->num)\"" ;
							$this->event .= "onmouseup=\"liste_event(marker$this->num[$compte],'mouseup',$compte, $this->num)\"" ;
							$this->event .= "onmouseout=\"liste_event(marker$this->num[$compte],'mouseout',$compte, $this->num)\"" ;
							$compte ++;
						};

						//affichage du dtail d'un lieu
						$this->_layout	= 'tmpl_span';
							echo JViewLegacy::Display('article');
						$this->_view	= 'gmapfplist';
						$this->_layout	= 'default';

						?>
					</div>
					<?php 
				if ($index_list >= $nbre_col) { 
					echo '</div><div class="gmapfp_liste_ligne row-fluid">';
					$index_list=0;
					$this->decale=!$this->decale;
				};
				// endforeach;
				endfor;
					?>
				</div>
			</div>
		</div>
	</div>
	<?php 
	//carte d droite du listing
	if ($this->params->get('gmapfp_position_liste')==0) {
		echo '<div class="span'.(12 - $this->params->get('gmapfp_width_list')).'">';
			echo $this->map['map'];
			if ($this->map['iti']) {
				echo '<legend style="float:left;">'.JText::_( 'GMAPFP_DIRECTION' ).'</legend>';
				echo $this->map['iti'];
			}
		echo '</div>';
	};

	//carte sous le listing
	if ($this->params->get('gmapfp_position_liste')==3) {
		echo '<div>';
			echo $this->map['map'];
			if ($this->map['iti']) {
				echo '<legend style="float:left;">'.JText::_( 'GMAPFP_DIRECTION' ).'</legend>';
				echo $this->map['iti'];
			}
		echo '</div>';
    };?>
</div>
<?php
if (isset($this->perso->conclusion_detail)) {
	$article = new stdClass();
	$article->text=@$this->perso->conclusion_detail; 
    $results = $dispatcher->trigger('onContentPrepare', array ('com_gmapfp', & $article, & $this->params, 0)); 
	echo $article->text;
}
?>
<?php if ($this->params->get('gmapfp_licence')) : ?>
	<div style="vertical-align: top; text-align: center">
		<?php echo JText::_('GMAPFP_COPYRIGHT'); ?>
	</div>
<?php endif; ?>