<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.109pro
	* Creation date: Mai 2017
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die( 'Restricted access' );

class GMapFPViewGMapFPList extends JViewLegacy
{
	function display($tpl = null)
	{
		$mainframe 	= JFactory::getApplication(); 
		$doc     	= JFactory::getDocument();
		$params 	= $mainframe->getParams();
		$feedEmail 	= (@$mainframe->getCfg('feed_email')) ? $mainframe->getCfg('feed_email') : 'author';
		$siteEmail 	= $mainframe->getCfg('mailfrom');

		// Get some data from the model
		$mainframe->input->set('limit', $mainframe->getCfg('feed_limit'));
		$rows 		=  $this->get( 'GMapFPList' );
		$categories	= $this->get('Categories');

		$doc->link = JRoute::_('index.php?option=com_gmapfp&view=gmapfp&layout=default');

		foreach ( $rows as $row )
		{
			// strip html from feed item title
			$title = $this->escape( $row->nom );
			$title = html_entity_decode( $title );

			// url link to article
			// & used instead of &amp; as this is converted by feed creator
			$link = JRoute::_(GMapFPHelperRoute::getArticleRoute($row->slug));

			// strip html from feed item description text
			$description	= ($params->get('feed_summary', 0) ? $row->introtext.$row->fulltext : $row->introtext);
			$author			= $row->author;

			// load individual item creator class
			$item = new JFeedItem();
			$item->title 		= $title;
			$item->link 		= $link;
			$item->description 	= $description;
			$item->date			= $row->created;
			$catids = explode(',', $item->catid);
			$cat_title = array();
			foreach ($catids as $catid) {
				$cat_title[] = $categories[$catid]->title;
			}
			$item->category   	= implode(', ', $cat_title);
			$item->author		= $author;
			if ($feedEmail == 'site') {
				$item->authorEmail = $siteEmail;
			}
			else {
				$item->authorEmail = $row->author_email;
			}

			// loads item info into rss array
			$doc->addItem( $item );
		}
	}
}
