<?php
	/*
	* GMapFP Component Google Map for Joomla! 3.x
	* Version J3.122pro
	* Creation date: Juillet 2019
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

//Ne pas utiliser JPATH_COMPONENT. Sinon bug avec l'utilisation du com_gmapfp_search
JLoader::register('GMapFPHelper', JPATH_ROOT . '/components/com_gmapfp/helpers/helper.php');
JLoader::load('GMapFPHelper');

class GMapFPViewGMapFPList extends JViewLegacy
{
	protected $item;
	protected $params;
	protected $layout;
	protected $tmpl;

    function display($tpl = null)
    {
		$app	= JFactory::getApplication(); 
		$Itemid		= $app->input->get('Itemid', '', 'int'); 
		$option		= $app->input->get('option', '', 'cmd'); 
		$this->tmpl	= ($app->input->get('tmpl', '') == 'component');

        $document   = JFactory::getDocument();

        $params 	= clone($app->getParams('com_gmapfp'));
        $model      = $this->getModel(); 

		//n'active ajax que si l'on ai pas en tamplate par dfaut
		$ajax = ($params->get('gmapfp_filtre') and $params->get('gmapfp_ajax', 0) and ($params->get('gmapfp_template') == 'categories' or $params->get('gmapfp_template') == 'bus_route'));
		$model->set_ajax($ajax);

        // Parametres
        $params->def('show_headings',           1);
        $params->def('filter',                  1);

 		$lists['classements']	= $model->getClassements(1);
		$lists['labels']		= $model->getClassements(2);
		$lists['pictos']		= $model->getClassements(3);
       //ajout du fil d'actualit
        if($params->get('show_feed_link', 1) == 1)
        {
            $link   = '&format=feed&limitstart=';
            $attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
            $document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
            $attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
            $document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
        }

		/*
		 * Handle the breadcrumbs
		 */
		$menus = $app->getMenu();
		$menu  = $menus->getActive();
		$pathway = $app->getPathway();
		$this->layout = $app->input->get('layout');
		if (array_key_exists('layout', $menu->query)) $layout = $menu->query['layout'];

		if (($this->getLayout() == 'article')&&($layout != 'article')) {
			if (@$lieux[0] and count($lieux) == 1)
				$pathway->addItem($lieux[0]->nom, '');
			else {
				$app->enqueueMessage(JText::_('COM_GMAPFP_PLACE_NOT_FOUND'));
				return false;
			}
		}
		/********/

		if (($params->get('show_description', 1) || $params->def('show_description_image', 1)) && $params->def('catid'))
			$this->category	= $model->getCategory($params->get('catid'));
		else $this->category = "";

		$model->setId_Perso($params->get('id_perso'));
        $this->perso = $model->getPersonnalisation($params->get('id_perso'));
        $this->ajax = $ajax;
        $this->map = $model->getView();	        
		$this->num	= $model->get_num();
        $this->custom = $model->getCustom();
        $this->lieux = $model->getGMapFPList();
        $this->params = $params;
		if ($params->get('gmapfp_filtre') == 1)
			$this->filtres = $model->getFilterList($option, $Itemid);
		$this->lists = $lists;
		$this->categories	= $model->getCategories();
		$this->marqueurs = $model->getmarqueurs();

		//creation de la div pour contenir l\'impression. Cette div doit tre dans le body
		$html = '<div id=\"gmapfp_print_frame'.$this->num.'\" class=\"gmapfp_print_frame\"></div>';
		$html .= '<div id=\"gmapfp_prepa_impression\" class=\"gmapfp_prepa_impression\" style=\"display : none;\">';
		$html .= '	<div id=\"gmapfp_prepa_impression_message\" class=\"gmapfp_prepa_impression_message\" style=\"background-image:url('.JURI::root().'/media/com_gmapfp/images/loader_black.gif)\">'.JText::_('GMAPFP_ATTENTE_IMPRESSION').'</div>';
		$html .= '	<div id=\"gmapfp_prepa_impression_fond\" class=\"gmapfp_prepa_impression_fond\"></div>';
		$html .= '</div>';
		$document->addScriptDeclaration('
			jQuery( document ).ready(function( ) {
				eval("jQuery(\'body\').append(\''.$html.'\');");
			});
		');

		$this->_prepareDocument();
		
        parent::display($tpl);
    }   

	/**
	 * Prepares the document
	 */
	protected function _prepareDocument()
	{
		$app		= JFactory::getApplication();
		$menus		= $app->getMenu();
		$pathway	= $app->getPathway();
		$title		= null;
		
		if($this->layout == "article") {
			$article = true;
			$this->item = $this->lieux[0];
		} else {
			$article = false;
			$this->item = "";
		}

		// Because the application sets a default page title,
		// we need to get it from the menu item itself
		$menu = $menus->getActive();

		if ($menu)
		{
			$this->params->def('page_heading', $this->params->get('page_title', $menu->title));
		}
		else
		{
			$this->params->def('page_heading', JText::_('JGLOBAL_ARTICLES'));
		}

		if ($article and $menu and $menu->query['view'] != 'article') {
			$catids = explode(',', $this->item->catid);
			$cat_title = array();
			foreach ($catids as $catid) {
				$cat_title[] = $this->categories[$catid]->title;
			}
			if ($this->params->get('show_ville_in_title'))
				$title = $this->item->ville.' : '.$this->item->nom.' ('.implode(', ', $cat_title).')';
			else
				$title = $this->item->nom.' ('.implode(', ', $cat_title).')';
		} else {
			$title = $this->params->get('page_title', '');
		}

		// Check for empty title and add site name if param is set
		if (empty($title))
		{
			$title = $app->get('sitename');
		}
		elseif ($app->get('sitename_pagetitles', 0) == 1)
		{
			$title = JText::sprintf('JPAGETITLE', $app->get('sitename'), $title);
		}
		elseif ($app->get('sitename_pagetitles', 0) == 2)
		{
			$title = JText::sprintf('JPAGETITLE', $title, $app->get('sitename'));
		}

		if (empty($title))
		{
			$title = $this->item->nom;
		}
		$this->document->setTitle($title);

		if ($this->params->get('menu-meta_description'))
		{
			$this->document->setDescription($this->params->get('menu-meta_description'));
		}

		if ($this->params->get('menu-meta_keywords'))
		{
			$this->document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
		}

		if ($this->params->get('robots'))
		{
			//$this->document->setMetadata('robots', $this->params->get('robots'));
		}
	}

	function get_default_marqueur($cat_id)
	{
        $model      = $this->getModel(); 
		$categories   = $model->getCategories();
		
		$cat_id = explode(',', $cat_id);
		
		$cat_param = $categories[$cat_id[0]]->cat_params;
		if (property_exists(json_decode($cat_param), 'default_marqueur_categories'))
			$marqueur_id = json_decode($cat_param)->default_marqueur_categories;
		else
			$marqueur_id = 1;
		return $this->marqueurs[$marqueur_id]->url;
	}
	
	function &getItem($index = 0, $params='')
	{
		jimport( 'joomla.html.parameter' );

		if (array_key_exists($index, $this->lieux)) {
			$item = $this->lieux[$index];
			
			// Get the page/component configuration and article parameters
			$item->params = clone($params);
			$aparams = new JRegistry($item->attribs);

			// Merge article parameters into the page configuration
			$item->params->merge($aparams);
		} else
			$item = new stdClass();
			
		return $item;
	}

	function &getChamps($index = 0, &$params = '')
	{
		jimport( 'joomla.html.parameter' );
        $model      = $this->getModel(); 

		$champ 		= $this->lieux[$index]->id;
		$champs     = $model->getChamps($champ);
		if (!$champs)  $champs = array();
		
		// die(print_r($champs));
		return $champs;
	}
}
?>
